//#define DEBUG
//#define USE_FCGI

#define MAX_HEADER    0xFFFF

#ifdef _WIN32
 #include <windows.h>
 #include <sys/utime.h>
#else
 #include <signal.h>
 #include <pthread.h>      // pthread_create
 #include <dlfcn.h>        // dlopen

 #define HANDLE            void *
 #define HMODULE           HANDLE

 #define SOCKET            int
 #define INVALID_SOCKET    -1
 #include <utime.h>
#endif

#include "AnsiString.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include "debugger.h"
#include "semhh.h"
#include <ctype.h>

int final_res = 0;
int run_debug = 0;

#ifdef _WIN32
 #include <io.h>
//#include <dir.h>
 #include <direct.h>
#else
//#include <unistd.h>
 #include <sys/select.h>
 #include <netinet/tcp.h>
 #include <sys/types.h>
 #include <sys/socket.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
 #include <netdb.h>
#endif

#ifdef USE_FCGI
extern "C" {
 #include <fcgi_stdio.h>
}
 #define MAX_FCGI_SERV    100
#endif

#ifdef _WIN32
 #define CMP_FUNC        stricmp
#else
 #define CMP_FUNC        strcmp
//#define LINUX_PATH "/opt/Concept/bin/"
 #define D_TEMP_DIR      "/tmp"
#endif

#define KEY_EXTENSION    ".appkey"
#define KEY_FILE         "generic.appkey"

#ifdef _WIN32
 #define LIBRARY         "concept-core.2.0.dll"
#else
 #define LIBRARY         "libconceptcore.2.0.so"
//#define LIBRARY      "concept-core.1.0alpha.so"
#endif

#define INI_FILE          "concept.ini"

#ifdef _WIN32
 #define TEMPLATE_PIPE    "ConceptCGIPipe"
#else
 #define TEMPLATE_PIPE    "ConceptCGIPipeXXXXXXXX.tmp"
#endif

typedef int (*GET_VARIABLE_PROC)(int operation, void *VDESC, void *CONTEXT, int Depth, char *VariableName, char *buffer, int buf_size);
typedef int (*DEBUGGER_CALLBACK)(void *VDESC, void *CONTEXT, int Depth, int line, char *filename, GET_VARIABLE_PROC GVP, void *DEBUGGER_RESERVED);
typedef int (*NOTIFY_PARENT)(int pipe_out, int apid, int msg_id, int len, char *data);

extern "C" {
typedef int (*API_SETNOTIFY)(NOTIFY_PARENT np);
typedef int (*API_INTERPRETER2)(char *filename, char *inc_dir, char *lib_dir, void *fp, SOCKET sock, int debug, DEBUGGER_CALLBACK DEBUGGER_TRAP, void *DEBUGGER_RESERVED, char *SERVER_PUBLIC_KEY, char *SERVER_PRIVATE_KEY, char *CLIENT_PUBLIC_KEY, int pipe_in, int pipe_out, int apid, int parent, void *userdata);
typedef int (*API_INTERPRETER)(char *filename, char *inc_dir, char *lib_dir, void *fp, SOCKET sock, int debug, DEBUGGER_CALLBACK DEBUGGER_TRAP, void *DEBUGGER_RESERVED, char *SERVER_PUBLIC_KEY, char *SERVER_PRIVATE_KEY, char *CLIENT_PUBLIC_KEY, int pipe_in, int pipe_out, int apid, int parent);
}

typedef unsigned   chartype;

static int _print_begin = 0;
static int _headers     = 0;
AnsiString namer;
AnsiString namew;
int        client_sock = -1;
int        c_piper     = 0, c_pipew = 0;

static char      done_thread = 0;
AnsiString       HOME_BASE;
AnsiString       Library;
AnsiString       Include;
AnsiString       host;
int              port;
int              autocompile;
int              handle_cgi;
int              allow_debug;
int              allow_parents;
API_INTERPRETER2 Concept_Execute  = 0;
API_INTERPRETER  Concept_Compiler = 0;
API_SETNOTIFY    SetNotifyParent  = 0;
HMODULE          hDLL             = 0;
HHSEM            sem_lock;

char *memstr(char *haystack, char *needle, int size, int needlesize) {
    char *p;

    for (p = haystack; p <= (haystack - needlesize + size); p++)
        if (memcmp(p, needle, needlesize) == 0)
            return(p);
    return(NULL);
}

#ifdef _WIN32
void switch_to_binary() {
    int hndl = fileno(stdout);

    setmode(hndl, O_BINARY);                 // handle to binary mode
    //ioctl( hndl, 1, (info & 0xff) | 0x20 );  // device to raw mode
    //stdout->flags |= _F_BIN;                 // stream to binary mode
}

#endif

AnsiString pre_buffer;
inline void FinishPrint() {
    if (!_print_begin) {
        pre_buffer = AnsiString("Content-type: text/html\r\n\r\n") + pre_buffer;
        fwrite(pre_buffer.c_str(), pre_buffer.Length(), 1, stdout);
        fflush(stdout);
        _headers     = 1;
        _print_begin = 1;
    }
}

char *def_strcasestr(const char *phaystack, const char *pneedle) {
    register const unsigned char *haystack, *needle;
    register chartype            b, c;

    haystack = (const unsigned char *)phaystack;
    needle   = (const unsigned char *)pneedle;

    b = _tolower(*needle);
    if (b != '\0') {
        haystack--;                             /* possible ANSI violation */
        do {
            c = *++haystack;
            if (c == '\0')
                goto ret0;
        } while (_tolower(c) != (int)b);

        c = _tolower(*++needle);
        if (c == '\0')
            goto foundneedle;
        ++needle;
        goto jin;

        for ( ; ; ) {
            register chartype            a;
            register const unsigned char *rhaystack, *rneedle;

            do {
                a = *++haystack;
                if (a == '\0')
                    goto ret0;
                if (_tolower(a) == (int)b)
                    break;
                a = *++haystack;
                if (a == '\0')
                    goto ret0;
shloop:
                ;
            } while (_tolower(a) != (int)b);

jin:      a = *++haystack;
            if (a == '\0')
                goto ret0;

            if (_tolower(a) != (int)c)
                goto shloop;

            rhaystack = haystack-- + 1;
            rneedle   = needle;
            a         = _tolower(*rneedle);

            if (_tolower(*rhaystack) == (int)a)
                do {
                    if (a == '\0')
                        goto foundneedle;
                    ++rhaystack;
                    a = _tolower(*++needle);
                    if (_tolower(*rhaystack) != (int)a)
                        break;
                    if (a == '\0')
                        goto foundneedle;
                    ++rhaystack;
                    a = _tolower(*++needle);
                } while (_tolower(*rhaystack) == (int)a);

            needle = rneedle;           /* took the register-poor approach */

            if (a == '\0')
                break;
        }
    }
foundneedle:
    return((char *)haystack);
ret0:
    return(0);
}

void Print(char *str, int length) {
    if (length <= 0)
        length = strlen(str);

    if (!_headers) {
        pre_buffer.AddBuffer(str, length);
        int  len  = pre_buffer.Length();
        char *ptr = memstr(pre_buffer.c_str(), "\r\n\r\n", len, 4);
        if ((len > 4) && (ptr)) {
            _headers = 1;
            char *buf = pre_buffer.c_str();
            if (!def_strcasestr(buf, "Content-Type")) {
                char *ptr2 = strstr(buf, "\n---- RUN TIME ERROR --------------------------------------------\n");
                if ((ptr2) && ((unsigned long)ptr2 < (unsigned long)ptr))
                    pre_buffer = AnsiString("Content-type: text/plain\r\n") + pre_buffer;
                else
                    pre_buffer = AnsiString("Content-type: text/html\r\n") + pre_buffer;
                buf = pre_buffer.c_str();
                len = pre_buffer.Length();
            }
            fwrite(buf, len, 1, stdout);
            fflush(stdout);
            _print_begin = 1;
        } else if (len > MAX_HEADER)
            FinishPrint();
    } else {
        if (length > 0)
            fwrite(str, length, 1, stdout);
        else if (str)
            fprintf(stdout, "%s", str);

        fflush(stdout);
        _print_begin = 1;
    }
}

#ifndef _WIN32
long GetPrivateProfileString(
    const char *lpAppName,
    const char *lpKeyName,
    const char *lpDefault,
    char       *lpReturnedString,
    long       nSize,
    const char *lpFileName) {
    FILE *in         = 0;
    long filesize    = 0;
    char *filebuffer = 0;
    char section_name[4096];
    char key_name[4096];
    int  error = 0;

    in = fopen(lpFileName, "rb");
    if (in) {
        fseek(in, 0L, SEEK_END);
        filesize = ftell(in);
        fseek(in, 0L, SEEK_SET);
        if (filesize) {
            filebuffer = new char[filesize];
            if (filebuffer) {
                if (fread(filebuffer, 1, filesize, in) == filesize) {
                    char in_name           = 0;
                    char in_quote          = 0;
                    char in_looked_section = 0;
                    char in_looked_key     = 0;
                    char in_looked_value   = 0;
                    char in_comment        = 0;
                    char in_key            = 0;
                    int  temp_pos          = 0;
                    int  key_pos           = 0;
                    int  value_pos         = 0;

                    section_name[0] = 0;
                    key_name[0]     = 0;

                    for (int i = 0; i < filesize; i++) {
                        if (in_comment) {
                            if ((filebuffer[i] == '\n') || (filebuffer[i] == '\r'))
                                in_comment = 0;
                            continue;
                        }

                        if (((filebuffer[i] == '\n') || (filebuffer[i] == '\r')) && (in_looked_value)) {
                            lpReturnedString[value_pos++] = 0;
                            break;
                        }

                        if (!in_quote) {
                            if (filebuffer[i] == ';') {
                                if (in_looked_value)
                                    break;
                                in_comment = 1;
                                continue;
                            }

                            if (filebuffer[i] == '[') {
                                // a inceput o sectziune noua, iar sectziunea precedenta este cea cautata ...
                                if (in_looked_section) {
                                    error = 1;
                                    break;
                                }
                                temp_pos = 0;
                                in_name  = 1;
                                continue;
                            }
                            if (in_name) {
                                if (filebuffer[i] == ']') {
                                    in_name = 0;
                                    section_name[temp_pos] = 0;
                                    if (!CMP_FUNC(section_name, lpAppName))
                                        in_looked_section = 1;
                                    continue;
                                }
                                if ((filebuffer[i] == '\n') || (filebuffer[i] == '\r')) {
                                    in_name = 0;
                                    continue;
                                }
                                if (in_name)
                                    section_name[temp_pos++] = filebuffer[i];
                            }
                        }
                        // schimb flag-ul de ghilimele, daca le-am gasit ...
                        if (!in_name) {
                            if (filebuffer[i] == '"') {
                                in_quote = !in_quote;
                                continue;
                            }
                            if (((filebuffer[i] == '\n') || (filebuffer[i] == '\r')) && (in_quote)) {
                                in_quote = 0;
                                continue;
                            }
                        }

                        if (in_looked_key) {
                            if (filebuffer[i] == '=') {
                                in_looked_value = 1;
                                continue;
                            }
                            if (in_looked_value) {
                                if (value_pos < nSize - 1) {
                                    if (value_pos)
                                        lpReturnedString[value_pos++] = filebuffer[i];
                                    else if ((filebuffer[i] != ' ') && (filebuffer[i] != '\t'))
                                        lpReturnedString[value_pos++] = filebuffer[i];
                                } else {
                                    lpReturnedString[value_pos++] = 0;
                                    break;
                                }
                                continue;
                            }
                        }

                        if (in_looked_section) {
                            if (((filebuffer[i] >= '0') && (filebuffer[i] <= '9')) ||
                                ((filebuffer[i] >= 'a') && (filebuffer[i] <= 'z')) ||
                                ((filebuffer[i] >= 'A') && (filebuffer[i] <= 'Z')) ||
                                (filebuffer[i] == '_')) {
                                if (in_key == 0) {
                                    key_pos = 0;
                                    in_key  = 1;
                                }
                                key_name[key_pos++] = filebuffer[i];
                            } else if (in_key)    {
                                key_name[key_pos] = 0;
                                if (!CMP_FUNC(key_name, lpKeyName))
                                    in_looked_key = 1;
                                in_key = 0;
                            }
                            // TO DO ... sunt in sectiunea cautata ...
                        }
                    }
                } else
                    error = 1;
            } else
                error = 1;
        } else
            error = 1;
        fclose(in);
    } else
        error = 1;

    if (error)
        strncpy(lpReturnedString, lpDefault, nSize);
    return((long)in);
}

#endif

AnsiString GetKey(char *ini_name, char *section, char *key, char *def) {
    char value[4096];

    value[0] = 0;
    GetPrivateProfileString(section, key, def, value, 4096, ini_name);
    return(AnsiString(value));
}

AnsiString GetDirectory() {
#ifdef _WIN32
    char buffer[4096];
    buffer[0] = 0;
    GetModuleFileName(NULL, buffer, 4096);
    for (int i = strlen(buffer) - 1; i >= 0; i--)
        if ((buffer[i] == '/') || (buffer[i] == '\\')) {
            buffer[i + 1] = 0;
            break;
        }
    return(AnsiString(buffer));
#else
    return(LINUX_PATH);
#endif
}

void SetWebDirectory() {
    char       *buffer;
    AnsiString temp;

    temp = getenv("PATH_TRANSLATED");
    if (temp != (char *)"") {
        buffer = temp.c_str();
        for (int i = strlen(buffer) - 1; i >= 0; i--)
            if ((buffer[i] == '/') || (buffer[i] == '\\')) {
                buffer[i + 1] = 0;
                break;
            }
        chdir(buffer);
    }
}

int need_compilation(char *filename) {
    AnsiString accel_filename = filename;

    accel_filename += ".accel";
    struct stat buf1, buf2;
    // if some error, report no need for compilation
    if (stat(filename, &buf1))
        return(0);

    if (stat(accel_filename.c_str(), &buf2))
        return(1);

    // last modification time don't match ... need recompilation ...
    if (buf1.st_mtime != buf2.st_mtime)
        return(1);

    return(0);
}

int Connect(char *HOST, int PORT) {
#ifdef _WIN32
    WSADATA data;
    WSAStartup(MAKEWORD(1, 1), &data);
#endif

    struct sockaddr_in sin;
    struct hostent     *hp;
    int CLIENT_SOCKET = -1;

    if ((hp = gethostbyname(HOST)) == 0) {
        fprintf(stderr, "\nUnable to resolve specified host\n");
        return(-1);
    }

    memset(&sin, 0, sizeof(sin));
    //INADDR_ANY;
    sin.sin_addr.s_addr = ((struct in_addr *)(hp->h_addr))->s_addr;
    sin.sin_family      = AF_INET;
    sin.sin_port        = htons(PORT);

    // creez socket-ul
    if ((CLIENT_SOCKET = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) == INVALID_SOCKET) {
        fprintf(stderr, "\nError creating sockets\n");
        return(-1);
    }

    int flag = 1;
    setsockopt(CLIENT_SOCKET,                     /* socket affected */
               IPPROTO_TCP,                       /* set option at TCP level */
               TCP_NODELAY,                       /* name of option */
               (char *)&flag,                     /* the cast is historical cruft */
               sizeof(int));                      /* length of option value */

    if (connect(CLIENT_SOCKET, (struct sockaddr *)&sin, sizeof(sin)) == INVALID_SOCKET) {
        fprintf(stderr, "Error connecting to specified host\n");
        return(-1);
    }

    return(CLIENT_SOCKET);
}

void Done() {
    if (client_sock == -1)
        return;
#ifdef _WIN32
    closesocket(client_sock);
#else
    close(client_sock);
#endif
    client_sock = -1;

    if (c_piper > 0) {
        close(c_piper);
        c_piper = 0;
        unlink(namer);

/*        if (unlink(namer)!=0) {
 * #ifdef _WIN32
 *          Sleep(10);
 * #else
 *          usleep(10000);
 * #endif
 *          unlink(namer);
 *      }*/
    }
    if (c_pipew > 0) {
        close(c_pipew);
        c_pipew = 0;
        unlink(namew);

/*        if (unlink(namew)!=0) {
 * #ifdef _WIN32
 *          Sleep(10);
 * #else
 *          usleep(10000);
 * #endif
 *          unlink(namew);
 *      }*/
    }
#ifdef _WIN32
    WSACleanup();
#endif
}

int NotifyServer(int CLIENT_SOCKET, char *key, int *pipew, int *piper, int *_APID, int *_parentAPID, bool *debug) {
    if (CLIENT_SOCKET == -1) {
        fprintf(stderr, "Error getting APID for CGI application\n");
        return(-1);
    }

#ifdef _WIN32
    char tmp[8192];
    tmp[0] = 0;
    GetTempPath(8192, tmp);
#else
    char       *tmp = D_TEMP_DIR;
    AnsiString temp(tmp);
    temp += "/";

    AnsiString tplw(temp);
    AnsiString tplr(temp);
#endif


#ifdef _WIN32
    char szTempName[8192];
    GetTempFileName(tmp, TEMPLATE_PIPE, 0, szTempName);
    namew = szTempName;
#else
    tplw += TEMPLATE_PIPE;
    tplr += TEMPLATE_PIPE;

    namew = mktemp(tplw.c_str());
    mode_t mode = S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH;
#endif

#ifdef _WIN32
    *pipew = open(namew.c_str(), O_WRONLY | O_BINARY | O_CREAT);
#else
    *pipew = open(namew.c_str(), O_WRONLY | O_CREAT, mode);
#endif

#ifdef _WIN32
    GetTempFileName(tmp, TEMPLATE_PIPE, 0, szTempName);
    namer = szTempName;
#else
    namer = mktemp(tplr.c_str());
#endif


#ifdef _WIN32
    *piper = open(namer.c_str(), O_RDONLY | O_BINARY | O_CREAT);
#else
    *piper = open(namer.c_str(), O_RDONLY | O_CREAT, mode);
#endif


    AnsiString query;

    query  = "piper ";
    query += namew; // write for us is read for server and vice-versa
    query += "\r\npipew ";
    query += namer;
    query += "\r\ngetapid\r\n";

    if ((key) && (key[0])) {
        query += "getparent ";
        query += key;
        query += "\r\n";
    }

    int len = query.Length();

    if (send(CLIENT_SOCKET, query.c_str(), len, 0) != len) {
        fprintf(stderr, "Concept Server query (request APID) failed\n");
        return(-1);
    }

    int APID;
    int rec_count = 0;
    int received  = 0;
    do {
        received   = recv(CLIENT_SOCKET, (char *)&APID + rec_count, sizeof(int) - rec_count, 0);
        rec_count += received;
    } while ((rec_count < sizeof(int)) && (received > 0));

    if (received == sizeof(int))
        *_APID = ntohl(APID);
    else {
        fprintf(stderr, "Concept Server query (request APID) failed (APID size is invalid)\n");
        return(-1);
    }


    if ((key) && (key[0])) {
        int parentAPID = 0;
        rec_count = 0;
        received  = 0;
        do {
            received   = recv(CLIENT_SOCKET, (char *)&parentAPID + rec_count, sizeof(int) - rec_count, 0);
            rec_count += received;
        } while ((rec_count < sizeof(int)) && (received > 0));

        if (received == sizeof(int)) {
            int pAPID = ntohl(parentAPID);
            if (pAPID < 0) {
                *debug = true;
                pAPID *= -1;
            }
            *_parentAPID = pAPID;
        } else {
            fprintf(stderr, "Concept Server query (request PARENT APID) failed (APID size is invalid)\n");
            return(-1);
        }
    }

    return(0);
}

#ifdef _WIN32
AnsiString INI_PATH;
#endif

int ConceptCGIInit() {
    HOME_BASE = GetDirectory();
    //char *filename=getenv("PATH_TRANSLATED");
    hDLL = 0;

#ifdef _WIN32
    Library = HOME_BASE + GetKey(INI_PATH, "Paths", "Library", "Library") + "\\";
    Include = HOME_BASE + GetKey(INI_PATH, "Paths", "Include", "Include") + "\\";
#else
    Library = HOME_BASE + GetKey(INI_PATH, "Paths", "Library", "Library") + "/";
    Include = HOME_BASE + GetKey(INI_PATH, "Paths", "Include", "Include") + "/";
#endif
    int autocompile = GetKey(INI_PATH, "Run", "AutoCompile", "0").ToInt();

    host          = GetKey(INI_PATH, "Server", "APIDHost", "localhost");
    port          = GetKey(INI_PATH, "Server", "CGIPort", "2663").ToInt();
    handle_cgi    = GetKey(INI_PATH, "Server", "HandleCGIRequests", "0").ToInt();
    allow_debug   = GetKey(INI_PATH, "Web", "AllowDebug", "0").ToInt();
    allow_parents = GetKey(INI_PATH, "Web", "AllowCASParent", "0").ToInt();

#ifdef _WIN32
    switch_to_binary();
#endif

    /*if (!filename) {
     *  fprintf(stdout, "%s%c%c\n","Content-Type:text/plain;charset=iso-8859-1",13,10);
     *  std::cout << "Invalid WEBServer query\n";
     *  done_thread=1;
     *  return 0;
     * }*/

#ifdef _WIN32
    hDLL = LoadLibrary(LIBRARY);
#else
    hDLL = dlopen(/*HOME_BASE+*/ LIBRARY_PATH, RTLD_LAZY);
#endif

    if (!hDLL) {
        fprintf(stdout, "%s%c%c%c%c", "Content-Type:text/plain", 13, 10, 13, 10);
        fprintf(stdout, "Error loading core library '%s'\n", LIBRARY);
        done_thread = 1;
        return(0);
    }

#ifdef _WIN32
    Concept_Execute = (API_INTERPRETER2)GetProcAddress(hDLL, "Concept_Execute");
    if (!Concept_Execute)
        Concept_Execute = (API_INTERPRETER2)GetProcAddress(hDLL, "_Concept_Execute");
#else
    Concept_Execute = (API_INTERPRETER2)dlsym(hDLL, "Concept_Execute");
#endif
    if (!Concept_Execute) {
        fprintf(stdout, "%s%c%c%c%c", "Content-Type:text/plain", 13, 10, 13, 10);
        fprintf(stdout, "Corrupted library : '%s'\n", LIBRARY);
        done_thread = 1;
        return(0);
    }

#ifdef _WIN32
    Concept_Compiler = (API_INTERPRETER)GetProcAddress(hDLL, "Concept_Compile");
    if (!Concept_Compiler)
        Concept_Compiler = (API_INTERPRETER)GetProcAddress(hDLL, "_Concept_Compile");

    SetNotifyParent = (API_SETNOTIFY)GetProcAddress(hDLL, "SetNotifyParent");
    if (!SetNotifyParent)
        SetNotifyParent = (API_SETNOTIFY)GetProcAddress(hDLL, "_SetNotifyParent");
#else
    Concept_Compiler = (API_INTERPRETER)dlsym(hDLL, "Concept_Compile");
    SetNotifyParent  = (API_SETNOTIFY)dlsym(hDLL, "SetNotifyParent");
#endif
    return(1);
}

void ConceptCGIDone() {
    if (!hDLL)
        return;
#ifdef _WIN32
    FreeLibrary(hDLL);
#else
    dlclose(hDLL);
#endif
}

#ifdef _WIN32
DWORD WINAPI thread_main(void *) {
#else
void *thread_main(void *) {
#endif
    SetWebDirectory();

    char *filename = getenv("PATH_TRANSLATED");
    if (!filename) {
        fprintf(stdout, "%s%c%c%c%c", "Content-Type:text/plain", 13, 10, 13, 10);
        fprintf(stdout, "Invalid WEBServer query\n");
        done_thread = 1;
        return(0);
    }
    // check for autocompile
    int res = 0;
    if (SetNotifyParent)
        SetNotifyParent(RemoteNotify);
    if ((autocompile) && (need_compilation(filename)) && (Concept_Compiler))
        res = Concept_Compiler(filename, Include, Library, (void *)Print, 0, -1, 0, 0, 0, 0, 0, -1, -1, -1, -1);

    int  APID       = 0;
    int  parentAPID = -1;
    bool debug      = false;
    //char *key=0;
    AnsiString my_key;

    if ((allow_parents) || (allow_debug))
        if ((my_key.LoadFile(AnsiString(filename) + KEY_EXTENSION) != 0) || (!my_key.Length()))
            my_key.LoadFile(KEY_FILE);

    if (handle_cgi) {
        client_sock = Connect(host, port);
        NotifyServer(client_sock, my_key.c_str(), &c_pipew, &c_piper, &APID, &parentAPID, &debug);
    }
    if (!allow_debug)
        debug = false;
    else
    if (!allow_parents)
        parentAPID = -1;


    if (!res) {
        int pipe_in  = c_piper ? c_piper : -1;
        int pipe_out = c_pipew ? c_pipew : -1;

        int  apid     = APID ? APID : -1;
        void *debuger = 0;

        if (debug) {
            debuger   = InitDebuger(filename, pipe_out, pipe_in, parentAPID);
            run_debug = 1;
            res       = Concept_Execute(filename, Include, Library, (void *)Print, 0, -2, CONCEPT_DEBUGGER_TRAP, debuger, 0, 0, 0, pipe_in, pipe_out, apid, parentAPID, 0);
        } else
            res = Concept_Execute(filename, Include, Library, (void *)Print, 0, -1, 0, 0, 0, 0, 0, pipe_in, pipe_out, apid, parentAPID, 0);
        if (res == -3) {
            Print("<HEAD><TITLE>404 Not Found</TITLE></HEAD>\n", 0);
            Print("<BODY><H1>404 Not Found</H1>\n", 0);
            Print("The requested Concept script/URL was not found on this server.\n", 0);
            Print("</BODY>\n", 0);

            //fprintf(stdout, "Content-type: text/html\r\nHTTP/1.0 404 Not Found\r\n");
            //fprintf(stdout, "%s%c%c\n","Content-Type:text/plain;charset=iso-8859-1",13,10);
            //fprintf(stdout, "File not found or insufficient rights : %s\r\n",filename);
            final_res = -1;
        }
        FinishPrint();
    }

    semp(sem_lock);
    done_thread = 1;
    semv(sem_lock);

    if (handle_cgi)
        Done();

    return /*res*/ (0);
}

int check_file() {
    FILE *in       = 0;
    char *filename = getenv("PATH_TRANSLATED");

    in = fopen(filename, "rb");
    if (in) {
        fclose(in);
        return(1);
    }

    /*fprintf(stdout, "Content-Type: text/html\r\n" );
     * fprintf(stdout, "HTTP/1.1 404 Not Found\r\n" );
     * fprintf(stdout, "Date: Mon, 14 Jan 2002 03:19:55 GMT\r\n" );
     * fprintf(stdout, "Server: Apache/1.3.22 (Unix)\r\n" );
     * fprintf(stdout, "Connection: close\n" );*/
    fprintf(stdout, "%s%c%c%c%c", "Content-Type: text/html", 10, 13, 10, 13);
    fprintf(stdout, "<HEAD><TITLE>404 Not Found</TITLE></HEAD>\n");
    fprintf(stdout, "<BODY><H1>404 Not Found</H1>\n");
    fprintf(stdout, "The requested Concept script/URL was not found on this server.\n");
    fprintf(stdout, "</BODY>\n");
    return(0);
}

int ConceptCGIClient(int seconds) {
    if (!check_file())
        return(0);
#ifdef _WIN32
    DWORD threadID;
    CreateThread(NULL, 0, thread_main, 0, 0, &threadID);
#else
    //pthread *threadID;
    pthread_t threadID;
    pthread_create(&threadID, NULL, thread_main, 0);
#endif
    int marcseconds = seconds * 100;
    for (int i = 0; i < marcseconds; i++) {
        semp(sem_lock);
        if (done_thread) {
            semv(sem_lock);
            return(0);           //final_res;
        }
        semv(sem_lock);
#ifdef _WIN32
        Sleep(10);
#else
        usleep(10000);
#endif
    }
    if (!_print_begin)
        fprintf(stdout, "%s%c%c%c%c", "Content-Type: text/html", 13, 10, 13, 10);
    fprintf(stdout, "<B>ERROR :</B> Script exceeded maximum execution time of %i seconds.\n", seconds);
    done_thread = 1;

    Done();

    return(0);
}

#ifdef _WIN32

BOOL sigterm_handler(DWORD fdwCtrlType) {
    switch (fdwCtrlType) {
        case CTRL_C_EVENT:
        case CTRL_CLOSE_EVENT:
        case CTRL_BREAK_EVENT:
        case CTRL_LOGOFF_EVENT:
        case CTRL_SHUTDOWN_EVENT:
            Done();
            exit(0);
            break;
    }
    return(FALSE);
}

#else

void sigterm_handler(int sig) {
    Done();
    exit(0);
}

#endif

int main(void) {
#ifdef _WIN32
    HOME_BASE = GetDirectory();
    INI_PATH  = HOME_BASE + INI_FILE;
    SetConsoleCtrlHandler((PHANDLER_ROUTINE)sigterm_handler, TRUE);
#else
    signal(SIGTERM, sigterm_handler);
#endif
    if (!ConceptCGIInit())
#ifdef USE_FCGI
        return(-1);
#else
        return(0);
#endif

    seminit(sem_lock, 1);

    int seconds = GetKey(INI_PATH, "Web", "Timeout", "10").ToInt();
    if (seconds <= 0)
        seconds = 10;

#ifdef USE_FCGI
    int connection_count = 0;
    while (FCGI_Accept() >= 0) {
        if (check_file()) {
            ConceptCGIClient(seconds);
            connection_count++;
            if (connection_count == MAX_FCGI_SERV)
                break;
        } else {
            fprintf(stdout, "%s%c%c%c%c", "Content-Type: text/html", 10, 13, 10, 13);
            fprintf(stdout, "<HEAD><TITLE>404 Not Found</TITLE></HEAD>\n");
            fprintf(stdout, "<BODY><H1>404 Not Found</H1>\n");
            fprintf(stdout, "The requested Concept script/URL was not found on this server.\n");
            fprintf(stdout, "</BODY>\n");
        }
    }
#else
    if (check_file())
        ConceptCGIClient(seconds);
#endif

    ConceptCGIDone();
#ifdef USE_FCGI
    return(1);
#else
    return(0);
#endif
}
