//#define DEBUG

#ifdef _WIN32
 #include <windows.h>
//      #include <sys/utime.h>
#else
 #include <dlfcn.h>        // dlopen

 #define HANDLE     void *
 #define HMODULE    HANDLE

 #define SOCKET     int
 #include <utime.h>
#endif

#include "AnsiString.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>

#ifdef _WIN32
//#include <dir.h>
 #include <direct.h>
#else
 #include <unistd.h>
#endif

#ifdef _WIN32
 #define CMP_FUNC    stricmp
#else
 #define CMP_FUNC    strcmp
//#define LINUX_PATH "/opt/Concept/bin/"
#endif

#ifdef _WIN32
 #define LIBRARY    "concept-core.2.0.dll"
//       #define LIBRARY      "concept_dll.dll"
#else
 #define LIBRARY    "libconceptcore.2.0.so"
#endif

#define INI_FILE    "concept.ini"

typedef int (*GET_VARIABLE_PROC)(int operation, void *VDESC, void *CONTEXT, int Depth, char *VariableName, char *buffer, int buf_size);
typedef int (*DEBUGGER_CALLBACK)(void *VDESC, void *CONTEXT, int Depth, int line, char *filename, GET_VARIABLE_PROC GVP, void *DEBUGGER_RESERVED);

extern "C" {
typedef int (*API_INTERPRETER2)(char *filename, char *inc_dir, char *lib_dir, void *fp, SOCKET sock, int debug, DEBUGGER_CALLBACK DEBUGGER_TRAP, void *DEBUGGER_RESERVED, char *SERVER_PUBLIC_KEY, char *SERVER_PRIVATE_KEY, char *CLIENT_PUBLIC_KEY, int pipe_in, int pipe_out, int apid, int parent, void *userdata);
typedef int (*API_INTERPRETER)(char *filename, char *inc_dir, char *lib_dir, void *fp, SOCKET sock, int debug, DEBUGGER_CALLBACK DEBUGGER_TRAP, void *DEBUGGER_RESERVED, char *SERVER_PUBLIC_KEY, char *SERVER_PRIVATE_KEY, char *CLIENT_PUBLIC_KEY, int pipe_in, int pipe_out, int apid, int parent);
typedef int (*CLI_INIT)(int argc, char **argv);
typedef int (*RESULT_GET)();
}

void Print(char *str, int length) {
    if (length > 0)
        std::cout.write(str, length);
    else
        std::cout << str;
}

static int next_line = 0;
static int step_into = 0;

int DEBUGGER_TRAP(void *VDESC, void *CONTEXT, int Depth, int line, char *filename, GET_VARIABLE_PROC GVP, void *DEBUGGER_RESERVED) {
    // to do !
    char varname[0xFF];
    char buffer[0xFFFF];
    char operation[0xFF];

    if ((!next_line) || (line == next_line) || (line < step_into)) {
        next_line = 0;
        step_into = 0;
        do {
            std::cout << "DEBUGGER TRAPPED ON LINE " << line << ".\r\nOperation ('stepover', 'stepinto', 'watch', 'break', 'goto','run') : ";
            std::cin >> operation;
            if (!strcmp(operation, "stepover")) {
                next_line = line + 1;
                return(0);
            }
            if (!strcmp(operation, "stepinto")) {
                step_into = line;
                return(0);
            }
            if (!strcmp(operation, "break"))
                return(1);
            if (!strcmp(operation, "run")) {
                next_line = -1;
                return(0);
            }
            if (!strcmp(operation, "goto")) {
                std::cout << "Run to line : ";
                std::cin >> next_line;
                return(0);
            }
            if (!strcmp(operation, "watch")) {
                std::cout << "Variable name : ";
                std::cin >> varname;
                if (GVP(0, VDESC, CONTEXT, Depth, varname, buffer, 0xFFFF))
                    std::cout << varname << " : " << buffer << "\r\n";
                else
                    std::cout << varname << " : " << "(variable not defined)\r\n";
            }
        } while (1);
    }
    return(0);
}

#ifndef _WIN32
long GetPrivateProfileString(
    const char *lpAppName,
    const char *lpKeyName,
    const char *lpDefault,
    char       *lpReturnedString,
    long       nSize,
    const char *lpFileName) {
    FILE *in         = 0;
    long filesize    = 0;
    char *filebuffer = 0;
    char section_name[4096];
    char key_name[4096];
    int  error = 0;

    in = fopen(lpFileName, "rb");
    if (in) {
        fseek(in, 0L, SEEK_END);
        filesize = ftell(in);
        fseek(in, 0L, SEEK_SET);
        if (filesize) {
            filebuffer = new char[filesize];
            if (filebuffer) {
                if (fread(filebuffer, 1, filesize, in) == filesize) {
                    char in_name           = 0;
                    char in_quote          = 0;
                    char in_looked_section = 0;
                    char in_looked_key     = 0;
                    char in_looked_value   = 0;
                    char in_comment        = 0;
                    char in_key            = 0;
                    int  temp_pos          = 0;
                    int  key_pos           = 0;
                    int  value_pos         = 0;

                    section_name[0] = 0;
                    key_name[0]     = 0;

                    for (int i = 0; i < filesize; i++) {
                        if (in_comment) {
                            if ((filebuffer[i] == '\n') || (filebuffer[i] == '\r'))
                                in_comment = 0;
                            continue;
                        }

                        if (((filebuffer[i] == '\n') || (filebuffer[i] == '\r')) && (in_looked_value)) {
                            lpReturnedString[value_pos++] = 0;
                            break;
                        }

                        if (!in_quote) {
                            if (filebuffer[i] == ';') {
                                if (in_looked_value)
                                    break;
                                in_comment = 1;
                                continue;
                            }

                            if (filebuffer[i] == '[') {
                                // a inceput o sectziune noua, iar sectziunea precedenta este cea cautata ...
                                if (in_looked_section) {
                                    error = 1;
                                    break;
                                }
                                temp_pos = 0;
                                in_name  = 1;
                                continue;
                            }
                            if (in_name) {
                                if (filebuffer[i] == ']') {
                                    in_name = 0;
                                    section_name[temp_pos] = 0;
                                    if (!CMP_FUNC(section_name, lpAppName))
                                        in_looked_section = 1;
                                    continue;
                                }
                                if ((filebuffer[i] == '\n') || (filebuffer[i] == '\r')) {
                                    in_name = 0;
                                    continue;
                                }
                                if (in_name)
                                    section_name[temp_pos++] = filebuffer[i];
                            }
                        }
                        // schimb flag-ul de ghilimele, daca le-am gasit ...
                        if (!in_name) {
                            if (filebuffer[i] == '"') {
                                in_quote = !in_quote;
                                continue;
                            }
                            if (((filebuffer[i] == '\n') || (filebuffer[i] == '\r')) && (in_quote)) {
                                in_quote = 0;
                                continue;
                            }
                        }

                        if (in_looked_key) {
                            if (filebuffer[i] == '=') {
                                in_looked_value = 1;
                                continue;
                            }
                            if (in_looked_value) {
                                if (value_pos < nSize - 1) {
                                    if (value_pos)
                                        lpReturnedString[value_pos++] = filebuffer[i];
                                    else if ((filebuffer[i] != ' ') && (filebuffer[i] != '\t'))
                                        lpReturnedString[value_pos++] = filebuffer[i];
                                } else {
                                    lpReturnedString[value_pos++] = 0;
                                    break;
                                }
                                continue;
                            }
                        }

                        if (in_looked_section) {
                            if (((filebuffer[i] >= '0') && (filebuffer[i] <= '9')) ||
                                ((filebuffer[i] >= 'a') && (filebuffer[i] <= 'z')) ||
                                ((filebuffer[i] >= 'A') && (filebuffer[i] <= 'Z')) ||
                                (filebuffer[i] == '_')) {
                                if (in_key == 0) {
                                    key_pos = 0;
                                    in_key  = 1;
                                }
                                key_name[key_pos++] = filebuffer[i];
                            } else if (in_key)    {
                                key_name[key_pos] = 0;
                                if (!CMP_FUNC(key_name, lpKeyName))
                                    in_looked_key = 1;
                                in_key = 0;
                            }
                            // TO DO ... sunt in sectiunea cautata ...
                        }
                    }
                } else
                    error = 1;
            } else
                error = 1;
        } else
            error = 1;
        fclose(in);
    } else
        error = 1;

    if (error)
        strncpy(lpReturnedString, lpDefault, nSize);
    return((long)in);
}

#endif

AnsiString GetKey(char *ini_name, char *section, char *key, char *def) {
    char value[4096];

    value[0] = 0;
    GetPrivateProfileString(section, key, def, value, 4096, ini_name);
    return(AnsiString(value));
}

AnsiString GetDirectory() {
#ifdef _WIN32
    char buffer[4096];
    buffer[0] = 0;
    GetModuleFileName(NULL, buffer, 4096);
    for (int i = strlen(buffer) - 1; i >= 0; i--)
        if ((buffer[i] == '/') || (buffer[i] == '\\')) {
            buffer[i + 1] = 0;
            break;
        }
    return(AnsiString(buffer));
#else
    return(LINUX_PATH);
#endif
}

AnsiString SetWebDirectory(AnsiString temp) {
    char       *buffer;
    AnsiString temp2;

    if (temp != (char *)"") {
        buffer = temp.c_str();
        for (int i = strlen(buffer) - 1; i >= 0; i--)
            if ((buffer[i] == '/') || (buffer[i] == '\\')) {
                temp2         = (char *)buffer + i + 1;
                buffer[i + 1] = 0;
                break;
            }
        if ((buffer) && (buffer[0]))
            chdir(buffer);
    }
    return(temp2);
}

int need_compilation(char *filename) {
    AnsiString accel_filename = filename;

    accel_filename += ".accel";
    struct stat buf1, buf2;
    // if some error, report no need for compilation
    if (stat(filename, &buf1))
        return(0);

    if (stat(accel_filename.c_str(), &buf2))
        return(1);

    // last modification time don't match ... need recompilation ...
    if (buf1.st_mtime != buf2.st_mtime)
        return(1);

    return(0);
}

int main(int argc, char **argv) {
    char       *filename = 0;
    AnsiString ftemp;
    HMODULE    hDLL      = 0;
    int        debug     = 0;
    AnsiString HOME_BASE = GetDirectory();

#ifdef _WIN32
    AnsiString INI_PATH = HOME_BASE + INI_FILE;
#endif

#ifdef _WIN32
    AnsiString Library = HOME_BASE + GetKey(INI_PATH, "Paths", "Library", "Library") + "\\";
    AnsiString Include = HOME_BASE + GetKey(INI_PATH, "Paths", "Include", "Include") + "\\";
#else
    AnsiString Library = HOME_BASE + GetKey(INI_PATH, "Paths", "Library", "Library") + "/";
    AnsiString Include = HOME_BASE + GetKey(INI_PATH, "Paths", "Include", "Include") + "/";
#endif
    int  autocompile  = GetKey(INI_PATH, "Run", "AutoCompile", "0").ToInt();
    int  arg_start    = 0;
    char *force_chdir = getenv("CONCEPT_FORCE_CHDIR");
    int  chdir        = 0;
    if (force_chdir)
        chdir = atoi(force_chdir);

    /*if (argc==2) {
     *  filename=argv[1];
     *  arg_start=2;
     * } else*/
    if (argc >= 3) {
        filename = argv[2];
        if (!strcmp(argv[1], "-debug")) {
            debug     = 1;
            arg_start = 3;
        } else
        if (!strcmp(argv[1], "-chdir")) {
            chdir     = 1;
            arg_start = 3;
        } else {
            //std::cout << "USAGE : " << argv[0] << " [-debug] filename\r\n";
            filename  = argv[1];
            arg_start = 2;
            //return -1;
        }
    } else
    if (argc == 2) {
        filename  = argv[1];
        arg_start = 2;
    } else {
        std::cout << "USAGE : " << argv[0] << " [-debug|-chdir] filename [arguments]\r\n";
        return(-1);
    }


    API_INTERPRETER2 Concept_Execute  = 0;
    API_INTERPRETER  Concept_Compiler = 0;
    CLI_INIT         ARGInit          = 0;
    RESULT_GET       LastResult       = 0;
#ifdef _WIN32
    hDLL = LoadLibrary(LIBRARY);
#else
    hDLL = dlopen(/*HOME_BASE+*/ LIBRARY_PATH, RTLD_LAZY);
#endif

    if (!hDLL) {
        std::cout << "Error loading core library '" << LIBRARY << "'\r\n";
        return(-1);
    }

#ifdef _WIN32
    LastResult = (RESULT_GET)GetProcAddress(hDLL, "LastResult");
    if (!LastResult)
        LastResult = (RESULT_GET)GetProcAddress(hDLL, "_LastResult");
#else
    LastResult = (RESULT_GET)dlsym(hDLL, "LastResult");
#endif

#ifdef _WIN32
    ARGInit = (CLI_INIT)GetProcAddress(hDLL, "SetArguments");
    if (!ARGInit)
        ARGInit = (CLI_INIT)GetProcAddress(hDLL, "_SetArguments");
#else
    ARGInit = (CLI_INIT)dlsym(hDLL, "SetArguments");
#endif
    if (ARGInit)
        ARGInit(argc - arg_start, &argv[arg_start]);

#ifdef _WIN32
    Concept_Execute = (API_INTERPRETER2)GetProcAddress(hDLL, "Concept_Execute");
    if (!Concept_Execute)
        Concept_Execute = (API_INTERPRETER2)GetProcAddress(hDLL, "_Concept_Execute");
#else
    Concept_Execute = (API_INTERPRETER2)dlsym(hDLL, "Concept_Execute");
#endif
    if (!Concept_Execute) {
        std::cout << "Corrupted library : '" << LIBRARY << "'\r\n";
        return(-1);
    }

    if (chdir) {
        ftemp = SetWebDirectory(filename);
        if (ftemp.Length())
            filename = ftemp.c_str();
    }

#ifdef _WIN32
    Concept_Compiler = (API_INTERPRETER)GetProcAddress(hDLL, "Concept_Compile");
    if (!Concept_Compiler)
        Concept_Compiler = (API_INTERPRETER)GetProcAddress(hDLL, "_Concept_Compile");
#else
    Concept_Compiler = (API_INTERPRETER)dlsym(hDLL, "Concept_Compile");
#endif
    // check for autocompile
    int res = 0;
    if ((!debug) && (autocompile) && (need_compilation(filename)) && (Concept_Compiler))
        res = Concept_Compiler(filename, Include, Library, (void *)Print, 0, 0, 0, 0, 0, 0, 0, -1, -1, -1, -1);


    if (!res) {
        res = Concept_Execute(filename, Include, Library, (void *)Print, 0, debug, DEBUGGER_TRAP, 0, 0, 0, 0, -1, -1, -1, -1, 0);
        if (res == -3)
            std::cout << "File not found or insufficient rights : " << filename << "\r\n";
        else if (LastResult)
            res = LastResult();
    }

#ifdef _WIN32
    FreeLibrary(hDLL);
#else
    dlclose(hDLL);
#endif

    return(res);
}
