#include "AnsiException.h"

POOLED_IMPLEMENTATION(AnsiException)

AnsiException::AnsiException(AnsiString text, long line, long ID, AnsiString extra, AnsiString FileName, AnsiString class_name, AnsiString member_name) {
    _TEXT   = text;
    _line   = line;
    _FILE   = FileName;
    _ID     = ID;
    _EXTRA  = extra;
    _MEMBER = member_name;
    _CLASS  = class_name;
}

AnsiString AnsiException::GetText() {
    return(_TEXT);
}

AnsiString AnsiException::GetExtra() {
    return(_EXTRA);
}

long AnsiException::GetLine() {
    return(_line);
}

long AnsiException::GetID() {
    return(_ID);
}

AnsiString AnsiException::GetFileName() {
    return(_FILE);
}

AnsiString AnsiException::GetClass() {
    return(_CLASS);
}

AnsiString AnsiException::GetMember() {
    return(_MEMBER);
}

AnsiString AnsiException::ToString() {
    AnsiString result = "Error Code : \t";

    result += AnsiString(_ID);
    result += "\nFile name : \t";
    result += _FILE;
    result += "\nLine number : \t";
    result += AnsiString(_line);
    if (_CLASS != (char *)"") {
        result += "\nIn : \t";
        result += _CLASS;
        if (_MEMBER != (char *)"") {
            if (_CLASS.Length()) {
                result += ".";
            }
            result += _MEMBER;
        }
        result += "\nError text : \t";
    }
    result += _TEXT;
    result += "\nError extra : \t";
    result += _EXTRA;
    result += "\n";
    return(result);
}

AnsiException::~AnsiException(void) {
}
