#ifndef __ANSIEXCEPTION_H
#define __ANSIEXCEPTION_H

#include "AnsiString.h"
#include "Errors.h"
#include "ConceptPools.h"

class AnsiException {
private:
    AnsiString _TEXT;
    AnsiString _EXTRA;
    AnsiString _FILE;
    AnsiString _MEMBER;
    AnsiString _CLASS;
    long       _line;
    long       _ID;
public:
    POOLED(AnsiException)

    AnsiException(AnsiString text, long line, long ID, AnsiString extra, AnsiString FileName, AnsiString class_name = "", AnsiString member_name = "");
    AnsiString GetText();
    AnsiString GetExtra();
    AnsiString GetFileName();
    AnsiString GetClass();
    AnsiString GetMember();
    long GetLine();
    long GetID();

    AnsiString ToString();

    ~AnsiException(void);
};

#endif //__ANSIEXCEPTION_H
