#include "Array.h"
#include "ConceptInterpreter.h"
#include <string.h>

POOLED_IMPLEMENTATION(_KEY)
POOLED_IMPLEMENTATION(_NODE)
POOLED_IMPLEMENTATION(Array)

//--- In line functions ------------------------------------------------------------
#define CREATE_SPACE(count)                                           \
    {                                                                 \
        long         blocks     = count / ARRAY_INCREMENT;            \
        ArrayElement *NEW_SPACE = new ArrayElement [blocks];          \
        memcpy(NEW_SPACE, ELEMENTS, sizeof(ArrayElement) * ALOCATED); \
        ALOCATED = blocks;                                            \
        delete[] ELEMENTS;                                            \
        ELEMENTS = NEW_SPACE;                                         \
    }

#define ADD_LINKED_VARIABLE(var)                          \
    int DISTRIBUTED_COUNT = COUNT % ARRAY_INCREMENT;      \
    int          TARGET_NODE = COUNT / ARRAY_INCREMENT;   \
    ArrayElement *ELEMENTS;                               \
    if (TARGET_NODE >= NODE_COUNT) {                      \
        ELEMENTS = new ArrayElement [ARRAY_INCREMENT];    \
        NODE *NEW_NODE = new NODE;                        \
        LAST->NEXT         = NEW_NODE;                    \
        NEW_NODE->ELEMENTS = ELEMENTS;                    \
        LAST = NEW_NODE;                                  \
        NODE_COUNT++;                                     \
    } else {                                              \
        NODE *CURRENT_NODE = FIRST;                       \
        for (int i = 0; i < TARGET_NODE; i++) {           \
            CURRENT_NODE = CURRENT_NODE->NEXT; }          \
        ELEMENTS = CURRENT_NODE->ELEMENTS;                \
    }                                                     \
    ELEMENTS [DISTRIBUTED_COUNT] = var;                   \
    ELEMENTS [DISTRIBUTED_COUNT]->LINKS++;                \
    ELEMENTS [DISTRIBUTED_COUNT]->CALL_SET           = 0; \
    ELEMENTS [DISTRIBUTED_COUNT]->EXTRA_DATA         = 0; \
    ELEMENTS [DISTRIBUTED_COUNT]->IS_PROPERTY_RESULT = 0; \
                                                          \
    COUNT++;                                              \
                                                          \
    return ELEMENTS [DISTRIBUTED_COUNT];


#define ADD_VARIABLE                                                         \
    int DISTRIBUTED_COUNT = COUNT % ARRAY_INCREMENT;                         \
    int          TARGET_NODE = COUNT / ARRAY_INCREMENT;                      \
    ArrayElement *ELEMENTS;                                                  \
    if (TARGET_NODE >= NODE_COUNT) {                                         \
        ELEMENTS = new ArrayElement [ARRAY_INCREMENT];                       \
        NODE *NEW_NODE = new NODE;                                           \
        LAST->NEXT         = NEW_NODE;                                       \
        NEW_NODE->ELEMENTS = ELEMENTS;                                       \
        LAST = NEW_NODE;                                                     \
        NODE_COUNT++;                                                        \
    } else {                                                                 \
        if ((TARGET_NODE == NODE_COUNT - 1) && (LAST)) {                     \
            ELEMENTS = LAST->ELEMENTS;                                       \
        } else {                                                             \
            NODE *CURRENT_NODE = FIRST;                                      \
            for (int i = 0; i < TARGET_NODE; i++) {                          \
                CURRENT_NODE = CURRENT_NODE->NEXT; }                         \
            ELEMENTS = CURRENT_NODE->ELEMENTS;                               \
        }                                                                    \
    }                                                                        \
    ELEMENTS [DISTRIBUTED_COUNT] = new VariableDATA;                         \
    /*ELEMENTS[DISTRIBUTED_COUNT]->ACCESS                =   ACCESS_LOCAL;*/ \
    ELEMENTS [DISTRIBUTED_COUNT]->TYPE               = VARIABLE_NUMBER;      \
    ELEMENTS [DISTRIBUTED_COUNT]->LINKS              = 1;                    \
    ELEMENTS [DISTRIBUTED_COUNT]->CALL_SET           = 0;                    \
    ELEMENTS [DISTRIBUTED_COUNT]->CLASS_DATA         = 0;                    \
    ELEMENTS [DISTRIBUTED_COUNT]->EXTRA_DATA         = 0;                    \
    ELEMENTS [DISTRIBUTED_COUNT]->IS_PROPERTY_RESULT = 0;                    \
    ELEMENTS [DISTRIBUTED_COUNT]->NUMBER_DATA        = 0;                    \
                                                                             \
    COUNT++;                                                                 \
                                                                             \
    return ELEMENTS [DISTRIBUTED_COUNT];

#define ADD_MULTIPLE_VARIABLE                                                \
    int DISTRIBUTED_COUNT = COUNT % ARRAY_INCREMENT;                         \
    int          TARGET_NODE = COUNT / ARRAY_INCREMENT;                      \
    ArrayElement *ELEMENTS;                                                  \
    if (TARGET_NODE >= NODE_COUNT) {                                         \
        ELEMENTS = new ArrayElement [ARRAY_INCREMENT];                       \
        NODE *NEW_NODE = new NODE;                                           \
        LAST->NEXT         = NEW_NODE;                                       \
        NEW_NODE->ELEMENTS = ELEMENTS;                                       \
        LAST = NEW_NODE;                                                     \
        NODE_COUNT++;                                                        \
    } else {                                                                 \
        NODE *CURRENT_NODE = FIRST;                                          \
        for (int i = 0; i < TARGET_NODE; i++) {                              \
            CURRENT_NODE = CURRENT_NODE->NEXT; }                             \
        ELEMENTS = CURRENT_NODE->ELEMENTS;                                   \
    }                                                                        \
    ELEMENTS [DISTRIBUTED_COUNT] = new VariableDATA;                         \
    /*ELEMENTS[DISTRIBUTED_COUNT]->ACCESS                =   ACCESS_LOCAL;*/ \
    ELEMENTS [DISTRIBUTED_COUNT]->TYPE               = VARIABLE_NUMBER;      \
    ELEMENTS [DISTRIBUTED_COUNT]->LINKS              = 1;                    \
    ELEMENTS [DISTRIBUTED_COUNT]->CALL_SET           = 0;                    \
    ELEMENTS [DISTRIBUTED_COUNT]->CLASS_DATA         = 0;                    \
    ELEMENTS [DISTRIBUTED_COUNT]->EXTRA_DATA         = 0;                    \
    ELEMENTS [DISTRIBUTED_COUNT]->IS_PROPERTY_RESULT = 0;                    \
    ELEMENTS [DISTRIBUTED_COUNT]->NUMBER_DATA        = 0;                    \
                                                                             \
    COUNT++;                                                                 \

#define ADD_MULTIPLE_VARIABLE2                           \
    int DISTRIBUTED_COUNT = COUNT % ARRAY_INCREMENT;     \
    int          TARGET_NODE = COUNT / ARRAY_INCREMENT;  \
    ArrayElement *ELEMENTS;                              \
    if (TARGET_NODE >= NODE_COUNT) {                     \
        ELEMENTS = new ArrayElement [ARRAY_INCREMENT];   \
        NODE *NEW_NODE = new NODE;                       \
        LAST->NEXT         = NEW_NODE;                   \
        NEW_NODE->ELEMENTS = ELEMENTS;                   \
        LAST = NEW_NODE;                                 \
        NODE_COUNT++;                                    \
    } else {                                             \
        if ((TARGET_NODE == NODE_COUNT - 1) && (LAST)) { \
            ELEMENTS = LAST->ELEMENTS;                   \
        } else {                                         \
            NODE *CURRENT_NODE = FIRST;                  \
            for (int i = 0; i < TARGET_NODE; i++) {      \
                CURRENT_NODE = CURRENT_NODE->NEXT; }     \
            ELEMENTS = CURRENT_NODE->ELEMENTS;           \
        }                                                \
    }                                                    \
    ELEMENTS [DISTRIBUTED_COUNT] = 0;                    \
    COUNT++;                                             \

#define CREATE_VARIABLE(DATA)                             \
    {                                                     \
        DATA = new VariableDATA;                          \
        /*DATA->ACCESS                =   ACCESS_LOCAL;*/ \
        DATA->TYPE               = VARIABLE_NUMBER;       \
        DATA->LINKS              = 1;                     \
        DATA->CALL_SET           = 0;                     \
        DATA->CLASS_DATA         = 0;                     \
        DATA->EXTRA_DATA         = 0;                     \
        DATA->IS_PROPERTY_RESULT = 0;                     \
        DATA->NUMBER_DATA        = 0;                     \
    }
//----------------------------------------------------------------------------------

#define FIND_PLACE(KEY)                                 \
    long PLACE = 0;                                     \
    if (KeysCount) {                                    \
        long START = KeysCount / 2;                     \
        long DELTA = KeysCount - START;                 \
        char *str  = KEY->c_str();                      \
        while (1) {                                     \
            int order;                                  \
            if (START < 0) {                            \
                break; }                                \
            if (START >= KeysCount) {                   \
                PLACE = KeysCount;                      \
                break;                                  \
            }                                           \
            if (!DELTA) {                               \
                order  = strcmp(str, Keys [START].KEY); \
                START += (order /*!=-1*/ >= 0);         \
                if (START < 0) {                        \
                    START = 0; }                        \
                else                                    \
                if (START >= KeysCount) {               \
                    START = KeysCount; }                \
                PLACE = START;                          \
                break;                                  \
            } else {                                    \
                order = strcmp(str, Keys [START].KEY);  \
                if (order > 0) {                        \
                    START += DELTA;                     \
                    if (START >= KeysCount) {           \
                        START = KeysCount - 1; }        \
                } else {                                \
                    START -= DELTA;                     \
                    if (START < 0) {                    \
                        START = 0; }                    \
                }                                       \
                DELTA /= 2;                             \
            }                                           \
        }                                               \
    }


#define FIND_KEY(sKEY)                                 \
    long KEY_INDEX = -1;                               \
    if (KeysCount) {                                   \
        long START = KeysCount / 2;                    \
        long DELTA = KeysCount - START;                \
        char *str  = sKEY.c_str();                     \
        while (1) {                                    \
            int order;                                 \
            if ((START < 0) || (START >= KeysCount)) { \
                break; }                               \
            if (!DELTA) {                              \
                order = strcmp(str, Keys [START].KEY); \
                if (!order) {                          \
                    KEY_INDEX = Keys [START].index; }  \
                break;                                 \
            } else {                                   \
                order = strcmp(str, Keys [START].KEY); \
                if (!order) {                          \
                    KEY_INDEX = Keys [START].index;    \
                    break;                             \
                }                                      \
                if (order > 0) {                       \
                    START += DELTA;                    \
                    if (START >= KeysCount) {          \
                        START = KeysCount - 1; }       \
                } else {                               \
                    START -= DELTA;                    \
                    if (START < 0) {                   \
                        START = 0; }                   \
                }                                      \
                DELTA /= 2;                            \
            }                                          \
        }                                              \
    }

//----------------------------------------------------------------------------------
#ifndef SINGLE_PROCESS_DLL
THREADED_FLAG GarbageCollector * Array::__gc_obj = 0;
#endif
//----------------------------------------------------------------------------------

Array::Array() {
#ifdef OPTIMIZE_FAST_ARRAYS
    LastNodeIndex = -1;
    LastNode      = 0;
#endif

    COUNT           = 0;
    FIRST           = new NODE;
    FIRST->NEXT     = 0;
    FIRST->ELEMENTS = new ArrayElement [ARRAY_INCREMENT];

    /*for (int i=0;i<ARRAY_INCREMENT;i++) {
     *  FIRST->ELEMENTS[i]=0;
     *  FIRST->ELEMENTS[i].Key=KEY_NUMBER;
     *  //ELEMENTS[i].nKey=0;
     * }*/
    // faster !!!
    memset(FIRST->ELEMENTS, 0, sizeof(ArrayElement) * ARRAY_INCREMENT);
    Keys       = 0;
    KeysCount  = 0;
    LINKS      = 1;
    LAST       = FIRST;
    NODE_COUNT = 1;
    LastKey    = 0;
    if (!/*Array::*/ __gc_obj) {
        /*Array::*/
        __gc_obj = new GarbageCollector();
    }
    /*Array::*/ __gc_obj->Reference(this);
}

long Array::FindIndex(long index) {
    if (index < COUNT) {
        int  target_node = index / ARRAY_INCREMENT;
        int  d_count     = index % ARRAY_INCREMENT;
        NODE *CURRENT    = FIRST;
        for (int k = 0; k < target_node; k++) {
            CURRENT = CURRENT->NEXT;
        }
        ArrayElement *ELEMENTS = CURRENT->ELEMENTS;
        if (!ELEMENTS [d_count]) {
            return(-1);
        }
        return(index);
    }
    return(-1);
}

long Array::FindKey(AnsiString *KEY) {
    if (!KeysCount) {
        return(-1);
    }

    char *str = KEY->c_str();
    if ((KeysCount > 10) && (LastKey != -1)) {
        if (LastKey < KeysCount) {
            if (!strcmp(str, Keys [LastKey].KEY)) {
                return(Keys [LastKey].index);
            }
        } else
        if (LastKey < KeysCount - 1) {
            if (!strcmp(str, Keys [++LastKey].KEY)) {
                return(Keys [LastKey].index);
            }
        }
    }
    LastKey = -1;

    long START = KeysCount / 2;
    long DELTA = KeysCount - START;
    while (1) {
        int order;
        if ((START < 0) || (START >= KeysCount)) {
            return(-1);
        }
        if (!DELTA) {
            order = strcmp(str, Keys [START].KEY);
            if (!order) {
                LastKey = START;
                return(Keys [START].index);
            }
            return(-1);
        } else {
            order = strcmp(str, Keys [START].KEY);

            if (!order) {
                LastKey = START;
                return(Keys [START].index);
            }

            if (order > 0) {
                // este dupa ...
                START += DELTA;
                if (START >= KeysCount) {
                    START = KeysCount - 1;
                }
            } else {
                // este inainte ...
                START -= DELTA;
                if (START < 0) {
                    START = 0;
                }
            }
            //DELTA/=2;
            DELTA = DELTA == 1 ? 0 : DELTA / 2 + DELTA % 2;
            //DELTA==3 ? DELTA=2 : DELTA/=2;
            //DELTA == (DELTA==1) ? 0 : DELTA/2 + 1;
        }
    }
    return(-1);
}

long Array::FindPlace(AnsiString *KEY) {
    if (!KeysCount) {
        return(0);
    }

    char *str = KEY->c_str();

    if (KeysCount > 10) {
        if (strcmp(str, Keys [KeysCount - 1].KEY) > 0) {
            return(KeysCount);
        }
    }

    long START = KeysCount / 2;
    long DELTA = KeysCount - START;
    while (1) {
        int order;
        if (START < 0) {
            return(0);
        }
        if (START >= KeysCount) {
            return(KeysCount);
        }
        if (!DELTA) {
            order  = strcmp(str, Keys [START].KEY);
            START += (order /*!=-1*/ >= 0);
            if (START < 0) {
                START = 0;
            } else
            if (START >= KeysCount) {
                START = KeysCount;
            }
            return(START);
        } else {
            order = strcmp(str, Keys [START].KEY);

            if (order > 0) {
                // este dupa ...
                START += DELTA;
                if (START >= KeysCount) {
                    START = KeysCount - 1;
                }
            } else {
                // este inainte ...
                START -= DELTA;
                if (START < 0) {
                    START = 0;
                }
            }

            DELTA = DELTA == 1 ? 0 : DELTA / 2 + DELTA % 2;
            //DELTA==3 ? DELTA=2 : DELTA/=2;
            //DELTA == (DELTA==1) ? 0 : DELTA/2 + 1;
        }
    }
    return(START);
}

long Array::AddKey(AnsiString *KEY, long index) {
    if (!(KeysCount % KEY_INCREMENT)) {
        ArrayKey *key2 = new ArrayKey [(KeysCount / KEY_INCREMENT + 1) * KEY_INCREMENT];
        if (Keys) {
            memcpy(key2, Keys, sizeof(ArrayKey) * KeysCount);
            delete[] Keys;
        }
        Keys = key2;
    }
    long place = FindPlace(KEY);

    /*FIND_PLACE(KEY);
     * long place=PLACE;*/

    int len = KEY->Length();
    memmove((void *)&Keys [place + 1], (void *)&Keys [place], sizeof(ArrayKey) * (KeysCount - place));
    Keys [place].KEY   = new char [len + 1];
    Keys [place].index = index;
    memcpy(Keys [place].KEY, KEY->c_str(), len);
    Keys [place].KEY [len] = 0;
    KeysCount++;
    return(KeysCount);
}

VariableDATA *Array::Add(VariableDATA *VAR_TO_ADD) {
    ADD_LINKED_VARIABLE(VAR_TO_ADD);
    return(0);
}

Array *Array::Concat(Array *array) {
    /*for (int i=0;i<NODE_COUNT;i++)
     *  newArray->Add(Get(i));*/
    for (int i = 0; i < array->COUNT; i++) {
        Add(array->Get(i));
    }
    return(this);
}

VariableDATA *Array::Get(long i) {
    if (i < 0) {
        return(0);
    }
    if (i < COUNT) {
        int  target_node = i / ARRAY_INCREMENT;
        int  d_count     = i % ARRAY_INCREMENT;
        NODE *CURRENT    = FIRST;
        for (int k = 0; k < target_node; k++) {
            CURRENT = CURRENT->NEXT;
        }
        ArrayElement *ELEMENTS = CURRENT->ELEMENTS;
        return(ELEMENTS [d_count]);
    }
    return(0);
}

VariableDATA *Array::Get(VariableDATA *KEY) {
    long i = -1;

    if (KEY->TYPE == VARIABLE_NUMBER) {
        i = (long)KEY->NUMBER_DATA;
        if (i < 0) {
            return(0);
        }
    } else
    if (KEY->TYPE == VARIABLE_STRING) {
        i = FindKey(&KEY->STRING_DATA);

        /*FIND_KEY(KEY->STRING_DATA);
         * i=KEY_INDEX;*/
        if (i == -1) {
            AddKey(&KEY->STRING_DATA, COUNT);
            ADD_VARIABLE;
        }
    }

    if (i < COUNT) {
        int target_node = i / ARRAY_INCREMENT;
        int d_count     = i % ARRAY_INCREMENT;

        NODE *CURRENT;
#ifdef OPTIMIZE_FAST_ARRAYS
        if (LastNodeIndex == target_node) {
            CURRENT = LastNode;
        } else
        if ((LastNodeIndex != -1) && (LastNodeIndex < target_node)) {
            CURRENT = LastNode;
            for (int k = LastNodeIndex; k < target_node; k++) {
                CURRENT = CURRENT->NEXT;
            }
            LastNode      = CURRENT;
            LastNodeIndex = target_node;
        } else {
#endif
        CURRENT = FIRST;
        for (int k = 0; k < target_node; k++) {
            CURRENT = CURRENT->NEXT;
        }

#ifdef OPTIMIZE_FAST_ARRAYS
        LastNode      = CURRENT;
        LastNodeIndex = target_node;
    }
#endif
        ArrayElement *ELEMENTS = CURRENT->ELEMENTS;
        if (!ELEMENTS [d_count]) {
            CREATE_VARIABLE(ELEMENTS [d_count]);
        }
        return(ELEMENTS [d_count]);
    }
    long target = i;
    while (COUNT < target) {
        ADD_MULTIPLE_VARIABLE2;
    }
    ADD_VARIABLE;
    return(0);
}

VariableDATA *Array::ModuleGet(long i) {
    if (i < COUNT) {
        int target_node = i / ARRAY_INCREMENT;
        int d_count     = i % ARRAY_INCREMENT;
        NODE *CURRENT   = FIRST;
        for (int k = 0; k < target_node; k++) {
            CURRENT = CURRENT->NEXT;
        }
        ArrayElement *ELEMENTS = CURRENT->ELEMENTS;
        if (!ELEMENTS [d_count]) {
            CREATE_VARIABLE(ELEMENTS [d_count]);
        }
        return(ELEMENTS [d_count]);
    }
    long target = i;
    while (COUNT < target) {
        ADD_MULTIPLE_VARIABLE2;
    }
    ADD_VARIABLE;
    return(0);
}

VariableDATA *Array::ModuleGet(AnsiString key) {
    long i = -1;

    i = FindKey(&key);

    /*FIND_KEY(KEY->STRING_DATA);
     * i=KEY_INDEX;*/
    if (i == -1) {
        AddKey(&key, COUNT);
        ADD_VARIABLE;
    }

    if (i < COUNT) {
        int target_node = i / ARRAY_INCREMENT;
        int d_count     = i % ARRAY_INCREMENT;
        NODE *CURRENT   = FIRST;
        for (int k = 0; k < target_node; k++) {
            CURRENT = CURRENT->NEXT;
        }
        ArrayElement *ELEMENTS = CURRENT->ELEMENTS;
        if (!ELEMENTS [d_count]) {
            CREATE_VARIABLE(ELEMENTS [d_count]);
        }
        return(ELEMENTS [d_count]);
    }
    long target = i;
    while (COUNT < target) {
        ADD_MULTIPLE_VARIABLE2;
    }
    ADD_VARIABLE;
    return(0);
}

void Array::__GO_GARBAGE(AnsiList *__GARBAGE_COLLECTION) {
    NODE *CURRENT = FIRST;
    int d_count   = COUNT % ARRAY_INCREMENT;

    for (int i = 0; i < NODE_COUNT; i++) {
        int target = ARRAY_INCREMENT;
        if (i == NODE_COUNT - 1) {
            target = d_count;
        }
        for (int j = 0; j < target; j++) {
            VariableDATA *Var = CURRENT->ELEMENTS [j];
            if (Var) {
                Var->LINKS--;
                if (Var->CLASS_DATA) {
                    if ((Var->TYPE == VARIABLE_CLASS) || (Var->TYPE == VARIABLE_DELEGATE)) {
                        __GARBAGE_COLLECTION->AddUniquePointer(Var->CLASS_DATA, DATA_COMPILED_CLASS);
                    } else
                    if (Var->TYPE == VARIABLE_ARRAY) {
                        __GARBAGE_COLLECTION->AddUniquePointer(Var->CLASS_DATA, DATA_ARRAY);
                    }

                    Var->CLASS_DATA = 0;
                    Var->TYPE       = VARIABLE_NUMBER;
                }
                if (!Var->LINKS) {
                    delete Var;
                }
                CURRENT->ELEMENTS [j] = 0;
            }
        }
        CURRENT = CURRENT->NEXT;
    }
}

VariableDATA *Array::NewArray() {
    VariableDATA *DATA = new VariableDATA;
    Array *newARRAY    = new Array();

    DATA = new VariableDATA;
    //DATA->ACCESS                =   ACCESS_LOCAL;
    DATA->TYPE               = VARIABLE_ARRAY;
    DATA->LINKS              = 0;
    DATA->CALL_SET           = 0;
    DATA->CLASS_DATA         = newARRAY;
    DATA->EXTRA_DATA         = 0;
    DATA->IS_PROPERTY_RESULT = 0;
    DATA->NUMBER_DATA        = 0;

    newARRAY->Concat(this);

    /*for (int i=0;i<KeysCount;i++) {
     *  newARRAY->Keys=new ArrayKey[(KeysCount/KEY_INCREMENT+1)*KEY_INCREMENT];
     *  newARRAY->KeysCount=KeysCount;
     *  memcpy(newARRAY->Keys,Keys,sizeof(ArrayKey)*KeysCount);
     *
     *  // to do !!! ... new Key[0].Key ...
     * }*/

    return(DATA);
}

int Array::Count() {
    return(COUNT);
}

char *Array::GetKey(long index) {
    for (long i = 0; i < KeysCount; i++) {
        if (Keys [i].index == index) {
            return(Keys [i].KEY);
        }
    }
    return(0);
}

long Array::GetIndex(char *Key) {
    for (long i = 0; i < KeysCount; i++) {
        if (!strcmp(Keys [i].KEY, Key)) {
            return(Keys [i].index);
        }
    }
    return(-1);
}

#define DO_LEVEL(RESULT, LEVEL)    for (int lev_index = 0; lev_index < LEVEL; lev_index++) { RESULT += "\t"; }

AnsiString Array::ToString(int level, Array *parent, int parents) {
    AnsiString result;

    DO_LEVEL(result, level)

    result += "Array {\n";

    for (long i = 0; i < COUNT; i++) {
        VariableDATA *VD = this->Get(i);
        if (VD) {
            DO_LEVEL(result, level)

            AnsiString key = AnsiString(GetKey(i));
            result        += "\t";
            result        += "[";
            result        += AnsiString(i);
            if (key != NULL_STRING) {
                result += ",\"";
                result += key;
                result += "\"] => ";
            } else {
                result += "] => ";
            }
            switch (VD->TYPE) {
                case VARIABLE_NUMBER:
                    result += AnsiString(VD->NUMBER_DATA);
                    break;

                case VARIABLE_STRING:
                    result += VD->STRING_DATA;
                    break;

                case VARIABLE_ARRAY:
                    {
                        Array *arr = (Array *)VD->CLASS_DATA;
                        if (arr == this) {
                            result += "This array";
                        } else
                        if (arr == parent) {
                            result += "Parent array";
                        } else
                        if (level > 10) {
                            result += "Array";
                        } else {
                            result += "\n";
                            result += arr->ToString(level + 2, this);
                        }
                    }
                    break;

                case VARIABLE_CLASS:
                    result += ((CompiledClass *)VD->CLASS_DATA)->_Class->NAME;
                    break;

                case VARIABLE_DELEGATE:
                    result += ((CompiledClass *)VD->CLASS_DATA)->_Class->NAME;
                    result += "::";
                    result += ((CompiledClass *)VD->CLASS_DATA)->_Class->pMEMBERS [((CompiledClass *)VD->CLASS_DATA)->_Class->RELOCATIONS [(INTEGER)VD->NUMBER_DATA] - 1]->NAME.c_str();
                    break;
            }
            result += "\n";
        }
    }
    DO_LEVEL(result, level)

    result += "}";
    return(result);
}

void Array::UnlinkObjects() {
    NODE *CURRENT = FIRST;
    int d_count   = COUNT % ARRAY_INCREMENT;

    for (int i = 0; i < NODE_COUNT; i++) {
        int target = ARRAY_INCREMENT;
        if (i == NODE_COUNT - 1) {
            target = d_count;
        }
        for (int j = 0; j < target; j++) {
            VariableDATA *Var = CURRENT->ELEMENTS [j];
            if (Var) {
                // don't delete any object ! ... it's the garbage collector's job
                if (Var->CLASS_DATA) {
                    Var->TYPE       = VARIABLE_NUMBER;
                    Var->CLASS_DATA = 0;

                    FREE_VARIABLE(Var);
                }
            }
        }
        NODE *NEXT = CURRENT->NEXT;

        delete[] CURRENT->ELEMENTS;
        delete CURRENT;
        CURRENT = NEXT;
    }
    COUNT      = 0;
    FIRST      = 0;
    NODE_COUNT = 0;
}

Array::~Array() {
    /*Array::*/
    __gc_obj->Unreference(this);
    this->LINKS = -1;

    NODE *CURRENT = FIRST;
    int d_count   = COUNT % ARRAY_INCREMENT;
    for (int i = 0; i < NODE_COUNT; i++) {
        int target = ARRAY_INCREMENT;
        if (i == NODE_COUNT - 1) {
            target = d_count;
        }
        for (int j = 0; j < target; j++) {
            VariableDATA *Var = CURRENT->ELEMENTS [j];
            if (Var) {
                FREE_VARIABLE(Var);
            }
        }
        NODE *NEXT = CURRENT->NEXT;

        delete[] CURRENT->ELEMENTS;
        delete CURRENT;
        CURRENT = NEXT;
    }
    if (Keys) {
        for (long i = 0; i < KeysCount; i++) {
            if (Keys [i].KEY) {
                delete[] Keys [i].KEY;
            }
        }
        delete[] Keys;
    }

    /*#ifdef SINGLE_PROCESS_DLL
     *      if (__gc_obj)
     *              delete __gc_obj;
     #endif*/
}

Array *Array::SortArrayElementsByKey() {
    Array *newARRAY = new Array();

    for (int i = 0; i < KeysCount; i++) {
        AnsiString key = Keys [i].KEY;
        newARRAY->Add(Get(Keys [i].index));
        newARRAY->AddKey(&key, i);
    }

    return(newARRAY);
}
