#ifndef __ARRAY_H
#define __ARRAY_H

#define OPTIMIZE_FAST_ARRAYS

#include "AnsiString.h"
#include "ConceptTypes.h"
#include "AnsiList.h"
#include "GarbageCollector.h"
#include "ConceptPools.h"

#define     KEY_NUMBER    0

//#define     ARRAY_INCREMENT             0xA00
//#define     KEY_INCREMENT               0xA00
#define     ARRAY_INCREMENT    0x2F
#define     KEY_INCREMENT      0x2F

#define ArrayElement           VariableDATA *

/*typedef struct _ArrayElement {
 *  long            Key;
 *  VariableDATA    *DATA;
 * } ArrayElement;*/

typedef struct _KEY {
    char *KEY;
    long index;

    POOLED(_KEY)
} ArrayKey;

typedef struct _NODE {
    ArrayElement *ELEMENTS;
    _NODE        *NEXT;

    POOLED(_NODE)
} NODE;

class Array {
private:
#ifdef OPTIMIZE_FAST_ARRAYS
    long LastNodeIndex;
    NODE *LastNode;
#endif
    ArrayKey * Keys;
    long LastKey;
    long KeysCount;

    NODE *FIRST;
    NODE *LAST;
    int  NODE_COUNT;
    long COUNT;

    long AddKey(AnsiString *KEY, long index);
    long FindPlace(AnsiString *KEY);

public:
    POOLED(Array)

    long FindKey(AnsiString *KEY);
    long FindIndex(long index);

    int LINKS;
    int Count();

    STATIC_FLAG GarbageCollector *__gc_obj;

    void __GO_GARBAGE(AnsiList *__GARBAGE_COLLECTION);
    void UnlinkObjects();

    VariableDATA *NewArray();

    char *GetKey(long);
    long         GetIndex(char *Key);

    VariableDATA *Get(long);
    VariableDATA *Get(VariableDATA *KEY);
    VariableDATA *Add(VariableDATA *VAR_TO_ADD);

    VariableDATA *ModuleGet(AnsiString key);
    VariableDATA *ModuleGet(long);

    Array *SortArrayElementsByKey();

    AnsiString ToString(int level = 0, Array *parent = 0, int parents = 0);
    Array *Concat(Array *array);

    Array();
    ~Array();
};

#endif // __ARRAY_H
