#ifndef __CLASSCODE
#define __CLASSCODE

#include "AnsiString.h"
#include "AnsiList.h"
#include "StaticList.h"
#include "ClassMember.h"
#include "PIFAlizator.h"
#include "CompiledClass.h"
#include "Optimizer.h"
#include "Array.h"
#include "GarbageCollector.h"
#include "ConceptPools.h"
#include <stdio.h>

#define THIS_CLASS    "this"

// bug in obfuscate
class PIFAlizator;
class CompiledClass;

class ClassCode {
    friend class PIFAlizator;
    friend class ConceptInterpreter;
    friend class CompiledClass;
    friend class Optimizer;
    friend class ClassMember;
    friend class Array;
    friend INTEGER Invoke(INTEGER, ...);
    friend int GetVariableByName(int operation, void **VDESC, void **CONTEXT, int Depth, char *VariableName, char *buffer, int buf_size);

    friend INTEGER GetClassMember(void *CLASS_PTR, char *class_member_name, INTEGER *TYPE, char **STRING_VALUE, NUMBER *NUMBER_VALUE);

    friend INTEGER GetClassMemberVariable(void *CLASS_PTR, char *class_member_name, void **ptr);

    friend VariableDATA *GetClassMember(void *CLASS_PTR, char *class_member_name);

    friend INTEGER SetClassMember(void *CLASS_PTR, char *class_member_name, INTEGER TYPE, char *STRING_VALUE, NUMBER NUMBER_VALUE);

private:
    AnsiString NAME;
    AnsiList   *Members;
    TinyString _DEBUG_INFO_FILENAME;
    //AnsiList    PIFGarbage;
    void *first_parent;
    STATIC_FLAG PIFAlizator *PIF;
    INTEGER     CONSTRUCTOR;
    ClassMember *CONSTRUCTOR_MEMBER;

    INTEGER     DESTRUCTOR;
    ClassMember *DESTRUCTOR_MEMBER;

    INTEGER CLSID;
    char    NEEDED;
    char    DEFINED_LEVEL;
    //char        has_equal;

    ParamList *EMPTY_PARAM_LIST;
    ParamList *ONE_PARAM_LIST;

    ClassMember **pMEMBERS;
    /*INTEGER*/ unsigned short pMEMBERS_COUNT;

    INTEGER *RELOCATIONS;

    unsigned short *RELOCATIONS2;
    unsigned short DataMembersCount;

public:
    POOLED(ClassCode)
    GarbageCollector __gc_obj;

    int Inherits(INTEGER CLSID);
    int GetAbsoluteMemberID(int mid);
    int BoundMember(ClassMember *CM, ClassCode *Sender);
    int HasMember(char *name);
    int HasMemberInCompiled(char *name, INTEGER *is_variable = NULL);
    ClassMember *MemberID(int mid);
    int GetSerialMembers(CompiledClass *CC, int max_members, char **pmembers, char *flags, char *access, char *types, char **szValue, double *n_data, void **class_data, void **variable_data);
    int CanBeRunStatic(char *name);

    ClassCode(char *name, PIFAlizator *P);
    ClassMember *AddLinked(ClassMember *CM_i);
    ClassMember *AddMember(char *name, INTEGER line, char *FileName, INTEGER ACCESS, char data_only);
    int RemoveMember(char *name, INTEGER line, char *FileName);

    // AnalizerElement AE l-am pus doar pentru informatziile de debug
    // next_is_asg l-am pus sa stiu daca nu cumva e o proprietate dupa care urmeaza egal ... ceea ce inseamna ca va urma un set de proprietate
    VariableDATA *ExecuteMember(INTEGER i, VariableDATA *Owner, AnalizerElement *AE, INTEGER local, ParamList *FORMAL_PARAM, VariableDATA **SenderCTX, char property /*=0*/, INTEGER CLSID /*=0*/, INTEGER LOCAL_CLSID, char next_is_asg = 0);
    VariableDATA *ExecuteDelegate(INTEGER i, VariableDATA *Owner, AnalizerElement *AE, ParamList *FORMAL_PARAM, VariableDATA **SenderCTX, INTEGER CLSID, INTEGER LOCAL_CLSID);

    TinyString *GetFilename(INTEGER LOCAL_CLSID, TinyString *default_Value);

    void SetProperty(INTEGER i, VariableDATA *Owner, AnalizerElement *AE, INTEGER local, INTEGER VALUE, VariableDATA **SenderCTX, INTEGER CLSID, INTEGER LOCAL_CLSID);
    CompiledClass *CreateInstance(VariableDATA *Owner, AnalizerElement *AE, ParamList *FORMAL_PARAM, VariableDATA **SenderCTX);
    void GenerateCode(StaticList *GeneralMembers);
    int Serialize(FILE *out, bool is_lib = false);
    int Unserialize(concept_FILE *in, AnsiList *ClassList, bool is_lib = false, int *ClassNames = 0, int *Relocation = 0);
    static int ComputeSharedSize(concept_FILE *in, int general_members);

    static void Hibernate(void *);
    void UpdateNeeded();

    ~ClassCode();
};

#endif // __CLASSCODE
