#include "ClassMember.h"
#include "Optimizer.h"
#include "ConceptInterpreter.h"

//#define EMPIRIC_STACK_CHECK
POOLED_IMPLEMENTATION(ExecutableMember)
POOLED_IMPLEMENTATION(ClassMember)

ClassMember::ClassMember(void *DefinedIn, char *name, /*AnsiString Filename,*/ char is_data_only, char _not_binary, char is_unserialize) {
    NAME   = name;
    ACCESS = ACCESS_PUBLIC;

    IS_FUNCTION           = 0;
    IS_STATIC             = 0;
    IS_OPERATOR           = 0;
    MEMBER_SET            = 0;
    MEMBER_GET            = 0;
    OPTIMIZER             = 0;
    INTERPRETER           = 0;
    PARAMETERS_COUNT      = 0;
    MUST_PARAMETERS_COUNT = 0;

    OPTIMIZER   = 0;
    INTERPRETER = 0;

    //MEMBER_TRIGERS =   0;
    Defined_In       = DefinedIn;
    _DEBUG_STARTLINE = 0;
    //_DEBUG_INFO_FILENAME = Filename;

    VD = 0;
    if (is_data_only) {
        if (!is_unserialize) {
            VD = new SmallVariableDESCRIPTOR;
            //VD->BY_REF  =   0;
            //VD->USED     =   1;
            ////VD->name     =   name;
            VD->TYPE   = VARIABLE_NUMBER;
            VD->value  = "0";
            VD->nValue = 0;
        }                 /*else
                           * VD           =   0;*/
        VariableDescriptors = 0;
        PIF_DATA            = 0;
    } else {
        //VD=0;
        //VariableDescriptors=new AnsiList();
        if (_not_binary) {
            PIF_DATA            = new AnsiList();
            VariableDescriptors = new AnsiList();
        } else {
            PIF_DATA = 0;
            // april 6, 2010
            VariableDescriptors = 0;
        }
    }
}

void ClassMember::EnsureVD() {
    if (VD) {
        return;
    }
    VD = new SmallVariableDESCRIPTOR;
    //VD->BY_REF  =   0;
    //VD->USED     =   1;
    VD->TYPE   = VARIABLE_NUMBER;
    VD->value  = "0";
    VD->nValue = 0;
}

int ClassMember::Serialize(FILE *out, bool is_lib) {
    //NAME.Serialize(out,SERIALIZE_16BIT_LENGTH);
    concept_fwrite(&ACCESS, sizeof(ACCESS), 1, out);
    char is_funtion_or_operator = IS_FUNCTION;
    if (IS_OPERATOR) {
        is_funtion_or_operator = -1;
    }

    concept_fwrite(&is_funtion_or_operator, sizeof(is_funtion_or_operator), 1, out);
    if (IS_FUNCTION == 2) {
        concept_fwrite(&MEMBER_GET, sizeof(MEMBER_GET), 1, out);
    } else
    if (IS_FUNCTION == 3) {
        concept_fwrite(&MEMBER_SET, sizeof(MEMBER_SET), 1, out);
        concept_fwrite(&MEMBER_GET, sizeof(MEMBER_GET), 1, out);
    } else
    if (IS_FUNCTION == 1) {
        concept_fwrite(&PARAMETERS_COUNT, sizeof(PARAMETERS_COUNT), 1, out);
        concept_fwrite(&MUST_PARAMETERS_COUNT, sizeof(PARAMETERS_COUNT), 1, out);
        concept_fwrite(&IS_STATIC, sizeof(IS_STATIC), 1, out);
    }

    /*INTEGER defined_in_index=-1;
     * if (Defined_In)
     *  defined_in_index=((ClassCode *)Defined_In)->CLSID;
     * concept_fwrite(&defined_in_index,sizeof(defined_in_index),1,out);*/

    SmallVariableDESCRIPTOR DUMMY;
    //DUMMY.BY_REF=0;
    DUMMY.nValue = 0;
    DUMMY.TYPE   = VARIABLE_NUMBER;
    //DUMMY.USED=0;

    SmallVariableDESCRIPTOR *refVD = &DUMMY;
    if (VD) {
        refVD = VD;
    }

    SERIALIZE_SMALL_VAR_DESCRIPTOR(refVD, out);
    if (IS_FUNCTION == 1) {
        ((Optimizer *)OPTIMIZER)->Serialize(out, (INTEGER)is_lib);
    }
    return(0);
}

int ClassMember::ComputeSharedSize(concept_FILE *in, char& IS_FUNCTION) {
    int  size = 0;
    char ACCESS;
    char IS_OPERATOR;

    FREAD_FAIL(&ACCESS, sizeof(ACCESS), 1, in);
    FREAD_FAIL(&IS_FUNCTION, sizeof(IS_FUNCTION), 1, in);
    if (IS_FUNCTION < 0) {
        IS_OPERATOR = 1;
        IS_FUNCTION = 1;
    }
    if (IS_FUNCTION == 2) {
        // MEMBER_GET;
        SKIP(sizeof(INTEGER), in);
    } else
    if (IS_FUNCTION == 3) {
        // MEMBER_GET
        SKIP(sizeof(INTEGER), in);
        // MEMBER_SET
        SKIP(sizeof(INTEGER), in);
    } else
    if (IS_FUNCTION == 1) {
        //PARAMETERS_COUNT
        SKIP(sizeof(unsigned short), in)
        //MUST_PARAMETERS_COUNT
        SKIP(sizeof(unsigned short), in);
        // daca este functie, atunci citesc si "IS_STATIC"
        SKIP(1, in);
        size += sizeof(AnsiList);                    //VariableDescriptors
    }
    VariableDESCRIPTOR VD;
    UNSERIALIZE_VAR_DESCRIPTOR_SIZE((&VD), in);
    int vd_size = VD.value.Length();
    if (vd_size) {
        size += vd_size + 1;
    }
    return(size);
}

int ClassMember::Unserialize(concept_FILE *in, AnsiList *ClassList /*, AnsiList *ModuleList*/, bool is_lib, int *Relocation, int *ClassNames) {
    //NAME.Unserialize(in,SERIALIZE_16BIT_LENGTH);
    concept_fread(&ACCESS, sizeof(ACCESS), 1, in);
    concept_fread(&IS_FUNCTION, sizeof(IS_FUNCTION), 1, in);
    if (IS_FUNCTION < 0) {
        IS_OPERATOR = 1;
        IS_FUNCTION = 1;
    }

    if (IS_FUNCTION == 2) {
        concept_fread(&MEMBER_GET, sizeof(MEMBER_GET), 1, in);
        if (is_lib) {
            MEMBER_GET = Relocation [MEMBER_GET - 1] + 1;
        }
    } else
    if (IS_FUNCTION == 3) {
        concept_fread(&MEMBER_SET, sizeof(MEMBER_SET), 1, in);
        concept_fread(&MEMBER_GET, sizeof(MEMBER_GET), 1, in);
        if (is_lib) {
            if (MEMBER_SET) {
                MEMBER_SET = Relocation [MEMBER_SET - 1] + 1;
            }
            if (MEMBER_GET) {
                MEMBER_GET = Relocation [MEMBER_GET - 1] + 1;
            }
        }
    } else
    if (IS_FUNCTION == 1) {
        concept_fread(&PARAMETERS_COUNT, sizeof(PARAMETERS_COUNT), 1, in);
        concept_fread(&MUST_PARAMETERS_COUNT, sizeof(PARAMETERS_COUNT), 1, in);
        // daca este functie, atunci citesc si "IS_STATIC"
        concept_fread(&IS_STATIC, sizeof(IS_STATIC), 1, in);
        // removed on april 6, 2010
        //VariableDescriptors=new AnsiList();
    }

    /*INTEGER defined_in_index=-1;
     * concept_fread(&defined_in_index,sizeof(defined_in_index),1,in);
     * if (defined_in_index>-1)
     *  Defined_In=ClassList->Item(defined_in_index);
     * else
     *  Defined_In=0;*/

    SmallVariableDESCRIPTOR DUMMY;
    //DUMMY.BY_REF=0;
    DUMMY.nValue = 0;
    DUMMY.TYPE   = VARIABLE_NUMBER;
    //DUMMY.USED=0;

    SmallVariableDESCRIPTOR *refVD = &DUMMY;
    if (!IS_FUNCTION) {
        this->EnsureVD();
        refVD = VD;
    } else {
        VD = 0;
    }

    if (!IS_FUNCTION) {
        refVD->value = (char *)"";
    }

    UNSERIALIZE_SMALL_VAR_DESCRIPTOR(refVD, in, false);
    //refVD->USED=1;

    /*if (IS_FUNCTION==1)
     *  ((Optimizer *)OPTIMIZER)->Unserialize(in, ModuleList);*/
    return(0);
}

ClassMember::~ClassMember(void) {
    if (OPTIMIZER) {
        if (MEMBER_GET != -1) {
            delete (Optimizer *)OPTIMIZER;
        }
    }

    if (INTERPRETER) {
        delete (ConceptInterpreter *)INTERPRETER;
    }

    if (VariableDescriptors) {
        delete VariableDescriptors;
    }

    if (PIF_DATA) {
        delete PIF_DATA;
    }

    //std::cout << "Deleting VD: " << VD << ", this: " << this << ", " << this->NAME.c_str() << "\n";
    //if ((!IS_FUNCTION) && (VD))
    if (VD) {
        delete VD;
    }
}

#ifdef EMPIRIC_STACK_CHECK
// o mica implementare ... asa ... empirica pentru a bloca stack overflow-ul
static int STACK_HIT = 0;
 #define MAX_RECURSIVE_CALL    2100
#endif

VariableDATA *ClassMember::Execute(long CONCEPT_CLASS_ID, VariableDATA *Owner, ParamList *FORMAL_PARAM, VariableDATA **SenderCTX, VariableDATA *& THROW_DATA) {
#ifdef EMPIRIC_STACK_CHECK
    if (++STACK_HIT > MAX_RECURSIVE_CALL) {
        ((Optimizer *)OPTIMIZER)->PIFOwner->Errors.Add(new AnsiException(ERR840, _DEBUG_STARTLINE, 840, NAME, _DEBUG_FILENAME), DATA_EXCEPTION);
        return(0);
    }
#endif

    //int PUSHED_CLSID=((ConceptInterpreter *)INTERPRETER)->ClassID;
    //((ConceptInterpreter *)INTERPRETER)->ClassID=CONCEPT_CLASS_ID;
    if (!this->INTERPRETER) {
        this->INTERPRETER = new ConceptInterpreter((Optimizer *)OPTIMIZER, ((Optimizer *)this->OPTIMIZER)->PIFOwner->out, &((Optimizer *)this->OPTIMIZER)->PIFOwner->ClassList, ((ClassCode *)Defined_In)->CLSID, this, ((Optimizer *)this->OPTIMIZER)->PIFOwner->DEBUGGER_TRAP, ((Optimizer *)this->OPTIMIZER)->PIFOwner->DEBUGGER_RESERVED, ((Optimizer *)this->OPTIMIZER)->PIFOwner->SERVER_PUBLIC_KEY, ((Optimizer *)this->OPTIMIZER)->PIFOwner->SERVER_PRIVATE_KEY, ((Optimizer *)this->OPTIMIZER)->PIFOwner->CLIENT_PUBLIC_KEY);
    }

    VariableDATA **CONTEXT = ((ConceptInterpreter *)INTERPRETER)->CreateEnviroment(Owner, FORMAL_PARAM, SenderCTX);
    VariableDATA *RESULT   = ((ConceptInterpreter *)INTERPRETER)->Interpret(CONTEXT, CONCEPT_CLASS_ID);
    THROW_DATA = ((ConceptInterpreter *)INTERPRETER)->THROW_DATA;
    if (CONTEXT) {
        ((ConceptInterpreter *)INTERPRETER)->DestroyEnviroment(CONTEXT);
    }

#ifdef EMPIRIC_STACK_CHECK
    --STACK_HIT;
#endif
    if (RESULT) {
        RESULT->LINKS--;
    }
    //((ConceptInterpreter *)INTERPRETER)->ClassID=PUSHED_CLSID;
    return(RESULT);
}
