#ifndef __CLASSMEMBER
#define __CLASSMEMBER

#include "AnsiString.h"
#include "AnsiList.h"
#include "ConceptTypes.h"
#include "Errors.h"
#include "AnsiException.h"
#include "ConceptPools.h"

#include <stdio.h>

#define ENOUGH_PARAMETERS(__CM, __FORMAL_PARAM)    ((__FORMAL_PARAM->COUNT >= __CM->MUST_PARAMETERS_COUNT) && (__FORMAL_PARAM->COUNT <= __CM->PARAMETERS_COUNT)) ? 1 : 0


/*#define FAST_EXECUTE_MEMBER(RESULT,CM,CONCEPT_CLASS_ID, Owner, FORMAL_PARAM,SenderCTX,THROW_DATA) \
 \
 \  ((ConceptInterpreter *)CM->INTERPRETER)->ClassID=CONCEPT_CLASS_ID; \
 \
 \  VariableDATA **CONTEXT=((ConceptInterpreter *)CM->INTERPRETER)->CreateEnviroment(Owner, FORMAL_PARAM, SenderCTX); \
 \  RESULT=((ConceptInterpreter *)CM->INTERPRETER)->Interpret(CONTEXT); \
 \  THROW_DATA=((ConceptInterpreter *)CM->INTERPRETER)->THROW_DATA; \
 \  if (CONTEXT) \
 \      ((ConceptInterpreter *)CM->INTERPRETER)->DestroyEnviroment(CONTEXT); \
 \
 \  if (RESULT) \
 \      RESULT->LINKS--; \
 */

/*class ExecutableMember {
 * public:
 *              POOLED(ExecutableMember)
 *      AnsiList *PIF_DATA;
 *      //AnsiList OPTIMIZED_DATA;
 *      AnsiList *VariableDescriptors;
 *
 *      //AnsiList Parameters;
 *
 *      void *OPTIMIZER;
 *      void *INTERPRETER;
 *
 *      //INTEGER IS_FUNCTION;
 *      char    IS_OPERATOR;
 *      char    IS_FUNCTION;
 *      char    IS_STATIC;
 *      //INTEGER MEMBER_TRIGERS;
 *      INTEGER MEMBER_SET;
 *      INTEGER MEMBER_GET;
 *
 *      unsigned short PARAMETERS_COUNT;
 *      unsigned short MUST_PARAMETERS_COUNT;
 *
 *      ExecutableMember1() {
 *              IS_FUNCTION =   0;
 *              IS_STATIC   =   0;
 *              IS_OPERATOR =   0;
 *              MEMBER_SET  =   0;
 *              MEMBER_GET  =   0;
 *              OPTIMIZER   =   0;
 *              INTERPRETER =   0;
 *              PARAMETERS_COUNT =  0;
 *              MUST_PARAMETERS_COUNT=0;
 *
 *              PIF_DATA=0;
 *              VariableDescriptors=0;
 *              OPTIMIZER=0;
 *              INTERPRETER=0;
 *      }
 * };
 */
class ClassCode;

class ClassMember {
    friend class ClassCode;
    friend class Optimizer;
    friend class PIFAlizator;
    friend class CompiledClass;
    friend class ConceptInterpreter;
    friend class Array;
    friend INTEGER Invoke(INTEGER, ...);
    friend int GetVariableByName(int operation, void **VDESC, void **CONTEXT, int Depth, char *VariableName, char *buffer, int buf_size);

    friend INTEGER GetClassMember(void *CLASS_PTR, char *class_member_name, INTEGER *TYPE, char **STRING_VALUE, NUMBER *NUMBER_VALUE);

    friend VariableDATA *GetClassMember(void *CLASS_PTR, char *class_member_name);

    friend INTEGER SetClassMember(void *CLASS_PTR, char *class_member_name, INTEGER TYPE, char *STRING_VALUE, NUMBER NUMBER_VALUE);

private:
    unsigned short _DEBUG_STARTLINE;
    //AnsiString _DEBUG_INFO_FILENAME;

    TinyString NAME;

    char ACCESS;
    SmallVariableDESCRIPTOR *VD;

    AnsiList *PIF_DATA;
    //AnsiList OPTIMIZED_DATA;
    AnsiList *VariableDescriptors;

    //AnsiList Parameters;

    void *OPTIMIZER;
    void *INTERPRETER;

    //INTEGER IS_FUNCTION;
    char IS_OPERATOR;
    char IS_FUNCTION;
    char IS_STATIC;
    //INTEGER MEMBER_TRIGERS;
    INTEGER MEMBER_SET;
    INTEGER MEMBER_GET;

    unsigned short /*INTEGER*/ PARAMETERS_COUNT;
    unsigned short /*INTEGER*/ MUST_PARAMETERS_COUNT;

    //VariableDATA    *THROW_DATA;
    void *Defined_In;
public:
    POOLED(ClassMember)

    ClassMember(void *DefinedIn, char *name /*,AnsiString Filename*/, char is_data_only, char _not_binary = 1, char is_unserialize = false);
    ~ClassMember(void);
    VariableDATA *Execute(long CONCEPT_CLASS_ID, VariableDATA *Owner, ParamList *FORMAL_PARAM, VariableDATA **SenderCTX, VariableDATA *& THROW_DATA);

    void EnsureVD();

    int Serialize(FILE *out, bool is_lib = false);
    int Unserialize(concept_FILE *in, AnsiList *ClassList /*, AnsiList *ModuleList*/, bool is_lib, int *Relocation, int *ClassNames);
    static int ComputeSharedSize(concept_FILE *in, char& IS_FUNCTION);
};


#endif // __CLASSMEMBER
