#include "CompiledClass.h"
#include "ClassMember.h"
#include "ConceptInterpreter.h"

POOLED_IMPLEMENTATION(CompiledClass)
CompiledClass::CompiledClass(ClassCode *CC) {
    _Class   = CC;
    _CONTEXT = 0;
    LINKS    = 0;
    unsigned short *RELOCATIONS2 = CC->RELOCATIONS2;
    //---------------------------------
    INTEGER Count  = _Class->DataMembersCount; //_Class->pMEMBERS_COUNT;
    INTEGER Count2 = _Class->pMEMBERS_COUNT;
    if ((Count) && (RELOCATIONS2)) {           // <== conditie adaugata de curand ...
        _CONTEXT = new VariableDATA * [Count];
        for (register INTEGER i = 0; i < Count2; i++) {
            register unsigned short reloc = RELOCATIONS2 [i];
            if (reloc) {
                reloc--;
                ClassMember *CM = _Class->pMEMBERS [i];
                _CONTEXT [reloc] = 0;
                // conditzie adaugata de curand (2 decembrie, 2006)
                if ((CM) && (!CM->IS_FUNCTION)) {
                    if ((CM->VD->TYPE != VARIABLE_NUMBER) || (CM->VD->nValue)) {
                        VariableDATA *_CONTEXT_i = new VariableDATA;
                        _CONTEXT [reloc] = _CONTEXT_i;
                        if (CM->VD->TYPE == VARIABLE_ARRAY) {
                            _CONTEXT_i->CLASS_DATA = new Array();
                        } else {
                            _CONTEXT_i->CLASS_DATA = 0;
                        }
                        _CONTEXT_i->LINKS       = 1;
                        _CONTEXT_i->NUMBER_DATA = CM->VD->nValue;
                        _CONTEXT_i->TYPE        = CM->VD->TYPE;
                        //_CONTEXT_i->ACCESS       =     CM->ACCESS;
                        if (_CONTEXT_i->TYPE == VARIABLE_STRING) {
                            _CONTEXT_i->STRING_DATA = CM->VD->value;
                        }

                        _CONTEXT_i->IS_PROPERTY_RESULT = 0;
                        _CONTEXT_i->CALL_SET           = 0;
                        _CONTEXT_i->EXTRA_DATA         = 0;
                    }
                }
            }
        }
        //__DEBUG_PRINT(AnsiString("NEW: class created ")+AnsiString((long)this));
    }
    _Class->__gc_obj.Reference(this);
}

/*INTEGER CompiledClass::CreateInstance() {
 *  INTEGER Count=_Class->pMEMBERS_COUNT;
 *  if (Count) { // <== conditzie adaugata de curand ...
 *      _CONTEXT=new VariableDATA * [Count];
 *
 *      for (INTEGER i=0;i<Count;i++) {
 *          ClassMember *CM=_Class->pMEMBERS[i];
 *          _CONTEXT[i]               =     0;
 *          if (CM) {
 *              _CONTEXT[i]               =     new VariableDATA;
 *              _CONTEXT[i]->CLASS_DATA   =     0;
 *              _CONTEXT[i]->LINKS        =     1;
 *              _CONTEXT[i]->NUMBER_DATA  =     0;
 *              _CONTEXT[i]->TYPE         =     CM->VD.TYPE;
 *              _CONTEXT[i]->ACCESS       =     CM->ACCESS;
 *
 *              _CONTEXT[i]->IS_PROPERTY_RESULT =   0;
 *              _CONTEXT[i]->CALL_SET           =   0;
 *              _CONTEXT[i]->EXTRA_DATA         =   0;
 *          }
 *      }
 *      //__DEBUG_PRINT(AnsiString("NEW: class created ")+AnsiString((long)this));
 *  }
 *  return 0;
 * }*/

AnsiString CompiledClass::GetClassName() {
    if (_Class) {
        return(_Class->NAME);
    }
    return(NULL_STRING);
}

void CompiledClass::__GO_GARBAGE(AnsiList *__GARBAGE_COLLECTION) {
    if (this->LINKS < 0) {                                                                                                                                                                                                                                                                         //(!_CONTEXT)
        return;
    }

    if (_Class->DESTRUCTOR) {
        Destroy();
    }

    INTEGER Count = _Class->pMEMBERS_COUNT;

    for (INTEGER i = 0; i < Count; i++) {
        if (_CONTEXT [i]) {
            _CONTEXT [i]->LINKS--;
            if (_CONTEXT [i]->CLASS_DATA) {
                if ((_CONTEXT [i]->TYPE == VARIABLE_CLASS) || (_CONTEXT [i]->TYPE == VARIABLE_DELEGATE)) {
                    __GARBAGE_COLLECTION->AddUniquePointer(_CONTEXT [i]->CLASS_DATA, DATA_COMPILED_CLASS);
                } else
                if (_CONTEXT [i]->TYPE == VARIABLE_ARRAY) {
                    __GARBAGE_COLLECTION->AddUniquePointer(_CONTEXT [i]->CLASS_DATA, DATA_ARRAY);
                }

                _CONTEXT [i]->TYPE       = VARIABLE_NUMBER;
                _CONTEXT [i]->CLASS_DATA = 0;
            }
            if (!_CONTEXT [i]->LINKS) {
                delete _CONTEXT [i];
            }
        }
    }
    delete[] _CONTEXT;
    _CONTEXT    = 0;
    this->LINKS = -1;
}

ClassCode *CompiledClass::GetClass() {
    return(_Class);
}

VariableDATA **CompiledClass::GetContext() {
    return(_CONTEXT);
}

int CompiledClass::Destroy() {
    VariableDATA *OWNER = new VariableDATA;

    OWNER->TYPE       = VARIABLE_CLASS;
    OWNER->LINKS      = 1;
    OWNER->CLASS_DATA = this;
    //OWNER->ACCESS=ACCESS_LOCAL;
    OWNER->IS_PROPERTY_RESULT = 0;
    this->LINKS++;
    VariableDATA *THROW_DATA = 0;

    STACK(_Class->NAME, _Class->DESTRUCTOR_MEMBER->NAME, _Class->DESTRUCTOR_MEMBER->_DEBUG_STARTLINE)
    VariableDATA * RESULT = _Class->DESTRUCTOR_MEMBER->Execute(this->_Class->CLSID, OWNER, 0, _CONTEXT, THROW_DATA);
    UNSTACK;
    if (RESULT) {
        FREE_VARIABLE(RESULT);
    }

    // avoid double deleting of the class !!!
    OWNER->TYPE       = VARIABLE_NUMBER;
    OWNER->CLASS_DATA = 0;
    FREE_VARIABLE(OWNER);

    if (THROW_DATA) {
        FREE_VARIABLE(THROW_DATA);
        AnsiException *Exc = new AnsiException(ERR635, 0, 635, 0, _Class->_DEBUG_INFO_FILENAME, _Class->NAME, _Class->DESTRUCTOR_MEMBER->NAME);
        _Class->PIF->AcknoledgeRunTimeError(Exc);
    }
    this->LINKS = -1;
    return(1);
}

int CompiledClass::HasDestructor() {
    //if (!_CONTEXT)
    //    return 0;
    if (this->LINKS < 0) {
        return(0);
    }

    if (_Class->DESTRUCTOR) {
        return(1);
    }

    return(0);
}

void CompiledClass::UnlinkObjects() {
    if (this->LINKS < 0) {                                                                                                                                                                                                                                                                         //(!_CONTEXT)
        return;
    }
    this->LINKS = -1;

    /*if (_Class->DESTRUCTOR)
     *  Destroy();*/

    INTEGER Count = _Class->DataMembersCount;     //_Class->pMEMBERS_COUNT;

    for (register INTEGER i = 0; i < Count; i++) {
        VariableDATA *_CONTEXT_i = _CONTEXT [i];
        if (_CONTEXT_i) {
            // don't delete any object ! ... it's the garbage collector's job
            if (_CONTEXT_i->CLASS_DATA) {
                _CONTEXT_i->TYPE       = VARIABLE_NUMBER;
                _CONTEXT_i->CLASS_DATA = 0;

                FREE_VARIABLE(_CONTEXT_i);
            }
        }
    }

    delete[] _CONTEXT;
    _CONTEXT = 0;
}

CompiledClass::~CompiledClass() {
    //__DEBUG_PRINT(AnsiString("DELETE: class destroyed ")+AnsiString((long)this));
    this->_Class->__gc_obj.Unreference(this);

    if (this->LINKS < 0) {                                                                                                                                                                                                                                                                         //(!_CONTEXT)
        return;
    }

    if (_Class->DESTRUCTOR) {
        Destroy();
    }

    this->LINKS = -1;

    INTEGER Count = _Class->DataMembersCount;     //_Class->pMEMBERS_COUNT;

    for (register INTEGER i = 0; i < Count; i++) {
        VariableDATA *_CONTEXT_i = _CONTEXT [i];
        if (_CONTEXT_i) {
            //=======================================//
            if ((_CONTEXT_i->CLASS_DATA == this) && ((_CONTEXT_i->TYPE == VARIABLE_CLASS) || (_CONTEXT_i->TYPE == VARIABLE_DELEGATE))) {
                _CONTEXT_i->TYPE       = VARIABLE_NUMBER;
                _CONTEXT_i->CLASS_DATA = 0;
            }
            //=======================================//

            FREE_VARIABLE(_CONTEXT_i);

            /*_CONTEXT_i->LINKS--;
             * if (!_CONTEXT_i->LINKS) {
             *  if (_CONTEXT_i->CLASS_DATA) {
             *      if (_CONTEXT_i->TYPE==VARIABLE_CLASS) {
             *          if ((!--((CompiledClass *)_CONTEXT_i->CLASS_DATA)->LINKS))
             *                  delete (CompiledClass *)_CONTEXT_i->CLASS_DATA;
             *      } else
             *      if (_CONTEXT_i->TYPE==VARIABLE_ARRAY) {
             *          if ((!--((Array *)_CONTEXT_i->CLASS_DATA)->LINKS))
             *                  delete (Array *)_CONTEXT_i->CLASS_DATA;
             *      }
             *  }
             *  delete _CONTEXT_i;
             * }*/
        }
    }
    delete[] _CONTEXT;
}
