//#define FAST_EXIT_NO_GC_CALL

#include "ConceptInterpreter.h"
#include "AnsiException.h"
#include "ModuleLink.h"
#include "Debugger.h"

POOLED_IMPLEMENTATION(tsSCStack)
POOLED_IMPLEMENTATION(ConceptInterpreter)

static AnsiString DLL_CLASS = "STATIC/LIBRARY";
static TinyString DLL_MEMBER = "STATIC_FUNCTION";

// CODUL CE VERIFICA DE PROPRIETATI ...
// To avoid another function call in time-critical function
//---------------------------------------------------------
// BUG corectat pe 13 ianuarie 2006 :
// OE->Result_ID-1 inlocuit cu OE->Result_ID deoarece atunci cand se construia lista
// cu un parametru pentru apel catre membrul de SET al proprietatzii, nu se mai trecea
// la index cu baza in 1, iar OE->Result_ID este deja in baza 1
#define PROPERTY_CODE                                                                                                                                                                                                                                                                                        \
    if (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->IS_PROPERTY_RESULT) {                                                                                                                                                                                                                                        \
        try {                                                                                                                                                                                                                                                                                                \
            CCTEMP = (CompiledClass *)((VariableDATA *)((VariableDATA *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1])->CALL_SET)->CLASS_DATA;                                                                                                                                                                      \
            RESULT = (VariableDATA *)((VariableDATA *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1])->CALL_SET;                                                                                                                                                                                                     \
            CCTEMP->_Class->SetProperty(LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->IS_PROPERTY_RESULT - 1, (VariableDATA *)((VariableDATA *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1])->CALL_SET, &OE->OperandLeft, CCTEMP->_Class->CLSID == ClassID, OE->Result_ID /*-1*/, LOCAL_CONTEXT, ClassID, LocalClassID); \
        } catch (VariableDATA *LAST_THROW) {                                                                                                                                                                                                                                                                 \
            THROW_DATA = LAST_THROW;                                                                                                                                                                                                                                                                         \
            if ((CATCH_INSTRUCTION_POINTER) && (CATCH_VARIABLE)) {                                                                                                                                                                                                                                           \
                LOCAL_CONTEXT [CATCH_VARIABLE - 1]->LINKS--;                                                                                                                                                                                                                                                 \
                if (!LOCAL_CONTEXT [CATCH_VARIABLE - 1]->LINKS) {                                                                                                                                                                                                                                            \
                    delete LOCAL_CONTEXT [CATCH_VARIABLE - 1]; }                                                                                                                                                                                                                                             \
                LOCAL_CONTEXT [CATCH_VARIABLE - 1] = THROW_DATA;                                                                                                                                                                                                                                             \
                INSTRUCTION_POINTER       = CATCH_INSTRUCTION_POINTER;                                                                                                                                                                                                                                       \
                THROW_DATA                = 0;                                                                                                                                                                                                                                                               \
                CATCH_INSTRUCTION_POINTER = 0;                                                                                                                                                                                                                                                               \
                CATCH_VARIABLE            = 0;                                                                                                                                                                                                                                                               \
                RESTORE_TRY_DATA;                                                                                                                                                                                                                                                                            \
            } else {                                                                                                                                                                                                                                                                                         \
                return 0; }                                                                                                                                                                                                                                                                                  \
        }                                                                                                                                                                                                                                                                                                    \
    }

#define PROPERTY_CODE_LEFT                                                                                                                                                                                                                                                                                        \
    if (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->IS_PROPERTY_RESULT) {                                                                                                                                                                                                                                             \
        try {                                                                                                                                                                                                                                                                                                     \
            CCTEMP = (CompiledClass *)((VariableDATA *)((VariableDATA *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1])->CALL_SET)->CLASS_DATA;                                                                                                                                                                           \
            RESULT = (VariableDATA *)((VariableDATA *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1])->CALL_SET;                                                                                                                                                                                                          \
            CCTEMP->_Class->SetProperty(LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->IS_PROPERTY_RESULT - 1, (VariableDATA *)((VariableDATA *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1])->CALL_SET, &OE->OperandLeft, CCTEMP->_Class->CLSID == ClassID, OE->OperandLeft.ID /*-1*/, LOCAL_CONTEXT, ClassID, LocalClassID); \
        } catch (VariableDATA *LAST_THROW) {                                                                                                                                                                                                                                                                      \
            THROW_DATA = LAST_THROW;                                                                                                                                                                                                                                                                              \
            if ((CATCH_INSTRUCTION_POINTER) && (CATCH_VARIABLE)) {                                                                                                                                                                                                                                                \
                LOCAL_CONTEXT [CATCH_VARIABLE - 1]->LINKS--;                                                                                                                                                                                                                                                      \
                if (!LOCAL_CONTEXT [CATCH_VARIABLE - 1]->LINKS) {                                                                                                                                                                                                                                                 \
                    delete LOCAL_CONTEXT [CATCH_VARIABLE - 1]; }                                                                                                                                                                                                                                                  \
                LOCAL_CONTEXT [CATCH_VARIABLE - 1] = THROW_DATA;                                                                                                                                                                                                                                                  \
                INSTRUCTION_POINTER       = CATCH_INSTRUCTION_POINTER;                                                                                                                                                                                                                                            \
                THROW_DATA                = 0;                                                                                                                                                                                                                                                                    \
                CATCH_INSTRUCTION_POINTER = 0;                                                                                                                                                                                                                                                                    \
                CATCH_VARIABLE            = 0;                                                                                                                                                                                                                                                                    \
                RESTORE_TRY_DATA;                                                                                                                                                                                                                                                                                 \
            } else {                                                                                                                                                                                                                                                                                              \
                return 0; }                                                                                                                                                                                                                                                                                       \
        }                                                                                                                                                                                                                                                                                                         \
    }
//---------------------------------------------------------
// chemat de proprietate[n]=x pentru a seta proprietatea ...
#define TEMP_PROPERTY_CODE                                                                                                                                                                                                                                                                                                        \
    if (LOCAL_CONTEXT [tempOE->OperandLeft.ID - 1]->IS_PROPERTY_RESULT) {                                                                                                                                                                                                                                                         \
        try {                                                                                                                                                                                                                                                                                                                     \
            CCTEMP = (CompiledClass *)((VariableDATA *)((VariableDATA *)LOCAL_CONTEXT [tempOE->OperandLeft.ID - 1])->CALL_SET)->CLASS_DATA;                                                                                                                                                                                       \
            RESULT = (VariableDATA *)((VariableDATA *)LOCAL_CONTEXT [tempOE->OperandLeft.ID - 1])->CALL_SET;                                                                                                                                                                                                                      \
            /*CCTEMP->_Class->SetProperty(LOCAL_CONTEXT[tempOE->OperandLeft.ID-1]->IS_PROPERTY_RESULT-1,(VariableDATA *)((VariableDATA *)LOCAL_CONTEXT[tempOE->OperandLeft.ID-1])->CALL_SET,&tempOE->OperandLeft,CCTEMP->_Class->CLSID==ClassID,tempOE->Result_ID,LOCAL_CONTEXT,ClassID,LocalClassID);*/                          \
            CCTEMP->_Class->SetProperty(LOCAL_CONTEXT [tempOE->OperandLeft.ID - 1]->IS_PROPERTY_RESULT - 1, (VariableDATA *)((VariableDATA *)LOCAL_CONTEXT [tempOE->OperandLeft.ID - 1])->CALL_SET, &tempOE->OperandLeft, CCTEMP->_Class->CLSID == ClassID, tempOE->OperandLeft.ID /*-1*/, LOCAL_CONTEXT, ClassID, LocalClassID); \
        } catch (VariableDATA *LAST_THROW) {                                                                                                                                                                                                                                                                                      \
            THROW_DATA = LAST_THROW;                                                                                                                                                                                                                                                                                              \
            if ((CATCH_INSTRUCTION_POINTER) && (CATCH_VARIABLE)) {                                                                                                                                                                                                                                                                \
                LOCAL_CONTEXT [CATCH_VARIABLE - 1]->LINKS--;                                                                                                                                                                                                                                                                      \
                if (!LOCAL_CONTEXT [CATCH_VARIABLE - 1]->LINKS) {                                                                                                                                                                                                                                                                 \
                    delete LOCAL_CONTEXT [CATCH_VARIABLE - 1]; }                                                                                                                                                                                                                                                                  \
                LOCAL_CONTEXT [CATCH_VARIABLE - 1] = THROW_DATA;                                                                                                                                                                                                                                                                  \
                INSTRUCTION_POINTER       = CATCH_INSTRUCTION_POINTER;                                                                                                                                                                                                                                                            \
                THROW_DATA                = 0;                                                                                                                                                                                                                                                                                    \
                CATCH_INSTRUCTION_POINTER = 0;                                                                                                                                                                                                                                                                                    \
                CATCH_VARIABLE            = 0;                                                                                                                                                                                                                                                                                    \
                RESTORE_TRY_DATA;                                                                                                                                                                                                                                                                                                 \
            } else {                                                                                                                                                                                                                                                                                                              \
                return 0; }                                                                                                                                                                                                                                                                                                       \
        }                                                                                                                                                                                                                                                                                                                         \
    }
//---------------------------------------------------------
#define UPDATE_STRING_VARIABLE_THAT_HAS_INDEX(VARIABLE)                                                                                                                                                    \
    if (VARIABLE->EXTRA_DATA) {                                                                                                                                                                            \
        OptimizedElement *tempOE = &OPT->CODE [VARIABLE->EXTRA_DATA - 1];                                                                                                                                  \
        VARIABLE->EXTRA_DATA = 0;                                                                                                                                                                          \
        INTEGER _def_index = -1;                                                                                                                                                                           \
        if (LOCAL_CONTEXT [tempOE->OperandLeft.ID - 1]->TYPE == VARIABLE_STRING) {                                                                                                                         \
            switch (LOCAL_CONTEXT [tempOE->OperandRight.ID - 1]->TYPE) {                                                                                                                                   \
                case VARIABLE_NUMBER:                                                                                                                                                                      \
                    _def_index = (INTEGER)LOCAL_CONTEXT [tempOE->OperandRight.ID - 1]->NUMBER_DATA;                                                                                                        \
                    break;                                                                                                                                                                                 \
                case VARIABLE_STRING:                                                                                                                                                                      \
                    _def_index = LOCAL_CONTEXT [tempOE->OperandRight.ID - 1]->STRING_DATA.ToInt();                                                                                                         \
                    break;                                                                                                                                                                                 \
            }                                                                                                                                                                                              \
            if ((_def_index > -1) && (_def_index < LOCAL_CONTEXT [tempOE->OperandLeft.ID - 1]->STRING_DATA.Length())) {                                                                                    \
                AnsiString first_part;                                                                                                                                                                     \
                first_part.LoadBuffer(LOCAL_CONTEXT [tempOE->OperandLeft.ID - 1]->STRING_DATA.c_str(), _def_index);                                                                                        \
                AnsiString last_part;                                                                                                                                                                      \
                last_part.LoadBuffer(LOCAL_CONTEXT [tempOE->OperandLeft.ID - 1]->STRING_DATA.c_str() + _def_index + 1, LOCAL_CONTEXT [tempOE->OperandLeft.ID - 1]->STRING_DATA.Length() - _def_index - 1); \
                LOCAL_CONTEXT [tempOE->OperandLeft.ID - 1]->STRING_DATA = first_part + VARIABLE->STRING_DATA + last_part;                                                                                  \
                /* chemat de proprietate[n]=x pentru a seta proprietatea ... */                                                                                                                            \
                TEMP_PROPERTY_CODE                                                                                                                                                                         \
            }                                                                                                                                                                                              \
        }                                                                                                                                                                                                  \
    }
//---------------------------------------------------------
#define CLASS_CHECK_KEEP_EXTRA(VARIABLE)                                                   \
    if (VARIABLE->CLASS_DATA) {                                                            \
        if ((VARIABLE->TYPE == VARIABLE_CLASS) || (VARIABLE->TYPE == VARIABLE_DELEGATE)) { \
            if (!--((CompiledClass *)VARIABLE->CLASS_DATA)->LINKS) {                       \
                delete (CompiledClass *)VARIABLE->CLASS_DATA; }                            \
        } else                                                                             \
        if (VARIABLE->TYPE == VARIABLE_ARRAY) {                                            \
            if (!--((Array *)VARIABLE->CLASS_DATA)->LINKS) {                               \
                delete (Array *)VARIABLE->CLASS_DATA; }                                    \
        }                                                                                  \
        VARIABLE->CLASS_DATA = 0;                                                          \
        VARIABLE->TYPE       = VARIABLE_NUMBER;                                            \
    }
//---------------------------------------------------------
#define RESTORE_TRY_DATA                                                             \
    if (PREVIOUS_TRY) {                                                              \
        CATCH_INSTRUCTION_POINTER = OPT->CODE [PREVIOUS_TRY - 1].OperandReserved.ID; \
        CATCH_VARIABLE            = OPT->CODE [PREVIOUS_TRY - 1].Result_ID;          \
    }
//---------------------------------------------------------
#define CHECK_IF_RIGHT_IS_A_NUMBER                                                                                                                                                                                                                                \
    if (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE != VARIABLE_NUMBER) {                                                                                                                                                                                       \
        switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {                                                                                                                                                                                                  \
            case VARIABLE_STRING:                                                                                                                                                                                                                                 \
                LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA.ToFloat();                                                                                                                            \
                break;                                                                                                                                                                                                                                            \
            default:                                                                                                                                                                                                                                              \
                this->AcknoledgeRunTimeError(new AnsiException(ERR1204, OE->OperandRight._DEBUG_INFO_LINE, 1204, OE->OperandRight._PARSE_DATA, ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME)); \
        }                                                                                                                                                                                                                                                         \
    }
//---------------------------------------------------------
#ifndef SINGLE_PROCESS_DLL
THREADED_FLAG SimpleStream *ConceptInterpreter::out;

THREADED_FLAG AnsiList *ConceptInterpreter::ClassList;

THREADED_FLAG DEBUGGER_CALLBACK ConceptInterpreter::DEBUGGER_TRAP;
THREADED_FLAG void              *ConceptInterpreter::DEBUGGER_RESERVED;
THREADED_FLAG char              *ConceptInterpreter::SERVER_PUBLIC_KEY;
THREADED_FLAG char              *ConceptInterpreter::SERVER_PRIVATE_KEY;
THREADED_FLAG char              *ConceptInterpreter::CLIENT_PUBLIC_KEY;
#endif

THREADED_FLAG SCStack            ConceptInterpreter::CALL_STACK [MAX_STACK_LIST];
THREADED_FLAG unsigned short int ConceptInterpreter::CALL_STACK_COUNT = 0;


ConceptInterpreter::ConceptInterpreter(Optimizer *O, SimpleStream *Out, AnsiList *CLST, INTEGER LocalClsID, ClassMember *Owner, DEBUGGER_CALLBACK DC, void *DEBUGGER_RESERVED, char *SPubK, char *SPrivK, char *CPubK) {
    OPT = O;
    //LOCAL_CONTEXT=0;
    out       = Out;
    ClassList = CLST;
    //ClassID=ClsID;
    LocalClassID                = LocalClsID;
    OWNER                       = Owner;
    OPERATOR_PARAM              = new ParamList;
    OPERATOR_PARAM->COUNT       = 1;
    OPERATOR_PARAM->PARAM_INDEX = DELTA_REF(OPERATOR_PARAM, new INTEGER [1]);
    DEBUGGER_TRAP               = DC;
    SERVER_PUBLIC_KEY           = SPubK;
    SERVER_PRIVATE_KEY          = SPrivK;
    CLIENT_PUBLIC_KEY           = CPubK;
    static_call_main            = 0;
    PREVIOUS_TRY                = 0;
    this->DEBUGGER_RESERVED     = DEBUGGER_RESERVED;
}

void ConceptInterpreter::AcknoledgeRunTimeError(AnsiException *Exc) {
    // notify the client about the run-time error ...
    // --------------------------------------- //
    AnsiString cstack = "Stack:\n";

    for (int i = 0; i < ConceptInterpreter::CALL_STACK_COUNT; i++) {
        cstack += *ConceptInterpreter::CALL_STACK [i].cls;
        cstack += ".";
        cstack += ConceptInterpreter::CALL_STACK [i].mem->c_str();
        cstack += ":";
        cstack += AnsiString((long)ConceptInterpreter::CALL_STACK [i].line);
        cstack += "\n";
    }
    out->ClientError(Exc->ToString() + cstack);
    // --------------------------------------- //
    OPT->PIFOwner->Errors.Add(Exc, DATA_EXCEPTION);
}

VariableDATA *ConceptInterpreter::Interpret(VariableDATA **LOCAL_CONTEXT, long ClassID) {
    register INTEGER INSTRUCTION_POINTER = 0;
    register INTEGER INSTRUCTION_COUNT   = OPT->codeCount;
    char             *STATIC_ERROR       = 0;
    ParamList        *FORMAL_PARAMETERS;
    VariableDATA     *RESULT;
    CompiledClass    *CCTEMP;
    INTEGER          OPERATOR_ID;
    ClassCode        *CC;
    void             *instancePTR;
    VariableDATA     *RETURN_DATA;
    AnsiException    *Exc;
    char             pushed_type, next_is_asg;

    //register VariableDATA **LOCAL_CONTEXT=this->LOCAL_CONTEXT;
    register OptimizedElement *CODE = OPT->CODE;

    while (INSTRUCTION_POINTER < INSTRUCTION_COUNT) {
        //OptimizedElement *OE=OPT->CODE[INSTRUCTION_POINTER++];
        register OptimizedElement *OE = &CODE [INSTRUCTION_POINTER++];
        register int OE_Operator_ID   = OE->Operator.ID;
        if (OE->Operator.TYPE == TYPE_OPERATOR) {
            // parte mutata dupa partea cu switch !!!

            /*if (OE->Operator.ID==KEY_ASG)
             *  LOCAL_CONTEXT[OE->Result_ID-1]->TYPE=LOCAL_CONTEXT[OE->OperandRight.ID-1]->TYPE;
             * else if (OE->OperandLeft.ID)
             *  LOCAL_CONTEXT[OE->Result_ID-1]->TYPE=LOCAL_CONTEXT[OE->OperandLeft.ID-1]->TYPE;
             */

            // la operatorul NEW nu tzin cont de tipul variabilelor ...
            switch (OE_Operator_ID) {
                case KEY_NEW:
                    // setez tipul rezultatului
                    CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1]);
                    if (OE->OperandLeft.ID == STATIC_CLASS_ARRAY) {
                        LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE       = VARIABLE_ARRAY;
                        LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA = new Array();
                    } else {
                        //CC=(ClassCode *)OE->OperandLeft.ID;
                        CC = (ClassCode *)ClassList->Item(OE->OperandLeft.ID - 1);
                        LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = VARIABLE_CLASS;

                        FORMAL_PARAMETERS = 0;
                        if (OE->OperandReserved.ID) {
                            FORMAL_PARAMETERS = &OPT->PARAMS [OE->OperandReserved.ID - 1];
                        }

                        instancePTR = CC->CreateInstance(LOCAL_CONTEXT [OE->Result_ID - 1], &OE->OperandLeft, FORMAL_PARAMETERS, LOCAL_CONTEXT);

                        LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA = instancePTR;

                        if (!instancePTR) {
                            LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = VARIABLE_NUMBER;
                        }
                    }
                    continue;
                    break;

                // nici la operatorul DELETE
                case KEY_DELETE:
                    //INTEGER index=OE->OperandRight.ID-1;

                    /*if (LOCAL_CONTEXT[OE->OperandLeft.ID-1]->CLASS_DATA) {
                     *  if ((LOCAL_CONTEXT[OE->OperandLeft.ID-1]->TYPE==VARIABLE_CLASS) && (!--((CompiledClass *)LOCAL_CONTEXT[OE->OperandLeft.ID-1]->CLASS_DATA)->LINKS))
                     *      delete (CompiledClass *)LOCAL_CONTEXT[OE->OperandLeft.ID-1]->CLASS_DATA;
                     *  else
                     *  if ((LOCAL_CONTEXT[OE->OperandLeft.ID-1]->TYPE==VARIABLE_ARRAY) && (!--((Array *)LOCAL_CONTEXT[OE->OperandLeft.ID-1]->CLASS_DATA)->LINKS))
                     *      delete (Array *)LOCAL_CONTEXT[OE->OperandLeft.ID-1]->CLASS_DATA;
                     * }*/
                    CLASS_CHECK(LOCAL_CONTEXT [OE->OperandLeft.ID - 1]);
                    LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA  = 0;
                    LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->TYPE        = VARIABLE_NUMBER;
                    LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA = 0;
                    continue;
                    break;

                // nici la operatorul SELECTOR (->) nu tzin cont de tipul variabilelor
                case KEY_SEL:
                    //LOCAL_CONTEXT[OE->Result_ID-1]->TYPE=VARIABLE_NUMBER;
                    // execute member !!!
                    if (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->TYPE != VARIABLE_CLASS) {
                        Exc = new AnsiException(ERR240, OE->OperandLeft._DEBUG_INFO_LINE, 240, OE->OperandLeft._PARSE_DATA, ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME);            //OPT->_CLASS,OPT->_MEMBER);
                        this->AcknoledgeRunTimeError(Exc);
                        continue;
                    }
                    CCTEMP = (CompiledClass *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA;

                    FORMAL_PARAMETERS = 0;
                    if (OE->OperandReserved.ID) {
                        FORMAL_PARAMETERS = &OPT->PARAMS [OE->OperandReserved.ID - 1];
                        next_is_asg       = 0;
                    } else {
                        // in OE->OperandReserved.TYPE am -1 pus din Optimizer
                        // daca urmatorul operator este = sau &=
                        next_is_asg = OE->OperandReserved.TYPE;
                    }
                    try {
                        /*// verificare apel functie delegate //
                         *  if (!FORMAL_PARAMETERS) &&{
                         *   // nu am lista de parametri, este apel delegate.
                         *   RESULT=LOCAL_CONTEXT[OE->Result_ID-1];
                         *   CLASS_CHECK(RESULT);
                         *   RESULT->TYPE=VARIABLE_CLASS;
                         *   RESULT->CLASS_DATA=LOCAL_CONTEXT[OE->OperandLeft.ID-1]->CLASS_DATA;
                         *   // incrementare link-uri ale clasei
                         *   ((CompiledClass *)LOCAL_CONTEXT[OE->OperandLeft.ID-1]->CLASS_DATA)->LINKS++;
                         *   RESULT->NUMBER_DATA=OE->OperandRight.ID;
                         *   continue;
                         *  }
                         *  // pana aici -----------------------//*/

                        //-------------------------------------------//
                        // adaugat pt BUG-ul ciudat de mai jos ... exista situatzii cand
                        // LOCAL_CONTEXT devine 0 !!!
                        //VariableDATA **BACKUP=LOCAL_CONTEXT;
                        //-------------------------------------------//
                        RESULT = CCTEMP->_Class->ExecuteMember(OE->OperandRight.ID - 1, LOCAL_CONTEXT [OE->OperandLeft.ID - 1], &OE->OperandRight, CCTEMP->_Class->CLSID == ClassID, FORMAL_PARAMETERS, LOCAL_CONTEXT, 0, ClassID, LocalClassID, next_is_asg);
                        //-------------------------------------------//
                        // BUG ciudat ... de verificat !!!

                        /*if (!LOCAL_CONTEXT)
                         *  LOCAL_CONTEXT=BACKUP;*/
                        //-------------------------------------------//
                        if (((RESULT) && ((RESULT->TYPE == VARIABLE_CLASS) || (RESULT->TYPE == VARIABLE_DELEGATE)) && (!RESULT->CLASS_DATA)) || (!RESULT)) {
                            LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = VARIABLE_NUMBER;
                        }
                        if (RESULT == LOCAL_CONTEXT [OE->Result_ID - 1]) {
                            continue;
                        }
                        if (RESULT) {
                            /*if (!--LOCAL_CONTEXT[OE->Result_ID-1]->LINKS) {
                             *  if ((LOCAL_CONTEXT[OE->Result_ID-1]->TYPE==VARIABLE_CLASS) && (!--((CompiledClass *)LOCAL_CONTEXT[OE->Result_ID-1]->CLASS_DATA)->LINKS))
                             *      delete (CompiledClass *)LOCAL_CONTEXT[OE->Result_ID-1]->CLASS_DATA;
                             *  delete LOCAL_CONTEXT[OE->Result_ID-1];
                             * }*/
                            FREE_VARIABLE(LOCAL_CONTEXT [OE->Result_ID - 1]);
                            LOCAL_CONTEXT [OE->Result_ID - 1] = RESULT;
                            RESULT->LINKS++;
                        }
                    } catch (VariableDATA *LAST_THROW) {
                        // incrementeze link-urile ...
                        THROW_DATA = LAST_THROW;
                        if ((CATCH_INSTRUCTION_POINTER) && (CATCH_VARIABLE)) {
                            /*LOCAL_CONTEXT[CATCH_VARIABLE-1]->LINKS--;
                             * if (!LOCAL_CONTEXT[CATCH_VARIABLE-1]->LINKS)
                             *  delete LOCAL_CONTEXT[CATCH_VARIABLE-1];*/
                            FREE_VARIABLE(LOCAL_CONTEXT [CATCH_VARIABLE - 1]);
                            LOCAL_CONTEXT [CATCH_VARIABLE - 1] = THROW_DATA;
                            INSTRUCTION_POINTER       = CATCH_INSTRUCTION_POINTER;
                            THROW_DATA                = 0;
                            CATCH_INSTRUCTION_POINTER = 0;
                            CATCH_VARIABLE            = 0;
                            //-------------//
                            RESTORE_TRY_DATA;
                            //-------------//
                        } else {
                            return(0);
                        }
                    }
                    continue;
                    break;

                case KEY_TYPE_OF:
                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = VARIABLE_STRING;
                    switch (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->TYPE) {
                        case VARIABLE_NUMBER:
                            LOCAL_CONTEXT [OE->Result_ID - 1]->STRING_DATA = "numeric";
                            break;

                        case VARIABLE_STRING:
                            LOCAL_CONTEXT [OE->Result_ID - 1]->STRING_DATA = "string";
                            break;

                        case VARIABLE_CLASS:
                            LOCAL_CONTEXT [OE->Result_ID - 1]->STRING_DATA = "class";
                            break;

                        case VARIABLE_ARRAY:
                            LOCAL_CONTEXT [OE->Result_ID - 1]->STRING_DATA = "array";
                            break;

                        case VARIABLE_DELEGATE:
                            LOCAL_CONTEXT [OE->Result_ID - 1]->STRING_DATA = "delegate";
                            break;

                        default:
                            LOCAL_CONTEXT [OE->Result_ID - 1]->STRING_DATA = "";
                    }
                    continue;
                    break;

                case KEY_CLASS_NAME:
                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = VARIABLE_STRING;
                    if (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->TYPE != VARIABLE_CLASS) {
                        LOCAL_CONTEXT [OE->Result_ID - 1]->STRING_DATA = "";
                    } else {
                        CCTEMP = (CompiledClass *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA;
                        LOCAL_CONTEXT [OE->Result_ID - 1]->STRING_DATA = CCTEMP->_Class->NAME;
                    }
                    continue;
                    break;

                case KEY_DLL_CALL:
                    FORMAL_PARAMETERS = 0;
                    STATIC_ERROR      = 0;
                    if (OE->OperandReserved.ID) {
                        FORMAL_PARAMETERS = &OPT->PARAMS [OE->OperandReserved.ID - 1];
                    }
                    if (OE->OperandLeft.ID == STATIC_CLASS_DELEGATE) {
                        // call to delegate function
                        VariableDATA *lOwner = 0;
                        try {
                            //-------------------------------------------//
                            // adaugat pt BUG-ul ciudat de mai jos ... exista situatzii cand
                            // LOCAL_CONTEXT devine 0 !!!
                            VariableDATA **BACKUP = LOCAL_CONTEXT;
                            //-------------------------------------------//
                            if (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE != VARIABLE_DELEGATE) {
                                Exc = new AnsiException(ERR970, OE->OperandRight._DEBUG_INFO_LINE, 970, OE->OperandRight._PARSE_DATA, ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME);               //OPT->_CLASS,OPT->_MEMBER);
                                this->AcknoledgeRunTimeError(Exc);
                                continue;
                            }
                            CCTEMP = (CompiledClass *)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA;
                            lOwner = new VariableDATA;
                            //lOwner->ACCESS=ACCESS_LOCAL;
                            lOwner->CALL_SET           = 0;
                            lOwner->CLASS_DATA         = CCTEMP;
                            lOwner->EXTRA_DATA         = 0;
                            lOwner->IS_PROPERTY_RESULT = 0;
                            lOwner->LINKS       = 1;
                            lOwner->NUMBER_DATA = 0;
                            lOwner->TYPE        = VARIABLE_CLASS;
                            CCTEMP->LINKS++;

                            RESULT = CCTEMP->_Class->ExecuteDelegate(
                                (INTEGER)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA,
                                lOwner,
                                &OE->OperandRight,
                                FORMAL_PARAMETERS,
                                LOCAL_CONTEXT,
                                ClassID,
                                LocalClassID
                                );

                            /*RESULT=CCTEMP->_Class->ExecuteMember(
                             *                              (INTEGER)LOCAL_CONTEXT[OE->OperandRight.ID-1]->NUMBER_DATA,
                             *                              lOwner,
                             *                              &OE->OperandRight,
                             *                              1,
                             *                              FORMAL_PARAMETERS,
                             *                              LOCAL_CONTEXT,
                             *                              0,
                             *                              ClassID,
                             *                              LocalClassID
                             *                              );*/
                            FREE_VARIABLE(lOwner);

                            //-------------------------------------------//
                            // BUG ciudat ... de verificat !!!
                            if (!LOCAL_CONTEXT) {
                                LOCAL_CONTEXT = BACKUP;
                            }
                            //-------------------------------------------//
                            if (((RESULT) && ((RESULT->TYPE == VARIABLE_CLASS) || (RESULT->TYPE == VARIABLE_DELEGATE)) && (!RESULT->CLASS_DATA)) || (!RESULT)) {
                                LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = VARIABLE_NUMBER;
                            }
                            if (RESULT == LOCAL_CONTEXT [OE->Result_ID - 1]) {
                                continue;
                            }
                            if (RESULT) {
                                FREE_VARIABLE(LOCAL_CONTEXT [OE->Result_ID - 1]);
                                LOCAL_CONTEXT [OE->Result_ID - 1] = RESULT;
                                RESULT->LINKS++;
                            }
                        } catch (VariableDATA *LAST_THROW) {
                            FREE_VARIABLE(lOwner);

                            // incrementeze link-urile ...
                            THROW_DATA = LAST_THROW;
                            if ((CATCH_INSTRUCTION_POINTER) && (CATCH_VARIABLE)) {
                                FREE_VARIABLE(LOCAL_CONTEXT [CATCH_VARIABLE - 1]);
                                LOCAL_CONTEXT [CATCH_VARIABLE - 1] = THROW_DATA;
                                INSTRUCTION_POINTER       = CATCH_INSTRUCTION_POINTER;
                                THROW_DATA                = 0;
                                CATCH_INSTRUCTION_POINTER = 0;
                                CATCH_VARIABLE            = 0;
                                //-------------//
                                RESTORE_TRY_DATA;
                                //-------------//
                            } else {
                                return(0);
                            }
                        }
                        continue;
                    } else
                    if (OE->OperandLeft.ID == STATIC_CLASS_DLL) {
                        //try {
                        //STATIC_ERROR=(char *)((EXTERNAL_CALL)OE->OperandLeft.ID)(FORMAL_PARAMETERS,LOCAL_CONTEXT,LOCAL_CONTEXT[OE->Result_ID-1],SetVariable,GetVariable,out->sock,SERVER_PUBLIC_KEY,SERVER_PRIVATE_KEY,CLIENT_PUBLIC_KEY,SetClassMember,GetClassMember);
                        ParamList FORMAL_PARAMETERS2 = { 0, 0 };
                        if ((FORMAL_PARAMETERS) && (FORMAL_PARAMETERS->COUNT)) {
                            FORMAL_PARAMETERS2.COUNT       = FORMAL_PARAMETERS->COUNT;
                            FORMAL_PARAMETERS2.PARAM_INDEX = DELTA_UNREF(FORMAL_PARAMETERS, FORMAL_PARAMETERS->PARAM_INDEX);
                        }
                        STACK(DLL_CLASS, DLL_MEMBER, OE->OperandLeft._DEBUG_INFO_LINE)
                        try {
                            STATIC_ERROR = (char *)((EXTERNAL_CALL)(OPT->PIFOwner->StaticLinks [OE->OperandRight.ID - 1]))(&FORMAL_PARAMETERS2, LOCAL_CONTEXT, LOCAL_CONTEXT [OE->Result_ID - 1], SetVariable, GetVariable, out->sock, SERVER_PUBLIC_KEY, SERVER_PRIVATE_KEY, CLIENT_PUBLIC_KEY, SetClassMember, GetClassMember, Invoke);
                        } catch (...) {
                            Exc = new AnsiException(ERR690, OE->OperandLeft._DEBUG_INFO_LINE, 690, OE->OperandRight._PARSE_DATA, ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME);                        //OPT->_CLASS,OPT->_MEMBER);
                            this->AcknoledgeRunTimeError(Exc);
                        }
                        UNSTACK;
                        if (STATIC_ERROR) {
                            if (OPT->PIFOwner->USE_EXC) {
                                THROW_DATA = new VariableDATA;
                                THROW_DATA->STRING_DATA = STATIC_ERROR;
                                THROW_DATA->NUMBER_DATA = 0;
                                THROW_DATA->CLASS_DATA  = 0;
                                THROW_DATA->LINKS       = 1;
                                //THROW_DATA->ACCESS=ACCESS_LOCAL;
                                THROW_DATA->IS_PROPERTY_RESULT = 0;
                                THROW_DATA->CALL_SET           = 0;
                                THROW_DATA->EXTRA_DATA         = 0;

                                if ((CATCH_INSTRUCTION_POINTER) && (CATCH_VARIABLE)) {
                                    FREE_VARIABLE(LOCAL_CONTEXT [CATCH_VARIABLE - 1]);
                                    LOCAL_CONTEXT [CATCH_VARIABLE - 1] = THROW_DATA;
                                    INSTRUCTION_POINTER       = CATCH_INSTRUCTION_POINTER;
                                    THROW_DATA                = 0;
                                    CATCH_INSTRUCTION_POINTER = 0;
                                    CATCH_VARIABLE            = 0;
                                    //--------------//
                                    RESTORE_TRY_DATA;
                                    //--------------//
                                } else {
                                    return(0);
                                }
                            } else {
                                Exc = new AnsiException(ERR700, OE->OperandLeft._DEBUG_INFO_LINE, 700, AnsiString(OE->OperandLeft._PARSE_DATA.c_str()) + AnsiString(": ") + AnsiString(STATIC_ERROR), ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME);                   //OPT->_CLASS,OPT->_MEMBER);
                                this->AcknoledgeRunTimeError(Exc);
                            }
                        }

                        /*} catch (...) {
                         *  Exc=new AnsiException(ERR690,OE->OperandLeft._DEBUG_INFO_LINE,690,OE->OperandLeft._PARSE_DATA,((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME,((ClassCode *)(OWNER->Defined_In))->NAME,OWNER->NAME);//OPT->_CLASS,OPT->_MEMBER);
                         *  this->AcknoledgeRunTimeError(Exc);
                         * }*/
                    } else {
                        // static call to class !!!
                        try {
                            //-------------------------------------------//
                            // adaugat pt BUG-ul ciudat de mai jos ... exista situatzii cand
                            // LOCAL_CONTEXT devine 0 !!!
                            VariableDATA **BACKUP = LOCAL_CONTEXT;
                            //-------------------------------------------//
                            CC     = (ClassCode *)ClassList->Item(OE->OperandLeft.ID - 1);
                            RESULT = CC->ExecuteMember(OE->OperandRight.ID - 1, LOCAL_CONTEXT [0], &OE->OperandRight, CC->CLSID == ClassID, FORMAL_PARAMETERS, LOCAL_CONTEXT, 0, ClassID, LocalClassID);
                            //-------------------------------------------//
                            // BUG ciudat ... de verificat !!!
                            if (!LOCAL_CONTEXT) {
                                LOCAL_CONTEXT = BACKUP;
                            }
                            //-------------------------------------------//
                            if (((RESULT) && ((RESULT->TYPE == VARIABLE_CLASS) || (RESULT->TYPE == VARIABLE_DELEGATE)) && (!RESULT->CLASS_DATA)) || (!RESULT)) {
                                LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = VARIABLE_NUMBER;
                            }
                            if (RESULT == LOCAL_CONTEXT [OE->Result_ID - 1]) {
                                continue;
                            }
                            if (RESULT) {
                                FREE_VARIABLE(LOCAL_CONTEXT [OE->Result_ID - 1]);
                                LOCAL_CONTEXT [OE->Result_ID - 1] = RESULT;
                                RESULT->LINKS++;
                            }
                        } catch (VariableDATA *LAST_THROW) {
                            // incrementeze link-urile ...
                            THROW_DATA = LAST_THROW;
                            if ((CATCH_INSTRUCTION_POINTER) && (CATCH_VARIABLE)) {
                                FREE_VARIABLE(LOCAL_CONTEXT [CATCH_VARIABLE - 1]);
                                LOCAL_CONTEXT [CATCH_VARIABLE - 1] = THROW_DATA;
                                INSTRUCTION_POINTER       = CATCH_INSTRUCTION_POINTER;
                                THROW_DATA                = 0;
                                CATCH_INSTRUCTION_POINTER = 0;
                                CATCH_VARIABLE            = 0;
                                //-------------//
                                RESTORE_TRY_DATA;
                                //-------------//
                            } else {
                                return(0);
                            }
                        }
                    }
                    continue;
                    break;

                // de aici pot sa mai pun case-uri
                // ---------------- PUS IF-urile de mai jos aici ---------------- //
                // verific daca nu am atribuire prin referintza
                case KEY_BY_REF:
                    CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1])
                    pushed_type = VARIABLE_NUMBER;             //LOCAL_CONTEXT[OE->Result_ID-1]->TYPE;
                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE;
                    break;

                case KEY_ASG:
                    {
                        char asg_type = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE;
                        switch (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->TYPE) {
                            case VARIABLE_NUMBER:
                            case VARIABLE_STRING:
                            case VARIABLE_ARRAY:
                            case VARIABLE_DELEGATE:
                                // ------------------- //
                                CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1])
                                // ------------------- //
                                LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE;
                                if ((asg_type == VARIABLE_CLASS) /*|| (asg_type==VARIABLE_DELEGATE)*/ ||
                                    (asg_type == VARIABLE_ARRAY)) {
                                    int delta = 0;
                                    if (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA != LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA) {
                                        CLASS_CHECK(LOCAL_CONTEXT [OE->OperandLeft.ID - 1]);
                                    } else {
                                        delta = -1;
                                    }

                                    LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA;
                                    if (asg_type == VARIABLE_CLASS) {                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        //|| (asg_type==VARIABLE_DELEGATE))
                                        ((CompiledClass *)LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA)->LINKS += 2 + delta;
                                    } else {
                                        ((Array *)LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA)->LINKS += 2 + delta;
                                    }
                                    // schimb tipul !
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->TYPE = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE;                       //VARIABLE_CLASS
                                    // este o proprietate
                                    if (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->IS_PROPERTY_RESULT) {
                                        CCTEMP = (CompiledClass *)((VariableDATA *)((VariableDATA *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1])->CALL_SET)->CLASS_DATA;
                                        RESULT = (VariableDATA *)((VariableDATA *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1])->CALL_SET;
                                        CCTEMP->_Class->SetProperty(LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->IS_PROPERTY_RESULT - 1, (VariableDATA *)((VariableDATA *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1])->CALL_SET, &OE->OperandLeft, CCTEMP->_Class->CLSID == ClassID, OE->Result_ID - 1, LOCAL_CONTEXT, ClassID, LocalClassID);
                                    }
                                    continue;
                                }
                                break;

                            case VARIABLE_CLASS:
                                //---------------------------------------------------
                                // verificare suplimentara :
                                // daca o clasa nu are implementat operatorul
                                // =, atunci = devine =&
                                CCTEMP = (CompiledClass *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA;
                                //if (!CCTEMP->_CONTEXT[DEF_ASG]) {
                                if (!CCTEMP->_Class->RELOCATIONS [DEF_ASG]) {
                                    // ------------------- //
                                    CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1])
                                    // ------------------- //
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE;
                                    OE_Operator_ID = KEY_BY_REF;
                                    break;
                                }
                                //---------------------------------------------------
                                // salvez tipul, pentru ca-l voi restaura !!!
                                ////////////////////////////////////////////////////////////
                                pushed_type = LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE;                        //////////
                                ////////////////////////////////////////////////////////////
                                LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = VARIABLE_CLASS;

                                break;
                        }
                    }
                    break;

                default:
                    if (OE->OperandLeft.ID) {
                        // salvez tipul, pentru ca-l voi restaura !!!
                        ////////////////////////////////////////////////////////////
                        pushed_type = LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE;            //////////
                        ////////////////////////////////////////////////////////////
                        LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->TYPE;
                    }
                    // -------------------- pana aici --------------------------------//
            }


            /*
             * // verific daca nu am atribuire prin referintza
             * if (OE->Operator.ID==KEY_BY_REF) {
             *  pushed_type=LOCAL_CONTEXT[OE->Result_ID-1]->TYPE;
             *  LOCAL_CONTEXT[OE->Result_ID-1]->TYPE=LOCAL_CONTEXT[OE->OperandRight.ID-1]->TYPE;
             * } else
             * // mutat de sus !!!
             * if (OE->Operator.ID==KEY_ASG) {
             *  switch (LOCAL_CONTEXT[OE->OperandLeft.ID-1]->TYPE) {
             *      case VARIABLE_NUMBER:
             *      case VARIABLE_STRING:
             *      case VARIABLE_ARRAY:
             *      case VARIABLE_DELEGATE:
             *                  // ------------------- //
             *                  CLASS_CHECK(LOCAL_CONTEXT[OE->Result_ID-1])
             *                  // ------------------- //
             *                  LOCAL_CONTEXT[OE->Result_ID-1]->TYPE=LOCAL_CONTEXT[OE->OperandRight.ID-1]->TYPE;
             *                  if (((LOCAL_CONTEXT[OE->OperandRight.ID-1]->TYPE)==VARIABLE_CLASS) ||
             *                     ((LOCAL_CONTEXT[OE->OperandRight.ID-1]->TYPE)==VARIABLE_ARRAY)) {
             *                      LOCAL_CONTEXT[OE->Result_ID-1]->CLASS_DATA  = LOCAL_CONTEXT[OE->OperandLeft.ID-1]->CLASS_DATA = LOCAL_CONTEXT[OE->OperandRight.ID-1]->CLASS_DATA;
             *                      if (LOCAL_CONTEXT[OE->OperandRight.ID-1]->TYPE==VARIABLE_CLASS)
             *                          ((CompiledClass *)LOCAL_CONTEXT[OE->Result_ID-1]->CLASS_DATA)->LINKS+=2;
             *                      else
             *                          ((Array *)LOCAL_CONTEXT[OE->Result_ID-1]->CLASS_DATA)->LINKS+=2;
             *                      // schimb tipul !
             *                      LOCAL_CONTEXT[OE->OperandLeft.ID-1]->TYPE=LOCAL_CONTEXT[OE->OperandRight.ID-1]->TYPE;//VARIABLE_CLASS
             *                      // este o proprietate
             *                      if (LOCAL_CONTEXT[OE->OperandLeft.ID-1]->IS_PROPERTY_RESULT) {
             *                          CCTEMP=(CompiledClass *)((VariableDATA *)((VariableDATA *)LOCAL_CONTEXT[OE->OperandLeft.ID-1])->CALL_SET)->CLASS_DATA;
             *                          RESULT=(VariableDATA *)((VariableDATA *)LOCAL_CONTEXT[OE->OperandLeft.ID-1])->CALL_SET;
             *                          CCTEMP->_Class->SetProperty(LOCAL_CONTEXT[OE->OperandLeft.ID-1]->IS_PROPERTY_RESULT-1,(VariableDATA *)((VariableDATA *)LOCAL_CONTEXT[OE->OperandLeft.ID-1])->CALL_SET,&OE->OperandLeft,CCTEMP->_Class->CLSID==ClassID,OE->Result_ID-1,LOCAL_CONTEXT,ClassID,LocalClassID);
             *                      }
             *                      continue;
             *                  }
             *                  break;
             *      case VARIABLE_CLASS:
             *                  // salvez tipul, pentru ca-l voi restaura !!!
             *                  ////////////////////////////////////////////////////////////
             *                  pushed_type=LOCAL_CONTEXT[OE->Result_ID-1]->TYPE; //////////
             *                  ////////////////////////////////////////////////////////////
             *                  LOCAL_CONTEXT[OE->Result_ID-1]->TYPE=VARIABLE_CLASS;
             *                  break;
             *  }
             * } else if (OE->OperandLeft.ID) {
             *  // salvez tipul, pentru ca-l voi restaura !!!
             *  ////////////////////////////////////////////////////////////
             *  pushed_type=LOCAL_CONTEXT[OE->Result_ID-1]->TYPE; //////////
             *  ////////////////////////////////////////////////////////////
             *  LOCAL_CONTEXT[OE->Result_ID-1]->TYPE=LOCAL_CONTEXT[OE->OperandLeft.ID-1]->TYPE;
             * }
             */

            switch (LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE) {
                case VARIABLE_NUMBER:
                    switch (OE_Operator_ID) {
                        // assigment operators
                        case KEY_BY_REF:
                        case KEY_ASG:
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            // schimb tipul !
                            // ------------------- //
                            CLASS_CHECK(LOCAL_CONTEXT [OE->OperandLeft.ID - 1])
                            // ------------------- //
                            LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->TYPE = VARIABLE_NUMBER;
                            // este o proprietate
                            //----------------//
                            PROPERTY_CODE
                            //----------------//
                            continue;                    //break;

                        case KEY_INC:
                            //LOCAL_CONTEXT[OE->Result_ID-1]->NUMBER_DATA  = ++LOCAL_CONTEXT[OE->OperandRight.ID-1]->NUMBER_DATA;
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = ++LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA;
                            //----------------//
                            PROPERTY_CODE
                            //----------------//
                            continue;                    //break;

                        case KEY_DEC:
                            //LOCAL_CONTEXT[OE->Result_ID-1]->NUMBER_DATA  = --LOCAL_CONTEXT[OE->OperandRight.ID-1]->NUMBER_DATA;
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = --LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA;
                            //----------------//
                            PROPERTY_CODE
                            //----------------//
                            continue;                    //break;

                        case KEY_INC_LEFT:
                            //LOCAL_CONTEXT[OE->Result_ID-1]->NUMBER_DATA  = (LOCAL_CONTEXT[OE->OperandRight.ID-1]->NUMBER_DATA)++;
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA)++;
                            //----------------//
                            PROPERTY_CODE_LEFT
                            //----------------//
                            continue;                    //break;

                        case KEY_DEC_LEFT:
                            //LOCAL_CONTEXT[OE->Result_ID-1]->NUMBER_DATA  = (LOCAL_CONTEXT[OE->OperandRight.ID-1]->NUMBER_DATA)--;
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA)--;
                            //----------------//
                            PROPERTY_CODE_LEFT
                            //----------------//
                            continue;                    //break;

                        case KEY_ASU:
                            // ------------------- //
                            CHECK_IF_RIGHT_IS_A_NUMBER
                            // ------------------- //
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA += LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            // schimb tipul !
                            // ------------------- //
                            CLASS_CHECK(LOCAL_CONTEXT [OE->OperandLeft.ID - 1])
                            // ------------------- //
                            LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->TYPE = VARIABLE_NUMBER;
                            // este o proprietate
                            //----------------//
                            PROPERTY_CODE
                            //----------------//
                            continue;                    //break;

                        case KEY_ADI:
                            // ------------------- //
                            CHECK_IF_RIGHT_IS_A_NUMBER
                            // ------------------- //
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA -= LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            // schimb tipul !
                            // ------------------- //
                            CLASS_CHECK(LOCAL_CONTEXT [OE->OperandLeft.ID - 1])
                            // ------------------- //
                            LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->TYPE = VARIABLE_NUMBER;
                            // este o proprietate
                            //----------------//
                            PROPERTY_CODE
                            //----------------//
                            continue;                    //break;

                        case KEY_AMU:
                            // ------------------- //
                            CHECK_IF_RIGHT_IS_A_NUMBER
                            // ------------------- //
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA *= LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            // schimb tipul !
                            // ------------------- //
                            CLASS_CHECK(LOCAL_CONTEXT [OE->OperandLeft.ID - 1])
                            // ------------------- //
                            LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->TYPE = VARIABLE_NUMBER;
                            // este o proprietate
                            //----------------//
                            PROPERTY_CODE
                            //----------------//
                            continue;                    //break;

                        case KEY_ADV:
                            // ------------------- //
                            CHECK_IF_RIGHT_IS_A_NUMBER
                            // ------------------- //
                            if (!LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA) {
                                this->AcknoledgeRunTimeError(new AnsiException(ERR260, OE->OperandRight._DEBUG_INFO_LINE, 260, OE->OperandRight._PARSE_DATA, ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME));                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  //OPT->_CLASS,OPT->_MEMBER));
                            } else                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           {
                                LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA /= LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            }
                            // schimb tipul !
                            // ------------------- //
                            CLASS_CHECK(LOCAL_CONTEXT [OE->OperandLeft.ID - 1])
                            // ------------------- //
                            LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->TYPE = VARIABLE_NUMBER;
                            // este o proprietate
                            //----------------//
                            PROPERTY_CODE
                            //----------------//
                            continue;                    //break;

                        case KEY_ARE:
                            // ------------------- //
                            CHECK_IF_RIGHT_IS_A_NUMBER
                            // ------------------- //
                            if (!LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA) {
                                this->AcknoledgeRunTimeError(new AnsiException(ERR260, OE->OperandRight._DEBUG_INFO_LINE, 260, OE->OperandRight._PARSE_DATA, ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME));                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  //OPT->_CLASS,OPT->_MEMBER));
                            } else                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           {
                                LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA = (INTEGER)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA % (INTEGER)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            }
                            // schimb tipul !
                            // ------------------- //
                            CLASS_CHECK(LOCAL_CONTEXT [OE->OperandLeft.ID - 1])
                            // ------------------- //
                            LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->TYPE = VARIABLE_NUMBER;
                            // este o proprietate
                            //----------------//
                            PROPERTY_CODE
                            //----------------//
                            continue;                    //break;

                        case KEY_AAN:
                            // ------------------- //
                            CHECK_IF_RIGHT_IS_A_NUMBER
                            // ------------------- //
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA = (INTEGER)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA & (INTEGER)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            // schimb tipul !
                            // ------------------- //
                            CLASS_CHECK(LOCAL_CONTEXT [OE->OperandLeft.ID - 1])
                            // ------------------- //
                            LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->TYPE = VARIABLE_NUMBER;
                            // este o proprietate
                            //----------------//
                            PROPERTY_CODE
                            //----------------//
                            continue;                    //break;

                        case KEY_AXO:
                            // ------------------- //
                            CHECK_IF_RIGHT_IS_A_NUMBER
                            // ------------------- //
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA = (INTEGER)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA ^ (INTEGER)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            // schimb tipul !
                            // ------------------- //
                            CLASS_CHECK(LOCAL_CONTEXT [OE->OperandLeft.ID - 1])
                            // ------------------- //
                            LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->TYPE = VARIABLE_NUMBER;
                            // este o proprietate
                            //----------------//
                            PROPERTY_CODE
                            //----------------//
                            continue;                    //break;

                        case KEY_AOR:
                            // ------------------- //
                            CHECK_IF_RIGHT_IS_A_NUMBER
                            // ------------------- //
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA = (INTEGER)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA | (INTEGER)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            // schimb tipul !
                            // ------------------- //
                            CLASS_CHECK(LOCAL_CONTEXT [OE->OperandLeft.ID - 1])
                            // ------------------- //
                            LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->TYPE = VARIABLE_NUMBER;
                            // este o proprietate
                            //----------------//
                            PROPERTY_CODE
                            //----------------//
                            continue;                    //break;

                        case KEY_ASL:
                            // ------------------- //
                            CHECK_IF_RIGHT_IS_A_NUMBER
                            // ------------------- //
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA = (INTEGER)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA << (INTEGER)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            // schimb tipul !
                            // ------------------- //
                            CLASS_CHECK(LOCAL_CONTEXT [OE->OperandLeft.ID - 1])
                            // ------------------- //
                            LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->TYPE = VARIABLE_NUMBER;
                            // este o proprietate
                            //----------------//
                            PROPERTY_CODE
                            //----------------//
                            continue;                    //break;

                        case KEY_ASR:
                            // ------------------- //
                            CHECK_IF_RIGHT_IS_A_NUMBER
                            // ------------------- //
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA = (INTEGER)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA >> (INTEGER)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            // schimb tipul !
                            // ------------------- //
                            CLASS_CHECK(LOCAL_CONTEXT [OE->OperandLeft.ID - 1])
                            // ------------------- //
                            LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->TYPE = VARIABLE_NUMBER;
                            //----------------//
                            PROPERTY_CODE
                            //----------------//
                            continue;                    //break;

                        // unary operators
                        case KEY_NOT:
                            //LOCAL_CONTEXT[OE->Result_ID-1]->NUMBER_DATA  = !LOCAL_CONTEXT[OE->OperandRight.ID-1]->NUMBER_DATA;
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = !LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA;
                            continue;                    //break;

                        case KEY_COM:
                            //LOCAL_CONTEXT[OE->Result_ID-1]->NUMBER_DATA  = ~(INTEGER)LOCAL_CONTEXT[OE->OperandRight.ID-1]->NUMBER_DATA;
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = ~(INTEGER)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA;
                            continue;                    //break;

                        case KEY_POZ:
                            //LOCAL_CONTEXT[OE->Result_ID-1]->NUMBER_DATA  = LOCAL_CONTEXT[OE->OperandRight.ID-1]->NUMBER_DATA;
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA;
                            continue;                    //break;

                        case KEY_NEG:
                            //LOCAL_CONTEXT[OE->Result_ID-1]->NUMBER_DATA  = -LOCAL_CONTEXT[OE->OperandRight.ID-1]->NUMBER_DATA;
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = -LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA;
                            continue;                    //break;

                        case KEY_MUL:
                            // ------------------- //
                            CHECK_IF_RIGHT_IS_A_NUMBER
                            // ------------------- //
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA * LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            continue;                    //break;

                        case KEY_DIV:
                            // ------------------- //
                            CHECK_IF_RIGHT_IS_A_NUMBER
                            // ------------------- //
                            if (!LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA) {
                                this->AcknoledgeRunTimeError(new AnsiException(ERR260, OE->OperandRight._DEBUG_INFO_LINE, 260, OE->OperandRight._PARSE_DATA, ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME));                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  //OPT->_CLASS,OPT->_MEMBER));
                            } else                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           {
                                LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA / LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            }
                            continue;                    //break;

                        case KEY_REM:
                            // ------------------- //
                            CHECK_IF_RIGHT_IS_A_NUMBER
                            // ------------------- //
                            if (!LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA) {
                                this->AcknoledgeRunTimeError(new AnsiException(ERR260, OE->OperandRight._DEBUG_INFO_LINE, 260, OE->OperandRight._PARSE_DATA, ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME));                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  //OPT->_CLASS,OPT->_MEMBER));
                            } else                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           {
                                LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = (INTEGER)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA % (INTEGER)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            }
                            continue;                    //break;

                        case KEY_SUM:
                            // ------------------- //
                            CHECK_IF_RIGHT_IS_A_NUMBER
                            // ------------------- //
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA + LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            continue;                    //break;

                        case KEY_DIF:
                            // ------------------- //
                            CHECK_IF_RIGHT_IS_A_NUMBER
                            // ------------------- //
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA - LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            continue;                    //break;

                        case KEY_SHL:
                            // ------------------- //
                            CHECK_IF_RIGHT_IS_A_NUMBER
                            // ------------------- //
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = (INTEGER)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA << (INTEGER)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            continue;                    //break;

                        case KEY_SHR:
                            // ------------------- //
                            CHECK_IF_RIGHT_IS_A_NUMBER
                            // ------------------- //
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = (INTEGER)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA >> (INTEGER)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            continue;                    //break;

                        case KEY_LES:
                            // ------------------- //
                            CHECK_IF_RIGHT_IS_A_NUMBER
                            // ------------------- //
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA < LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            continue;                    //break;

                        case KEY_LEQ:
                            // ------------------- //
                            CHECK_IF_RIGHT_IS_A_NUMBER
                            // ------------------- //
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA <= LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            continue;                    //break;

                        case KEY_GRE:
                            // ------------------- //
                            CHECK_IF_RIGHT_IS_A_NUMBER
                            // ------------------- //
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA > LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            continue;                    //break;

                        case KEY_GEQ:
                            // ------------------- //
                            CHECK_IF_RIGHT_IS_A_NUMBER
                            // ------------------- //
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA >= LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            continue;                    //break;

                        case KEY_EQU:

                            /*
                             * // ------------------- //
                             * CHECK_IF_RIGHT_IS_A_NUMBER
                             * // ------------------- //
                             * LOCAL_CONTEXT[OE->Result_ID-1]->NUMBER_DATA  = LOCAL_CONTEXT[OE->OperandLeft.ID-1]->NUMBER_DATA == LOCAL_CONTEXT[OE->OperandRight.ID-1]->NUMBER_DATA;
                             */
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_NUMBER:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA == LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                                    break;

                                case VARIABLE_STRING:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA == LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA.ToFloat();
                                    break;

                                case VARIABLE_CLASS:
                                case VARIABLE_ARRAY:
                                case VARIABLE_DELEGATE:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = 0;
                                    break;

                                default:
                                    this->AcknoledgeRunTimeError(new AnsiException(ERR1204, OE->OperandRight._DEBUG_INFO_LINE, 1204, OE->OperandRight._PARSE_DATA, ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME));
                            }
                            continue;                    //break;

                        case KEY_NEQ:

                            /*
                             * // ------------------- //
                             * CHECK_IF_RIGHT_IS_A_NUMBER
                             * // ------------------- //
                             * LOCAL_CONTEXT[OE->Result_ID-1]->NUMBER_DATA  = LOCAL_CONTEXT[OE->OperandLeft.ID-1]->NUMBER_DATA != LOCAL_CONTEXT[OE->OperandRight.ID-1]->NUMBER_DATA;
                             */
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_NUMBER:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA != LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                                    break;

                                case VARIABLE_STRING:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA != LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA.ToFloat();
                                    break;

                                case VARIABLE_CLASS:
                                case VARIABLE_ARRAY:
                                case VARIABLE_DELEGATE:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = 1;
                                    break;

                                default:
                                    this->AcknoledgeRunTimeError(new AnsiException(ERR1204, OE->OperandRight._DEBUG_INFO_LINE, 1204, OE->OperandRight._PARSE_DATA, ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME));
                            }
                            continue;                    //break;

                        case KEY_AND:
                            // ------------------- //
                            CHECK_IF_RIGHT_IS_A_NUMBER
                            // ------------------- //
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = (INTEGER)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA & (INTEGER)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            continue;                    //break;

                        case KEY_XOR:
                            // ------------------- //
                            CHECK_IF_RIGHT_IS_A_NUMBER
                            // ------------------- //
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = (INTEGER)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA ^ (INTEGER)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            continue;                    //break;

                        case KEY_OR:
                            // ------------------- //
                            CHECK_IF_RIGHT_IS_A_NUMBER
                            // ------------------- //
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = (INTEGER)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA | (INTEGER)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            continue;                    //break;

                        case KEY_BAN:
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_NUMBER:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA && LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                                    break;

                                case VARIABLE_STRING:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA && LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA.Length();
                                    break;

                                case VARIABLE_CLASS:
                                case VARIABLE_DELEGATE:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA != 0);
                                    break;

                                case VARIABLE_ARRAY:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA && ((Array *)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA)->Count();
                                    break;
                            }
                            continue;                    //break;

                        case KEY_BOR:
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_NUMBER:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA || LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                                    break;

                                case VARIABLE_STRING:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA || LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA.Length();
                                    break;

                                case VARIABLE_CLASS:
                                case VARIABLE_DELEGATE:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = 1;
                                    break;

                                case VARIABLE_ARRAY:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA || ((Array *)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA)->Count();
                                    break;
                            }
                            continue;                    //break;

                        case KEY_CND_NULL:
                            // ------------------- //
                            CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1])
                            // ------------------- //
                            if (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA) {
                                LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA;
                                continue;
                            }
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_NUMBER:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                                    break;

                                case VARIABLE_STRING:

                                    /*if (LOCAL_CONTEXT[OE->Result_ID-1]!=LOCAL_CONTEXT[OE->OperandRight.ID-1]) {
                                     *  FREE_VARIABLE(LOCAL_CONTEXT[OE->Result_ID-1]);
                                     *  LOCAL_CONTEXT[OE->Result_ID-1]=LOCAL_CONTEXT[OE->OperandRight.ID-1];
                                     *  LOCAL_CONTEXT[OE->OperandRight.ID-1]->LINKS++;
                                     * }*/
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->STRING_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_STRING;
                                    break;

                                case VARIABLE_DELEGATE:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;

                                case VARIABLE_CLASS:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE       = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE;
                                    ((CompiledClass *)LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA)->LINKS++;
                                    break;

                                case VARIABLE_ARRAY:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE       = VARIABLE_ARRAY;
                                    ((Array *)LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA)->LINKS++;
                                    break;
                            }
                            continue;                    //break;

                        default:
                            Exc = new AnsiException(ERR660, OE->Operator._DEBUG_INFO_LINE, 660, /*OE->Operator._PARSE_DATA.Length() ? OE->Operator._PARSE_DATA :*/ GetKeyWord(OE->Operator.ID), ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME);
                            this->AcknoledgeRunTimeError(Exc);
                            break;
                    }
                    break;

                case VARIABLE_STRING:
                    switch (OE_Operator_ID) {
                        // unary operators
                        case KEY_NOT:
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA.Length() == 0);
                            LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                            continue;                    //break;

                        case KEY_LENGTH:
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA.Length();
                            LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                            continue;                    //break;

                        case KEY_VALUE:
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA.ToFloat();
                            LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                            continue;                    //break;

                        case KEY_INC:
                            if (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA.Length()) {
                                LOCAL_CONTEXT [OE->Result_ID - 1]->STRING_DATA.LoadBuffer(LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA.c_str() + 1, LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA.Length() - 1);
                                LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA = LOCAL_CONTEXT [OE->Result_ID - 1]->STRING_DATA;
                                //----------------//
                                PROPERTY_CODE
                                //----------------//
                            }
                            continue;                    //break;

                        case KEY_INC_LEFT:
                            if (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA.Length()) {
                                LOCAL_CONTEXT [OE->Result_ID - 1]->STRING_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA;
                                LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA.LoadBuffer(LOCAL_CONTEXT [OE->Result_ID - 1]->STRING_DATA.c_str() + 1, LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA.Length() - 1);
                                //----------------//
                                PROPERTY_CODE_LEFT
                                //----------------//
                            }
                            continue;                    //break;

                        // binary ...
                        case KEY_SUM:
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_STRING:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->STRING_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA + LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA;
                                    break;

                                case VARIABLE_NUMBER:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->STRING_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA + AnsiString(LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA);
                                    break;

                                default:
                                    Exc = new AnsiException(ERR650, OE->Operator._DEBUG_INFO_LINE, 650, /*OE->Operator._PARSE_DATA.Length() ? OE->Operator._PARSE_DATA :*/ GetKeyWord(OE->Operator.ID), ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME);                           //OPT->_CLASS,OPT->_MEMBER);
                                    this->AcknoledgeRunTimeError(Exc);
                                    break;
                            }
                            continue;                    //break;

                        case KEY_EQU:
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_STRING:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA == LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA ? 1 : 0;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                case VARIABLE_NUMBER:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA == LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA ? 1 : 0;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                default:
                                    Exc = new AnsiException(ERR650, OE->Operator._DEBUG_INFO_LINE, 650, /*OE->Operator._PARSE_DATA.Length() ? OE->Operator._PARSE_DATA : */ GetKeyWord(OE->Operator.ID), ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME);                           //OPT->_CLASS,OPT->_MEMBER);
                                    this->AcknoledgeRunTimeError(Exc);
                                    break;
                            }
                            continue;                    //break;

                        case KEY_GRE:
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_STRING:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA > LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA ? 1 : 0;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                case VARIABLE_NUMBER:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA > AnsiString(LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA) ? 1 : 0;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                default:
                                    Exc = new AnsiException(ERR650, OE->Operator._DEBUG_INFO_LINE, 650, /*OE->Operator._PARSE_DATA.Length() ? OE->Operator._PARSE_DATA : */ GetKeyWord(OE->Operator.ID), ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME);                           //OPT->_CLASS,OPT->_MEMBER);
                                    this->AcknoledgeRunTimeError(Exc);
                                    break;
                            }
                            continue;                    //break;

                        case KEY_LES:
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_STRING:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA < LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA ? 1 : 0;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                case VARIABLE_NUMBER:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA < AnsiString(LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA) ? 1 : 0;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                default:
                                    Exc = new AnsiException(ERR650, OE->Operator._DEBUG_INFO_LINE, 650, /*OE->Operator._PARSE_DATA.Length() ? OE->Operator._PARSE_DATA :*/ GetKeyWord(OE->Operator.ID), ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME);                           //OPT->_CLASS,OPT->_MEMBER);
                                    this->AcknoledgeRunTimeError(Exc);
                                    break;
                            }
                            continue;                    //break;

                        case KEY_GEQ:
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_STRING:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA >= LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA ? 1 : 0;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                case VARIABLE_NUMBER:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA >= AnsiString(LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA) ? 1 : 0;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                default:
                                    Exc = new AnsiException(ERR650, OE->Operator._DEBUG_INFO_LINE, 650, /*OE->Operator._PARSE_DATA.Length() ? OE->Operator._PARSE_DATA : */ GetKeyWord(OE->Operator.ID), ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME);                           //OPT->_CLASS,OPT->_MEMBER);
                                    this->AcknoledgeRunTimeError(Exc);
                                    break;
                            }
                            continue;                    //break;

                        case KEY_LEQ:
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_STRING:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA <= LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA ? 1 : 0;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                case VARIABLE_NUMBER:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA <= AnsiString(LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA) ? 1 : 0;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                default:
                                    Exc = new AnsiException(ERR650, OE->Operator._DEBUG_INFO_LINE, 650, /*OE->Operator._PARSE_DATA.Length() ? OE->Operator._PARSE_DATA : */ GetKeyWord(OE->Operator.ID), ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME);                           //OPT->_CLASS,OPT->_MEMBER);
                                    this->AcknoledgeRunTimeError(Exc);
                                    break;
                            }
                            continue;                    //break;

                        case KEY_NEQ:
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_STRING:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA != LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA ? 1 : 0;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                case VARIABLE_NUMBER:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA != LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA ? 1 : 0;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                default:
                                    Exc = new AnsiException(ERR650, OE->Operator._DEBUG_INFO_LINE, 650, /*OE->Operator._PARSE_DATA.Length() ? OE->Operator._PARSE_DATA : */ GetKeyWord(OE->Operator.ID), ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME);                           //OPT->_CLASS,OPT->_MEMBER);
                                    this->AcknoledgeRunTimeError(Exc);
                                    break;
                            }
                            continue;                    //break;

                        case KEY_BY_REF:
                        case KEY_ASG:
                            // ------------------- //
                            CLASS_CHECK_KEEP_EXTRA(LOCAL_CONTEXT [OE->OperandLeft.ID - 1])
                            // ------------------- //
                            LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->TYPE = VARIABLE_STRING;
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_STRING:
                                    LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA;
                                    //LOCAL_CONTEXT[OE->Result_ID-1]->STRING_DATA  = LOCAL_CONTEXT[OE->OperandRight.ID-1]->STRING_DATA;
                                    //LOCAL_CONTEXT[OE->Result_ID-1]->STRING_DATA.SetByReference(&LOCAL_CONTEXT[OE->OperandLeft.ID-1]->STRING_DATA);
                                    if (LOCAL_CONTEXT [OE->Result_ID - 1] != LOCAL_CONTEXT [OE->OperandLeft.ID - 1]) {
                                        FREE_VARIABLE(LOCAL_CONTEXT [OE->Result_ID - 1]);
                                        LOCAL_CONTEXT [OE->Result_ID - 1] = LOCAL_CONTEXT [OE->OperandLeft.ID - 1];
                                        LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->LINKS++;
                                    }
                                    //----------------------------------------------------------------------------------------//
                                    UPDATE_STRING_VARIABLE_THAT_HAS_INDEX(LOCAL_CONTEXT [OE->OperandLeft.ID - 1]);
                                    //----------------------------------------------------------------------------------------//
                                    break;

                                case VARIABLE_NUMBER:
                                    LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA = LOCAL_CONTEXT [OE->Result_ID - 1]->STRING_DATA;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->STRING_DATA      = AnsiString(LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA);
                                    //----------------------------------------------------------------------------------------//
                                    UPDATE_STRING_VARIABLE_THAT_HAS_INDEX(LOCAL_CONTEXT [OE->OperandLeft.ID - 1]);
                                    //----------------------------------------------------------------------------------------//
                                    break;

                                default:
                                    Exc = new AnsiException(ERR650, OE->Operator._DEBUG_INFO_LINE, 650, /*OE->Operator._PARSE_DATA.Length() ? OE->Operator._PARSE_DATA : */ GetKeyWord(OE->Operator.ID), ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME);                           //OPT->_CLASS,OPT->_MEMBER);
                                    this->AcknoledgeRunTimeError(Exc);
                                    break;
                            }
                            //----------------//
                            PROPERTY_CODE
                            //----------------//
                            continue;                    //break;

                        case KEY_ASU:
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_STRING:
                                    LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA += LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA;
                                    //LOCAL_CONTEXT[OE->Result_ID-1]->STRING_DATA  = LOCAL_CONTEXT[OE->OperandLeft.ID-1]->STRING_DATA;
                                    //LOCAL_CONTEXT[OE->Result_ID-1]->STRING_DATA.SetByReference(&LOCAL_CONTEXT[OE->OperandLeft.ID-1]->STRING_DATA);
                                    if (LOCAL_CONTEXT [OE->Result_ID - 1] != LOCAL_CONTEXT [OE->OperandLeft.ID - 1]) {
                                        FREE_VARIABLE(LOCAL_CONTEXT [OE->Result_ID - 1]);
                                        LOCAL_CONTEXT [OE->Result_ID - 1] = LOCAL_CONTEXT [OE->OperandLeft.ID - 1];
                                        LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->LINKS++;
                                    }
                                    break;

                                case VARIABLE_NUMBER:
                                    LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA += AnsiString(LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA);
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->STRING_DATA       = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA;
                                    break;

                                default:
                                    Exc = new AnsiException(ERR650, OE->Operator._DEBUG_INFO_LINE, 650, /*OE->Operator._PARSE_DATA.Length() ? OE->Operator._PARSE_DATA :*/ GetKeyWord(OE->Operator.ID), ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME);                           //OPT->_CLASS,OPT->_MEMBER);
                                    this->AcknoledgeRunTimeError(Exc);
                                    break;
                            }
                            //----------------//
                            PROPERTY_CODE
                            //----------------//
                            continue;                    //break;

                        case KEY_INDEX_OPEN:
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_NUMBER:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->STRING_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA [(INTEGER)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA];
                                    // marchez de unde am indexat, sa stiu cand pun la loc :)
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->EXTRA_DATA = INSTRUCTION_POINTER;
                                    break;

                                case VARIABLE_STRING:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->STRING_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA [(INTEGER)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA.ToInt()];
                                    // marchez de unde am indexat, sa stiu cand pun la loc :)
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->EXTRA_DATA = INSTRUCTION_POINTER;
                                    break;

                                default:
                                    Exc = new AnsiException(ERR640, OE->OperandLeft._DEBUG_INFO_LINE, 640, OE->OperandLeft._PARSE_DATA, ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME);                           //OPT->_CLASS,OPT->_MEMBER);
                                    this->AcknoledgeRunTimeError(Exc);
                                    break;
                            }
                            break;

                        case KEY_BAN:
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_NUMBER:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA.Length() && LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                case VARIABLE_STRING:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA.Length() && LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA.Length();
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                case VARIABLE_CLASS:
                                case VARIABLE_DELEGATE:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA.Length() != 0);
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                case VARIABLE_ARRAY:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA.Length() && ((Array *)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA)->Count();
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;
                            }
                            continue;                    //break;

                        case KEY_BOR:
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_NUMBER:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA.Length() || LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                case VARIABLE_STRING:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA.Length() || LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA.Length();
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                case VARIABLE_CLASS:
                                case VARIABLE_DELEGATE:
                                    // always true for class and delegates
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = 1;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                case VARIABLE_ARRAY:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA.Length() || ((Array *)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA)->Count();
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;
                            }
                            continue;                    //break;

                        case KEY_CND_NULL:
                            // ------------------- //
                            CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1])
                            // ------------------- //
                            if (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA.Length()) {
                                LOCAL_CONTEXT [OE->Result_ID - 1]->STRING_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->STRING_DATA;
                                LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_STRING;
                                continue;
                            }
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_NUMBER:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                case VARIABLE_STRING:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->STRING_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_STRING;
                                    break;

                                case VARIABLE_DELEGATE:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;

                                case VARIABLE_CLASS:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE       = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE;
                                    ((CompiledClass *)LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA)->LINKS++;
                                    break;

                                case VARIABLE_ARRAY:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE       = VARIABLE_ARRAY;
                                    ((Array *)LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA)->LINKS++;
                                    break;
                            }
                            continue;                    //break;

                        default:
                            Exc = new AnsiException(ERR650, OE->Operator._DEBUG_INFO_LINE, 650, /*OE->Operator._PARSE_DATA.Length() ? OE->Operator._PARSE_DATA :*/ GetKeyWord(OE->Operator.ID), ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME);                    //OPT->_CLASS,OPT->_MEMBER);
                            this->AcknoledgeRunTimeError(Exc);
                            break;
                    }
                    continue;             //break;

                case VARIABLE_CLASS:
                    OPERATOR_ID = 0;
                    switch (OE_Operator_ID) {
                        //case KEY_ASG:
                        //            OPERATOR_ID=DEF_ASG;
                        //            if (((CompiledClass *)(LOCAL_CONTEXT[OE->OperandRight.ID-1]->CLASS_DATA))->_Class->has_equal)
                        //               break;
                        case KEY_BY_REF:
                            //---------------------------//
                            if (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA != LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA) {
                                CLASS_CHECK(LOCAL_CONTEXT [OE->OperandLeft.ID - 1])
                                //CLASS_CHECK(LOCAL_CONTEXT[OE->Result_ID-1])
                            } else {
                                if (LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA == LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA) {
                                    ((CompiledClass *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA)->LINKS -= 2;
                                } else {
                                    CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1]);
                                    ((CompiledClass *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA)->LINKS -= 1;
                                }
                            }
                            //---------------------------//

                            LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA;
                            ((CompiledClass *)LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA)->LINKS += 2;

                            // schimb tipul !
                            LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->TYPE = VARIABLE_CLASS;
                            // este o proprietate
                            if (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->IS_PROPERTY_RESULT) {
                                CCTEMP = (CompiledClass *)((VariableDATA *)((VariableDATA *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1])->CALL_SET)->CLASS_DATA;
                                RESULT = (VariableDATA *)((VariableDATA *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1])->CALL_SET;
                                CCTEMP->_Class->SetProperty(LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->IS_PROPERTY_RESULT - 1, (VariableDATA *)((VariableDATA *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1])->CALL_SET, &OE->OperandLeft, CCTEMP->_Class->CLSID == ClassID, OE->Result_ID - 1, LOCAL_CONTEXT, ClassID, LocalClassID);
                            }
                            continue;
                            break;

                        case KEY_ASG:
                            OPERATOR_ID = DEF_ASG;
                            break;

                        case KEY_INDEX_OPEN:
                            OPERATOR_ID = DEF_SELECTOR_I;
                            break;

                        case KEY_SUM:
                            OPERATOR_ID = DEF_SUM;
                            break;

                        case KEY_MUL:
                            OPERATOR_ID = DEF_MUL;
                            break;

                        case KEY_DIV:
                            OPERATOR_ID = DEF_DIV;
                            break;

                        case KEY_REM:
                            OPERATOR_ID = DEF_REM;
                            break;

                        case KEY_DIF:
                            OPERATOR_ID = DEF_DIF;
                            break;

                        case KEY_SHL:
                            OPERATOR_ID = DEF_SHL;
                            break;

                        case KEY_SHR:
                            OPERATOR_ID = DEF_SHR;
                            break;

                        case KEY_LES:
                            OPERATOR_ID = DEF_LES;
                            break;

                        case KEY_LEQ:
                            OPERATOR_ID = DEF_LEQ;
                            break;

                        case KEY_GRE:
                            OPERATOR_ID = DEF_GRE;
                            break;

                        case KEY_GEQ:
                            OPERATOR_ID = DEF_GEQ;
                            break;

                        case KEY_EQU:
                            CCTEMP = (CompiledClass *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA;
                            if (!CCTEMP->_Class->RELOCATIONS [DEF_EQU]) {
                                CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1])

                                switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                    case VARIABLE_CLASS:
                                        LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA == LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA ? 1 : 0;
                                        LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                        break;

                                    default:
                                        LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = 0;
                                        LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                }
                                continue;
                            }
                            OPERATOR_ID = DEF_EQU;
                            break;

                        case KEY_NEQ:
                            CCTEMP = (CompiledClass *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA;
                            if (!CCTEMP->_Class->RELOCATIONS [DEF_NEQ]) {
                                CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1])

                                switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                    case VARIABLE_CLASS:
                                        LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA != LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA ? 1 : 0;
                                        LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                        break;

                                    default:
                                        LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = 1;
                                        LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                }
                                continue;
                            }
                            OPERATOR_ID = DEF_NEQ;
                            break;

                        case KEY_AND:
                            OPERATOR_ID = DEF_AND;
                            break;

                        case KEY_XOR:
                            OPERATOR_ID = DEF_XOR;
                            break;

                        case KEY_OR:
                            OPERATOR_ID = DEF_OR;
                            break;

                        case KEY_BAN:
                            CCTEMP = (CompiledClass *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA;
                            if (!CCTEMP->_Class->RELOCATIONS [DEF_BAN]) {
                                CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1])
                                switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                    case VARIABLE_NUMBER:
                                        LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA != 0;
                                        LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                        break;

                                    case VARIABLE_STRING:
                                        LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA.Length() != 0;
                                        LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                        break;

                                    case VARIABLE_CLASS:
                                    case VARIABLE_DELEGATE:
                                        LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = 1;
                                        LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                        break;

                                    case VARIABLE_ARRAY:
                                        LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = ((Array *)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA)->Count() != 0;
                                        LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                        break;
                                }
                                continue;
                            }

                            OPERATOR_ID = DEF_BAN;
                            break;

                        case KEY_BOR:
                            CCTEMP = (CompiledClass *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA;
                            if (!CCTEMP->_Class->RELOCATIONS [DEF_BOR]) {
                                CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1])
                                LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = 1;
                                LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                continue;
                            }
                            OPERATOR_ID = DEF_BOR;
                            break;

                        case KEY_ASU:
                            OPERATOR_ID = DEF_ASU;
                            break;

                        case KEY_ADI:
                            OPERATOR_ID = DEF_ADI;
                            break;

                        case KEY_AMU:
                            OPERATOR_ID = DEF_AMU;
                            break;

                        case KEY_ADV:
                            OPERATOR_ID = DEF_ADV;
                            break;

                        case KEY_ARE:
                            OPERATOR_ID = DEF_ARE;
                            break;

                        case KEY_AAN:
                            OPERATOR_ID = DEF_AAN;
                            break;

                        case KEY_AXO:
                            OPERATOR_ID = DEF_AXO;
                            break;

                        case KEY_AOR:
                            OPERATOR_ID = DEF_AOR;
                            break;

                        case KEY_ASL:
                            OPERATOR_ID = DEF_ASL;
                            break;

                        case KEY_ASR:
                            OPERATOR_ID = DEF_ASR;
                            break;

                        // unari !
                        case KEY_NOT:
                            CCTEMP = (CompiledClass *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA;
                            if (!CCTEMP->_Class->RELOCATIONS [DEF_NOT]) {
                                CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1])
                                LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = 0;
                                LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                continue;
                            }
                            OPERATOR_ID = DEF_NOT;
                            break;

                        case KEY_COM:
                            OPERATOR_ID = DEF_COM;
                            break;

                        case KEY_INC_LEFT:
                        case KEY_INC:
                            OPERATOR_ID = DEF_INC;
                            break;

                        case KEY_DEC_LEFT:
                        case KEY_DEC:
                            OPERATOR_ID = DEF_DEC;
                            break;

                        case KEY_CND_NULL:
                            if ((LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE == VARIABLE_CLASS) && (LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA == LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA)) {
                                continue;
                            }
                            //---------------------------//
                            CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1])
                            //---------------------------//
                            LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA;
                            ((CompiledClass *)LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA)->LINKS++;
                            LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->TYPE = VARIABLE_CLASS;
                            continue;

                        default:
                            Exc = new AnsiException(ERR920, OE->Operator._DEBUG_INFO_LINE, 920, /*OE->Operator._PARSE_DATA.Length() ? OE->Operator._PARSE_DATA :*/ GetKeyWord(OE->Operator.ID), ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME);                    //OPT->_CLASS,OPT->_MEMBER);
                            this->AcknoledgeRunTimeError(Exc);
                            break;
                    }
                    //////////////////////////////////////////////////////
                    // restaurez tipul ...                              //
                    //////////////////////////////////////////////////////
                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = pushed_type;             /////
                    //////////////////////////////////////////////////////
                    if (!OPERATOR_ID) {
                        continue;
                    }
                    if (OE->OperandRight.ID) {
                        OPERATOR_PARAM->COUNT = 1;
                        DELTA_UNREF(OPERATOR_PARAM, OPERATOR_PARAM->PARAM_INDEX) [0] = OE->OperandRight.ID;
                    } else {
                        OPERATOR_PARAM->COUNT = 0;
                    }
                    CCTEMP = (CompiledClass *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA;
                    try {
                        RESULT = CCTEMP->_Class->ExecuteMember(OPERATOR_ID, LOCAL_CONTEXT [OE->OperandLeft.ID - 1], &/*OE->Operator*/ OE->OperandLeft, CCTEMP->_Class->CLSID == ClassID, OPERATOR_PARAM, LOCAL_CONTEXT, 0, ClassID, LocalClassID);
                        // am adaugat | !RESULT pt atunci cand e o erroare
                        //if (((RESULT) && (RESULT->TYPE==VARIABLE_CLASS) && (!RESULT->CLASS_DATA)) || (!RESULT))
                        if (((RESULT) && ((RESULT->TYPE == VARIABLE_CLASS) || (RESULT->TYPE == VARIABLE_DELEGATE)) && (!RESULT->CLASS_DATA)) || (!RESULT)) {
                            LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = VARIABLE_NUMBER;
                        }
                        if (RESULT == LOCAL_CONTEXT [OE->Result_ID - 1]) {
                            continue;
                        }
                        if (RESULT) {
                            /*if (!--LOCAL_CONTEXT[OE->Result_ID-1]->LINKS)
                             *  delete LOCAL_CONTEXT[OE->Result_ID-1];*/
                            FREE_VARIABLE(LOCAL_CONTEXT [OE->Result_ID - 1]);
                            LOCAL_CONTEXT [OE->Result_ID - 1] = RESULT;
                            RESULT->LINKS++;
                        }
                    } catch (VariableDATA *LAST_THROW) {
                        // incrementeze link-urile ...
                        THROW_DATA = LAST_THROW;
                        if ((CATCH_INSTRUCTION_POINTER) && (CATCH_VARIABLE)) {
                            /*LOCAL_CONTEXT[CATCH_VARIABLE-1]->LINKS--;
                             * if (!LOCAL_CONTEXT[CATCH_VARIABLE-1]->LINKS)
                             *  delete LOCAL_CONTEXT[CATCH_VARIABLE-1];*/
                            FREE_VARIABLE(LOCAL_CONTEXT [CATCH_VARIABLE - 1]);
                            LOCAL_CONTEXT [CATCH_VARIABLE - 1] = THROW_DATA;
                            INSTRUCTION_POINTER       = CATCH_INSTRUCTION_POINTER;
                            THROW_DATA                = 0;
                            CATCH_INSTRUCTION_POINTER = 0;
                            CATCH_VARIABLE            = 0;
                            //-------------//
                            RESTORE_TRY_DATA;
                            //-------------//
                        } else {
                            return(0);
                        }
                    }
                    break;

                case VARIABLE_ARRAY:
                    switch (OE_Operator_ID) {
                        case KEY_ASG:
                        case KEY_BY_REF:
                            CLASS_CHECK(LOCAL_CONTEXT [OE->OperandLeft.ID - 1])
                            // next line was commented (?)
                            CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1])
                            //---------------------------//
                            LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA;
                            ((Array *)LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA)->LINKS += 2;
                            // schimb tipul !
                            LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->TYPE = VARIABLE_ARRAY;
                            // este o proprietate
                            if (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->IS_PROPERTY_RESULT) {
                                CCTEMP = (CompiledClass *)((VariableDATA *)((VariableDATA *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1])->CALL_SET)->CLASS_DATA;
                                RESULT = (VariableDATA *)((VariableDATA *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1])->CALL_SET;
                                CCTEMP->_Class->SetProperty(LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->IS_PROPERTY_RESULT - 1, (VariableDATA *)((VariableDATA *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1])->CALL_SET, &OE->OperandLeft, CCTEMP->_Class->CLSID == ClassID, OE->Result_ID - 1, LOCAL_CONTEXT, ClassID, LocalClassID);
                            }
                            continue;
                            break;

                        case KEY_INDEX_OPEN:
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_NUMBER:
                                case VARIABLE_STRING:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = pushed_type;
                                    RETURN_DATA = ((Array *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA)->Get(LOCAL_CONTEXT [OE->OperandRight.ID - 1]);
                                    if (!RETURN_DATA) {
                                        Exc = new AnsiException(ERR1110, OE->OperandLeft._DEBUG_INFO_LINE, 1110, AnsiString(LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA), ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME);                          //OPT->_CLASS,OPT->_MEMBER);
                                        this->AcknoledgeRunTimeError(Exc);
                                        LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = VARIABLE_NUMBER;
                                        break;
                                    }
                                    if (LOCAL_CONTEXT [OE->Result_ID - 1] != RETURN_DATA) {
                                        FREE_VARIABLE(LOCAL_CONTEXT [OE->Result_ID - 1]);
                                        LOCAL_CONTEXT [OE->Result_ID - 1] = RETURN_DATA;
                                        RETURN_DATA->LINKS++;
                                    }
                                    continue;                           //break;

                                default:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = pushed_type;
                                    Exc = new AnsiException(ERR900, OE->OperandLeft._DEBUG_INFO_LINE, 900, OE->OperandLeft._PARSE_DATA, ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME);                           //OPT->_CLASS,OPT->_MEMBER);
                                    this->AcknoledgeRunTimeError(Exc);
                                    break;
                            }
                            continue;                //break;

                        case KEY_SUM:                // array+array, array+ELEMENT => array.Add(element)
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_STRING:
                                case VARIABLE_NUMBER:
                                case VARIABLE_CLASS:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = pushed_type;
                                    RETURN_DATA = ((Array *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA)->NewArray();
                                    ((Array *)RETURN_DATA->CLASS_DATA)->Add(LOCAL_CONTEXT [OE->OperandRight.ID - 1]);
                                    if (LOCAL_CONTEXT [OE->Result_ID - 1] != RETURN_DATA) {
                                        FREE_VARIABLE(LOCAL_CONTEXT [OE->Result_ID - 1]);
                                        LOCAL_CONTEXT [OE->Result_ID - 1] = RETURN_DATA;
                                        RETURN_DATA->LINKS++;
                                    }
                                    continue;                           //break;

                                case VARIABLE_ARRAY:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = pushed_type;
                                    RETURN_DATA = ((Array *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA)->NewArray();
                                    ((Array *)RETURN_DATA->CLASS_DATA)->Concat((Array *)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA);
                                    if (LOCAL_CONTEXT [OE->Result_ID - 1] != RETURN_DATA) {
                                        FREE_VARIABLE(LOCAL_CONTEXT [OE->Result_ID - 1]);
                                        LOCAL_CONTEXT [OE->Result_ID - 1] = RETURN_DATA;
                                        RETURN_DATA->LINKS++;
                                    }
                                    continue;                           //break;
                            }
                            break;

                        case KEY_ASU:                // array+=array, array+=ELEMENT => array.Add(element)
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_STRING:
                                case VARIABLE_NUMBER:
                                case VARIABLE_CLASS:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = pushed_type;
                                    RETURN_DATA = ((Array *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA)->Add(LOCAL_CONTEXT [OE->OperandRight.ID - 1]);
                                    if (LOCAL_CONTEXT [OE->Result_ID - 1] != RETURN_DATA) {
                                        FREE_VARIABLE(LOCAL_CONTEXT [OE->Result_ID - 1]);
                                        LOCAL_CONTEXT [OE->Result_ID - 1] = RETURN_DATA;
                                        RETURN_DATA->LINKS++;
                                    }
                                    continue;                           //break;

                                case VARIABLE_ARRAY:
                                    CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1]);
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA = ((Array *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA)->Concat((Array *)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA);
                                    if (LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA) {
                                        LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = VARIABLE_ARRAY;
                                        ((Array *)LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA)->LINKS++;
                                    } else {
                                        LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = VARIABLE_NUMBER;
                                    }
                                    continue;                           //break;
                            }
                            break;

                        case KEY_LENGTH:
                            CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1]);
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = ((Array *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA)->Count();
                            LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                            continue;                    //break;

                        case KEY_EQU:
                            CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1]);
                            if (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE != VARIABLE_ARRAY) {
                                LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = 0;
                            } else {
                                LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA == LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA);
                            }
                            LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = VARIABLE_NUMBER;
                            continue;                    //break;

                        case KEY_NEQ:
                            CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1]);
                            if (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE != VARIABLE_ARRAY) {
                                LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = 1;
                            } else {
                                LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA != LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA);
                            }
                            LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = VARIABLE_NUMBER;
                            continue;                    //break;

                        case KEY_BAN:
                            CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1]);
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_NUMBER:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = ((Array *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA)->Count() && LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                case VARIABLE_STRING:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = ((Array *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA)->Count() && LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA.Length();
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                case VARIABLE_CLASS:
                                case VARIABLE_DELEGATE:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = (((Array *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA)->Count() != 0);
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                case VARIABLE_ARRAY:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = ((Array *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA)->Count() && ((Array *)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA)->Count();
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;
                            }
                            continue;                    //break;

                        case KEY_BOR:
                            CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1]);
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_NUMBER:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = ((Array *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA)->Count() || LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                case VARIABLE_STRING:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = ((Array *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA)->Count() || LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA.Length();
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                case VARIABLE_CLASS:
                                case VARIABLE_DELEGATE:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = 1;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                case VARIABLE_ARRAY:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = ((Array *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA)->Count() || ((Array *)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA)->Count();
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;
                            }
                            continue;                    //break;

                        case KEY_NOT:
                            CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1]);
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = ((Array *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA)->Count() == 0;
                            LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                            continue;

                        case KEY_CND_NULL:
                            if ((LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE == VARIABLE_ARRAY) && (LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA == LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA) && (((Array *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA)->Count())) {
                                continue;
                            }
                            // ------------------- //
                            CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1])
                            // ------------------- //
                            if (((Array *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA)->Count()) {
                                LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA;
                                ((Array *)LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA)->LINKS++;
                                LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = VARIABLE_ARRAY;
                                continue;
                            }
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_NUMBER:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                case VARIABLE_STRING:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->STRING_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_STRING;
                                    break;

                                case VARIABLE_DELEGATE:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;

                                case VARIABLE_CLASS:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE       = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE;
                                    ((CompiledClass *)LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA)->LINKS++;
                                    break;

                                case VARIABLE_ARRAY:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE       = VARIABLE_ARRAY;
                                    ((Array *)LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA)->LINKS++;
                                    break;
                            }
                            continue;

                        default:
                            CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1]);
                            LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = VARIABLE_NUMBER;
                            Exc = new AnsiException(ERR910, OE->Operator._DEBUG_INFO_LINE, 910, /*OE->Operator._PARSE_DATA.Length() ? OE->Operator._PARSE_DATA :*/ GetKeyWord(OE->Operator.ID), ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME);                    //OPT->_CLASS,OPT->_MEMBER);
                            this->AcknoledgeRunTimeError(Exc);
                            break;
                    }
                    break;

                case VARIABLE_DELEGATE:
                    switch (OE_Operator_ID) {
                        case KEY_ASG:
                        case KEY_BY_REF:
                            // un bug ciudat ....
                            // ------------------- //
                            if (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA != LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA) {
                                CLASS_CHECK(LOCAL_CONTEXT [OE->OperandLeft.ID - 1])
                            } else {
                                ((CompiledClass *)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA)->LINKS -= 1;
                            }

                            // ------------------- //
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                            LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA  = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA;
                            ((CompiledClass *)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA)->LINKS += 2;
                            // schimb tipul !
                            LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->TYPE = VARIABLE_DELEGATE;
                            // este o proprietate
                            //----------------//
                            PROPERTY_CODE
                            //----------------//
                            continue;                    //break;

                        case KEY_EQU:
                            CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1]);
                            if (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE != VARIABLE_DELEGATE) {
                                LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = 0;
                            } else {
                                LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = ((LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA == LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA) && (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA == LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA));
                            }
                            LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = VARIABLE_NUMBER;
                            continue;                    //break;

                        case KEY_NEQ:
                            CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1]);
                            if (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE != VARIABLE_DELEGATE) {
                                LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = 0;
                            } else {
                                LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = ((LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA != LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA) || (LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA != LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA));
                            }
                            LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = VARIABLE_NUMBER;
                            continue;                    //break;

                        case KEY_BAN:
                            CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1]);
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_NUMBER:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA != 0);
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                case VARIABLE_STRING:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA.Length() != 0);
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                case VARIABLE_CLASS:
                                case VARIABLE_DELEGATE:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = 1;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;

                                case VARIABLE_ARRAY:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = (((Array *)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA)->Count() != 0);
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;
                            }
                            continue;                    //break;

                        case KEY_BOR:
                            CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1]);
                            switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                                case VARIABLE_NUMBER:
                                case VARIABLE_STRING:
                                case VARIABLE_CLASS:
                                case VARIABLE_DELEGATE:
                                case VARIABLE_ARRAY:
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = 1;
                                    LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                                    break;
                            }
                            continue;                    //break;

                        case KEY_NOT:
                            CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1]);
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = 0;
                            LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE        = VARIABLE_NUMBER;
                            continue;

                        case KEY_CND_NULL:
                            if ((LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE == VARIABLE_DELEGATE) && (LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA == LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA) && (LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA == LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA)) {
                                continue;
                            }
                            //---------------------------//
                            CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1])
                            //---------------------------//
                            LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA  = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->CLASS_DATA;
                            LOCAL_CONTEXT [OE->Result_ID - 1]->NUMBER_DATA = LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->NUMBER_DATA;
                            ((CompiledClass *)LOCAL_CONTEXT [OE->Result_ID - 1]->CLASS_DATA)->LINKS++;
                            LOCAL_CONTEXT [OE->OperandLeft.ID - 1]->TYPE = VARIABLE_CLASS;
                            continue;

                        default:
                            CLASS_CHECK(LOCAL_CONTEXT [OE->Result_ID - 1]);
                            LOCAL_CONTEXT [OE->Result_ID - 1]->TYPE = VARIABLE_NUMBER;
                            Exc = new AnsiException(ERR960, OE->Operator._DEBUG_INFO_LINE, 960, /*OE->Operator._PARSE_DATA*/ GetKeyWord(OE->Operator.ID), ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME);                    //OPT->_CLASS,OPT->_MEMBER);
                            this->AcknoledgeRunTimeError(Exc);
                            break;
                    }
                    break;
            }
        } else
        if (OE->Operator.TYPE == TYPE_OPTIMIZED_KEYWORD) {
            //double d=0;
            switch (OE_Operator_ID) {
                case KEY_OPTIMIZED_IF:
                    // verific daca este adevarata conditzia lui IF
                    // daca nu, fac saltul complementar

                    switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                        case VARIABLE_STRING:
                            //if ((LOCAL_CONTEXT[OE->OperandRight.ID-1]->STRING_DATA)==NULL_STRING)
                            if (!LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA.Length()) {
                                INSTRUCTION_POINTER = OE->OperandReserved.ID;
                            }
                            continue;                            //break;

                        case VARIABLE_NUMBER:
                            //d=(LOCAL_CONTEXT[OE->OperandRight.ID-1]->NUMBER_DATA);
                            if (!LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA) {
                                INSTRUCTION_POINTER = OE->OperandReserved.ID;
                            }
                            continue;                            //break;

                        case VARIABLE_ARRAY:
                            if (!((Array *)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA)->Count()) {
                                INSTRUCTION_POINTER = OE->OperandReserved.ID;
                            }
                            continue;                            //break;
                    }
                    break;

                case KEY_OPTIMIZED_GOTO:          // goto-ul ... pur si simplu ma mut la linia respectiva
                    INSTRUCTION_POINTER = OE->OperandReserved.ID;
                    continue;                     //break;

                case KEY_OPTIMIZED_ECHO:
                    if (out) {
                        switch (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE) {
                            case VARIABLE_STRING:
                                //(*out) << LOCAL_CONTEXT[OE->OperandRight.ID-1]->STRING_DATA;
                                out->Print(LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA, LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA.Length());
                                break;

                            case VARIABLE_NUMBER:
                                //(*out) << LOCAL_CONTEXT[OE->OperandRight.ID-1]->NUMBER_DATA;
                                out->Print(LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA);
                                break;

                            case VARIABLE_CLASS:
                                CCTEMP = (CompiledClass *)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA;
                                out->Print(CCTEMP->_Class->NAME);
                                break;

                            case VARIABLE_ARRAY:
                                out->Print(((Array *)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA)->ToString());
                                break;

                            case VARIABLE_DELEGATE:
                                CCTEMP = (CompiledClass *)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA;
                                out->Print(CCTEMP->_Class->NAME);
                                out->Print("::");
                                //int reloc=(INTEGER)LOCAL_CONTEXT[OE->OperandRight.ID-1]->NUMBER_DATA;
                                //reloc=CCTEMP->_Class->RELOCATIONS[reloc]-1;
                                //out->Print(AnsiString((long)reloc));
                                out->Print(
                                    CCTEMP->_Class->pMEMBERS [
                                        CCTEMP->_Class->RELOCATIONS [
                                            (INTEGER)LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA
                                        ]
                                        - 1
                                    ]->NAME
                                    //CCTEMP->_Class->pMEMBERS[CCTEMP->_Class->RELOCATIONS2[CCTEMP->_Class->RELOCATIONS[(INTEGER)LOCAL_CONTEXT[OE->OperandRight.ID-1]->NUMBER_DATA-1]]-1]->NAME
                                    );
                                break;
                        }
                    }
                    continue;                     //break;

                case KEY_OPTIMIZED_RETURN:
                    // incrementeze link-urile ...
                    if (LOCAL_CONTEXT [OE->OperandRight.ID - 1]->LINKS == 1) {
                        LOCAL_CONTEXT [OE->OperandRight.ID - 1]->LINKS = 2;
                        LOCAL_CONTEXT [OE->OperandRight.ID - 1]->IS_PROPERTY_RESULT = 0;

                        /*if ((LOCAL_CONTEXT[OE->OperandRight.ID-1]->TYPE==VARIABLE_CLASS) && (LOCAL_CONTEXT[OE->OperandRight.ID-1]->CLASS_DATA))
                         *  ((CompiledClass *)LOCAL_CONTEXT[OE->OperandRight.ID-1]->CLASS_DATA)->LINKS++;*/
                        LOCAL_CONTEXT [OE->OperandRight.ID - 1]->EXTRA_DATA = 0;
                        return(LOCAL_CONTEXT [OE->OperandRight.ID - 1]);
                    } else {
                        // daca este operator, returnez prin referinta
                        if (OWNER->IS_OPERATOR) {
                            LOCAL_CONTEXT [OE->OperandRight.ID - 1]->LINKS++;
                            LOCAL_CONTEXT [OE->OperandRight.ID - 1]->IS_PROPERTY_RESULT = 0;
                            LOCAL_CONTEXT [OE->OperandRight.ID - 1]->EXTRA_DATA         = 0;
                            return(LOCAL_CONTEXT [OE->OperandRight.ID - 1]);
                        }
                        RETURN_DATA = new VariableDATA;
                        //RETURN_DATA->ACCESS             =   LOCAL_CONTEXT[OE->OperandRight.ID-1]->ACCESS;
                        RETURN_DATA->CLASS_DATA         = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->CLASS_DATA;
                        RETURN_DATA->LINKS              = 1;
                        RETURN_DATA->NUMBER_DATA        = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->NUMBER_DATA;
                        RETURN_DATA->TYPE               = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->TYPE;
                        RETURN_DATA->CALL_SET           = 0;
                        RETURN_DATA->IS_PROPERTY_RESULT = 0;
                        RETURN_DATA->EXTRA_DATA         = 0;
                        if (RETURN_DATA->TYPE == VARIABLE_STRING) {
                            RETURN_DATA->STRING_DATA = LOCAL_CONTEXT [OE->OperandRight.ID - 1]->STRING_DATA;
                        }
                        if (RETURN_DATA->CLASS_DATA) {
                            if ((RETURN_DATA->TYPE == VARIABLE_CLASS) || (RETURN_DATA->TYPE == VARIABLE_DELEGATE)) {
                                ((CompiledClass *)RETURN_DATA->CLASS_DATA)->LINKS++;
                            } else
                            if (RETURN_DATA->TYPE == VARIABLE_ARRAY) {
                                ((Array *)RETURN_DATA->CLASS_DATA)->LINKS++;
                            }
                        }
                        return(RETURN_DATA);
                    }
                    break;

                case KEY_OPTIMIZED_THROW:
                    // incrementeze link-urile ...
                    LOCAL_CONTEXT [OE->OperandRight.ID - 1]->LINKS++;
                    THROW_DATA             = LOCAL_CONTEXT [OE->OperandRight.ID - 1];
                    THROW_DATA->EXTRA_DATA = 0;
                    if ((CATCH_INSTRUCTION_POINTER) && (CATCH_VARIABLE)) {
                        /*LOCAL_CONTEXT[CATCH_VARIABLE-1]->LINKS--;
                         * if (!LOCAL_CONTEXT[CATCH_VARIABLE-1]->LINKS)
                         *  delete LOCAL_CONTEXT[CATCH_VARIABLE-1];*/
                        FREE_VARIABLE(LOCAL_CONTEXT [CATCH_VARIABLE - 1]);
                        LOCAL_CONTEXT [CATCH_VARIABLE - 1] = THROW_DATA;
                        INSTRUCTION_POINTER       = CATCH_INSTRUCTION_POINTER;
                        THROW_DATA                = 0;
                        CATCH_INSTRUCTION_POINTER = 0;
                        CATCH_VARIABLE            = 0;
                        //------------------//
                        RESTORE_TRY_DATA;
                        //------------------//
                    } else {
                        return(0);
                    }
                    continue;                     //break;

                case KEY_OPTIMIZED_TRY_CATCH:
                    CATCH_INSTRUCTION_POINTER = OE->OperandReserved.ID;
                    CATCH_VARIABLE            = OE->Result_ID;
                    PREVIOUS_TRY = OE->OperandLeft.ID;
                    continue;                     //break;

                case KEY_OPTIMIZED_END_CATCH:
                    CATCH_INSTRUCTION_POINTER = 0;
                    CATCH_VARIABLE            = 0;
                    THROW_DATA = 0;
                    //------------------//
                    RESTORE_TRY_DATA;
                    //------------------//
                    continue;                     //break;

                case KEY_OPTIMIZED_DEBUG_TRAP:
                    if (DEBUGGER_TRAP) {
                        // chem debugger-ul ... iar daca returneaza ceva diferit de 0, termin procedura
                        if (DEBUGGER_TRAP(OPT->DATA, LOCAL_CONTEXT, OPT->dataCount, OE->Operator._DEBUG_INFO_LINE, ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME.c_str(), (GET_VARIABLE_PROC)GetVariableByName, DEBUGGER_RESERVED)) {
                            INSTRUCTION_POINTER = INSTRUCTION_COUNT;
                        }
                    }
                    continue;                     //break;
            }
        }
    }

    THROW_DATA  = 0;
    RETURN_DATA = new VariableDATA;
    //RETURN_DATA->ACCESS             =   ACCESS_LOCAL;//ACCESS_PUBLIC;
    RETURN_DATA->CLASS_DATA         = 0;
    RETURN_DATA->LINKS              = 1;
    RETURN_DATA->NUMBER_DATA        = 0;
    RETURN_DATA->TYPE               = VARIABLE_NUMBER;
    RETURN_DATA->CALL_SET           = 0;
    RETURN_DATA->IS_PROPERTY_RESULT = 0;
    RETURN_DATA->EXTRA_DATA         = 0;
    return(RETURN_DATA);
}

VariableDATA **ConceptInterpreter::CreateEnviroment(VariableDATA *Sender, ParamList *FORMAL_PARAM, VariableDATA **SenderCTX) {
    static_call_main = (SenderCTX == 0);
    VariableDATA **LOCAL_CONTEXT;
    if (OPT->dataCount) {
        THROW_DATA = 0;
        CATCH_INSTRUCTION_POINTER = 0;
        CATCH_VARIABLE            = 0;


        LOCAL_CONTEXT = new VariableDATA * [OPT->dataCount];

        // primul este "this"

        /*if (Sender->TYPE==VARIABLE_CLASS) {
         *  LOCAL_CONTEXT[0]                 =   new VariableDATA;
         *
         *  LOCAL_CONTEXT[0]->TYPE           =   Sender->TYPE;
         *  LOCAL_CONTEXT[0]->LINKS          =   1;
         *  //LOCAL_CONTEXT[0]->NUMBER_DATA    =   Sender->NUMBER_DATA;
         *  LOCAL_CONTEXT[0]->CLASS_DATA     =   Sender->CLASS_DATA;
         *
         *  LOCAL_CONTEXT[0]->CALL_SET          =   0;
         *  LOCAL_CONTEXT[0]->EXTRA_DATA        =   0;
         *  LOCAL_CONTEXT[0]->IS_PROPERTY_RESULT=   0;
         *
         *  ((CompiledClass *)Sender->CLASS_DATA)->LINKS++;
         * } else {*/
        LOCAL_CONTEXT [0] = Sender;
        Sender->LINKS++;
        //}

        // urmatorii sunt parametri formali ...
        INTEGER ParamCount = FORMAL_PARAM ? FORMAL_PARAM->COUNT : 0;    //OWNER->PARAMETERS_COUNT;
        INTEGER data_count = OPT->dataCount;

        for (register INTEGER i = 1; i < data_count; i++) {
            // variable descriptor
            VariableDESCRIPTOR *TARGET = &OPT->DATA [i];
            if (i > ParamCount) {
                VariableDATA *LOCAL_CONTEXT_i = new VariableDATA;
                LOCAL_CONTEXT [i] = LOCAL_CONTEXT_i;

                LOCAL_CONTEXT_i->TYPE  = TARGET->TYPE;  //TARGET->TYPE < 0 ? -TARGET->TYPE : TARGET->TYPE;
                LOCAL_CONTEXT_i->LINKS = 1;
                //LOCAL_CONTEXT_i->NUMBER_DATA    =   LOCAL_CONTEXT_i->TYPE==VARIABLE_NUMBER ? OPT->DATA[i]->value.ToFloat() : 0;
                LOCAL_CONTEXT_i->NUMBER_DATA = TARGET->nValue;

                switch (LOCAL_CONTEXT_i->TYPE) {
                    case VARIABLE_ARRAY:
                        LOCAL_CONTEXT_i->CLASS_DATA = new Array();
                        break;

                    case VARIABLE_STRING:
                        //LOCAL_CONTEXT_i->STRING_DATA    =    TARGET->value;
                        if (TARGET->value.Length()) {
                            LOCAL_CONTEXT_i->STRING_DATA.LoadBuffer(TARGET->value.c_str(), TARGET->value.Length());
                        }


                    // attention !!! no break here !
                    default:
                        LOCAL_CONTEXT_i->CLASS_DATA = 0;
                }

                /*if (LOCAL_CONTEXT_i->TYPE==VARIABLE_STRING)
                 *  LOCAL_CONTEXT_i->STRING_DATA    =    TARGET->value;
                 *
                 * if (TARGET->TYPE==VARIABLE_ARRAY)
                 *  LOCAL_CONTEXT_i->CLASS_DATA     =   new Array();
                 * else
                 *  LOCAL_CONTEXT_i->CLASS_DATA     =   0;*/

                //LOCAL_CONTEXT_i->ACCESS         =   ACCESS_LOCAL;

                LOCAL_CONTEXT_i->CALL_SET           = 0;
                LOCAL_CONTEXT_i->IS_PROPERTY_RESULT = 0;
                LOCAL_CONTEXT_i->EXTRA_DATA         = 0;
            } else {
                VariableDATA *sndr = SenderCTX [DELTA_UNREF(FORMAL_PARAM, FORMAL_PARAM->PARAM_INDEX) [i - 1] - 1];
                if (TARGET->TYPE < 0) {
                    // validator !
                    if (sndr->TYPE != -TARGET->TYPE) {
                        VariableDATA *sender = SenderCTX ? SenderCTX [0] : 0;
                        if ((sender) && (sender->TYPE == VARIABLE_CLASS) && (sender->CLASS_DATA)) {
                            CompiledClass *cc = (CompiledClass *)sender->CLASS_DATA;
                            this->AcknoledgeRunTimeError(new AnsiException(ERR1205, OWNER->_DEBUG_STARTLINE, 1205, AnsiString("parameter ") + AnsiString((long)i), cc->_Class->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME));
                        } else {
                            this->AcknoledgeRunTimeError(new AnsiException(ERR1205, OWNER->_DEBUG_STARTLINE, 1205, AnsiString("parameter ") + AnsiString((long)i), ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME));
                        }
                    } else
                    if (sndr->TYPE == VARIABLE_CLASS) {
                        long CLS_ID = (long)TARGET->nValue - 1;
                        if (CLS_ID >= 0) {
                            if ((!sndr->CLASS_DATA) || (!((CompiledClass *)sndr->CLASS_DATA)->_Class->Inherits(CLS_ID))) {
                                VariableDATA *sender = SenderCTX [0];
                                if ((sender) && (sender->TYPE == VARIABLE_CLASS) && (sender->CLASS_DATA)) {
                                    CompiledClass *cc = (CompiledClass *)sender->CLASS_DATA;
                                    this->AcknoledgeRunTimeError(new AnsiException(ERR1206, OWNER->_DEBUG_STARTLINE, 1206, AnsiString(OWNER->NAME.c_str()) + AnsiString(", parameter ") + AnsiString((long)i + 1), cc->_Class->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME));
                                } else {
                                    this->AcknoledgeRunTimeError(new AnsiException(ERR1206, OWNER->_DEBUG_STARTLINE, 1206, AnsiString(OWNER->NAME.c_str()) + AnsiString(", parameter ") + AnsiString((long)i + 1), ((ClassCode *)(OWNER->Defined_In))->_DEBUG_INFO_FILENAME, ((ClassCode *)(OWNER->Defined_In))->NAME, OWNER->NAME));
                                }
                            }
                        }
                    }
                }
                if (TARGET->BY_REF) {
                    LOCAL_CONTEXT [i] = sndr;   //SenderCTX[FORMAL_PARAM->PARAM_INDEX[i-1]-1];
                    LOCAL_CONTEXT [i]->LINKS++;
                } else {
                    VariableDATA *PARAM           = sndr; //SenderCTX[FORMAL_PARAM->PARAM_INDEX[i-1]-1];
                    VariableDATA *LOCAL_CONTEXT_i = new VariableDATA;
                    LOCAL_CONTEXT [i] = LOCAL_CONTEXT_i;

                    LOCAL_CONTEXT_i->TYPE        = PARAM->TYPE;
                    LOCAL_CONTEXT_i->LINKS       = 1;
                    LOCAL_CONTEXT_i->NUMBER_DATA = PARAM->NUMBER_DATA;
                    if (PARAM->TYPE == VARIABLE_STRING) {
                        LOCAL_CONTEXT_i->STRING_DATA = PARAM->STRING_DATA;
                    }
                    LOCAL_CONTEXT_i->CLASS_DATA = PARAM->CLASS_DATA;
                    //LOCAL_CONTEXT_i->ACCESS         =   ACCESS_LOCAL;//PARAM->ACCESS;

                    LOCAL_CONTEXT_i->CALL_SET           = 0;
                    LOCAL_CONTEXT_i->IS_PROPERTY_RESULT = 0;
                    LOCAL_CONTEXT_i->EXTRA_DATA         = 0;

                    if (PARAM->CLASS_DATA) {
                        if ((PARAM->TYPE == VARIABLE_CLASS) || (PARAM->TYPE == VARIABLE_DELEGATE)) {
                            ((CompiledClass *)PARAM->CLASS_DATA)->LINKS++;
                        } else
                        if (PARAM->TYPE == VARIABLE_ARRAY) {
                            ((Array *)PARAM->CLASS_DATA)->LINKS++;
                        }
                    }
                }
            }
        }
    } else {
        return(0);
    }
    return(LOCAL_CONTEXT);
}

void ConceptInterpreter::DestroyEnviroment(VariableDATA **LOCAL_CONTEXT) {
    /*if (!LOCAL_CONTEXT)
     *  return;*/

    // decrementez link-urile catre Sender
    // LOCAL_CONTEXT[0]->LINKS--;

    // anuntz debugger-ul ca am revenit din functzie
    // debugger-ul va fi anuntzat la apelul urmator ...
    if (DEBUGGER_RESERVED) {
        if (*(long *)DEBUGGER_RESERVED == (long)LOCAL_CONTEXT) {
            *(long *)DEBUGGER_RESERVED = -1;
        }
    }

    register INTEGER i;
    register INTEGER data_count = OPT->dataCount;
    //void *LOCAL_CONTEXT_0_CLASS_DATA=LOCAL_CONTEXT[0]->CLASS_DATA;

#ifndef FAST_EXIT_NO_GC_CALL
    if (static_call_main) {
        /*AnsiList *__GARBAGE_COLLECTION=new AnsiList();
         * for (i=0;i<data_count;i++) {
         *  VariableDATA *LOCAL_CONTEXT_i=LOCAL_CONTEXT[i];
         *
         *  LOCAL_CONTEXT_i->LINKS--;
         *  if (LOCAL_CONTEXT_i->CLASS_DATA) {
         *      if ((LOCAL_CONTEXT_i->TYPE==VARIABLE_CLASS) || (LOCAL_CONTEXT_i->TYPE==VARIABLE_DELEGATE)) {
         *          // a doua conditie e pusa pt situatia in care exista referinte de tip "class" la
         *          // this, this fiind class Main
         *          //if (LOCAL_CONTEXT_i->CLASS_DATA!=LOCAL_CONTEXT_0_CLASS_DATA) {
         *              //((CompiledClass *)LOCAL_CONTEXT_i->CLASS_DATA)->LINKS=0;
         *              __GARBAGE_COLLECTION->AddUniquePointer(LOCAL_CONTEXT_i->CLASS_DATA,DATA_COMPILED_CLASS);
         *          //}
         *      } else
         *      if (LOCAL_CONTEXT_i->TYPE==VARIABLE_ARRAY) {
         *          //((Array *)LOCAL_CONTEXT_i->CLASS_DATA)->LINKS=0;
         *          __GARBAGE_COLLECTION->AddUniquePointer(LOCAL_CONTEXT_i->CLASS_DATA,DATA_ARRAY);
         *      }
         *      LOCAL_CONTEXT_i->CLASS_DATA=0;
         *      LOCAL_CONTEXT_i->TYPE=VARIABLE_NUMBER;
         *  }
         *  if (LOCAL_CONTEXT_i->LINKS<1)
         *      delete LOCAL_CONTEXT_i;
         *  else {
         *      // e pus ca sa nu mai sterg clasa inca o data !!!
         *      LOCAL_CONTEXT_i->TYPE=VARIABLE_NUMBER;
         *      LOCAL_CONTEXT_i->CLASS_DATA=0;
         *  }
         * }
         * register INTEGER l_i=0;
         * while (l_i<__GARBAGE_COLLECTION->Count()) {
         *  void *ptr=__GARBAGE_COLLECTION->Item(l_i);
         *  char LAST_TYPE=__GARBAGE_COLLECTION->GetLastType();
         *  if (LAST_TYPE==DATA_ARRAY) {
         *      Array *_GELEMENT=(Array *)ptr;
         *      _GELEMENT->__GO_GARBAGE(__GARBAGE_COLLECTION);
         *  } else {
         *      CompiledClass *_GELEMENT=(CompiledClass *)ptr;
         *      _GELEMENT->__GO_GARBAGE(__GARBAGE_COLLECTION);
         *  }
         *  l_i++;
         * }
         * delete __GARBAGE_COLLECTION;*/

        // call all destructors before delete !
        int class_count = ClassList->Count();
        for (i = 0; i < class_count; i++) {
            ClassCode *CC = (ClassCode *)ClassList->Item(i);
            CC->__gc_obj.Call_All_Destructors();
        }

        for (i = 0; i < class_count; i++) {
            ClassCode *CC = (ClassCode *)ClassList->Item(i);
            CC->__gc_obj.EndOfExecution_SayBye_Objects();
        }
        if (Array::__gc_obj) {
            Array::__gc_obj->EndOfExecution_SayBye_Arrays();
            delete Array::__gc_obj;
        }
        //======================================================//
        for (i = 0; i < data_count; i++) {
            VariableDATA *LOCAL_CONTEXT_i = LOCAL_CONTEXT [i];
            LOCAL_CONTEXT_i->CLASS_DATA = 0;
            LOCAL_CONTEXT_i->TYPE       = VARIABLE_NUMBER;
            // to be activated after testing ...
            FREE_VARIABLE(LOCAL_CONTEXT_i);
        }
        //======================================================//
    } else

    /*#else
     *  return;*/
#endif
    {
        for (i = 0; i < data_count; i++) {
            VariableDATA *LOCAL_CONTEXT_i = LOCAL_CONTEXT [i];
            FREE_VARIABLE(LOCAL_CONTEXT_i);
        }
    }
    delete[] LOCAL_CONTEXT;
    //LOCAL_CONTEXT=0;
}

ConceptInterpreter::~ConceptInterpreter(void) {
    //DestroyEnviroment();
    delete [] DELTA_UNREF(OPERATOR_PARAM, OPERATOR_PARAM->PARAM_INDEX);
    delete OPERATOR_PARAM;
}
