#ifndef __CONCEPTTYPES_H
#define __CONCEPTTYPES_H

//#define SINGLE_PROCESS_DLL
//#define THREADED_FLAG __declspec(thread)
#define THREADED_FLAG

#ifdef SINGLE_PROCESS_DLL
 #define STATIC_FLAG
#else
 #define STATIC_FLAG    THREADED_FLAG static
#endif

#ifdef _WIN32
 #include <winsock.h>
#else
 #include <sys/types.h>
 #include <sys/socket.h>
 #include <netinet/in.h>
#endif

#ifdef _WIN64
 #include <winsock.h>
 #define __SIZEOF_POINTER__    8
#endif

#ifdef __x86_64
 #define __SIZEOF_POINTER__    8
#endif

#ifdef _M_IA64
 #define __SIZEOF_POINTER__    8
#endif

#ifdef _LP64
 #define __SIZEOF_POINTER__    8
#endif

#ifdef __LP64__
 #define __SIZEOF_POINTER__    8
#endif

#include <string.h>
#include "ConceptPools.h"
#include "TinyString.h"
#include "StaticString.h"
#include "Codes.h"

typedef void (*CHECK_POINT)(int status);

#define INVOKE_SET_VARIABLE                0x01
#define INVOKE_GET_VARIABLE                0x02
#define INVOKE_SET_CLASS_MEMBER            0x03
#define INVOKE_GET_CLASS_MEMBER            0x04
#define INVOKE_FREE_VARIABLE               0x05
#define INVOKE_CREATE_ARRAY                0x06
#define INVOKE_GET_ARRAY_ELEMENT           0x07
#define INVOKE_SET_ARRAY_ELEMENT           0x08
#define INVOKE_GET_ARRAY_COUNT             0x09
#define INVOKE_GET_ARRAY_ELEMENT_BY_KEY    0x0A
#define INVOKE_SET_ARRAY_ELEMENT_BY_KEY    0x0B
#define INVOKE_CALL_DELEGATE               0x0C
#define INVOKE_COUNT_DELEGATE_PARAMS       0x0D
#define INVOKE_LOCK_VARIABLE               0x0E
#define INVOKE_GET_ARRAY_KEY               0x0F
#define INVOKE_GET_ARRAY_INDEX             0x10
#define INVOKE_CREATE_VARIABLE             0x11
#define INVOKE_DEFINE_CONSTANT             0x12
#define INVOKE_ARRAY_VARIABLE              0x13
#define INVOKE_ARRAY_VARIABLE_BY_KEY       0x14
#define INVOKE_GET_CLASS_VARIABLE          0x15
#define INVOKE_DEFINE_CLASS                0x16
#define INVOKE_CREATE_OBJECT               0x17
#define INVOKE_GET_APPLICATION_INFO        0x18
#define INVOKE_GET_SERIAL_CLASS            0x19
#define INVOKE_SET_SERIAL_CLASS            0x20
#define INVOKE_GET_MEMBER_FROM_ID          0x21
#define INVOKE_DYNAMIC_LOCK                0x22
#define INVOKE_HAS_MEMBER                  0x23
#define INVOKE_OBJECT_LINKS                0x24
#define INVOKE_VAR_LINKS                   0x25
#define INVOKE_CLI_ARGUMENTS               0x26
#define INVOKE_SORT_ARRAY_BY_KEYS          0x27
#define INVOKE_CHECK_POINT                 0x28
#define INVOKE_ARRAY_ELEMENT_IS_SET        0x29
#define INVOKE_GET_DELEGATE_NAMES          0x2A
#define INVOKE_GET_USERDATA                0x2B
#define INVOKE_GET_THREAD_DATA             0x2C
#define INVOKE_SET_THREAD_DATA             0x2D
#define INVOKE_HIBERNATE                   0x2E
#define INVOKE_NEW_BUFFER                  0x2F
#define INVOKE_DELETE_BUFFER               0x30
#define INVOKE_PRINT                       0x31

#define INVOKE_SUCCESS                     0
#define CANNOT_INVOKE_INTERFACE            -10
#define INVALID_INVOKE_PARAMETER           -20
#define CANNOT_INVOKE_IN_THIS_CASE         -30


//#define     TEMPORARY_NAME      "%T"

#define     ACCESS_LOCAL             0x00
#define     ACCESS_PUBLIC            0x01
#define     ACCESS_PRIVATE           0x02
#define     ACCESS_PROTECTED         0x03

#define     VARIABLE_CONSTANT        0x00
#define     VARIABLE_UNDEFINED       0x01
#define     VARIABLE_NUMBER          0x02
#define     VARIABLE_STRING          0x03
#define     VARIABLE_CLASS           0x04
#define     VARIABLE_ARRAY           0x05
#define     VARIABLE_DELEGATE        0x06
#define     _LINK__STRING_DATA       -1

#define     STATIC_CLASS_ARRAY       -1
#define     STATIC_CLASS_DLL         -2
#define     STATIC_CLASS_DELEGATE    -3

typedef struct tsVariableDESCRIPTOR {
    char         TYPE;
    char         USED;
    char         BY_REF;
    NUMBER       nValue;

    TinyString   name;
    // value is for constants only !
    StaticString value;

    POOLED(tsVariableDESCRIPTOR);

    /*static boost::object_pool<tsVariableDESCRIPTOR> POOL;
     *
     * inline void tsVariableDESCRIPTOR::operator delete(void *p, size_t size) {
     *      tsVariableDESCRIPTOR::POOL.destroy((tsVariableDESCRIPTOR *)p);
     * }
     *
     * inline void *tsVariableDESCRIPTOR::operator new(size_t size) {
     *      return tsVariableDESCRIPTOR::POOL.malloc();
     * }*/
} VariableDESCRIPTOR;

typedef struct tsSmallVariableDESCRIPTOR {
    char         TYPE;
    NUMBER       nValue;
    StaticString value;

    POOLED(tsSmallVariableDESCRIPTOR);
} SmallVariableDESCRIPTOR;

typedef struct tsVariableDATA {
    //VariableDESCRIPTOR *VD;
    char           TYPE;
    short          LINKS;
    unsigned short IS_PROPERTY_RESULT;
    INTEGER        EXTRA_DATA;
    POINTER        CALL_SET;
    NUMBER         NUMBER_DATA;
    POINTER        CLASS_DATA;
    AnsiString     STRING_DATA;

    POOLED(tsVariableDATA);
} VariableDATA;

typedef struct tsUndefinedMember {
    AnsiString name;
    int        line;
    AnsiString filename;
    AnsiString _CLASS;
    AnsiString _MEMBER;

    POOLED(tsUndefinedMember);
} UndefinedMember;

typedef struct tsAnalizerElement {
    char           TYPE;
    SYS_INT        ID;
    // data for debugging ...
    TinyString     _PARSE_DATA;
    unsigned short _DEBUG_INFO_LINE;
    char           _INFO_OPTIMIZED;
    void           *_HASH_DATA;

    POOLED(tsAnalizerElement)
} AnalizerElement;

typedef struct tsSHORT_AnalizerElement {
    char    TYPE;
    INTEGER ID;

    POOLED(tsSHORT_AnalizerElement)
} SHORT_AnalizerElement;

typedef struct tsPartialAnalizerElement {
    char           TYPE;
    char           _INFO_OPTIMIZED;
    unsigned short _DEBUG_INFO_LINE;
    INTEGER        ID;

    POOLED(tsPartialAnalizerElement)
} PartialAnalizerElement;

typedef struct tsOptimizedElement {
    INTEGER                Result_ID;
    SHORT_AnalizerElement  OperandReserved;
    PartialAnalizerElement Operator;
    AnalizerElement        OperandLeft;
    AnalizerElement        OperandRight;

    POOLED(tsOptimizedElement)
} OptimizedElement;

typedef struct tsParamList {
    INTEGER *PARAM_INDEX;
    INTEGER COUNT;
    //unsigned short COUNT;

    POOLED(tsParamList)
} ParamList;

#define FREAD_FAIL(buffer, size, elems, fin)        \
    if (!concept_fread(buffer, size, elems, fin)) { \
        concept_fclose(in);                         \
        return 0;                                   \
    }
#define SKIP(bytes, fin)    concept_fseek(fin, bytes, SEEK_CUR);

#define SERIALIZE_PARAM_LIST(Param, out)                                   \
    concept_fwrite(&Param->COUNT, sizeof(/*Param->COUNT*/ short), 1, out); \
    concept_fwrite(DELTA_UNREF(Param, Param->PARAM_INDEX), sizeof(INTEGER) * Param->COUNT, 1, out);

#if __SIZEOF_POINTER__ == 8
 #define SERIALIZE_AE(AE, out, put_parse)              \
    concept_fwrite(&AE.TYPE, sizeof(AE.TYPE), 1, out); \
    {                                                  \
        int _id = AE.ID;                               \
        concept_fwrite(&_id, sizeof(_id), 1, out);     \
    }                                                  \
    if (put_parse) {                                   \
        AE._PARSE_DATA.Serialize(out, SERIALIZE_16BIT_LENGTH); }
#else
 #define SERIALIZE_AE(AE, out, put_parse)              \
    concept_fwrite(&AE.TYPE, sizeof(AE.TYPE), 1, out); \
    concept_fwrite(&AE.ID, sizeof(AE.ID), 1, out);     \
    if (put_parse) {                                   \
        AE._PARSE_DATA.Serialize(out, SERIALIZE_16BIT_LENGTH); }
#endif

#define SERIALIZE_SHORT_AE(AE, out)                    \
    concept_fwrite(&AE.TYPE, sizeof(AE.TYPE), 1, out); \
    concept_fwrite(&AE.ID, sizeof(AE.ID), 1, out);

#define SERIALIZE_SMALL_VAR_DESCRIPTOR(VD, out)                  \
    /* is a parameter validator ? */                             \
    char VD_TYPE = VD->TYPE;                                     \
    char VD_DUMMY;                                               \
    if (VD->TYPE < 0) {                                          \
        char flag = 0x40;                                        \
        concept_fwrite(&flag, sizeof(flag), 1, out);             \
        INTEGER cls_object = (INTEGER)VD->nValue;                \
        concept_fwrite(&cls_object, sizeof(cls_object), 1, out); \
        VD_TYPE = -VD_TYPE;                                      \
    }                                                            \
    concept_fwrite(&VD_DUMMY, sizeof(VD_DUMMY), 1, out);         \
    if ((VD_TYPE == VARIABLE_NUMBER) && (VD->nValue)) {          \
        VD->value = AnsiString(VD->nValue); }                    \
    if (VD->value.Length()) {                                    \
        concept_fwrite(&VD_TYPE, sizeof(VD_TYPE), 1, out);       \
        VD->value.Serialize(out, SERIALIZE_32BIT_LENGTH);        \
    } else {                                                     \
        char temp = -VD_TYPE;                                    \
        concept_fwrite(&temp, sizeof(temp), 1, out);             \
    }

#define SERIALIZE_VAR_DESCRIPTOR(VD, out)                        \
    /* is a parameter validator ? */                             \
    char VD_TYPE = VD->TYPE;                                     \
    if (VD->TYPE < 0) {                                          \
        char flag = 0x40;                                        \
        concept_fwrite(&flag, sizeof(flag), 1, out);             \
        INTEGER cls_object = (INTEGER)VD->nValue;                \
        concept_fwrite(&cls_object, sizeof(cls_object), 1, out); \
        VD_TYPE = -VD_TYPE;                                      \
    }                                                            \
    concept_fwrite(&VD->BY_REF, sizeof(VD->BY_REF), 1, out);     \
    if ((VD_TYPE == VARIABLE_NUMBER) && (VD->nValue)) {          \
        VD->value = AnsiString(VD->nValue); }                    \
    if (VD->value.Length()) {                                    \
        concept_fwrite(&VD_TYPE, sizeof(VD_TYPE), 1, out);       \
        VD->value.Serialize(out, SERIALIZE_32BIT_LENGTH);        \
    } else {                                                     \
        char temp = -VD_TYPE;                                    \
        concept_fwrite(&temp, sizeof(temp), 1, out);             \
    }

/*if (VD->TYPE!=VARIABLE_NUMBER) \
 *  VD->value.Serialize(out,SERIALIZE_32BIT_LENGTH); \
 * else { \
 *  NUMBER temp=VD->value.ToFloat(); \
 *  concept_fwrite(&temp,sizeof(NUMBER),1,out); \
 * } */
//VD->name.Serialize(out, SERIALIZE_16BIT_LENGTH);

/*#define SERIALIZE_OPTIMIZED(OE,out) \
 *      SERIALIZE_AE(OE->Operator, out, 0); \
 *      if ((OE->Operator.TYPE==TYPE_OPERATOR) && (OE->Operator.ID==KEY_DLL_CALL)) { \
 *          SERIALIZE_AE(OE->OperandLeft, out , 1); \
 *      } else { \
 *          SERIALIZE_AE(OE->OperandLeft, out , 0); \
 *      } \
 *      SERIALIZE_AE(OE->OperandRight, out, 0); \
 *      SERIALIZE_AE(OE->OperandReserved, out, 0); \
 *      SERIALIZE_AE(OE->Result, out, 0); */

#define SERIALIZE_OPTIMIZED(OE, out)                                                                                             \
    /*SERIALIZE_AE(OE->Operator, out, 0);*/                                                                                      \
    SERIALIZE_SHORT_AE(OE->Operator, out);                                                                                       \
    SERIALIZE_AE(OE->OperandLeft, out, 0);                                                                                       \
    if ((OE->Operator.TYPE == TYPE_OPERATOR) && (OE->Operator.ID == KEY_DLL_CALL) && (OE->OperandLeft.ID == STATIC_CLASS_DLL)) { \
        SERIALIZE_AE(OE->OperandRight, out, 1);                                                                                  \
    } else {                                                                                                                     \
        SERIALIZE_AE(OE->OperandRight, out, 0);                                                                                  \
    }                                                                                                                            \
    SERIALIZE_SHORT_AE(OE->OperandReserved, out);                                                                                \
    concept_fwrite(&OE->Result_ID, sizeof(OE->Result_ID), 1, out);
//SERIALIZE_AE(OE->Result, out, 0);

#define SERIALIZE_OPTIMIZED_PACKAGE(OE, out)                                                                                    \
    SERIALIZE_AE(OE->Operator, out, 0);                                                                                         \
    SERIALIZE_AE(OE->OperandLeft, out, 0);                                                                                      \
    if (((OE->Operator.TYPE == TYPE_OPERATOR) && (OE->Operator.ID == KEY_DLL_CALL) && (OE->OperandLeft.ID == STATIC_CLASS_DLL)) \
        || (OE->Operator.TYPE == TYPE_OPERATOR) && (OE->Operator.ID == KEY_SEL)) {                                              \
        SERIALIZE_AE(OE->OperandRight, out, 1);                                                                                 \
    } else {                                                                                                                    \
        SERIALIZE_AE(OE->OperandRight, out, 0);                                                                                 \
    }                                                                                                                           \
    SERIALIZE_SHORT_AE(OE->OperandReserved, out, 0);                                                                            \
    concept_fwrite(&OE->Result_ID, sizeof(OE->Result_ID), 1, out);
//SERIALIZE_AE(OE->Result, out, 0);


#define UNSERIALIZE_PARAM_LIST_SIZE(Param, in)                           \
    concept_fread(&Param->COUNT, sizeof(/*Param->COUNT*/ short), 1, in); \
    if (Param->COUNT) {                                                  \
        SKIP(sizeof(INTEGER) * Param->COUNT, in); }                      \

#define UNSERIALIZE_PARAM_LIST(Param, in, is_pooled)                                                     \
    concept_fread(&Param->COUNT, sizeof(/*Param->COUNT*/ short), 1, in);                                 \
    if (Param->COUNT) {                                                                                  \
        if (is_pooled) {                                                                                 \
            Param->PARAM_INDEX = (INTEGER *)DELTA_REF(Param, SHAlloc(sizeof(INTEGER) * Param->COUNT)); } \
        else {                                                                                           \
            Param->PARAM_INDEX = (INTEGER *)DELTA_REF(Param, new INTEGER [Param->COUNT]); }              \
        concept_fread(DELTA_UNREF(Param, Param->PARAM_INDEX), sizeof(INTEGER) * Param->COUNT, 1, in);    \
    }


#if __SIZEOF_POINTER__ == 8
 #define UNSERIALIZE_AE(AE, out, get_parse, is_pooled) \
    concept_fread(&AE.TYPE, sizeof(AE.TYPE), 1, out);  \
    {                                                  \
        int _id;                                       \
        concept_fread(&_id, sizeof(_id), 1, out);      \
        AE.ID = _id;                                   \
    }                                                  \
    AE._DEBUG_INFO_LINE = 0;                           \
    if (get_parse) {                                   \
        AE._PARSE_DATA.Unserialize(out, SERIALIZE_16BIT_LENGTH, is_pooled); }

#else
 #define UNSERIALIZE_AE(AE, out, get_parse, is_pooled) \
    concept_fread(&AE.TYPE, sizeof(AE.TYPE), 1, out);  \
    concept_fread(&AE.ID, sizeof(AE.ID), 1, out);      \
    AE._DEBUG_INFO_LINE = 0;                           \
    if (get_parse) {                                   \
        AE._PARSE_DATA.Unserialize(out, SERIALIZE_16BIT_LENGTH, is_pooled); }
#endif

#define UNSERIALIZE_SHORT_AE(AE, out)                 \
    concept_fread(&AE.TYPE, sizeof(AE.TYPE), 1, out); \
    concept_fread(&AE.ID, sizeof(AE.ID), 1, out);     \

#define UNSERIALIZE_VAR_DESCRIPTOR_SIZE(VD, in)                \
    concept_fread(&VD->BY_REF, sizeof(VD->BY_REF), 1, in);     \
    VD->nValue = 0;                                            \
    INTEGER cls_object   = 0;                                  \
    bool    is_validator = false;                              \
    if (VD->BY_REF == 0x40) {                                  \
        concept_fread(&cls_object, sizeof(cls_object), 1, in); \
        is_validator = true;                                   \
        concept_fread(&VD->BY_REF, sizeof(VD->BY_REF), 1, in); \
    }                                                          \
    concept_fread(&VD->TYPE, sizeof(VD->TYPE), 1, in);         \
    if (VD->TYPE < 0) {                                        \
        VD->TYPE *= -1;                                        \
    } else {                                                   \
        VD->value.Unserialize(in, SERIALIZE_32BIT_LENGTH);     \
    }

//        char VD_DUMMY;\
//        concept_fread(&VD_DUMMY,sizeof(VD_DUMMY),1,in); \
// //
#define UNSERIALIZE_SMALL_VAR_DESCRIPTOR(VD, in, is_pooled)           \
    SKIP(1, in);                                                      \
    VD->nValue = 0;                                                   \
    concept_fread(&VD->TYPE, sizeof(VD->TYPE), 1, in);                \
    if (VD->TYPE < 0) {                                               \
        VD->TYPE *= -1;                                               \
    } else {                                                          \
        VD->value.Unserialize(in, SERIALIZE_32BIT_LENGTH, is_pooled); \
        if (VD->TYPE == VARIABLE_NUMBER) {                            \
            VD->nValue = VD->value.ToFloat(); }                       \
    }

#define UNSERIALIZE_VAR_DESCRIPTOR(VD, in, is_pooled)                 \
    concept_fread(&VD->BY_REF, sizeof(VD->BY_REF), 1, in);            \
    VD->nValue = 0;                                                   \
    INTEGER cls_object   = 0;                                         \
    bool    is_validator = false;                                     \
    /* is a parameter validator ? */                                  \
    if (VD->BY_REF == 0x40) {                                         \
        concept_fread(&cls_object, sizeof(cls_object), 1, in);        \
        is_validator = true;                                          \
        concept_fread(&VD->BY_REF, sizeof(VD->BY_REF), 1, in);        \
    }                                                                 \
    concept_fread(&VD->TYPE, sizeof(VD->TYPE), 1, in);                \
    if (VD->TYPE < 0) {                                               \
        VD->TYPE *= -1;                                               \
    } else {                                                          \
        VD->value.Unserialize(in, SERIALIZE_32BIT_LENGTH, is_pooled); \
        if (VD->TYPE == VARIABLE_NUMBER) {                            \
            VD->nValue = VD->value.ToFloat(); }                       \
    }                                                                 \
    if (is_validator) {                                               \
        if (is_lib) {                                                 \
            if (VD->TYPE == VARIABLE_CLASS) {                         \
                VD->nValue = ClassNames [cls_object - 1] + 1; }       \
        } else {                                                      \
            VD->nValue = cls_object; }                                \
        VD->TYPE = -VD->TYPE;                                         \
    }

/*if (VD->TYPE!=VARIABLE_NUMBER) \
 *  VD->value.Unserialize(in,SERIALIZE_32BIT_LENGTH); \
 * else { \
 *  NUMBER temp; \
 *  concept_fread(&temp,sizeof(temp),1,in); \
 *  VD->value=temp; \
 * } \*/
//VD->name.Unserialize(in, SERIALIZE_16BIT_LENGTH);

#define UNSERIALIZE_OPTIMIZED(OE, out, is_pooled)                                                                                \
    /*UNSERIALIZE_AE(OE->Operator, out, 0);*/                                                                                    \
    UNSERIALIZE_SHORT_AE(OE->Operator, out);                                                                                     \
    UNSERIALIZE_AE(OE->OperandLeft, out, 0, is_pooled);                                                                          \
    if ((OE->Operator.TYPE == TYPE_OPERATOR) && (OE->Operator.ID == KEY_DLL_CALL) && (OE->OperandLeft.ID == STATIC_CLASS_DLL)) { \
        UNSERIALIZE_AE(OE->OperandRight, out, 1, is_pooled);                                                                     \
    } else {                                                                                                                     \
        UNSERIALIZE_AE(OE->OperandRight, out, 0, is_pooled);                                                                     \
    }                                                                                                                            \
    UNSERIALIZE_SHORT_AE(OE->OperandReserved, out);                                                                              \
    concept_fread(&OE->Result_ID, sizeof(OE->Result_ID), 1, out);
//UNSERIALIZE_AE(OE->Result, out, 0);

typedef void (*ForeignPrint)(char *str, int length, void *userdata);

/*class GeneralMember {
 * public:
 *  AnsiString NAME;
 *  char NEEDED;
 *
 *  GeneralMember(AnsiString name) {
 *      this->NAME=name;
 *      NEEDED=0;
 *  }
 * };*/

class SimpleStream {
    friend class ConceptInterpreter;
    friend class PIFAlizator;
    friend INTEGER Invoke(INTEGER INVOKE_TYPE, ...);

private:
    ForeignPrint fprint;
    ForeignPrint fprint_notify;
    int          sock;
    char         start_print;
    void         *userdata;
public:
    char AlreadyPrinted() {
        return(start_print);
    }

    SimpleStream(ForeignPrint fp, int _sock = 0, ForeignPrint fp2 = 0, void *ud = 0) {
        sock          = _sock;
        fprint        = fp;
        fprint_notify = fp2;
        userdata      = ud;
        start_print   = 0;
    }

    int SerializeBuffer(char **buffer, int *size, AnsiString *Owner, int message, AnsiString *Target, AnsiString *Value) {
        // OWNER poate avea maxim 256 octeti
        *size = sizeof(char) + Owner->Length() + sizeof(int) + sizeof(short) + Target->Length() + Value->Length();
        char *buf = new char [*size];
        *buffer = buf;

        *(unsigned char *)buf = (unsigned char)Owner->Length();
        buf += sizeof(char);

        memcpy(buf, Owner->c_str(), Owner->Length());
        buf += Owner->Length();

        *(int *)buf = htonl(message);
        buf        += sizeof(int);

        *(unsigned short *)buf = htons((unsigned short)Target->Length());
        buf += sizeof(short);

        memcpy(buf, Target->c_str(), Target->Length());
        buf += Target->Length();

        memcpy(buf, Value->c_str(), Value->Length());

        return(1);
    }

    void Print(char *str, int length = -1, int message_id = -1) {
        if (!length) {
            return;
        }
        if (sock) {
            char       *buffer = 0;
            int        size    = 0;
            AnsiString Owner("%SYSTEM");
            AnsiString Target("%SCREEN");
            AnsiString Value;
            if (length < 0) {
                Value = str;
            } else {
                Value.LoadBuffer(str, length);
            }
            SerializeBuffer(&buffer, &size, &Owner, message_id, &Target, &Value);
            int size_n = htonl(size);
            send(sock, (char *)&size_n, sizeof(int), 0);
            send(sock, buffer, size, 0);
            delete[] buffer;
            if (fprint_notify) {
                fprint_notify(str, length, userdata);
            }
        } else {
            fprint(str, length, userdata);
            start_print = 1;
        }
    }

    void Print(double val) {
        AnsiString value(val);

        Print(value.c_str());
    }

    void ClientError(char *error_text, int err_id = -11) {
        if (sock) {
            char       *buffer = 0;
            int        size    = 0;
            AnsiString Owner("%SYSTEM");
            AnsiString Target("%SCREEN");
            AnsiString Value(error_text);
            SerializeBuffer(&buffer, &size, &Owner, err_id, &Target, &Value);
            int size_n = htonl(size);
            send(sock, (char *)&size_n, sizeof(int), 0);
            send(sock, buffer, size, 0);
            delete[] buffer;
        } else {
            if (userdata) {
                Print("<br /><pre>");
            }
            Print("\n---- RUN TIME ERROR --------------------------------------------\n");
            Print(error_text);
            Print("----------------------------------------------------------------\n");
            if (userdata) {
                Print("</pre>");
            }
        }
    }
};

#endif //__CONCEPTTYPES_H
