#include "Codes.h"
#include "ConceptTypes.h"
#include "AnsiString.h"
#include "CompiledClass.h"
#include "Debugger.h"
#include "ConceptInterpreter.h"
#include <string.h>
#include "ModuleLink.h"

#define MIN(a, b)    (((a) < (b)) ? (a) : (b))

VariableDATA *VarToClean [0xFF];
int          VarCnt = 0;

#define CLEAN_VARS    { for (int i = 0; i < VarCnt; i ++) { FREE_VARIABLE(VarToClean [i]); } VarCnt = 0; }
#define ADD_VAR(VAR)    { VarToClean [VarCnt ++] = VAR; }

/*VariableDATA *GetClassMember(void *CLASS_PTR, char *class_member_name) {
 *  if (CLASS_PTR) {
 *      ClassCode *CCode=((CompiledClass *)CLASS_PTR)->GetClass();
 *      VariableDATA **CONTEXT=((CompiledClass *)CLASS_PTR)->GetContext();
 *      if ((CCode) && (CONTEXT)) {
 *          INTEGER index=CCode->HasMemberInCompiled(class_member_name);
 *          if (index) {
 *              index--;
 *              return CONTEXT[index];
 *          }
 *      }
 *  }
 *  return 0;
 * }*/


VariableDATA *GetClassMember(void *CLASS_PTR, char *class_member_name) {
    if (CLASS_PTR) {
        ClassCode    *CCode    = ((CompiledClass *)CLASS_PTR)->GetClass();
        VariableDATA **CONTEXT = ((CompiledClass *)CLASS_PTR)->GetContext();
        if ((CCode) && (CONTEXT)) {
            INTEGER index = CCode->HasMemberInCompiled(class_member_name);
            if (index) {
                index--;

                INTEGER index2 = CCode->HasMember(class_member_name);
                index2--;
                ClassMember *CM = (ClassMember *)CCode->Members->Item(index2);

                if ((CM) && (CM->IS_FUNCTION)) {
                    //VariableDATA
                    index = CCode->GetAbsoluteMemberID(index + 1) - 1;

                    ParamList PLIST;
                    PLIST.COUNT = 0;

                    AnalizerElement AE;
                    AE._DEBUG_INFO_LINE = AE.ID = AE.TYPE = 0;

                    //int is_property=CM->IS_FUNCTION==3 ? 1 : 0;


                    VariableDATA *Owner = new VariableDATA;
                    //Owner->ACCESS=ACCESS_LOCAL;
                    Owner->CALL_SET           = 0;
                    Owner->CLASS_DATA         = CLASS_PTR;
                    Owner->EXTRA_DATA         = 0;
                    Owner->IS_PROPERTY_RESULT = 0;
                    Owner->LINKS       = 1;
                    Owner->NUMBER_DATA = 0;
                    Owner->TYPE        = VARIABLE_CLASS;
                    ((CompiledClass *)CLASS_PTR)->LINKS++;

                    try {
                        VariableDATA *VarDATA = CCode->ExecuteMember(
                            index,
                            Owner,
                            &AE,
                            true,
                            CM->IS_FUNCTION == 3 ? 0 : &PLIST,
                            (VariableDATA **)-1,
                            0,
                            CCode->CLSID,
                            CCode->CLSID
                            );
                        FREE_VARIABLE(Owner);
                        ADD_VAR(VarDATA);
                        return(VarDATA);
                    } catch (VariableDATA *THROW_DATA) {
                        FREE_VARIABLE(THROW_DATA);
                        FREE_VARIABLE(Owner);
                        return(0);
                    }
                }
                return(CONTEXT [index]);
            }
        }
    }
    return(0);
}

VariableDATA *GetClassMembers(void *CLASS_PTR, char *members_string) {
    AnsiString ParsedVariableName = members_string;
    AnsiString _S(".");
    int        point            = ParsedVariableName.Pos(_S);
    void       *CLASS_PTR_LOCAL = CLASS_PTR;

    while (point > 0) {
        AnsiString temp_varname = ParsedVariableName;
        AnsiString temp2        = temp_varname;
        temp2.c_str() [point - 1] = 0;
        temp_varname       = (char *)temp2.c_str();
        temp2              = ParsedVariableName.c_str() + point;
        ParsedVariableName = temp2;
        VariableDATA *Temp = GetClassMember(CLASS_PTR_LOCAL, temp_varname);
        if ((Temp) && (Temp->TYPE == VARIABLE_CLASS)) {
            CLASS_PTR_LOCAL = Temp->CLASS_DATA;
        } else {
            return(0);
        }
        if (!CLASS_PTR_LOCAL) {
            return(0);
        }
        point = ParsedVariableName.Pos(_S);
    }
    return(CLASS_PTR_LOCAL ? GetClassMember(CLASS_PTR_LOCAL, ParsedVariableName) : 0);
}

int GetVariableByName(int operation, void **VDESC, void **CONTEXT, int Depth, char *VariableName, char *buffer, int buf_size) {
    if (operation == -1) {
        AnsiString cstack;
        for (int i = 0; i < ConceptInterpreter::CALL_STACK_COUNT; i++) {
            cstack += *ConceptInterpreter::CALL_STACK [i].cls;
            cstack += ".";
            cstack += ConceptInterpreter::CALL_STACK [i].mem->c_str();
            cstack += ":";
            cstack += AnsiString((long)ConceptInterpreter::CALL_STACK [i].line);
            cstack += "\n";
        }
        buffer [buf_size - 1] = 0;
        strncpy(buffer, cstack.c_str(), buf_size - 1);
        buffer [cstack.Length()] = 0;
        return(-1);
    }

    if (!CONTEXT) {
        return(0);
    }

    CLEAN_VARS;

    AnsiString ParsedVariableName = VariableName;
    AnsiString temp_varname       = VariableName;
    int        point = ParsedVariableName.Pos(AnsiString("."));
    if (point > 0) {
        temp_varname = ParsedVariableName;
        AnsiString temp2 = temp_varname;
        temp2.c_str() [point - 1] = 0;
        temp_varname       = (char *)temp2.c_str();
        temp2              = ParsedVariableName.c_str() + point;
        ParsedVariableName = temp2;
    } else {
        point = 0;
    }

    for (INTEGER i = 0; i < Depth; i++) {
        if ((((VariableDESCRIPTOR *)VDESC) [i]).name == temp_varname) {
            if (((VariableDATA *)CONTEXT [i])->TYPE == VARIABLE_STRING) {
                if (operation == 0) {
                    strncpy(buffer, ((VariableDATA *)CONTEXT [i])->STRING_DATA.c_str(), buf_size);
                } else
                if (operation == 1) {
                    ((VariableDATA *)CONTEXT [i])->STRING_DATA = buffer;
                }

                CLEAN_VARS;

                return(point ? 0 : VARIABLE_STRING);
            } else
            if (((VariableDATA *)CONTEXT [i])->TYPE == VARIABLE_NUMBER) {
                if (operation == 0) {
                    strncpy(buffer, AnsiString(((VariableDATA *)CONTEXT [i])->NUMBER_DATA).c_str(), buf_size);
                } else
                if (operation == 1) {
                    ((VariableDATA *)CONTEXT [i])->NUMBER_DATA = AnsiString(buffer).ToFloat();
                }

                CLEAN_VARS;

                return(point ? 0 : VARIABLE_NUMBER);
            } else
            if (((VariableDATA *)CONTEXT [i])->TYPE == VARIABLE_CLASS) {
                if (operation == 0) {
                    strncpy(buffer, ((CompiledClass *)((VariableDATA *)CONTEXT [i])->CLASS_DATA)->GetClassName().c_str(), buf_size);
                }
                if (!point) {
                    CLEAN_VARS;
                    return(VARIABLE_CLASS);
                } else {
                    VariableDATA *VD = GetClassMembers(((VariableDATA *)CONTEXT [i])->CLASS_DATA, ParsedVariableName.c_str());
                    if (!VD) {
                        CLEAN_VARS;
                        return(0);
                    }
                    switch (VD->TYPE) {
                        case VARIABLE_STRING:
                            if (operation == 0) {
                                strncpy(buffer, VD->STRING_DATA.c_str(), buf_size);
                            } else
                            if (operation == 1) {
                                VD->STRING_DATA = buffer;
                                if (VD->IS_PROPERTY_RESULT) {
                                    SetClassMember(((VariableDATA *)CONTEXT [i])->CLASS_DATA, ParsedVariableName.c_str(), VARIABLE_STRING, buffer, 0);
                                }
                            }
                            CLEAN_VARS;
                            return(VD->TYPE);
                            break;

                        case VARIABLE_NUMBER:
                            if (operation == 0) {
                                strncpy(buffer, AnsiString(VD->NUMBER_DATA).c_str(), buf_size);
                            } else
                            if (operation == 1) {
                                VD->NUMBER_DATA = AnsiString(buffer).ToFloat();
                                if (VD->IS_PROPERTY_RESULT) {
                                    SetClassMember(((VariableDATA *)CONTEXT [i])->CLASS_DATA, ParsedVariableName.c_str(), VARIABLE_NUMBER, "", VD->NUMBER_DATA);
                                }
                            }
                            CLEAN_VARS;
                            return(VD->TYPE);
                            break;

                        case VARIABLE_CLASS:
                            if (operation == 0) {
                                strncpy(buffer, ((CompiledClass *)VD->CLASS_DATA)->GetClassName().c_str(), buf_size);
                            }
                            CLEAN_VARS;
                            return(VD->TYPE);
                            break;

                        case VARIABLE_ARRAY:
                            if (operation == 0) {
                                strncpy(buffer, ((Array *)VD->CLASS_DATA)->ToString(), buf_size);
                            }
                            CLEAN_VARS;
                            return(VD->TYPE);
                            break;

                        case VARIABLE_DELEGATE:
                            {
                                if (operation == 0) {
                                    AnsiString delegate = ((CompiledClass *)VD->CLASS_DATA)->GetClassName();
                                    delegate += (char *)".";
                                    delegate += ((CompiledClass *)VD->CLASS_DATA)->_Class->pMEMBERS [(INTEGER)VD->NUMBER_DATA]->NAME.c_str();
                                    strncpy(buffer, delegate.c_str(), buf_size);
                                }
                                CLEAN_VARS;
                                return(VD->TYPE);
                            }
                            break;

                        default:
                            CLEAN_VARS;
                            return(0);
                    }
                }
            }
            CLEAN_VARS;
            return(0);
        }
    }
    CLEAN_VARS;
    return(0);
}
