#ifndef __ERRORS_H
#define __ERRORS_H

#define ERR010      "Invalid identifier"
#define ERR020      "Unexpected symbol in expression"
#define ERR030      "Missing operand in expression"
#define ERR040      "Invalid operand in expression"
#define ERR050      "Unable to classify element"
#define ERR060      "Class already contains a member with that name"
#define ERR070      "Variable already defined"
#define ERR080      "Missing entry-point class"
#define ERR090      "Missing entry-point member (constructor) in entry-point class"
#define ERR100      "Undefined class"
#define ERR110      "Right of operator 'new' must be of 'class' type"
#define ERR120      "No such member in class"
#define ERR130      "Invalid member in selector('->') expression"
#define ERR140      "There is no class containing a member with that name"
#define ERR150      "No such member in this class"
#define ERR160      "Invalid member-variable name"
#define ERR170      "Invalid 'extends' class"
#define ERR180      "No such class defined to extend"
#define ERR190      "You can't access a private member of a class"
#define ERR200      "Invalid syntax in formal parameter list"
#define ERR210      "Wrong number of parameters in formal parameter list"
#define ERR220      "Wrong number of parameters in constructor's formal parameter list"
#define ERR230      "The constructor of a entry-point class should not take any formal parameter"
#define ERR240      "The selector operator could be applied only for objects. STRING and NUMBER are static data types."
#define ERR250      "A class variable can't take formal parameters"
#define ERR260      "Division by 0"
#define ERR270      "Could not include file (file not found or insufficient access rights)"
#define ERR280      "This class has no constructor and should be instantiated with no formal parameters."
#define ERR290      "Unable to find formal parameter list in indexer operator"
#define ERR300      "Operators should be declared with 'operator' statement"
#define ERR310      "'operator' isn't followed by an operator"
#define ERR320      "Operator can't be overloaded"
#define ERR330      "'event' missing 'triggers'"
#define ERR340      "Statement missing ';'"
#define ERR350      "'{' expected"
#define ERR360      "'}' or ',' expected"
#define ERR370      "Property can't be read"
#define ERR380      "'get' or 'set' expected"
#define ERR390      "A class property can't take formal parameters"
#define ERR400      "'get' method is not implemented for this property"
#define ERR410      "Property can't be written"
#define ERR420      "'set' method is not implemented for this property"
#define ERR430      "Statement is invalid outside a class member"
#define ERR440      "Operator is invalid outside a class member"
#define ERR450      "Method is invalid outside a class member"
#define ERR460      "Invalid constant declaration outside a class member"
#define ERR470      "'extends' should be used before the class members list"
#define ERR480      "';' (separator) is used only inside a class or within a statement"
#define ERR490      "Expression syntax"
#define ERR500      "Expression missing ')'"
#define ERR510      "Expression missing ']'"
#define ERR520      "Expression missing ';'"
#define ERR530      "Misplaced 'else' (no matching 'if')"
#define ERR540      "'try' encountered with no matching 'catch'"
#define ERR550      "'do' encountered with no matching 'while'"
#define ERR560      "Misplaced 'catch' (no matching 'try')"
#define ERR570      "Unexpected keyword"
#define ERR580      "Statement missing ';'"
#define ERR590      "'break' can't be used outside an iterative structure"
#define ERR600      "'continue' can't be used outside an iterative structure"
#define ERR610      "Statement requires a valid expression. Check expression syntax."
#define ERR620      "A constructor isn't allowed to have a return value"
#define ERR630      "A constructor isn't allowed to throw an exception"
#define ERR635      "A finalizer isn't allowed to throw an exception"
#define ERR640      "A STATIC STRING data type can be indexed only by a STATIC NUMBER"
#define ERR650      "Invalid operator in STATIC STRING expression"
#define ERR660      "Invalid operator in STATIC NUMBER expression"
#define ERR670      "Unable to import specified library"
#define ERR680      "Invalid static function call; A static function cannot be a DELEGATE"
#define ERR690      "Third party error in static function"
#define ERR700      "Static function returned an error"
#define ERR710      "An 'override' statement is 'public' by default"
#define ERR720      "Write-only properties are not supported. If property has 'set' it must have 'get'."
#define ERR730      "'get' redefinition"
#define ERR740      "'set' redefinition"
#define ERR750      "Multiple definitions for class"
#define ERR760      "Can't use an assignment operator on a constant"
#define ERR770      "Invalid syntax in parameter list declaration"
#define ERR780      "Invalid operator in parameter list declaration"
#define ERR790      "Parameter definition expected"
#define ERR800      "Function header already contains a parameter with that name"
#define ERR810      "Can't use an assignment operator on a temporary"
#define ERR820      "Invalid constant name"
#define ERR830      "String constant exceeds line"
#define ERR840      "Stack overflow in function call"
#define ERR850      "You can't access a protected member of a class"
#define ERR860      "You can't access a private member of a base class of this class. You should modify it to 'protected' access."
#define ERR870      "Can't link to function in external dynamic link library"
#define ERR880      "Cannot load module; OnCreateContext event returned an error. See extra information for details"
#define ERR890      "A variable name cannot be an operator or a keyword"
#define ERR900      "An array can have a key only a STATIC element (number or string)"
#define ERR910      "Invalid operator in STATIC ARRAY expression"
#define ERR920      "Invalid operator in CLASS expression"
#define ERR930      "You can't use 'this' members in a static function"
#define ERR940      "Only 'function' can be 'static'"
#define ERR950      "You can't run using '::' non-static member of a class."
#define ERR960      "Invalid operator in DELEGATE function definition"
#define ERR970      "Variable it's not a DELEGATE function"
#define ERR980      "Class has no parent"
#define ERR990      "Parent class has no constructor"
#define ERR1000     "Parent's constructor was overridden"
#define ERR1100     "Expression syntax error in static array"
#define ERR1110     "Invalid index in array expression (negative index ?)"
#define ERR1120     "Corrupted Concept package encountered."
#define ERR1130     "Unexpected constant in formal parameters list"
#define ERR1140     "Constant expected in formal parameters list, after '='"
#define ERR1150     "After a default parameter, all parameters should have a default value 'eg: function foo(a,b=10,c=5)'"
#define ERR1160     "Only static values are accepted for default values of class members"
#define ERR1170     "You can't assign a default value to an array."
#define ERR1180     "A finalizer(destructor) can't take any parameters"
#define ERR1190     "You can't override a private member"
#define ERR1200     "'{' expected in 'switch' statement"
#define ERR1201     "'(' expected"
#define ERR1202     "Bad switch syntax; 'case', 'default' or '}' expected "
#define ERR1203     "For syntax compatibility reasons, 'default' should be followed by ':'"
#define ERR1204     "Invalid right operand type in STATIC NUMBER expression (not a number)"
#define ERR1205     "Parameter missmatch in function call"
#define ERR1206     "Parameter missmatch in function call (wrong object type)"
#define ERR1207     "You can't provide a default value for a dynamic object in parameters list. Default values can be only numbers or string."
#define ERR1208     "Form parameter type is different from the default value type"
#define ERR1209     "Invalid special constant (special constants are @line, @filename, @path, @time, @class and @member)"
#define ERR1210     "Unexpected end of file / unmatch '{' with '}'"
#define ERR1220     "Left of '::' is not a class"
#define ERR1230     "Class was implicitly declared (used before its declaration) and cannot be extended with a class declared (explicitly or implicitly) after the first reference to this class"
#define ERR1240     "A class may not extend itself"

#define WRN10001    "Possibly incorrect assignment: do you mean '==' instead of '=' ?"
#define WRN10002    "Empty statement encountered. Is this your intention ?"
#define WRN10003    "Variable is declared, but never used"
#define WRN10004    "Constant redefinition"
#define WRN10005    "Unknown pragma"
#define WRN10006    "Unexpected pragma parameter"
#define WRN10007    "Implicit declaration for class. Typed parameters may not be accepted."

#endif
