#include "GarbageCollector.h"
#include "CompiledClass.h"
#include "Array.h"

POOLED_IMPLEMENTATION(_GarbageElement)
POOLED_IMPLEMENTATION(GarbageCollector)

GarbageCollector::GarbageCollector() {
    BASE = 0;
}

void GarbageCollector::Call_All_Destructors() {
    GarbageElement *NODE  = BASE;
    GarbageElement *NODE2 = 0;

    while (NODE) {
        NODE2 = NODE->NEXT;
        CompiledClass *ptr = (CompiledClass *)NODE->DATA;

        if (ptr->HasDestructor()) {
            ptr->Destroy();
        }

        NODE = NODE2;
    }
}

void GarbageCollector::EndOfExecution_SayBye_Objects() {
    GarbageElement *NODE  = BASE;
    GarbageElement *NODE2 = 0;

    // to prevent recursive re-execution
    BASE = 0;
    while (NODE) {
        NODE2 = NODE->NEXT;
        CompiledClass *ptr = (CompiledClass *)NODE->DATA;
        free(NODE);
        NODE = NODE2;

        ptr->LINKS++;

        ptr->UnlinkObjects();
        delete ptr;
    }
}

void GarbageCollector::EndOfExecution_SayBye_Arrays() {
    GarbageElement *NODE  = BASE;
    GarbageElement *NODE2 = 0;

    BASE = 0;
    while (NODE) {
        NODE2 = NODE->NEXT;
        Array *ptr = (Array *)NODE->DATA;
        free(NODE);
        NODE = NODE2;

        ptr->LINKS++;

        ptr->UnlinkObjects();
        delete ptr;
    }
}

/*void GarbageCollector::Reference(void *data) {
 *  GarbageElement *NODE=(GarbageElement *)malloc(sizeof(GarbageElement));
 *  NODE->NEXT=BASE;
 *  NODE->DATA=data;
 *
 *  if (!BASE) {
 *      BASE=NODE;
 *  }
 * }*/

/*
 * void *GarbageCollector::Unreference(void *data) {
 *  GarbageElement *NODE=BASE;
 *  GarbageElement *NODE_PREC=0;
 *  while (NODE) {
 *      if (NODE->DATA==data) {
 *          if (NODE_PREC)
 *              NODE_PREC->NEXT=NODE->NEXT;
 *          else
 *              BASE=NODE->NEXT;
 *
 *          free(NODE);
 *          return data;
 *      }
 *      NODE_PREC=NODE;
 *      NODE=NODE->NEXT;
 *  }
 *  return 0;
 * }
 */

GarbageCollector::~GarbageCollector() {
    GarbageElement *NODE  = BASE;
    GarbageElement *NODE2 = 0;

    while (NODE) {
        NODE2 = NODE->NEXT;
        free(NODE);
        NODE = NODE2;
    }
}
