#ifndef __GARBAGE_COLLECTOR_H
#define __GARBAGE_COLLECTOR_H
#include <stdlib.h>
#include "ConceptPools.h"

// no freing of the memory when the application closes (faster). Comment this if it should free.
//#define FAST_EXIT_NO_GC_CALL
typedef void (*foreach_slot)(void *data);

typedef struct _GarbageElement {
    void            *DATA;
    _GarbageElement *NEXT;
    POOLED(_GarbageElement)
} GarbageElement;

class GarbageCollector {
    GarbageElement *BASE;
    //int my_index;
public:
    POOLED(GarbageCollector)

    inline void Foreach(foreach_slot fs) {
        GarbageElement *NODE = BASE;

        while (NODE) {
            if (NODE->DATA) {
                fs(NODE->DATA);
            }
            NODE = NODE->NEXT;
        }
    }

    inline void Reference(void *data) {
        GarbageElement *NODE = (GarbageElement *)malloc(sizeof(GarbageElement));

        NODE->NEXT = BASE;
        NODE->DATA = data;

        //if (!BASE) {
        BASE = NODE;
        //}
    }

    inline void *Unreference(void *data) {
        GarbageElement *NODE      = BASE;
        GarbageElement *NODE_PREC = 0;

        while (NODE) {
            if (NODE->DATA == data) {
                if (NODE_PREC) {
                    NODE_PREC->NEXT = NODE->NEXT;
                } else {
                    BASE = NODE->NEXT;
                }

                free(NODE);
                return(data);
            }
            NODE_PREC = NODE;
            NODE      = NODE->NEXT;
        }
        return(0);
    }

    void Call_All_Destructors();
    void EndOfExecution_SayBye_Objects();
    void EndOfExecution_SayBye_Arrays();

    GarbageCollector(void);
    ~GarbageCollector(void);
};

#endif //__GARBAGE_COLLECTOR_H
