#ifndef __STATICLIST_H
#define __STATICLIST_H
#include "ConceptPools.h"
#include "AnsiString.h"
#include "TinyString.h"

#define STATICLIST_BLOCKSIZE    0xF

class StaticList {
private:
    long DataOffset;
    int allocated;
    int count;
    int pooled_marker;

    int EnsureSpace();

public:
    POOLED(StaticList)

    StaticList();
    void Add(char *str, int len = -1);
    void PoolMap(int len);
    void Add(AnsiString& str);
    void Add(TinyString& str);
    int ContainsString(char *str);

    char *operator[](int i);
    char *Item(int i);
    void Clear();
    void ReInit(int i, bool pooled);
    int Count();

    ~StaticList(void);
};

#endif //__STATICLIST_H
