#ifndef __STATICSTRING_H
#define __STATICSTRING_H

#include <stdio.h>
#include "ConceptPools.h"
#include "AnsiString.h"

#define SERIALIZE_8BIT_LENGTH     1
#define SERIALIZE_16BIT_LENGTH    2
#define SERIALIZE_32BIT_LENGTH    4

class StaticString {
private:
    long DataOffset;
    int _LENGTH;
public:
    POOLED(StaticString);

    StaticString(void);
    StaticString(char *value);
    StaticString(const StaticString& S);

    void operator=(char *value);
    void operator=(StaticString& S);
    void operator=(long i);
    void operator=(AnsiString& S);

    operator char *();

    char *c_str();
    long ToInt();
    double ToFloat();

    long Length();
    void LoadBuffer(char *buffer, int size);

    int Serialize(FILE *out, int type);
    static int ComputeSharedSize(concept_FILE *in, int type);
    int Unserialize(concept_FILE *out, int type, char use_pool = 0);

    ~StaticString();
};

#endif
