#!/bin/sh

DIST="core cli cgi compiler runsafe server service modules/concept.helper.idgenerator standard.C.casts standard.C.io standard.C.math standard.C.string standard.C.time standard.coding.base64 standard.lang.cli standard.lang.serialize standard.lib.cripto standard.lib.regex standard.lib.shared standard.lib.str standard.lib.thread standard.lib.xml standard.net.ftp standard.net.mail standard.net.socket web.server.api web.service.template win32.base.messages standard.ai.fann standard.db.sqlite standard.lib.json standard.db.sql win32.graph.freeimage standard.arch.zip standard.net.curl standard.net.soap standard.lib.preg standard.net.ym standard.lib.hpdf standard.commercial.pdf standard.lib.gd standard.lib.chart standard.lib.xslt standard.db.mysql standard.lib.iconv"
SQL="standard.db.sql"
EXOTIC="modules/win32.graph.freeimage modules/standard.arch.zip modules/standard.net.curl modules/standard.net.soap modules/standard.lib.preg modules/standard.net.ym modules/standard.lib.hpdf modules/standard.lib.gd modules/standard.lib.xslfo"

FAILED=false
SQL_INSTALLED=true

for target in $DIST;
do
    cd $target
    ./configure $@
    RESULT=$?
    if [ "$RESULT" -eq "0" ]; then
	make install
    else
	FAILED=true
	#break
    fi
    
    RESULT=$?
    if [ ! "$RESULT" -eq "0" ]; then
	FAILED=true
	echo "Failed to install $target"
	#break
    fi
    
    cd ..
done

cd $SQL
./configure $@
RESULT=$?
if [ "$RESULT" -eq "0" ]; then
	make install
else
	SQL_INSTALLED=false
	break
fi
cd ..
    
RESULT=$?
if [ ! "$RESULT" -eq "0" ]; then
	SQL_INSTALLED=false
	break
fi

if [ "x$FAILED" = "xtrue" ]; then
    echo
    #echo "Instalation of the Concept Pengoon failed. Please check the error output and install manually by running ./configure and make install in each directory of the distribution."
    echo "At least one module failed to install"
    echo "Failure code: $RESULT"
    echo
    exit 1
else
    echo
    echo
    echo
    echo Concept successfully installed !
    echo
    echo
fi

echo
echo "NOTICE:"
echo "    - The following Concept libraries may require manual installation (have dependecies):"
echo "      $EXOTIC"
echo
echo " You can install this libraries by manually cd into their directories and running ./confgiure and make install"

if [ "x$SQL_INSTALLED" = "xfalse" ]; then
    echo
    echo "WARNING:"
    echo
    echo "Could not install the standard.db.sql located in modules/standard.db.sql."
    echo "You must install this library manually by cd into modules/standard.db.sql and"
    echo "running ./configure and the make install."
    echo "You must specify the location of the iodbc library or the unixodbc library"
    echo "installed on your system (if is not installed, please install it)."
    echo 
    echo "Eg (if you are using the iodbc library installed in /usr)"
    echo "       cd modules/standard.db.sql"
    echo "       ./configure --with-iodbc=/usr"
    echo "       make install"
    echo
    echo "Eg (if you are using the unixodbc library installed in /usr/local)"
    echo "       cd modules/standard.db.sql"
    echo "       ./configure --with-unixodbc=/usr/local"
    echo "       make install"
    echo
    echo
fi

{
  (exit 0); exit 0
}
