//------------ standard header -----------------------------------//
#include "stdlibrary.h"
//------------ end of standard header ----------------------------//
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <strings.h>
#include "library.h"
#include <string.h>
#include "AnsiString.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>

#include <utime.h>
#include <time.h>

#ifdef _WIN32
	#include <process.h>
	#include <direct.h>
    #include <locale.h>

    #define NEW_LINE    "\r\n"
    #define NEW_LINE2   "\r\n\r\n"


	#define pipe(phandles)	_pipe (phandles, 4096, 0)
#else
	#include <sys/types.h>
	#include <sys/wait.h>
	#include <unistd.h>

    #define NEW_LINE    "\n"
    #define NEW_LINE2   "\r\n"
#endif

#define MAXIMUM_EXEC_PARAMETERS		0x100

#ifdef _WIN32
wchar_t *wstr(const char *utf8) {
    int len = MultiByteToWideChar(CP_UTF8, 0, utf8, -1, NULL, 0);
    wchar_t *utf16= (wchar_t *)malloc( (len + 1) * sizeof( wchar_t ));
    if (utf16) {
        int size=MultiByteToWideChar(CP_UTF8, 0, utf8, -1, utf16, len);
        if (size==(size_t)(-1)) {
            free(utf16);
            utf16=NULL;
        }
    }
    return utf16;
}
#endif
//-----------------------------------------------------------------------------------
//#ifndef _WIN32
long MyGetPrivateProfileString(
        const char *lpAppName,
        const char *lpKeyName,
        const char *lpDefault,
        char *lpReturnedString,
        long nSize,
        const char * lpFileName, int *start_pos=0, int *end_pos=0, int *section_start=0, int *f_size=0) 
{
    FILE *in=0;
    long filesize=0;
    char *filebuffer=0;
    char section_name[4096];
    char key_name[4096];
    int error=0;

#ifdef _WIN32
    wchar_t *fname=wstr(lpFileName);
    if (fname) {
        in=_wfopen(fname, L"rb");
        free(fname);
    } else
        in=fopen(lpFileName,"rb");
#else
    in=fopen(lpFileName,"rb");
#endif
    if (in) {
        fseek(in, 0L, SEEK_END);
        filesize=ftell(in);
        if (f_size)
            *f_size=filesize;
        fseek(in, 0L, SEEK_SET);
        if (filesize) {
            filebuffer=new char[filesize];
            if (filebuffer) {
                if (fread(filebuffer,1,filesize,in)==filesize) {
                    char in_name=0;
                    char in_quote=0;
                    char in_looked_section=0;
                    char in_looked_key=0;
                    char in_looked_value=0;
                    char in_comment=0;
                    char in_key=0;
                    char in_escape=0;
                    int  temp_pos=0;
                    int key_pos=0;
                    int value_pos=0;

                    section_name[0]=0;
                    key_name[0]=0;

                    int i;
                    for (i=0;i<filesize;i++) {
                        if (in_comment) {
                            if ((filebuffer[i]=='\n') || (filebuffer[i]=='\r'))
                                in_comment=0;
                            continue;
                        }

                        if (((filebuffer[i]=='\n') || (filebuffer[i]=='\r')) && (in_looked_value)) {
                            lpReturnedString[value_pos++]=0;
                            if (end_pos)
                                *end_pos=i;
                            break;
                        }

                        if (!in_quote) {
                            if (filebuffer[i]==';') {
                                if (in_looked_value)
                                    break;
                                in_comment=1;
                                continue;
                            }

                            if (filebuffer[i]=='[') {
                                // a inceput o sectziune noua, iar sectziunea precedenta este cea cautata ...
                                if (in_looked_section) {
                                    error=1;
                                    break;
                                }
                                temp_pos=0;
                                in_name=1;
                                continue;
                            }
                            if (in_name) {
                                if (filebuffer[i]==']') {
                                    in_name=0;
                                    section_name[temp_pos]=0;
                                    if (!strcmp(section_name,lpAppName)) {
                                        in_looked_section=1;
                                        if (section_start)
                                            *section_start=i+1;
                                    }
                                    continue;
                                }
                                if ((filebuffer[i]=='\n') || (filebuffer[i]=='\r')) {
                                    in_name=0;
                                    continue;
                                }
                                if (in_name)
                                    section_name[temp_pos++]=filebuffer[i];
                            }
                        }

                        // schimb flag-ul de ghilimele, daca le-am gasit ...
                        if (!in_name) {
                            if ((filebuffer[i]=='\\') && (!in_escape)) {
                                if ((i<filesize-1) && (filebuffer[i+1]=='"')) {
                                    in_escape=1;
                                    continue;
                                }
                            }
                            if ((filebuffer[i]=='"') && (!in_escape)){
                                in_quote=!in_quote;
                                continue;
                            }
                            if (((filebuffer[i]=='\n') || (filebuffer[i]=='\r')) && (in_quote)) {
                                in_escape=0;
                                in_quote=0;
                                continue;
                            }
                            if (in_escape)
                                in_escape=0;
                        }

                        if (in_looked_key) {
                           if ((filebuffer[i]=='=') && (!in_looked_value)) {
                               in_looked_value=1;
                               if ((start_pos) && (i<filesize-1)) {
                                   *start_pos=i;
                                   if (i<filesize-1)
                                       (*start_pos)++;
                               }
                               continue;
                           }
                           if (in_looked_value) {
                               if (value_pos<nSize-1) {
                                  if (value_pos)
                                     lpReturnedString[value_pos++]=filebuffer[i];
                                  else if ((filebuffer[i]!=' ') && (filebuffer[i]!='\t'))
                                     lpReturnedString[value_pos++]=filebuffer[i];
                               } else {
                                   lpReturnedString[value_pos++]=0;
                                   if (end_pos)
                                       *end_pos=i;
                                   break;
                               }
                               continue;
                           }
                        }

                        if (in_looked_section) {
                            if (((filebuffer[i]>='0') && (filebuffer[i]<='9')) ||
                               ((filebuffer[i]>='a') && (filebuffer[i]<='z')) ||
                               ((filebuffer[i]>='A') && (filebuffer[i]<='Z')) ||
                               (filebuffer[i]=='_') || (filebuffer[i]=='(') ||
                               (filebuffer[i]==')') || (filebuffer[i]=='.') || 
                               (filebuffer[i]=='-')) {
                                   if (in_key==0) {
                                       key_pos=0;
                                       in_key=1;
                                   }
                                   key_name[key_pos++]=filebuffer[i];

                               } else {
                                   if (in_key) {
                                       key_name[key_pos]=0;
                                       if (!strcmp(key_name,lpKeyName))
                                          in_looked_key=1;
                                       in_key=0;
                                       if (filebuffer[i]=='=')
                                           i--;
                                   }
                               }
                            // TO DO ... sunt in sectiunea cautata ...
                        }
                    }
                    // in caz ca e ultima linie din fisier ...
                    if ((i==filesize) && (in_looked_value)) {
                        lpReturnedString[value_pos++]=0;
                        if (end_pos)
                            *end_pos=i;
                    }
                } else
                    error=1;
            } else
                error=1;
        } else
            error=1;
        if ((!start_pos) || (!end_pos) || (!section_start))
            fclose(in);
    } else
        error=1;

    if (error)
        strncpy(lpReturnedString, lpDefault, nSize);
    if (filebuffer) {
        delete[] filebuffer;
        filebuffer=0;
    }
    return (long)in;
}

int VisNumber(char *value) {
    int len=strlen(value);
    for (int i=0;i<len;i++) {
        char c=value[i];
        if ((c<'0') || (c>'9'))
            return 0;
    }
    return 1;
}

long MySetPrivateProfileString(char *section,char *key,char *value,char *ini_name) {
    FILE *in;
    int start_pos=0, end_pos=0, section_start=0, filesize=0;
    char old_value[4096];
    AnsiString pre_data;
	old_value[0]=0;
    in=(FILE *)MyGetPrivateProfileString(section,key,"",old_value,4096,ini_name,&start_pos,&end_pos,&section_start,&filesize);
    AnsiString val;
    if (VisNumber(value))
        val=value;
    else {
        val="\"";
        val+=value;
        val+="\"";
    }

    if (in) {
        int delta=0;
        if ((start_pos) && (end_pos)) {        
            char *buf=new char [start_pos+1];
            buf[start_pos]=0;
            fseek(in, 0, SEEK_SET);
            if (fread(buf,1,start_pos,in)==start_pos) {
                pre_data.LoadBuffer(buf, start_pos);
            } else {
                delete[] buf;
                fclose(in);
                return 0;
            }
            delete[] buf;
            fseek(in, end_pos, SEEK_SET);
            delta=filesize-end_pos;
            pre_data+=(char *)"\t";
            if (value)
                pre_data+=val;
            else
                pre_data+=(char *)"\"\"";

            buf=new char [delta+1];
            buf[delta]=0;

            if (fread(buf,1,delta,in)==delta) {
                pre_data.AddBuffer(buf, delta);
            } else {
                delete[] buf;
                fclose(in);
                return 0;
            }
            delete[] buf; 
        } else
        if (section_start) {
            char *buf=new char [section_start+1];
            buf[section_start]=0;
            fseek(in, 0L, SEEK_SET);
            if (fread(buf,1,section_start,in)==section_start) {
                pre_data.LoadBuffer(buf, section_start);
            } else {
                delete[] buf;
                fclose(in);
                return 0;
            }
            delete[] buf;

            delta=filesize-section_start;
            if (key) {
                pre_data+=(char *)NEW_LINE2;
                pre_data+=key;
                pre_data+=(char *)"\t=\t";
                if (value)
                    pre_data+=val;
                else
                    pre_data+=(char *)"\"\"";
            }
            buf=new char [delta+1];
            buf[delta]=0;
            if (fread(buf,1,delta,in)==delta) {
                pre_data.AddBuffer(buf, delta);
            } else {
                delete[] buf;
                fclose(in);
                return 0;
            }
            delete[] buf; 
        } else {
            fclose(in);
            in=0;
            pre_data.LoadFile(ini_name);
            if ((section) && (section[0])) {
                pre_data+=(char *)NEW_LINE;
                pre_data+=(char *)"[";
                pre_data+=section;
                pre_data+=(char *)"]";
                pre_data+=NEW_LINE;
            }
            if (key) {
                pre_data+=(char *)NEW_LINE;
                pre_data+=key;
                pre_data+=(char *)"\t=\t";
                if (value)
                    pre_data+=val;
                else
                    pre_data+=(char *)"\"\"";
            }
        }
        if (in)
            fclose(in);
        if (pre_data.SaveFile(ini_name)==0)
            return 1;
    }
    return 0;
}
//#endif
//-----------------------------------------------------------------------------------
AnsiString GetKey(char *ini_name, char *section, char *key, char *def) {
    char value[4096];
	value[0]=0;
    MyGetPrivateProfileString(section,key,def,value,4096,ini_name);
    return AnsiString(value);
}
//-----------------------------------------------------------------------------------
long SetKey(char *ini_name, char *section, char *key, char *value) {
    return MySetPrivateProfileString(section,key,value,ini_name);
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS {
#ifdef _WIN32
    //setlocale(LC_ALL, "");
#endif
	AnsiString value=SEEK_SET;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "SEEK_SET",value.c_str());
	value=SEEK_CUR;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "SEEK_CUR",value.c_str());
	value=SEEK_END;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "SEEK_END",value.c_str());

	value=(long)S_IFIFO;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "S_IFIFO",value.c_str());
	value=(long)S_IFCHR;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "S_IFCHR",value.c_str());
	value=(long)S_IFBLK;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "S_IFBLK",value.c_str());
	value=(long)S_IFDIR;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "S_IFDIR",value.c_str());
	value=(long)S_IFREG;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "S_IFREG",value.c_str());
	value=(long)S_IFMT;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "S_IFMT",value.c_str());
	value=(long)S_IEXEC;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "S_IEXEC",value.c_str());
	value=(long)S_IWRITE;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "S_IWRITE",value.c_str());
	value=(long)S_IREAD;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "S_IREAD",value.c_str());
	value=(long)S_IRWXU;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "S_IRWXU",value.c_str());
	value=(long)S_IXUSR;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "S_IXUSR",value.c_str());
	value=(long)S_IWUSR;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "S_IWUSR",value.c_str());
	value=(long)S_IRUSR;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "S_IRUSR",value.c_str());

	value=(long)stdin;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "stdin",value.c_str());

	value=(long)stdout;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "stdout",value.c_str());

	value=(long)stderr;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "stderr",value.c_str());

	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "ON_MSWINDOWS","_MSWINDOWS()");
    Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "SERVER_BITS","_BITS()");
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__fopen CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=2)
           return (void *)": 'fopen' parameters error. This fuction takes 2 parameters.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        FILE*	_C_call_result;
        // Specific variables
        char *       szParam0;
        char *       szParam1;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &szParam0, &NUMBER_DUMMY);
        if (TYPE!=VARIABLE_STRING)
           return (void *)"fopen: parameter 1 should be of STATIC STRING type";
        // Parameter 2
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[1]-1], &TYPE, &szParam1, &NUMBER_DUMMY);
        if (TYPE!=VARIABLE_STRING)
           return (void *)"fopen: parameter 2 should be of STATIC STRING type";

        // function call
#ifdef _WIN32
    wchar_t *fname=wstr(szParam0);
    if (fname) {
        wchar_t *otype=wstr(szParam1);
        _C_call_result=_wfopen(fname, otype);
        free(fname);
        if (otype)
            free(otype);
    } else
        _C_call_result=fopen((char*)szParam0,"rb");
#else
        _C_call_result=(FILE*)fopen((char*)szParam0, (char*)szParam1);
#endif

        SetVariable(RESULT,VARIABLE_NUMBER,"",(long)_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__fclose CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'fclose' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        int	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"fclose: parameter 1 should be of STATIC NUMBER type";

        if (!nParam0) {
           RETURN_NUMBER(0);
           return 0;
        }
        // function call
        _C_call_result=(int)fclose((FILE*)(long)nParam0);

        SetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1],VARIABLE_NUMBER,"",0);
        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__fread CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=4)
           return (void *)": 'fread' parameters error. This fuction takes 4 parameters.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        size_t	_C_call_result;
        // Specific variables
        char *       szParam0;
        NUMBER       nParam1;
        NUMBER       nParam2;
        NUMBER       nParam3;

        // Variable type check
        // Parameter 1
        /*GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &szParam0, &NUMBER_DUMMY);
        if ((TYPE!=VARIABLE_NUMBER) && (TYPE!=VARIABLE_STRING))
           return (void *)"fread: parameter 1 should be of STATIC STRING type";*/
        // Parameter 2
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[1]-1], &TYPE, &STRING_DUMMY, &nParam1);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"fread: parameter 2 should be of STATIC NUMBER type";
        // Parameter 3
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[2]-1], &TYPE, &STRING_DUMMY, &nParam2);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"fread: parameter 3 should be of STATIC NUMBER type";
        // Parameter 4
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[3]-1], &TYPE, &STRING_DUMMY, &nParam3);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"fread: parameter 4 should be of STATIC NUMBER type";

        if ((int)nParam1*(int)nParam2==0) {
            SetVariable(RESULT,VARIABLE_NUMBER,"",0);
            return 0;
        }

        int len=(int)nParam1*(int)nParam2;
        CORE_NEW(len+1, szParam0);
        if (!szParam0)
            return (void *)"fread: Not enough memory";

        //szParam0=new char[len+1];
        szParam0[0]=szParam0[len]=0;

        // function call
        _C_call_result=(size_t)fread((void*)szParam0, (size_t)nParam1, (size_t)nParam2, (FILE*)(long)nParam3);

#if 0
//        SetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1],VARIABLE_STRING,szParam0,_C_call_result);
//        delete[] szParam0;
#else
        // link variable. Concept Core will free it
        if (_C_call_result>0) {
            SetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1],-1,szParam0,_C_call_result);
        } else {
            CORE_DELETE(szParam0);
            SetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1],VARIABLE_STRING,"",(long)0);
        }
#endif

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__fwrite CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=4)
           return (void *)": 'fwrite' parameters error. This fuction takes 4 parameters.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        size_t	_C_call_result;
        // Specific variables
        char *       szParam0;
        NUMBER       nParam1;
        NUMBER       nParam2;
        NUMBER       nParam3;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &szParam0, &NUMBER_DUMMY);
        if (TYPE!=VARIABLE_STRING)
           return (void *)"fwrite: parameter 1 should be of STATIC STRING type";
        // Parameter 2
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[1]-1], &TYPE, &STRING_DUMMY, &nParam1);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"fwrite: parameter 2 should be of STATIC NUMBER type";
        // Parameter 3
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[2]-1], &TYPE, &STRING_DUMMY, &nParam2);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"fwrite: parameter 3 should be of STATIC NUMBER type";
        // Parameter 4
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[3]-1], &TYPE, &STRING_DUMMY, &nParam3);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"fwrite: parameter 4 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(size_t)fwrite((void*)szParam0, (size_t)nParam1, (size_t)nParam2, (FILE*)(long)nParam3);

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__fseek CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=3)
           return (void *)": 'fseek' parameters error. This fuction takes 3 parameters.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        int	_C_call_result;
        // Specific variables
        NUMBER       nParam0;
        NUMBER       nParam1;
        NUMBER       nParam2;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"fseek: parameter 1 should be of STATIC NUMBER type";
        // Parameter 2
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[1]-1], &TYPE, &STRING_DUMMY, &nParam1);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"fseek: parameter 2 should be of STATIC NUMBER type";
        // Parameter 3
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[2]-1], &TYPE, &STRING_DUMMY, &nParam2);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"fseek: parameter 3 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(int)fseek((FILE*)(long)nParam0, (long)nParam1, (int)nParam2);

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__ftell CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'ftell' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        long	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"ftell: parameter 1 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(long)ftell((FILE*)(long)nParam0);

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__fsize CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'fsize' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        long	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"ftell: parameter 1 should be of STATIC NUMBER type";

        long old_position=ftell((FILE*)(long)nParam0);

        fseek((FILE*)(long)nParam0,0,SEEK_END);
        // function call
        _C_call_result=(long)ftell((FILE*)(long)nParam0);
        fseek((FILE*)(long)nParam0,old_position,SEEK_SET);

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__fgetstring CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=3)
           return (void *)": 'fgetstring' parameters error. This fuction takes 3 parameters.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        int	_C_call_result;
        // Specific variables
        NUMBER       nParam0;
        char        *szParam1;
        NUMBER       nParam2;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"fgetstring: parameter 1 should be of STATIC NUMBER type";
        // Parameter 2
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[1]-1], &TYPE, &szParam1, &NUMBER_DUMMY);
        if (TYPE!=VARIABLE_STRING)
           return (void *)"fgetstring: parameter 2 should be of STATIC STRING type";
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[2]-1], &TYPE, &STRING_DUMMY, &nParam2);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"fgetstring: parameter 3 should be of STATIC NUMBER type";

	if ((!szParam1) || (!szParam1[0])) {
           return (void *)"fgetstring: separator can't be empty";
	}

	if ((nParam2<=0) || (nParam2>0xFFFF)) {
           return (void *)"fgetstring: maximum length should be between 1 and 0xFFFF";
	}

        // function call
        _C_call_result=0;

	char *result=new char[(int)nParam2+1];
	result[0]=0;
	int pos=0;

	FILE *fin=(FILE *)(long)nParam0;
	while (!feof(fin)) {
		char c=fgetc(fin);
		if (strchr(szParam1,c)) {
			if (result[0]!=0)
				break;
		} else {
			result[pos++]=c;
			result[pos]=0;
		}
	}
        SetVariable(RESULT,VARIABLE_STRING,result,pos);

	delete[] result;
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__feof CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'feof' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        long	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"feof: parameter 1 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(long)feof((FILE*)(long)nParam0);
	
        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__remove CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'remove' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        long         _C_call_result;
        // Specific variables
        char *       szParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &szParam0, &NUMBER_DUMMY);
        if (TYPE!=VARIABLE_STRING)
           return (void *)"remove: parameter 1 should be of STATIC STRING type";

        // function call
        _C_call_result=(int)remove(szParam0);
	
        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT___unlink CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'unlink' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        long         _C_call_result;
        // Specific variables
        char *       szParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &szParam0, &NUMBER_DUMMY);
        if (TYPE!=VARIABLE_STRING)
           return (void *)"unlink: parameter 1 should be of STATIC STRING type";

        // function call
        _C_call_result=(int)unlink(szParam0);
	
        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT___rmdir CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'rmdir' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        long         _C_call_result;
        // Specific variables
        char *       szParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &szParam0, &NUMBER_DUMMY);
        if (TYPE!=VARIABLE_STRING)
           return (void *)"rmdir: parameter 1 should be of STATIC STRING type";

        // function call
        _C_call_result=(int)rmdir(szParam0);
	
        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__ReadFile CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'ReadFile' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        FILE*	FIN;
        // Specific variables
        char *       szParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &szParam0, &NUMBER_DUMMY);
        if (TYPE!=VARIABLE_STRING)
           return (void *)"ReadFile: parameter 1 should be of STATIC STRING type";

#ifdef _WIN32
        wchar_t *fname=wstr(szParam0);
        if (fname) {
            FIN=_wfopen(fname, L"rb");
            free(fname);
        } else
            FIN==fopen((char*)szParam0,"rb");
#else
        FIN=(FILE*)fopen((char*)szParam0, "rb");
#endif
        // function call
        if (FIN) {
            fseek(FIN,0,SEEK_END);
            long size=(long)ftell(FIN);
            fseek(FIN,0,SEEK_SET);
            if (size>0) {
//                char *buffer=new char[size];
                char *buffer=0;
                CORE_NEW((size+1), buffer);
                if (!buffer)
                    return (void *)"ReadFile: Not enough memory";
                buffer[0]=buffer[size]=0;
                fread(buffer, 1, size, FIN);
#if 0
//                SetVariable(RESULT,VARIABLE_STRING,buffer,size);
//                delete[] buffer;
#else
                // LINK buffer, no copy, concept core will free it
                SetVariable(RESULT,-1,buffer,size);
#endif
                fclose(FIN);
                return 0;
            }
            fclose(FIN);
        }

        SetVariable(RESULT,VARIABLE_STRING,"",0);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__WriteFile CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=2)
           return (void *)": 'WriteFile' parameters error. This fuction takes 2 parameters.";

        // General variables
        NUMBER       NUMBER_DUMMY;
	NUMBER       STR_LEN=0;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        FILE*	FOUT;
        // Specific variables
        char *       szParam0;
        char *       szParam1;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &szParam0, &STR_LEN);
        if (TYPE!=VARIABLE_STRING)
           return (void *)"WriteFile: parameter 1 should be of STATIC STRING type";

        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[1]-1], &TYPE, &szParam1, &NUMBER_DUMMY);
        if (TYPE!=VARIABLE_STRING)
           return (void *)"WriteFile: parameter 2 should be of STATIC STRING type";

#ifdef _WIN32
        wchar_t *fname=wstr(szParam1);
        if (fname) {
            FOUT=_wfopen(fname, L"wb");
            free(fname);
        } else
            FOUT==fopen((char*)szParam1,"wb");
#else
        FOUT=(FILE*)fopen((char*)szParam1, "wb");
#endif
        // function call
        if (FOUT) {
            long size=(long)STR_LEN;
            fwrite(szParam0,1,size,FOUT);
            fclose(FOUT);
            SetVariable(RESULT,VARIABLE_NUMBER,"",1);
        } else
            SetVariable(RESULT,VARIABLE_NUMBER,"",0);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__FileExists CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": '_FileExists' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        FILE*	FIN;
        // Specific variables
        char *       szParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &szParam0, &NUMBER_DUMMY);
        if (TYPE!=VARIABLE_STRING)
           return (void *)"_FileExists: parameter 1 should be of STATIC STRING type";

        FIN=(FILE*)fopen((char*)szParam0, "rb");
        // function call
        if (FIN) {
		fclose(FIN);
        	SetVariable(RESULT,VARIABLE_NUMBER,"",1);
        } else
        	SetVariable(RESULT,VARIABLE_NUMBER,"",0);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__DirectoryExists CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": '_DirectoryExists' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        FILE*	FIN;
        // Specific variables
        char *       szParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &szParam0, &NUMBER_DUMMY);
        if (TYPE!=VARIABLE_STRING)
           return (void *)"_DirectoryExists: parameter 1 should be of STATIC STRING type";

	DIR *_C_call_result=opendir(szParam0);


        if (_C_call_result) {
		closedir(_C_call_result);
        	SetVariable(RESULT,VARIABLE_NUMBER,"",1);
        } else
        	SetVariable(RESULT,VARIABLE_NUMBER,"",0);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__fflush CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(1,"'fflush' takes 1 parameters. See help for details.");
        LOCAL_INIT;

        int	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GET_CHECK_NUMBER(0, nParam0, "'fflush' parameter 0 should be a number (STATIC NUMBER).");

        // function call
        _C_call_result=(int)fflush((FILE*)(long)nParam0);

        RETURN_NUMBER(_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__fgetc CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(1,"'fgetc' takes 1 parameters. See help for details.");
        LOCAL_INIT;

        int	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GET_CHECK_NUMBER(0, nParam0, "'fgetc' parameter 0 should be a number (STATIC NUMBER).");

        // function call
	char sir[2];
	sir[1]=0;
        //_C_call_result=(int)fgetc((FILE*)(long)nParam0);
        //RETURN_NUMBER(_C_call_result);
	sir[0]=fgetc((FILE*)(long)nParam0);
	RETURN_BUFFER(sir, 1);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__fputc CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(2,"'fputc' takes 2 parameters. See help for details.");
        LOCAL_INIT;

        int	_C_call_result;
        // Specific variables
        NUMBER       nParam0;
        NUMBER       nParam1;

        // Variable type check
        // Parameter 1
        GET_CHECK_NUMBER(0, nParam0, "'fputc' parameter 0 should be a number (STATIC NUMBER).");
        // Parameter 2
        GET_CHECK_NUMBER(1, nParam1, "'fputc' parameter 1 should be a number (STATIC NUMBER).");

        // function call
        _C_call_result=(int)fputc((int)nParam0, (FILE*)(long)nParam1);

        RETURN_NUMBER(_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__fputs CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(2,"'fputs' takes 2 parameters. See help for details.");
        LOCAL_INIT;

        int	_C_call_result;
        // Specific variables
        char *       szParam0;
        NUMBER       nParam1;

        // Variable type check
        // Parameter 1
        GET_CHECK_STRING(0, szParam0, "'fputs' parameter 0 should be a string (STATIC STRING).");
        // Parameter 2
        GET_CHECK_NUMBER(1, nParam1, "'fputs' parameter 1 should be a number (STATIC NUMBER).");

        // function call
        _C_call_result=(int)fputs((char*)szParam0, (FILE*)(long)nParam1);

        RETURN_NUMBER(_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT___fileno CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(1,"'fileno' takes 1 parameters. See help for details.");
        LOCAL_INIT;

        int	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GET_CHECK_NUMBER(0, nParam0, "'fileno' parameter 0 should be a number (STATIC NUMBER).");

        // function call
        _C_call_result=(int)fileno((FILE*)(long)nParam0);

        RETURN_NUMBER(_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__freopen CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(3,"'freopen' takes 3 parameters. See help for details.");
        LOCAL_INIT;

        FILE*	_C_call_result;
        // Specific variables
        char *       szParam0;
        char *       szParam1;
        NUMBER       nParam2;

        // Variable type check
        // Parameter 1
        GET_CHECK_STRING(0, szParam0, "'freopen' parameter 0 should be a string (STATIC STRING).");
        // Parameter 2
        GET_CHECK_STRING(1, szParam1, "'freopen' parameter 1 should be a string (STATIC STRING).");
        // Parameter 3
        GET_CHECK_NUMBER(2, nParam2, "'freopen' parameter 2 should be a number (STATIC NUMBER).");

        // function call
        _C_call_result=(FILE*)freopen((char*)szParam0, (char*)szParam1, (FILE*)(long)nParam2);

        RETURN_NUMBER((long)_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__fgets CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(3,"'fgets' takes 3 parameters. See help for details.");
        LOCAL_INIT;

        char*	_C_call_result;
        // Specific variables
        char *       szParam0;
        NUMBER       nParam1;
        NUMBER       nParam2;

        // Variable type check
        // Parameter 1
        GET_CHECK_STRING(0, szParam0, "'fgets' parameter 0 should be a string (STATIC STRING).");
        // Parameter 2
        GET_CHECK_NUMBER(1, nParam1, "'fgets' parameter 1 should be a number (STATIC NUMBER).");
        // Parameter 3
        GET_CHECK_NUMBER(2, nParam2, "'fgets' parameter 2 should be a number (STATIC NUMBER).");

        if (!(int)nParam1) {
		RETURN_STRING("");
		return 0;
	}

        char *buffer=new char[(int)nParam1+1];
	buffer[(int)nParam1]=0;

        // function call
        _C_call_result=(char*)fgets((char*)buffer, (int)nParam1, (FILE*)(long)nParam2);

        RETURN_STRING(_C_call_result);
        SET_STRING(0, buffer);

        delete[] buffer;
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT___chdir CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(1,"'chdir' takes 1 parameters. See help for details.");
        LOCAL_INIT;

        int	_C_call_result;
        // Specific variables
        char *       szParam0;

        // Variable type check
        // Parameter 1
        GET_CHECK_STRING(0, szParam0, "'chdir' parameter 0 should be a string (STATIC STRING).");

        // function call
        _C_call_result=(int)chdir((char*)szParam0);

        RETURN_NUMBER(_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT___mkdir CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(1,"'mkdir' takes 1 parameters. See help for details.");
        LOCAL_INIT;

        int	_C_call_result;
        // Specific variables
        char *       szParam0;

        // Variable type check
        // Parameter 1
        GET_CHECK_STRING(0, szParam0, "'mkdir' parameter 0 should be a string (STATIC STRING).");

        // function call
#ifdef _WIN32
        _C_call_result=(int)mkdir((char*)szParam0);
#else
        _C_call_result=(int)mkdir((char*)szParam0,0777L);
#endif

        RETURN_NUMBER(_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__exec CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK_MIN_MAX(1,MAXIMUM_EXEC_PARAMETERS,"'exec' takes at least 1 parameter. See help for details.");
	LOCAL_INIT;

        int	_C_call_result=0;
        // Specific variables
        char *       szParam[MAXIMUM_EXEC_PARAMETERS+1];
	char *       szPath;

	GET_CHECK_STRING(0,szPath,"All parameters should be of static string type");

	int i;
	for (i=0;i<PARAMETERS_COUNT;i++) {
		GET_CHECK_STRING(i,szParam[i],"All parameters should be of static string type");
	}
	szParam[i]=0;

#ifdef _WIN32
        // function call
        _C_call_result=(int)spawnvp(_P_WAIT,szPath,szParam);
#else
	pid_t pid=fork();
	if (pid<0)
		return (char *)"Error creating Process";
	if (!pid) {
        	_C_call_result=(int)execvp(szPath,szParam);
	} else
		waitpid(pid,NULL,0);
#endif

        RETURN_NUMBER(_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__opendir CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(1,"'opendir' takes 1 parameters. See help for details.");

	LOCAL_INIT;

        void *       _C_call_result;
        // Specific variables
        char *       szParam0;

        // Variable type check
        // Parameter 1
        GET_CHECK_STRING(0, szParam0, "Parameter 0 should be a string (STATIC STRING).");
	_C_call_result=opendir(szParam0);

        RETURN_NUMBER((long)_C_call_result);
	return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__readdir CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(1,"'readdir' takes 1 parameters. See help for details.");

	LOCAL_INIT;

        void *       _C_call_result;
        // Specific variables
        double       nParam0;

        GET_CHECK_NUMBER(0, nParam0, "Parameter 0 should be a number (STATIC NUMBER).");

	_C_call_result=readdir((DIR *)(long)nParam0);

        RETURN_NUMBER((long)_C_call_result);
	return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__telldir CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(1,"'telldir' takes 1 parameters. See help for details.");

	LOCAL_INIT;

        double       _C_call_result;
        // Specific variables
        double       nParam0;

        GET_CHECK_NUMBER(0, nParam0, "Parameter 0 should be a number (STATIC NUMBER).");

	_C_call_result=telldir((DIR *)(long)nParam0);

        RETURN_NUMBER(_C_call_result);
	return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__seekdir CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(2,"'seekdir' takes 2 parameters. See help for details.");

	LOCAL_INIT;

        // Specific variables
        double       nParam0;
        double       nParam1;

        GET_CHECK_NUMBER(0, nParam0, "Parameter 0 should be a number (STATIC NUMBER).");
        GET_CHECK_NUMBER(0, nParam1, "Parameter 1 should be a number (STATIC NUMBER).");

	seekdir((DIR *)(long)nParam0,(long)nParam1);

        RETURN_NUMBER(0);
	return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__rewinddir CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(1,"'rewinddir' takes 1 parameters. See help for details.");

	LOCAL_INIT;

        // Specific variables
        double       nParam0;

        GET_CHECK_NUMBER(0, nParam0, "Parameter 0 should be a number (STATIC NUMBER).");

	rewinddir((DIR *)(long)nParam0);

        RETURN_NUMBER(0);
	return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__closedir CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(1,"'closedir' takes 1 parameters. See help for details.");

	LOCAL_INIT;

	double       c_result;
        // Specific variables
        double       nParam0;

        GET_CHECK_NUMBER(0, nParam0, "Parameter 0 should be a number (STATIC NUMBER).");

	c_result=closedir((DIR *)(long)nParam0);

        RETURN_NUMBER(c_result);
	return 0;
}
//-----------------------------------------------------------------------------------
/*CONCEPT_DLL_API CONCEPT__dirfd CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(1,"'dirfd' takes 1 parameters. See help for details.");

	LOCAL_INIT;

        double       _C_call_result;
        // Specific variables
        double       nParam0;

        GET_CHECK_NUMBER(0, nParam0, "Parameter 0 should be a number (STATIC NUMBER).");

	_C_call_result=dirfd((DIR *)(long)nParam0);

        RETURN_NUMBER(_C_call_result);
	return 0;
}*/
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__dirname CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(1,"'dirname' takes 1 parameters. See help for details.");

	LOCAL_INIT;

        double       _C_call_result;
        // Specific variables
        double       nParam0;

        GET_CHECK_NUMBER(0, nParam0, "Parameter 0 should be a number (STATIC NUMBER).");

	dirent *dent=(dirent *)(long)nParam0;
	//RETURN_BUFFER(dent->d_name,dent->d_namlen);
    RETURN_STRING(dent->d_name);
	return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__filetype CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(1,"'filetype' takes 1 parameters. See help for details.");

	LOCAL_INIT;

        double       _C_call_result;
        // Specific variables
        char *       szParam0;

        GET_CHECK_STRING(0, szParam0, "Parameter 0 should be a string (STATIC STRING).");

	struct stat buf;
	stat(szParam0, &buf);

#ifdef _WIN32	
	_C_call_result = (buf.st_mode) & _S_IFMT;
#else
	_C_call_result = (buf.st_mode) & S_IFMT;
#endif

	RETURN_NUMBER(_C_call_result);
	return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__filesize CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(1,"'filesize' takes 1 parameters. See help for details.");

	LOCAL_INIT;

        double       _C_call_result;
        // Specific variables
        char *       szParam0;

        GET_CHECK_STRING(0, szParam0, "filesize: Parameter 0 should be a string (STATIC STRING).");

	struct stat buf;
	stat(szParam0, &buf);

	RETURN_NUMBER(buf.st_size);
	return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__filelast_acc CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(1,"'filelast_acc' takes 1 parameters. See help for details.");

	LOCAL_INIT;

        double       _C_call_result;
        // Specific variables
        char *       szParam0;

        GET_CHECK_STRING(0, szParam0, "filelast_acc: Parameter 0 should be a string (STATIC STRING).");

	struct stat buf;
	stat(szParam0, &buf);

	RETURN_NUMBER(buf.st_atime);
	return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__filelast_mod CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(1,"'filelast_mod' takes 1 parameters. See help for details.");

	LOCAL_INIT;

        double       _C_call_result;
        // Specific variables
        char *       szParam0;

        GET_CHECK_STRING(0, szParam0, "filelast_mod: Parameter 0 should be a string (STATIC STRING).");

	struct stat buf;
	stat(szParam0, &buf);

	RETURN_NUMBER(buf.st_mtime);
	return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__filelast_ch CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(1,"'filelast_ch' takes 1 parameters. See help for details.");

	LOCAL_INIT;

        double       _C_call_result;
        // Specific variables
        char *       szParam0;

        GET_CHECK_STRING(0, szParam0, "filelast_ch: Parameter 0 should be a string (STATIC STRING).");

	struct stat buf;
	stat(szParam0, &buf);

	RETURN_NUMBER(buf.st_ctime);
	return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__fileuid CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(1,"'fileuid' takes 1 parameters. See help for details.");

	LOCAL_INIT;

        double       _C_call_result;
        // Specific variables
        char *       szParam0;

        GET_CHECK_STRING(0, szParam0, "fileuid: Parameter 0 should be a string (STATIC STRING).");

	struct stat buf;
	stat(szParam0, &buf);

	RETURN_NUMBER(buf.st_uid);
	return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__filegid CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(1,"'filegid' takes 1 parameters. See help for details.");

	LOCAL_INIT;

        double       _C_call_result;
        // Specific variables
        char *       szParam0;

        GET_CHECK_STRING(0, szParam0, "filegid: Parameter 0 should be a string (STATIC STRING).");

	struct stat buf;
	stat(szParam0, &buf);

	RETURN_NUMBER(buf.st_gid);
	return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT___stat CONCEPT_API_PARAMETERS {
        PARAMETERS_CHECK(2,"'stat' takes 2 parameters. See help for details.");

	LOCAL_INIT;

        double       _C_call_result;
        // Specific variables
        char *       szParam0;

        GET_CHECK_STRING(0, szParam0, "stat: Parameter 0 should be a string (STATIC STRING).");
        //GET_CHECK_NUMBER(1, ?, "stat: Parameter 0 should be a string (STATIC STRING).");

	struct stat buf;
	int result=stat(szParam0, &buf);
	void *array_var=PARAMETER(1);

	if (!IS_OK(Invoke(INVOKE_CREATE_ARRAY,array_var)))
		return (void *)"stat : Failed to INVOKE_CREATE_ARRAY";

    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,array_var,"st_gid",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)(long)buf.st_gid);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,array_var,"st_atime",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)(long)buf.st_atime);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,array_var,"st_ctime",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)(long)buf.st_ctime);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,array_var,"st_dev",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)(long)buf.st_dev);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,array_var,"st_ino",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)(long)buf.st_ino);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,array_var,"st_mode",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)(long)buf.st_mode);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,array_var,"st_mtime",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)(long)buf.st_mtime);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,array_var,"st_nlink",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)(long)buf.st_nlink);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,array_var,"st_rdev",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)(long)buf.st_rdev);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,array_var,"st_size",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)(long)buf.st_size);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,array_var,"st_uid",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)(long)buf.st_uid);

	RETURN_NUMBER((double)result);
	return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT___errno CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(0,"'_errno' takes 0 parameters. See help for details.");

	RETURN_NUMBER((double)errno);
	return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(__getenv,1)
    T_STRING(0)

    RETURN_STRING(getenv(PARAM(0)))
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(__putenv,1)
    T_STRING(0)
#ifdef _WIN32
    RETURN_NUMBER(_putenv(PARAM(0)))
#else
    RETURN_NUMBER(putenv(PARAM(0)))
#endif
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_system,1)
    T_STRING(0)

    RETURN_NUMBER(system(PARAM(0)))
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(rename,2)
    T_STRING(0)
    T_STRING(1)

    RETURN_NUMBER(rename(PARAM(0),PARAM(1)))
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL_MINMAX_PARAMS(IniGet,3, 4)
	T_STRING(0)
	T_STRING(1)
	T_STRING(2)

	if (PARAMETERS_COUNT > 3) {
		T_STRING(3)
		RETURN_STRING(GetKey(PARAM(0), PARAM(1), PARAM(2), PARAM(3)).c_str());
	} else {
		RETURN_STRING(GetKey(PARAM(0), PARAM(1), PARAM(2), "").c_str());
	}
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(IniSet,4)
	T_STRING(0)
	T_STRING(1)
	T_STRING(2)
	T_STRING(3)

	RETURN_NUMBER(SetKey(PARAM(0), PARAM(1), PARAM(2), PARAM(3)));
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(popen,2)
    T_STRING(0)
    T_STRING(1)

    RETURN_NUMBER((SYS_INT)popen(PARAM(0),PARAM(1)))
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(pclose,1)
    T_NUMBER(0)
    if (PARAM_INT(0)) {
        RETURN_NUMBER(pclose((FILE *)PARAM_INT(0)))
    } else {
        RETURN_NUMBER(0);
    }
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_WEXITSTATUS,1)
    T_NUMBER(0)
#ifdef _WIN32
    RETURN_NUMBER(PARAM_INT(0))
#else
    int param_i0=PARAM_INT(0);
    RETURN_NUMBER(WEXITSTATUS(param_i0))
#endif
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_MSWINDOWS, 0)
#ifdef _WIN32
    RETURN_NUMBER(1);
#else
    RETURN_NUMBER(0);
#endif
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_BITS, 0)
    long res=sizeof(void *)*8;
    RETURN_NUMBER(res);
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(IsSymlink, 1)
    T_STRING(0)
#ifdef _WIN32
    RETURN_NUMBER(0)
#else
    struct stat buf;

    if (lstat(PARAM(0), &buf)) {
        RETURN_NUMBER(-1)
        return 0;
    }

    if (S_ISLNK(buf.st_mode)) {
        RETURN_NUMBER(1)
    } else {
        RETURN_NUMBER(0)
    }
#endif
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(utime,3)
    T_STRING(0)
    T_NUMBER(1)
    T_NUMBER(2)

    utimbuf buf;
    buf.actime=(time_t)PARAM_INT(1);
    buf.modtime=(time_t)PARAM_INT(2);
    int res=utime(PARAM(0), &buf);
    RETURN_NUMBER(res);
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(dup,1)
    T_NUMBER(0)

    RETURN_NUMBER(dup(PARAM_INT(0)));
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(dup2,2)
    T_NUMBER(0)
    T_NUMBER(1)

    RETURN_NUMBER(dup2(PARAM_INT(0), PARAM_INT(1)));
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(fdopen,2)
    T_NUMBER(0)
    T_STRING(1)

    RETURN_NUMBER((SYS_INT)fdopen(PARAM_INT(0), PARAM(1)));
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(pipe,2)
    T_NUMBER(0)
    T_NUMBER(1)

    int p[2];
    p[0]=PARAM_INT(0);
    p[1]=PARAM_INT(1);

    RETURN_NUMBER(pipe(p));

    SET_NUMBER(0, p[0]);
    SET_NUMBER(1, p[1]);
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(close,1)
    T_NUMBER(0)
    RETURN_NUMBER(close(PARAM_INT(0)))
END_IMPL
//---------------------------------------------------------------------------
#define	DUP2CLOSE(oldfd, newfd)	(dup2(oldfd, newfd) == 0  &&  close(oldfd) == 0)
int remap_pipe_stdin_stdout(int rpipe, int wpipe)
{
	/*------------------------------------------------------------------
	 * CASE [A]
	 *
	 * This is the trivial case that probably never happens: the two FDs
	 * are already in the right place and we have nothing to do. Though
	 * this probably doesn't happen much, it's guaranteed that *doing*
	 * any shufflingn would close descriptors that shouldn't have been.
	 */
	if ( rpipe == 0  &&  wpipe == 1 )
		return 1;

	/*----------------------------------------------------------------
	 * CASE [B] and [C]
	 *
	 * These two have the same handling but not the same rules. In case
	 * [C] where both FDs are "out of the way", it doesn't matter which
	 * of the FDs is closed first, but in case [B] it MUST be done in
	 * this order.
	 */
	if ( rpipe >= 1  &&  wpipe > 1 )
	{
		return DUP2CLOSE(rpipe, 0)
		    && DUP2CLOSE(wpipe, 1);
	}


	/*----------------------------------------------------------------
	 * CASE [D]
	 * CASE [E]
	 *
 	 * In these cases, *one* of the FDs is already correct and the other
	 * one can just be dup'd to the right place:
	 */
	if ( rpipe == 0  &&  wpipe >= 1 )
		return DUP2CLOSE(wpipe, 1);

	if ( rpipe  >= 1  &&  wpipe == 1 )
		return DUP2CLOSE(rpipe, 0);


	/*----------------------------------------------------------------
	 * CASE [F]
	 *
	 * Here we have the write pipe in the read slot, but the read FD
	 * is out of the way: this means we can do this in just two steps
	 * but they MUST be in this order.
	 */
	if ( rpipe >= 1   &&  wpipe == 0 )
	{
		return DUP2CLOSE(wpipe, 1)
		    && DUP2CLOSE(rpipe, 0);
	}

	/*----------------------------------------------------------------
	 * CASE [G]
	 *
	 * This is the trickiest case because the two file descriptors  are
	 * *backwards*, and the only way to make it right is to make a
	 * third temporary FD during the swap.
	 */
	if ( rpipe == 1  &&  wpipe == 0 )
	{
	const int tmp = dup(wpipe);		/* NOTE! this is not dup2() ! */

		return	tmp > 1
		    &&  close(wpipe)   == 0
		    &&  DUP2CLOSE(rpipe, 0)
		    &&  DUP2CLOSE(tmp,   1);
	}

	/* SHOULD NEVER GET HERE */

	return  0;
}
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(remap_pipe_stdin_stdout,2)
    T_NUMBER(0)
    T_NUMBER(1)

    RETURN_NUMBER(remap_pipe_stdin_stdout(PARAM_INT(0), PARAM_INT(1)))
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(write,2)
    T_NUMBER(0)
    T_STRING(1)

    RETURN_NUMBER(write(PARAM_INT(0), PARAM(1), PARAM_LEN(1)));
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(read,3)
    T_NUMBER(0)
    T_NUMBER(2)
    
    int size=PARAM_INT(2);
    char *c=new char[size+1];

    SET_STRING(1, "");
    if (!c)
        return (void *)"pread: error - not enough memory";

    ssize_t ret=read(PARAM_INT(0), c, size);
    if (ret>=0) {
        c[ret]=0;
        SET_BUFFER(1, c, ret);
    }
    delete[] c;

    RETURN_NUMBER(ret);
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(seek,3)
    T_NUMBER(0)
    T_NUMBER(1)
    T_NUMBER(2)

    RETURN_NUMBER(lseek(PARAM_INT(0), PARAM_INT(1), PARAM_INT(2)))
END_IMPL
//---------------------------------------------------------------------------
