#ifndef __LIBRARY_H
#define __LIBRARY_H

// user definition ...

extern "C" {
    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

    //CONCEPT_FUNCTION(_fann_create_standard)
    CONCEPT_FUNCTION(_fann_create_standard_array)
    //CONCEPT_FUNCTION(_fann_create_sparse)
    CONCEPT_FUNCTION(_fann_create_sparse_array)
    //CONCEPT_FUNCTION(_fann_create_shortcut)
    CONCEPT_FUNCTION(_fann_create_shortcut_array)
    CONCEPT_FUNCTION(_fann_destroy)
    CONCEPT_FUNCTION(_fann_run)
    CONCEPT_FUNCTION(_fann_randomize_weights)
    CONCEPT_FUNCTION(_fann_init_weights)
    CONCEPT_FUNCTION(_fann_print_connections)
    CONCEPT_FUNCTION(_fann_print_parameters)
    CONCEPT_FUNCTION(_fann_get_num_input)
    CONCEPT_FUNCTION(_fann_get_num_output)
    CONCEPT_FUNCTION(_fann_get_total_neurons)
    CONCEPT_FUNCTION(_fann_get_total_connections)
    //CONCEPT_FUNCTION(_fann_get_decimal_point)
    //CONCEPT_FUNCTION(_fann_get_multiplier)
    CONCEPT_FUNCTION(_fann_set_error_log)
    CONCEPT_FUNCTION(_fann_reset_errno)
    CONCEPT_FUNCTION(_fann_reset_errstr)
    CONCEPT_FUNCTION(_fann_get_errstr)
    CONCEPT_FUNCTION(_fann_print_error)
    CONCEPT_FUNCTION(_fann_train)
    CONCEPT_FUNCTION(_fann_test)
    CONCEPT_FUNCTION(_fann_get_MSE)
    CONCEPT_FUNCTION(_fann_get_bit_fail)
    CONCEPT_FUNCTION(_fann_reset_MSE)
    CONCEPT_FUNCTION(_fann_train_on_data)
    CONCEPT_FUNCTION(_fann_train_on_file)
    CONCEPT_FUNCTION(_fann_train_epoch)
    CONCEPT_FUNCTION(_fann_test_data)
    CONCEPT_FUNCTION(_fann_read_train_from_file)
    CONCEPT_FUNCTION(_fann_destroy_train)
    CONCEPT_FUNCTION(_fann_shuffle_train_data)
    CONCEPT_FUNCTION(_fann_scale_input_train_data)
    CONCEPT_FUNCTION(_fann_scale_output_train_data)
    CONCEPT_FUNCTION(_fann_scale_train_data)
    CONCEPT_FUNCTION(_fann_merge_train_data)
    CONCEPT_FUNCTION(_fann_duplicate_train_data)
    CONCEPT_FUNCTION(_fann_subset_train_data)
    CONCEPT_FUNCTION(_fann_length_train_data)
    CONCEPT_FUNCTION(_fann_num_input_train_data)
    CONCEPT_FUNCTION(_fann_num_output_train_data)
    CONCEPT_FUNCTION(_fann_save_train)
    CONCEPT_FUNCTION(_fann_save_train_to_fixed)
    CONCEPT_FUNCTION(_fann_set_training_algorithm)
    CONCEPT_FUNCTION(_fann_get_learning_rate)
    CONCEPT_FUNCTION(_fann_set_learning_rate)
    CONCEPT_FUNCTION(_fann_get_learning_momentum)
    CONCEPT_FUNCTION(_fann_set_learning_momentum)
    CONCEPT_FUNCTION(_fann_set_activation_function)
    CONCEPT_FUNCTION(_fann_set_activation_function_layer)
    CONCEPT_FUNCTION(_fann_set_activation_function_hidden)
    CONCEPT_FUNCTION(_fann_set_activation_function_output)
    CONCEPT_FUNCTION(_fann_set_activation_steepness)
    CONCEPT_FUNCTION(_fann_set_activation_steepness_layer)
    CONCEPT_FUNCTION(_fann_set_activation_steepness_hidden)
    CONCEPT_FUNCTION(_fann_set_activation_steepness_output)
    CONCEPT_FUNCTION(_fann_get_train_error_function)
    CONCEPT_FUNCTION(_fann_set_train_error_function)
    CONCEPT_FUNCTION(_fann_set_train_stop_function)
    CONCEPT_FUNCTION(_fann_get_bit_fail_limit)
    CONCEPT_FUNCTION(_fann_set_bit_fail_limit)
    //CONCEPT_FUNCTION(_fann_set_callback)
    CONCEPT_FUNCTION(_fann_get_quickprop_decay)
    CONCEPT_FUNCTION(_fann_set_quickprop_decay)
    CONCEPT_FUNCTION(_fann_get_quickprop_mu)
    CONCEPT_FUNCTION(_fann_set_quickprop_mu)
    CONCEPT_FUNCTION(_fann_get_rprop_increase_factor)
    CONCEPT_FUNCTION(_fann_set_rprop_increase_factor)
    CONCEPT_FUNCTION(_fann_get_rprop_decrease_factor)
    CONCEPT_FUNCTION(_fann_set_rprop_decrease_factor)
    CONCEPT_FUNCTION(_fann_get_rprop_delta_min)
    CONCEPT_FUNCTION(_fann_set_rprop_delta_min)
    CONCEPT_FUNCTION(_fann_get_rprop_delta_max)
    CONCEPT_FUNCTION(_fann_set_rprop_delta_max)
    CONCEPT_FUNCTION(_fann_create_from_file)
    CONCEPT_FUNCTION(_fann_save)
    CONCEPT_FUNCTION(_fann_save_to_fixed)
}



#endif // __LIBRARY_H
