//------------ standard header -----------------------------------//
#include "stdlibrary.h"
//------------ end of standard header ----------------------------//
#include "library.h"
#include "AnsiString.h"
#include <speex/speex.h>
#include <string.h>
//-------------------------//
// Local variables         //
//-------------------------//
#define MAX_IN_SAMPLES  640

INVOKE_CALL InvokePtr=0;
//-----------------------------------------------------//
CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS {
    InvokePtr=Invoke;
    DEFINE_ECONSTANT(SPEEX_SET_ENH)
    DEFINE_ECONSTANT(SPEEX_GET_ENH)
    DEFINE_ECONSTANT(SPEEX_GET_FRAME_SIZE)
    DEFINE_ECONSTANT(SPEEX_SET_QUALITY)
    DEFINE_ECONSTANT(SPEEX_SET_MODE)
    DEFINE_ECONSTANT(SPEEX_GET_MODE)
    DEFINE_ECONSTANT(SPEEX_SET_LOW_MODE)
    DEFINE_ECONSTANT(SPEEX_GET_LOW_MODE)
    DEFINE_ECONSTANT(SPEEX_SET_HIGH_MODE)
    DEFINE_ECONSTANT(SPEEX_GET_HIGH_MODE)
    DEFINE_ECONSTANT(SPEEX_SET_VBR)
    DEFINE_ECONSTANT(SPEEX_GET_VBR)
    DEFINE_ECONSTANT(SPEEX_SET_VBR_QUALITY)
    DEFINE_ECONSTANT(SPEEX_GET_VBR_QUALITY)
    DEFINE_ECONSTANT(SPEEX_SET_COMPLEXITY)
    DEFINE_ECONSTANT(SPEEX_GET_COMPLEXITY)
    DEFINE_ECONSTANT(SPEEX_SET_BITRATE)
    DEFINE_ECONSTANT(SPEEX_GET_BITRATE)
    DEFINE_ECONSTANT(SPEEX_SET_HANDLER)
    DEFINE_ECONSTANT(SPEEX_SET_USER_HANDLER)
    DEFINE_ECONSTANT(SPEEX_SET_SAMPLING_RATE)
    DEFINE_ECONSTANT(SPEEX_GET_SAMPLING_RATE)
    DEFINE_ECONSTANT(SPEEX_RESET_STATE)
    DEFINE_ECONSTANT(SPEEX_GET_RELATIVE_QUALITY)
    DEFINE_ECONSTANT(SPEEX_SET_VAD)
    DEFINE_ECONSTANT(SPEEX_GET_VAD)
    DEFINE_ECONSTANT(SPEEX_SET_ABR)
    DEFINE_ECONSTANT(SPEEX_GET_ABR)
    DEFINE_ECONSTANT(SPEEX_SET_DTX)
    DEFINE_ECONSTANT(SPEEX_GET_DTX)
    DEFINE_ECONSTANT(SPEEX_SET_SUBMODE_ENCODING)
    DEFINE_ECONSTANT(SPEEX_GET_SUBMODE_ENCODING)
    DEFINE_ECONSTANT(SPEEX_GET_LOOKAHEAD)
    DEFINE_ECONSTANT(SPEEX_SET_PLC_TUNING)
    DEFINE_ECONSTANT(SPEEX_GET_PLC_TUNING)
    DEFINE_ECONSTANT(SPEEX_SET_VBR_MAX_BITRATE)
    DEFINE_ECONSTANT(SPEEX_GET_VBR_MAX_BITRATE)
    DEFINE_ECONSTANT(SPEEX_SET_HIGHPASS)
    DEFINE_ECONSTANT(SPEEX_GET_HIGHPASS)
    DEFINE_ECONSTANT(SPEEX_GET_ACTIVITY)
    DEFINE_ECONSTANT(SPEEX_SET_PF)
    DEFINE_ECONSTANT(SPEEX_GET_PF)
    DEFINE_ECONSTANT(SPEEX_MODE_FRAME_SIZE)
    DEFINE_ECONSTANT(SPEEX_SUBMODE_BITS_PER_FRAME)
    DEFINE_ECONSTANT(SPEEX_LIB_GET_MAJOR_VERSION)
    DEFINE_ECONSTANT(SPEEX_LIB_GET_MINOR_VERSION)
    DEFINE_ECONSTANT(SPEEX_LIB_GET_MICRO_VERSION)
    DEFINE_ECONSTANT(SPEEX_LIB_GET_EXTRA_VERSION)
    DEFINE_ECONSTANT(SPEEX_LIB_GET_VERSION_STRING)
    DEFINE_ECONSTANT(SPEEX_NB_MODES)
    DEFINE_ECONSTANT(SPEEX_MODEID_NB)
    DEFINE_ECONSTANT(SPEEX_MODEID_WB)
    DEFINE_ECONSTANT(SPEEX_MODEID_UWB)
    DEFINE_ICONSTANT("speex_nb_mode", (SYS_INT)&speex_nb_mode)
    DEFINE_ICONSTANT("speex_wb_mode", (SYS_INT)&speex_wb_mode)
    DEFINE_ICONSTANT("speex_uwb_mode", (SYS_INT)&speex_uwb_mode)
    return 0;
}
//-----------------------------------------------------//
CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS {
    return 0;
}
//-----------------------------------------------------//
//------------------------------------------------------------------------
// void speex_bits_init(SpeexBits* bits)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_bits_init, 1)
    SpeexBits* bits=(SpeexBits*)malloc(sizeof(SpeexBits));
    if (!bits)
        return (void *)"speex_bits_init: not enough memory";

    speex_bits_init(bits);
    SET_NUMBER(0, (SYS_INT)bits)
    RETURN_NUMBER((SYS_INT)bits)
END_IMPL
//------------------------------------------------------------------------
// void speex_bits_init_buffer(SpeexBits* bits, void* buff, int buf_size)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_bits_init_buffer, 2)
    SpeexBits* bits=(SpeexBits*)malloc(sizeof(SpeexBits));
    if (!bits)
        return (void *)"speex_bits_init_buffer: not enough memory";

    T_STRING(1) // void* buff
    void* buff=(void*)PARAM(1);
    int buf_size=(int)PARAM_LEN(1);

    speex_bits_init_buffer(bits, buff, buf_size);
    SET_NUMBER(0, (SYS_INT)bits)
    RETURN_NUMBER((SYS_INT)bits)
END_IMPL
//------------------------------------------------------------------------
// void speex_bits_set_bit_buffer(SpeexBits* bits, void* buff, int buf_size)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_bits_set_bit_buffer, 2)
    T_HANDLE(0) // SpeexBits* bits
    SpeexBits* bits=(SpeexBits*)PARAM_INT(0);

    T_STRING(1) // void* buff
    void* buff=(void*)PARAM(1);

    int buf_size=(int)PARAM_LEN(1);

    speex_bits_set_bit_buffer(bits, buff, buf_size);
    RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
// void speex_bits_destroy(SpeexBits* bits)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_bits_destroy, 1)
    T_HANDLE(0) // SpeexBits* bits
    SpeexBits* bits=(SpeexBits*)PARAM_INT(0);

    speex_bits_destroy(bits);
    free(bits);
    SET_NUMBER(0,0);
    RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
// void speex_bits_reset(SpeexBits* bits)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_bits_reset, 1)
    T_HANDLE(0) // SpeexBits* bits
    SpeexBits* bits=(SpeexBits*)PARAM_INT(0);

    speex_bits_reset(bits);
    RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
// void speex_bits_rewind(SpeexBits* bits)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_bits_rewind, 1)
    T_HANDLE(0) // SpeexBits* bits
    SpeexBits* bits=(SpeexBits*)PARAM_INT(0);

    speex_bits_rewind(bits);
    RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
// void speex_bits_read_from(SpeexBits* bits, char* bytes, int len)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_bits_read_from, 2)
    T_HANDLE(0) // SpeexBits* bits
    SpeexBits* bits=(SpeexBits*)PARAM_INT(0);

    T_STRING(1) // char* bytes
    char* bytes=(char*)PARAM(1);
    int len=(int)PARAM_LEN(1);

    speex_bits_read_from(bits, bytes, len);
    RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
// void speex_bits_read_whole_bytes(SpeexBits* bits, char* bytes, int len)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_bits_read_whole_bytes, 2)
    T_HANDLE(0) // SpeexBits* bits
    SpeexBits* bits=(SpeexBits*)PARAM_INT(0);

    T_STRING(1) // char* bytes
    char* bytes=(char*)PARAM(1);
    int len=(int)PARAM_LEN(1);

    speex_bits_read_whole_bytes(bits, bytes, len);
    RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
// int speex_bits_write(SpeexBits* bits, char* bytes, int max_len)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_bits_write, 3)
    T_HANDLE(0) // SpeexBits* bits
    SpeexBits* bits=(SpeexBits*)PARAM_INT(0);

    T_NUMBER(2) // char* bytes
    int max_len=(int)PARAM_INT(2);

    char* bytes=new char[max_len+1];
    bytes[max_len]=0;
    int res=speex_bits_write(bits, bytes, max_len);
    if (res>0) {
        SET_BUFFER(1, bytes, res);
    } else {
        SET_STRING(1, "");
    }
    delete[] bytes;

    RETURN_NUMBER(res)
END_IMPL
//------------------------------------------------------------------------
// int speex_bits_write_whole_bytes(SpeexBits* bits, char* bytes, int max_len)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_bits_write_whole_bytes, 3)
    T_HANDLE(0) // SpeexBits* bits
    SpeexBits* bits=(SpeexBits*)PARAM_INT(0);

    T_NUMBER(2) // char* bytes
    int max_len=(int)PARAM_INT(2);

    char* bytes=new char[max_len+1];
    bytes[max_len]=0;
    int res=speex_bits_write_whole_bytes(bits, bytes, max_len);
    if (res>0) {
        SET_BUFFER(1, bytes, res);
    } else {
        SET_STRING(1, "");
    }
    delete[] bytes;

    RETURN_NUMBER(res)
END_IMPL
//------------------------------------------------------------------------
// void speex_bits_pack(SpeexBits* bits, int data, int nbBits)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_bits_pack, 3)
    T_HANDLE(0) // SpeexBits* bits
    SpeexBits *bits=(SpeexBits *)PARAM_INT(0);

    T_NUMBER(1) // int data
    int data=(int)PARAM(1);

    T_NUMBER(2) // int nbBits
    int nbBits=(int)PARAM(2);

    speex_bits_pack(bits, data, nbBits);
    RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
// int speex_bits_unpack_signed(SpeexBits* bits, int nbBits)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_bits_unpack_signed, 2)
    T_HANDLE(0) // SpeexBits* bits
    SpeexBits *bits=(SpeexBits *)PARAM_INT(0);

    T_NUMBER(1) // int nbBits
    int nbBits=(int)PARAM(1);

    RETURN_NUMBER(speex_bits_unpack_signed(bits, nbBits))
END_IMPL
//------------------------------------------------------------------------
// unsigned int speex_bits_unpack_unsigned(SpeexBits* bits, int nbBits)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_bits_unpack_unsigned, 2)
    T_HANDLE(0) // SpeexBits* bits
    SpeexBits *bits=(SpeexBits *)PARAM_INT(0);

    T_NUMBER(1) // int nbBits
    int nbBits=(int)PARAM(1);

    RETURN_NUMBER(speex_bits_unpack_unsigned(bits, nbBits))
END_IMPL
//------------------------------------------------------------------------
// int speex_bits_nbytes(SpeexBits* bits)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_bits_nbytes, 1)
    T_HANDLE(0) // SpeexBits* bits
    SpeexBits *bits=(SpeexBits *)PARAM_INT(0);

    RETURN_NUMBER(speex_bits_nbytes(bits))
END_IMPL
//------------------------------------------------------------------------
// unsigned int speex_bits_peek_unsigned(SpeexBits* bits, int nbBits)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_bits_peek_unsigned, 2)
    T_HANDLE(0) // SpeexBits* bits
    SpeexBits *bits=(SpeexBits *)PARAM_INT(0);

    T_NUMBER(1) // int nbBits
    int nbBits=(int)PARAM(1);

    RETURN_NUMBER(speex_bits_peek_unsigned(bits, nbBits))
END_IMPL
//------------------------------------------------------------------------
// int speex_bits_peek(SpeexBits* bits)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_bits_peek, 1)
    T_HANDLE(0) // SpeexBits* bits
    SpeexBits *bits=(SpeexBits *)PARAM_INT(0);

    RETURN_NUMBER(speex_bits_peek(bits))
END_IMPL
//------------------------------------------------------------------------
// void speex_bits_advance(SpeexBits* bits, int n)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_bits_advance, 2)
    T_HANDLE(0) // SpeexBits* bits
    SpeexBits *bits=(SpeexBits *)PARAM_INT(0);

    T_NUMBER(1) // int n
    int n=(int)PARAM(1);

    speex_bits_advance(bits, n);
    RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
// int speex_bits_remaining(SpeexBits* bits)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_bits_remaining, 1)
    T_HANDLE(0) // SpeexBits* bits
    SpeexBits *bits=(SpeexBits *)PARAM_INT(0);

    RETURN_NUMBER(speex_bits_remaining(bits))
END_IMPL
//------------------------------------------------------------------------
// void speex_bits_insert_terminator(SpeexBits* bits)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_bits_insert_terminator, 1)
    T_HANDLE(0) // SpeexBits* bits
    SpeexBits *bits=(SpeexBits *)PARAM_INT(0);

    speex_bits_insert_terminator(bits);
    RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
// void* speex_encoder_init(SpeexMode* mode)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_encoder_init, 1)
    T_HANDLE(0) // SpeexMode* mode
    SpeexMode* mode=(SpeexMode*)PARAM_INT(0);

    RETURN_NUMBER((SYS_INT)speex_encoder_init(mode))
END_IMPL
//------------------------------------------------------------------------
// void speex_encoder_destroy(void* state)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_encoder_destroy, 1)
    T_HANDLE(0) // void* state
    void* state=(void*)PARAM_INT(0);

    speex_encoder_destroy(state);
    SET_NUMBER(0,0)
    RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
// int speex_encode_int(void* state, spx_int16_t* in, SpeexBits* bits)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_encode_int, 3)
    T_HANDLE(0) // void* state
    void* state=(void*)PARAM_INT(0);

    T_STRING(1) // spx_int16_t* in
    spx_int16_t* in=(spx_int16_t*)PARAM(1);
    spx_int32_t N=0;
    spx_int16_t short_out[MAX_IN_SAMPLES];
    speex_encoder_ctl(state, SPEEX_GET_FRAME_SIZE, &N);
    if (PARAM_LEN(1)<N*sizeof(spx_int16_t))
        return (void *)"speex_encode_int: invalid buffer received (size is less than framesize)";

    T_HANDLE(2) // SpeexBits* bits
    SpeexBits* bits=(SpeexBits*)PARAM_INT(2);

    RETURN_NUMBER(speex_encode_int(state, in, bits))
END_IMPL
//------------------------------------------------------------------------
// int speex_encoder_ctl(void* state, int request, void* ptr)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_encoder_ctl, 3)
    T_HANDLE(0) // void* state
    void* state=(void*)PARAM_INT(0);

    T_NUMBER(1) // int request
    int request=(int)PARAM(1);
    spx_int32_t ptr1;
    spx_int16_t ptr2;
    char *ptr3=0;

    switch(request) {
        case SPEEX_SET_QUALITY:
        case SPEEX_SET_LOW_MODE:
        case SPEEX_SET_MODE:
        case SPEEX_RESET_STATE:
        case SPEEX_SET_ENH:
        case SPEEX_SET_SUBMODE_ENCODING:
        case SPEEX_SET_SAMPLING_RATE:
        //case SPEEX_SET_WIDEBAND:
            {
                T_NUMBER(2)
                ptr1=PARAM_INT(2);
                RETURN_NUMBER(speex_encoder_ctl(state, request, &ptr1))
            }
            break;
        case SPEEX_GET_LOW_MODE:
        case SPEEX_GET_MODE:
        case SPEEX_GET_ENH:
        case SPEEX_GET_FRAME_SIZE:
        case SPEEX_GET_BITRATE:
        case SPEEX_GET_SAMPLING_RATE:
        case SPEEX_GET_SUBMODE_ENCODING:
        case SPEEX_GET_LOOKAHEAD:
        case SPEEX_SET_HIGHPASS:
        case SPEEX_GET_HIGHPASS:
        //case SPEEX_GET_DTX_STATUS:
            RETURN_NUMBER(speex_encoder_ctl(state, request, &ptr1))
            SET_NUMBER(2, ptr1)
            break;
        /*case SPEEX_SET_INNOVATION_SAVE:
            {
                T_NUMBER(2)
                ptr2=PARAM_INT(2);
                RETURN_NUMBER(speex_encoder_ctl(state, request, &ptr2))
            }
            break;
        case SPEEX_GET_STACK:
            RETURN_NUMBER(speex_encoder_ctl(state, request, &ptr3))
            SET_STRING(2, ptr3)
            break;
        */
        default:
            RETURN_NUMBER(-3)
    }
END_IMPL
//------------------------------------------------------------------------
// void* speex_decoder_init(SpeexMode* mode)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_decoder_init, 1)
    T_HANDLE(0) // SpeexMode* mode
    SpeexMode* mode=(SpeexMode*)PARAM_INT(0);

    RETURN_NUMBER((SYS_INT)speex_decoder_init(mode))
END_IMPL
//------------------------------------------------------------------------
// void speex_decoder_destroy(void* state)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_decoder_destroy, 1)
    T_HANDLE(0) // void* state
    void* state=(void*)PARAM_INT(0);

    speex_decoder_destroy(state);
    SET_NUMBER(0,0)
    RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
// int speex_decode_int(void* state, SpeexBits* bits, spx_int16_t* out)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_decode_int, 3)
    T_HANDLE(0) // void* state
    void* state=(void*)PARAM_INT(0);

    T_HANDLE(1) // SpeexBits* bits
    SpeexBits* bits=(SpeexBits*)PARAM_INT(1);

    spx_int32_t N=0;
    spx_int16_t short_out[MAX_IN_SAMPLES];
    speex_decoder_ctl(state, SPEEX_GET_FRAME_SIZE, &N);
    
    int res=speex_decode_int(state, bits, short_out);
    if (!res) {
        SET_BUFFER(2, (char *)short_out, N*sizeof(spx_int16_t))
    } else {
        SET_STRING(2, "")
    }

    RETURN_NUMBER(res)
END_IMPL
//------------------------------------------------------------------------
// int speex_decoder_ctl(void* state, int request, void* ptr)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_decoder_ctl, 3)
    T_HANDLE(0) // void* state
    void* state=(void*)PARAM_INT(0);

    T_NUMBER(1) // int request
    int request=(int)PARAM(1);
    spx_int32_t ptr1;
    spx_int16_t ptr2;
    char *ptr3=0;

    switch(request) {
        case SPEEX_SET_LOW_MODE:
        case SPEEX_SET_ENH:
        case SPEEX_SET_MODE:
        case SPEEX_SET_QUALITY:
        case SPEEX_SET_SUBMODE_ENCODING:
        case SPEEX_RESET_STATE:
        case SPEEX_SET_HIGHPASS:
        //case SPEEX_SET_WIDEBAND:
            {
                T_NUMBER(2)
                ptr1=PARAM_INT(2);
                RETURN_NUMBER(speex_decoder_ctl(state, request, &ptr1))
            }
            break;
        case SPEEX_GET_LOW_MODE:
        case SPEEX_GET_ENH:
        case SPEEX_GET_MODE:
        case SPEEX_GET_FRAME_SIZE:
        case SPEEX_GET_BITRATE:
        case SPEEX_SET_SAMPLING_RATE:
        case SPEEX_GET_SAMPLING_RATE:
        case SPEEX_GET_SUBMODE_ENCODING:
        case SPEEX_GET_HIGHPASS:
        case SPEEX_GET_LOOKAHEAD:
            RETURN_NUMBER(speex_decoder_ctl(state, request, &ptr1))
            SET_NUMBER(2, ptr1)
            break;
        /*case SPEEX_SET_INNOVATION_SAVE:
            {
                T_NUMBER(2)
                ptr1=PARAM_INT(2);
                RETURN_NUMBER(speex_decoder_ctl(state, request, &ptr2))
            }
            break;
        case SPEEX_GET_STACK:
            RETURN_NUMBER(speex_decoder_ctl(state, request, &ptr3))
            SET_STRING(2, ptr3)
            break;*/
        default:
            RETURN_NUMBER(-2)
    } 
END_IMPL
//------------------------------------------------------------------------
// int speex_mode_query(SpeexMode* mode, int request, void* ptr)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_mode_query, 3)
    T_HANDLE(0) // SpeexMode* mode
    SpeexMode* mode=(SpeexMode*)PARAM_INT(0);

    T_NUMBER(1) // int request
    int request=(int)PARAM(1);

    int ptr=0;
    RETURN_NUMBER(speex_mode_query(mode, request, &ptr))
    SET_NUMBER(2, ptr)
END_IMPL
//------------------------------------------------------------------------
// int speex_lib_ctl(int request, void* ptr)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_lib_ctl, 2)
    T_NUMBER(0) // int request
    int request=(int)PARAM(0);

    //T_STRING(1) // void* ptr
    int ptr;
    char *ptr2;
    switch (request) {
        case SPEEX_LIB_GET_MAJOR_VERSION:
        case SPEEX_LIB_GET_MICRO_VERSION:
        case SPEEX_LIB_GET_MINOR_VERSION:
            RETURN_NUMBER(speex_lib_ctl(request, &ptr))
            SET_NUMBER(1, ptr)
            break;
        case SPEEX_LIB_GET_EXTRA_VERSION:
        case SPEEX_LIB_GET_VERSION_STRING:
            RETURN_NUMBER(speex_lib_ctl(request, &ptr2))
            SET_STRING(1,ptr2);
            break;
        default:
            SET_NUMBER(1,0)
    }
END_IMPL
//------------------------------------------------------------------------
// SpeexMode* speex_lib_get_mode(int mode)
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(speex_lib_get_mode, 1)
    T_NUMBER(0) // int mode
    int mode=(int)PARAM_INT(0);

    RETURN_NUMBER((SYS_INT)speex_lib_get_mode(mode))
END_IMPL
