#ifndef __LIBRARY_H
#define __LIBRARY_H

#include "stdlibrary.h"

extern "C" {
        CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
        CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

		CONCEPT_FUNCTION(MySQLInit)
		CONCEPT_FUNCTION(MySQLLibraryDone)
		CONCEPT_FUNCTION(MySQLLibraryInit)
		CONCEPT_FUNCTION(MySQLOptions)
		CONCEPT_FUNCTION(MySQLCountParams)
		CONCEPT_FUNCTION(MySQLPrepare)
		CONCEPT_FUNCTION(MySQLBindParameters)
		CONCEPT_FUNCTION(MySQLPreparedExecute)
		CONCEPT_FUNCTION(MySQLBindStatement)
		CONCEPT_FUNCTION(MySQLSTMTResult)
		CONCEPT_FUNCTION(MySQLFetchRow)

        CONCEPT_FUNCTION(MySQLConnect)
        CONCEPT_FUNCTION(MySQLDisconnect)

        CONCEPT_FUNCTION(MySQLAutoCommit)
        CONCEPT_FUNCTION(MySQLCommit)
        CONCEPT_FUNCTION(MySQLRollback)

        CONCEPT_FUNCTION(MySQLError)
        CONCEPT_FUNCTION(MySQLSTMTError)
        CONCEPT_FUNCTION(MySQLWarningCount)

        CONCEPT_FUNCTION(MySQLListTables)
        CONCEPT_FUNCTION(MySQLListColumns)
        CONCEPT_FUNCTION(MySQLListDatabases)

        CONCEPT_FUNCTION(MySQLFreeResult)
        CONCEPT_FUNCTION(MySQLFetchForward)

        CONCEPT_FUNCTION(MySQLCountColumns)
        CONCEPT_FUNCTION(MySQLCountRows)

        CONCEPT_FUNCTION(MySQLDescribeCol)

        CONCEPT_FUNCTION(MySQLStatement)
        CONCEPT_FUNCTION(MySQLFreeQuery)

        CONCEPT_FUNCTION(MySQLExecute)

        CONCEPT_FUNCTION(MySQLQuery)

        CONCEPT_FUNCTION(MySQLStoreResult)
        CONCEPT_FUNCTION(MySQLUseResult)

        CONCEPT_FUNCTION(MySQLFetchAbsolute)
        CONCEPT_FUNCTION(MySQLFetchFirst)
        CONCEPT_FUNCTION(MySQLFetchNext)
        CONCEPT_FUNCTION(MySQLFetchLast)

        CONCEPT_FUNCTION(MySQLColumnGet)
        CONCEPT_FUNCTION(MySQLSTMTColumnGet)

        CONCEPT_FUNCTION(MySQLEscape)

        //CONCEPT_FUNCTION(MySQLPosition)


        /*

        CONCEPT_DLL_API CONCEPT_ODBCAddParameter            CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCClearParameters         CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT_ODBCExecuteQuery            CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT_ODBCFetchPrior              CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCSkip                    CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT_ODBCColumnSet               CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCUpdate                  CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCDelete                  CONCEPT_API_PARAMETERS;*/
}


#endif // __LIBRARY_H
