#ifndef __LIBRARY_H
#define __LIBRARY_H

#include "stdlibrary.h"

extern "C" {
    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

    CONCEPT_FUNCTION(MagickRelinquishMemory)

    CONCEPT_FUNCTION(MagickGetException)
    CONCEPT_FUNCTION(GetMagickModule)
    CONCEPT_FUNCTION(NewMagickWand)
    CONCEPT_FUNCTION(MagickReadImage)
    CONCEPT_FUNCTION(MagickWriteImages)
    CONCEPT_FUNCTION(MagickSetIteratorIndex)
    CONCEPT_FUNCTION(MagickGetIteratorIndex)
    CONCEPT_FUNCTION(MagickResetIterator)
    CONCEPT_FUNCTION(MagickSetFirstIterator)
    CONCEPT_FUNCTION(MagickSetLastIterator)
    CONCEPT_FUNCTION(MagickNextImage)
    CONCEPT_FUNCTION(MagickResizeImage)
    CONCEPT_FUNCTION(DestroyMagickWand)

    CONCEPT_FUNCTION(ClearMagickWand)
    CONCEPT_FUNCTION(NewMagickWandFromImage)
    CONCEPT_FUNCTION(CloneMagickWand)
    CONCEPT_FUNCTION(IsMagickWand)
    CONCEPT_FUNCTION(MagickGetExceptionType)
    CONCEPT_FUNCTION(MagickClearException)

    CONCEPT_FUNCTION(MagickAdaptiveBlurImage)
    CONCEPT_FUNCTION(MagickAdaptiveBlurImageChannel)
    CONCEPT_FUNCTION(MagickAdaptiveResizeImage)
    CONCEPT_FUNCTION(MagickAdaptiveSharpenImage)
    CONCEPT_FUNCTION(MagickAdaptiveSharpenImageChannel)
    CONCEPT_FUNCTION(MagickAdaptiveThresholdImage)
    CONCEPT_FUNCTION(MagickAddImage)
    CONCEPT_FUNCTION(MagickAddNoiseImage)
    CONCEPT_FUNCTION(MagickAddNoiseImageChannel)
    CONCEPT_FUNCTION(MagickAffineTransformImage)
    CONCEPT_FUNCTION(MagickAnnotateImage)
    CONCEPT_FUNCTION(MagickAnimateImages)
    CONCEPT_FUNCTION(MagickAutoGammaImage)
    CONCEPT_FUNCTION(MagickAutoGammaImageChannel)
    CONCEPT_FUNCTION(MagickAutoLevelImage)
    CONCEPT_FUNCTION(MagickAutoLevelImageChannel)
    CONCEPT_FUNCTION(MagickBlackThresholdImage)
    CONCEPT_FUNCTION(MagickBlueShiftImage)
    CONCEPT_FUNCTION(MagickBlurImage)
    CONCEPT_FUNCTION(MagickBlurImageChannel)
    CONCEPT_FUNCTION(MagickBorderImage)
    CONCEPT_FUNCTION(MagickBrightnessContrastImage)
    CONCEPT_FUNCTION(MagickBrightnessContrastImageChannel)
    CONCEPT_FUNCTION(MagickCharcoalImage)
    CONCEPT_FUNCTION(MagickChopImage)
    CONCEPT_FUNCTION(MagickClampImage)
    CONCEPT_FUNCTION(MagickClampImageChannel)
    CONCEPT_FUNCTION(MagickClipImage)
    CONCEPT_FUNCTION(MagickClipImagePath)
    CONCEPT_FUNCTION(MagickClutImage)
    CONCEPT_FUNCTION(MagickClutImageChannel)
    CONCEPT_FUNCTION(MagickColorDecisionListImage)
    CONCEPT_FUNCTION(MagickColorizeImage)
    CONCEPT_FUNCTION(MagickColorMatrixImage)
    CONCEPT_FUNCTION(MagickCommentImage)
    CONCEPT_FUNCTION(MagickCompositeImage)
    CONCEPT_FUNCTION(MagickCompositeImageChannel)
    CONCEPT_FUNCTION(MagickConstituteImage)
    CONCEPT_FUNCTION(MagickContrastImage)
    CONCEPT_FUNCTION(MagickContrastStretchImage)
    CONCEPT_FUNCTION(MagickContrastStretchImageChannel)
    CONCEPT_FUNCTION(MagickConvolveImage)
    CONCEPT_FUNCTION(MagickConvolveImageChannel)
    CONCEPT_FUNCTION(MagickCropImage)
    CONCEPT_FUNCTION(MagickCycleColormapImage)
    CONCEPT_FUNCTION(MagickDecipherImage)
    CONCEPT_FUNCTION(MagickDeskewImage)
    CONCEPT_FUNCTION(MagickDespeckleImage)
    CONCEPT_FUNCTION(MagickDisplayImage)
    CONCEPT_FUNCTION(MagickDisplayImages)
    CONCEPT_FUNCTION(MagickDistortImage)
    CONCEPT_FUNCTION(MagickDrawImage)
    CONCEPT_FUNCTION(MagickEdgeImage)
    CONCEPT_FUNCTION(MagickEmbossImage)
    CONCEPT_FUNCTION(MagickEncipherImage)
    CONCEPT_FUNCTION(MagickEnhanceImage)
    CONCEPT_FUNCTION(MagickEqualizeImage)
    CONCEPT_FUNCTION(MagickEqualizeImageChannel)
    CONCEPT_FUNCTION(MagickEvaluateImage)
    CONCEPT_FUNCTION(MagickEvaluateImageChannel)
    CONCEPT_FUNCTION(MagickExportImagePixels)
    CONCEPT_FUNCTION(MagickExtentImage)
    CONCEPT_FUNCTION(MagickFilterImage)
    CONCEPT_FUNCTION(MagickFilterImageChannel)
    CONCEPT_FUNCTION(MagickFlipImage)
    CONCEPT_FUNCTION(MagickFloodfillPaintImage)
    CONCEPT_FUNCTION(MagickFlopImage)
    CONCEPT_FUNCTION(MagickForwardFourierTransformImage)
    CONCEPT_FUNCTION(MagickFrameImage)
    CONCEPT_FUNCTION(MagickFunctionImage)
    CONCEPT_FUNCTION(MagickFunctionImageChannel)
    CONCEPT_FUNCTION(MagickGammaImage)
    CONCEPT_FUNCTION(MagickGammaImageChannel)
    CONCEPT_FUNCTION(MagickGaussianBlurImage)
    CONCEPT_FUNCTION(MagickGaussianBlurImageChannel)
    CONCEPT_FUNCTION(MagickGetImageAlphaChannel)
    CONCEPT_FUNCTION(MagickGetImageBackgroundColor)
    CONCEPT_FUNCTION(MagickGetImageBluePrimary)
    CONCEPT_FUNCTION(MagickGetImageBorderColor)
    CONCEPT_FUNCTION(MagickGetImageChannelDistortion)
    CONCEPT_FUNCTION(MagickGetImageChannelKurtosis)
    CONCEPT_FUNCTION(MagickGetImageChannelMean)
    CONCEPT_FUNCTION(MagickGetImageChannelRange)
    CONCEPT_FUNCTION(MagickGetImageColormapColor)
    CONCEPT_FUNCTION(MagickGetImageDistortion)
    CONCEPT_FUNCTION(MagickGetImageGreenPrimary)
    CONCEPT_FUNCTION(MagickGetImageMatteColor)
    CONCEPT_FUNCTION(MagickGetImageLength)
    CONCEPT_FUNCTION(MagickGetImagePage)
    CONCEPT_FUNCTION(MagickGetImagePixelColor)
    CONCEPT_FUNCTION(MagickGetImageRange)
    CONCEPT_FUNCTION(MagickGetImageRedPrimary)
    CONCEPT_FUNCTION(MagickGetImageResolution)
    CONCEPT_FUNCTION(MagickGetImageWhitePoint)
    CONCEPT_FUNCTION(MagickHaldClutImage)
    CONCEPT_FUNCTION(MagickHaldClutImageChannel)
    CONCEPT_FUNCTION(MagickHasNextImage)
    CONCEPT_FUNCTION(MagickHasPreviousImage)
    CONCEPT_FUNCTION(MagickImplodeImage)
    CONCEPT_FUNCTION(MagickImportImagePixels)
    CONCEPT_FUNCTION(MagickInverseFourierTransformImage)
    CONCEPT_FUNCTION(MagickLabelImage)
    CONCEPT_FUNCTION(MagickLevelImage)
    CONCEPT_FUNCTION(MagickLevelImageChannel)
    CONCEPT_FUNCTION(MagickLinearStretchImage)
    CONCEPT_FUNCTION(MagickLiquidRescaleImage)
    CONCEPT_FUNCTION(MagickMagnifyImage)
    CONCEPT_FUNCTION(MagickMedianFilterImage)
    CONCEPT_FUNCTION(MagickMinifyImage)
    CONCEPT_FUNCTION(MagickModulateImage)
    CONCEPT_FUNCTION(MagickMorphologyImage)
    CONCEPT_FUNCTION(MagickMorphologyImageChannel)
    CONCEPT_FUNCTION(MagickMotionBlurImage)
    CONCEPT_FUNCTION(MagickMotionBlurImageChannel)
    CONCEPT_FUNCTION(MagickNegateImage)
    CONCEPT_FUNCTION(MagickNegateImageChannel)
    CONCEPT_FUNCTION(MagickNewImage)
    CONCEPT_FUNCTION(MagickNextImage)
    CONCEPT_FUNCTION(MagickNormalizeImage)
    CONCEPT_FUNCTION(MagickNormalizeImageChannel)
    CONCEPT_FUNCTION(MagickOilPaintImage)
    CONCEPT_FUNCTION(MagickOpaquePaintImage)
    CONCEPT_FUNCTION(MagickOpaquePaintImageChannel)
    CONCEPT_FUNCTION(MagickOrderedPosterizeImage)
    CONCEPT_FUNCTION(MagickOrderedPosterizeImageChannel)
    CONCEPT_FUNCTION(MagickTransparentPaintImage)
    CONCEPT_FUNCTION(MagickPingImage)
    CONCEPT_FUNCTION(MagickPingImageBlob)
    CONCEPT_FUNCTION(MagickPingImageFile)
    CONCEPT_FUNCTION(MagickPolaroidImage)
    CONCEPT_FUNCTION(MagickPosterizeImage)
    CONCEPT_FUNCTION(MagickPreviousImage)
    CONCEPT_FUNCTION(MagickQuantizeImage)
    CONCEPT_FUNCTION(MagickQuantizeImages)
    CONCEPT_FUNCTION(MagickRadialBlurImage)
    CONCEPT_FUNCTION(MagickRadialBlurImageChannel)
    CONCEPT_FUNCTION(MagickRaiseImage)
    CONCEPT_FUNCTION(MagickRandomThresholdImage)
    CONCEPT_FUNCTION(MagickRandomThresholdImageChannel)
    CONCEPT_FUNCTION(MagickReadImage)
    CONCEPT_FUNCTION(MagickReadImageBlob)
    CONCEPT_FUNCTION(MagickReadImageFile)
    CONCEPT_FUNCTION(MagickReduceNoiseImage)
    CONCEPT_FUNCTION(MagickRemapImage)
    CONCEPT_FUNCTION(MagickRemoveImage)
    CONCEPT_FUNCTION(MagickResampleImage)
    CONCEPT_FUNCTION(MagickResetImagePage)
    CONCEPT_FUNCTION(MagickResizeImage)
    CONCEPT_FUNCTION(MagickRollImage)
    CONCEPT_FUNCTION(MagickRotateImage)
    CONCEPT_FUNCTION(MagickSampleImage)
    CONCEPT_FUNCTION(MagickScaleImage)
    CONCEPT_FUNCTION(MagickSegmentImage)
    CONCEPT_FUNCTION(MagickSelectiveBlurImage)
    CONCEPT_FUNCTION(MagickSelectiveBlurImageChannel)
    CONCEPT_FUNCTION(MagickSeparateImageChannel)
    CONCEPT_FUNCTION(MagickSepiaToneImage)
    CONCEPT_FUNCTION(MagickSetImage)
    CONCEPT_FUNCTION(MagickSetImageAlphaChannel)
    CONCEPT_FUNCTION(MagickSetImageBackgroundColor)
    CONCEPT_FUNCTION(MagickSetImageBias)
    CONCEPT_FUNCTION(MagickSetImageBluePrimary)
    CONCEPT_FUNCTION(MagickSetImageBorderColor)
    CONCEPT_FUNCTION(MagickSetImageChannelDepth)
    CONCEPT_FUNCTION(MagickSetImageClipMask)
    CONCEPT_FUNCTION(MagickSetImageColor)
    CONCEPT_FUNCTION(MagickSetImageColormapColor)
    CONCEPT_FUNCTION(MagickSetImageColorspace)
    CONCEPT_FUNCTION(MagickSetImageCompose)
    CONCEPT_FUNCTION(MagickSetImageCompression)
    CONCEPT_FUNCTION(MagickSetImageDelay)
    CONCEPT_FUNCTION(MagickSetImageDepth)
    CONCEPT_FUNCTION(MagickSetImageDispose)
    CONCEPT_FUNCTION(MagickSetImageCompressionQuality)
    CONCEPT_FUNCTION(MagickSetImageExtent)
    CONCEPT_FUNCTION(MagickSetImageFilename)
    CONCEPT_FUNCTION(MagickSetImageFormat)
    CONCEPT_FUNCTION(MagickSetImageFuzz)
    CONCEPT_FUNCTION(MagickSetImageGamma)
    CONCEPT_FUNCTION(MagickSetImageGravity)
    CONCEPT_FUNCTION(MagickSetImageGreenPrimary)
    CONCEPT_FUNCTION(MagickSetImageInterlaceScheme)
    CONCEPT_FUNCTION(MagickSetImageInterpolateMethod)
    CONCEPT_FUNCTION(MagickSetImageIterations)
    CONCEPT_FUNCTION(MagickSetImageMatte)
    CONCEPT_FUNCTION(MagickSetImageMatteColor)
    CONCEPT_FUNCTION(MagickSetImageOpacity)
    CONCEPT_FUNCTION(MagickSetImageOrientation)
    CONCEPT_FUNCTION(MagickSetImagePage)
    CONCEPT_FUNCTION(MagickSetImageRedPrimary)
    CONCEPT_FUNCTION(MagickSetImageRenderingIntent)
    CONCEPT_FUNCTION(MagickSetImageResolution)
    CONCEPT_FUNCTION(MagickSetImageScene)
    CONCEPT_FUNCTION(MagickSetImageTicksPerSecond)
    CONCEPT_FUNCTION(MagickSetImageType)
    CONCEPT_FUNCTION(MagickSetImageUnits)
    CONCEPT_FUNCTION(MagickSetImageWhitePoint)
    CONCEPT_FUNCTION(MagickShadeImage)
    CONCEPT_FUNCTION(MagickShadowImage)
    CONCEPT_FUNCTION(MagickSharpenImage)
    CONCEPT_FUNCTION(MagickSharpenImageChannel)
    CONCEPT_FUNCTION(MagickShaveImage)
    CONCEPT_FUNCTION(MagickShearImage)
    CONCEPT_FUNCTION(MagickSigmoidalContrastImage)
    CONCEPT_FUNCTION(MagickSigmoidalContrastImageChannel)
    CONCEPT_FUNCTION(MagickSketchImage)
    CONCEPT_FUNCTION(MagickSolarizeImage)
    CONCEPT_FUNCTION(MagickSparseColorImage)
    CONCEPT_FUNCTION(MagickSpliceImage)
    CONCEPT_FUNCTION(MagickSpreadImage)
    CONCEPT_FUNCTION(MagickStripImage)
    CONCEPT_FUNCTION(MagickSwirlImage)
    CONCEPT_FUNCTION(MagickTintImage)
    CONCEPT_FUNCTION(MagickTransformImageColorspace)
    CONCEPT_FUNCTION(MagickTransposeImage)
    CONCEPT_FUNCTION(MagickTransverseImage)
    CONCEPT_FUNCTION(MagickThresholdImage)
    CONCEPT_FUNCTION(MagickThresholdImageChannel)
    CONCEPT_FUNCTION(MagickThumbnailImage)
    CONCEPT_FUNCTION(MagickTrimImage)
    CONCEPT_FUNCTION(MagickUniqueImageColors)
    CONCEPT_FUNCTION(MagickUnsharpMaskImage)
    CONCEPT_FUNCTION(MagickUnsharpMaskImageChannel)
    CONCEPT_FUNCTION(MagickVignetteImage)
    CONCEPT_FUNCTION(MagickWaveImage)
    CONCEPT_FUNCTION(MagickWhiteThresholdImage)
    CONCEPT_FUNCTION(MagickWriteImage)
    CONCEPT_FUNCTION(MagickWriteImageFile)
    CONCEPT_FUNCTION(MagickWriteImages)
    CONCEPT_FUNCTION(MagickWriteImagesFile)

    CONCEPT_FUNCTION(MagickGetImageChannelFeatures)
    CONCEPT_FUNCTION(MagickGetImageChannelStatistics)
    CONCEPT_FUNCTION(MagickGetImageFilename)
    CONCEPT_FUNCTION(MagickGetImageFormat)
    CONCEPT_FUNCTION(MagickGetImageSignature)
    CONCEPT_FUNCTION(MagickIdentifyImage)
    CONCEPT_FUNCTION(MagickGetImageColorspace)
    CONCEPT_FUNCTION(MagickGetImageCompose)
    CONCEPT_FUNCTION(MagickGetImageCompression)
    CONCEPT_FUNCTION(MagickGetImageDispose)
    CONCEPT_FUNCTION(MagickGetImageChannelDistortions)
    CONCEPT_FUNCTION(MagickGetImageFuzz)
    CONCEPT_FUNCTION(MagickGetImageGamma)
    CONCEPT_FUNCTION(MagickGetImageTotalInkDensity)
    CONCEPT_FUNCTION(MagickGetImageGravity)
    CONCEPT_FUNCTION(MagickDestroyImage)
    CONCEPT_FUNCTION(GetImageFromMagickWand)
    CONCEPT_FUNCTION(MagickGetImageType)
    CONCEPT_FUNCTION(MagickGetImageInterlaceScheme)
    CONCEPT_FUNCTION(MagickGetImageInterpolateMethod)
    CONCEPT_FUNCTION(MagickAppendImages)
    CONCEPT_FUNCTION(MagickCoalesceImages)
    CONCEPT_FUNCTION(MagickCombineImages)
    CONCEPT_FUNCTION(MagickCompareImageChannels)
    CONCEPT_FUNCTION(MagickCompareImages)
    CONCEPT_FUNCTION(MagickCompareImageLayers)
    CONCEPT_FUNCTION(MagickDeconstructImages)
    CONCEPT_FUNCTION(MagickEvaluateImages)
    CONCEPT_FUNCTION(MagickFxImage)
    CONCEPT_FUNCTION(MagickFxImageChannel)
    CONCEPT_FUNCTION(MagickGetImage)
    CONCEPT_FUNCTION(MagickGetImageClipMask)
    CONCEPT_FUNCTION(MagickGetImageRegion)
    CONCEPT_FUNCTION(MagickMergeImageLayers)
    CONCEPT_FUNCTION(MagickMorphImages)
    CONCEPT_FUNCTION(MagickMontageImage)
    CONCEPT_FUNCTION(MagickOptimizeImageLayers)
    CONCEPT_FUNCTION(MagickPreviewImages)
    CONCEPT_FUNCTION(MagickSimilarityImage)
    CONCEPT_FUNCTION(MagickSteganoImage)
    CONCEPT_FUNCTION(MagickStereoImage)
    CONCEPT_FUNCTION(MagickTextureImage)
    CONCEPT_FUNCTION(MagickTransformImage)
    CONCEPT_FUNCTION(MagickGetImageOrientation)
    CONCEPT_FUNCTION(MagickGetImageHistogram)
    CONCEPT_FUNCTION(MagickGetImageRenderingIntent)
    CONCEPT_FUNCTION(MagickGetImageUnits)
    CONCEPT_FUNCTION(MagickGetImageColors)
    CONCEPT_FUNCTION(MagickGetImageCompressionQuality)
    CONCEPT_FUNCTION(MagickGetImageDelay)
    CONCEPT_FUNCTION(MagickGetImageChannelDepth)
    CONCEPT_FUNCTION(MagickGetImageDepth)
    CONCEPT_FUNCTION(MagickGetImageHeight)
    CONCEPT_FUNCTION(MagickGetImageIterations)
    CONCEPT_FUNCTION(MagickGetImageScene)
    CONCEPT_FUNCTION(MagickGetImageTicksPerSecond)
    CONCEPT_FUNCTION(MagickGetImageWidth)
    CONCEPT_FUNCTION(MagickGetNumberImages)
    CONCEPT_FUNCTION(MagickGetImageBlob)
    CONCEPT_FUNCTION(MagickGetImagesBlob)
    CONCEPT_FUNCTION(MagickGetImageVirtualPixelMethod)
    CONCEPT_FUNCTION(MagickSetImageVirtualPixelMethod)

    CONCEPT_FUNCTION(DrawGetTextAlignment)
    CONCEPT_FUNCTION(DrawGetClipPath)
    CONCEPT_FUNCTION(DrawGetException)
    CONCEPT_FUNCTION(DrawGetFont)
    CONCEPT_FUNCTION(DrawGetFontFamily)
    CONCEPT_FUNCTION(DrawGetTextEncoding)
    CONCEPT_FUNCTION(DrawGetVectorGraphics)
    CONCEPT_FUNCTION(DrawGetClipUnits)
    CONCEPT_FUNCTION(DrawGetTextDecoration)
    CONCEPT_FUNCTION(DrawGetFillOpacity)
    CONCEPT_FUNCTION(DrawGetFontSize)
    CONCEPT_FUNCTION(DrawGetOpacity)
    CONCEPT_FUNCTION(DrawGetStrokeDashArray)
    CONCEPT_FUNCTION(DrawGetStrokeDashOffset)
    CONCEPT_FUNCTION(DrawGetStrokeOpacity)
    CONCEPT_FUNCTION(DrawGetStrokeWidth)
    CONCEPT_FUNCTION(DrawGetTextKerning)
    CONCEPT_FUNCTION(DrawGetTextInterlineSpacing)
    CONCEPT_FUNCTION(DrawGetTextInterwordSpacing)
    CONCEPT_FUNCTION(PeekDrawingWand)
    CONCEPT_FUNCTION(CloneDrawingWand)
    CONCEPT_FUNCTION(DestroyDrawingWand)
    CONCEPT_FUNCTION(DrawAllocateWand)
    CONCEPT_FUNCTION(NewDrawingWand)
    CONCEPT_FUNCTION(DrawGetExceptionType)
    CONCEPT_FUNCTION(DrawGetClipRule)
    CONCEPT_FUNCTION(DrawGetFillRule)
    CONCEPT_FUNCTION(DrawGetGravity)
    CONCEPT_FUNCTION(DrawGetStrokeLineCap)
    CONCEPT_FUNCTION(DrawGetStrokeLineJoin)
    CONCEPT_FUNCTION(DrawClearException)
    CONCEPT_FUNCTION(DrawComposite)
    CONCEPT_FUNCTION(DrawGetFontResolution)
    CONCEPT_FUNCTION(DrawGetStrokeAntialias)
    CONCEPT_FUNCTION(DrawGetTextAntialias)
    CONCEPT_FUNCTION(DrawPopPattern)
    CONCEPT_FUNCTION(DrawPushPattern)
    CONCEPT_FUNCTION(DrawRender)
    CONCEPT_FUNCTION(DrawSetClipPath)
    CONCEPT_FUNCTION(DrawSetFillPatternURL)
    CONCEPT_FUNCTION(DrawSetFont)
    CONCEPT_FUNCTION(DrawSetFontFamily)
    CONCEPT_FUNCTION(DrawSetFontResolution)
    CONCEPT_FUNCTION(DrawSetStrokeDashArray)
    CONCEPT_FUNCTION(DrawSetStrokePatternURL)
    CONCEPT_FUNCTION(DrawSetVectorGraphics)
    CONCEPT_FUNCTION(IsDrawingWand)
    CONCEPT_FUNCTION(PopDrawingWand)
    CONCEPT_FUNCTION(PushDrawingWand)
    CONCEPT_FUNCTION(DrawGetFontStretch)
    CONCEPT_FUNCTION(DrawGetFontStyle)
    CONCEPT_FUNCTION(DrawGetFontWeight)
    CONCEPT_FUNCTION(DrawGetStrokeMiterLimit)
    CONCEPT_FUNCTION(ClearDrawingWand)
    CONCEPT_FUNCTION(DrawAffine)
    CONCEPT_FUNCTION(DrawAnnotation)
    CONCEPT_FUNCTION(DrawArc)
    CONCEPT_FUNCTION(DrawBezier)
    CONCEPT_FUNCTION(DrawGetBorderColor)
    CONCEPT_FUNCTION(DrawCircle)
    CONCEPT_FUNCTION(DrawColor)
    CONCEPT_FUNCTION(DrawComment)
    CONCEPT_FUNCTION(DrawEllipse)
    CONCEPT_FUNCTION(DrawGetFillColor)
    CONCEPT_FUNCTION(DrawGetStrokeColor)
    CONCEPT_FUNCTION(DrawSetTextKerning)
    CONCEPT_FUNCTION(DrawSetTextInterlineSpacing)
    CONCEPT_FUNCTION(DrawSetTextInterwordSpacing)
    CONCEPT_FUNCTION(DrawGetTextUnderColor)
    CONCEPT_FUNCTION(DrawLine)
    CONCEPT_FUNCTION(DrawMatte)
    CONCEPT_FUNCTION(DrawPathClose)
    CONCEPT_FUNCTION(DrawPathCurveToAbsolute)
    CONCEPT_FUNCTION(DrawPathCurveToRelative)
    CONCEPT_FUNCTION(DrawPathCurveToQuadraticBezierAbsolute)
    CONCEPT_FUNCTION(DrawPathCurveToQuadraticBezierRelative)
    CONCEPT_FUNCTION(DrawPathCurveToQuadraticBezierSmoothAbsolute)
    CONCEPT_FUNCTION(DrawPathCurveToQuadraticBezierSmoothRelative)
    CONCEPT_FUNCTION(DrawPathCurveToSmoothAbsolute)
    CONCEPT_FUNCTION(DrawPathCurveToSmoothRelative)
    CONCEPT_FUNCTION(DrawPathEllipticArcAbsolute)
    CONCEPT_FUNCTION(DrawPathEllipticArcRelative)
    CONCEPT_FUNCTION(DrawPathFinish)
    CONCEPT_FUNCTION(DrawPathLineToAbsolute)
    CONCEPT_FUNCTION(DrawPathLineToRelative)
    CONCEPT_FUNCTION(DrawPathLineToHorizontalAbsolute)
    CONCEPT_FUNCTION(DrawPathLineToHorizontalRelative)
    CONCEPT_FUNCTION(DrawPathLineToVerticalAbsolute)
    CONCEPT_FUNCTION(DrawPathLineToVerticalRelative)
    CONCEPT_FUNCTION(DrawPathMoveToAbsolute)
    CONCEPT_FUNCTION(DrawPathMoveToRelative)
    CONCEPT_FUNCTION(DrawPathStart)
    CONCEPT_FUNCTION(DrawPoint)
    CONCEPT_FUNCTION(DrawPolygon)
    CONCEPT_FUNCTION(DrawPolyline)
    CONCEPT_FUNCTION(DrawPopClipPath)
    CONCEPT_FUNCTION(DrawPopDefs)
    CONCEPT_FUNCTION(DrawPushClipPath)
    CONCEPT_FUNCTION(DrawPushDefs)
    CONCEPT_FUNCTION(DrawRectangle)
    CONCEPT_FUNCTION(DrawResetVectorGraphics)
    CONCEPT_FUNCTION(DrawRotate)
    CONCEPT_FUNCTION(DrawRoundRectangle)
    CONCEPT_FUNCTION(DrawScale)
    CONCEPT_FUNCTION(DrawSetBorderColor)
    CONCEPT_FUNCTION(DrawSetClipRule)
    CONCEPT_FUNCTION(DrawSetClipUnits)
    CONCEPT_FUNCTION(DrawSetFillColor)
    CONCEPT_FUNCTION(DrawSetFillOpacity)
    CONCEPT_FUNCTION(DrawSetFillRule)
    CONCEPT_FUNCTION(DrawSetFontSize)
    CONCEPT_FUNCTION(DrawSetFontStretch)
    CONCEPT_FUNCTION(DrawSetFontStyle)
    CONCEPT_FUNCTION(DrawSetFontWeight)
    CONCEPT_FUNCTION(DrawSetGravity)
    CONCEPT_FUNCTION(DrawSetOpacity)
    CONCEPT_FUNCTION(DrawSetStrokeAntialias)
    CONCEPT_FUNCTION(DrawSetStrokeColor)
    CONCEPT_FUNCTION(DrawSetStrokeDashOffset)
    CONCEPT_FUNCTION(DrawSetStrokeLineCap)
    CONCEPT_FUNCTION(DrawSetStrokeLineJoin)
    CONCEPT_FUNCTION(DrawSetStrokeMiterLimit)
    CONCEPT_FUNCTION(DrawSetStrokeOpacity)
    CONCEPT_FUNCTION(DrawSetStrokeWidth)
    CONCEPT_FUNCTION(DrawSetTextAlignment)
    CONCEPT_FUNCTION(DrawSetTextAntialias)
    CONCEPT_FUNCTION(DrawSetTextDecoration)
    CONCEPT_FUNCTION(DrawSetTextEncoding)
    CONCEPT_FUNCTION(DrawSetTextUnderColor)
    CONCEPT_FUNCTION(DrawSetViewbox)
    CONCEPT_FUNCTION(DrawSkewX)
    CONCEPT_FUNCTION(DrawSkewY)
    CONCEPT_FUNCTION(DrawTranslate)

    CONCEPT_FUNCTION(PixelGetColorAsNormalizedString)
    CONCEPT_FUNCTION(PixelGetColorAsString)
    CONCEPT_FUNCTION(PixelGetException)
    CONCEPT_FUNCTION(PixelGetAlpha)
    CONCEPT_FUNCTION(PixelGetBlack)
    CONCEPT_FUNCTION(PixelGetBlue)
    CONCEPT_FUNCTION(PixelGetCyan)
    CONCEPT_FUNCTION(PixelGetFuzz)
    CONCEPT_FUNCTION(PixelGetGreen)
    CONCEPT_FUNCTION(PixelGetMagenta)
    CONCEPT_FUNCTION(PixelGetOpacity)
    CONCEPT_FUNCTION(PixelGetRed)
    CONCEPT_FUNCTION(PixelGetYellow)
    CONCEPT_FUNCTION(PixelGetExceptionType)
    CONCEPT_FUNCTION(PixelGetIndex)
    CONCEPT_FUNCTION(IsPixelWand)
    CONCEPT_FUNCTION(IsPixelWandSimilar)
    CONCEPT_FUNCTION(PixelClearException)
    CONCEPT_FUNCTION(PixelSetColor)
    CONCEPT_FUNCTION(ClonePixelWand)
    //CONCEPT_FUNCTION(ClonePixelWands)
    CONCEPT_FUNCTION(DestroyPixelWand)
    //CONCEPT_FUNCTION(DestroyPixelWands)
    CONCEPT_FUNCTION(NewPixelWand)
    //CONCEPT_FUNCTION(NewPixelWands)
    CONCEPT_FUNCTION(PixelGetAlphaQuantum)
    CONCEPT_FUNCTION(PixelGetBlackQuantum)
    CONCEPT_FUNCTION(PixelGetBlueQuantum)
    CONCEPT_FUNCTION(PixelGetCyanQuantum)
    CONCEPT_FUNCTION(PixelGetGreenQuantum)
    CONCEPT_FUNCTION(PixelGetMagentaQuantum)
    CONCEPT_FUNCTION(PixelGetOpacityQuantum)
    CONCEPT_FUNCTION(PixelGetRedQuantum)
    CONCEPT_FUNCTION(PixelGetYellowQuantum)
    CONCEPT_FUNCTION(PixelGetColorCount)
    CONCEPT_FUNCTION(ClearPixelWand)
    CONCEPT_FUNCTION(PixelGetHSL)
    CONCEPT_FUNCTION(PixelGetQuantumColor)
    CONCEPT_FUNCTION(PixelSetAlpha)
    CONCEPT_FUNCTION(PixelSetAlphaQuantum)
    CONCEPT_FUNCTION(PixelSetBlack)
    CONCEPT_FUNCTION(PixelSetBlackQuantum)
    CONCEPT_FUNCTION(PixelSetBlue)
    CONCEPT_FUNCTION(PixelSetBlueQuantum)
    CONCEPT_FUNCTION(PixelSetColorFromWand)
    CONCEPT_FUNCTION(PixelSetColorCount)
    CONCEPT_FUNCTION(PixelSetCyan)
    CONCEPT_FUNCTION(PixelSetCyanQuantum)
    CONCEPT_FUNCTION(PixelSetFuzz)
    CONCEPT_FUNCTION(PixelSetGreen)
    CONCEPT_FUNCTION(PixelSetGreenQuantum)
    CONCEPT_FUNCTION(PixelSetHSL)
    CONCEPT_FUNCTION(PixelSetIndex)
    CONCEPT_FUNCTION(PixelSetMagenta)
    CONCEPT_FUNCTION(PixelSetMagentaQuantum)
    CONCEPT_FUNCTION(PixelSetMagickColor)
    CONCEPT_FUNCTION(PixelSetOpacity)
    CONCEPT_FUNCTION(PixelSetOpacityQuantum)
    CONCEPT_FUNCTION(PixelSetQuantumColor)
    CONCEPT_FUNCTION(PixelSetRed)
    CONCEPT_FUNCTION(PixelSetRedQuantum)
    CONCEPT_FUNCTION(PixelSetYellow)
    CONCEPT_FUNCTION(PixelSetYellowQuantum)
    CONCEPT_FUNCTION(MagickGetFilename)
    CONCEPT_FUNCTION(MagickGetFormat)
    CONCEPT_FUNCTION(MagickGetFont)
    CONCEPT_FUNCTION(MagickGetHomeURL)
    CONCEPT_FUNCTION(MagickGetImageArtifact)
    CONCEPT_FUNCTION(MagickGetImageArtifacts)
    CONCEPT_FUNCTION(MagickGetImageProfiles)
    CONCEPT_FUNCTION(MagickGetImageProperty)
    CONCEPT_FUNCTION(MagickGetImageProperties)
    CONCEPT_FUNCTION(MagickGetOption)
    CONCEPT_FUNCTION(MagickGetOptions)
    CONCEPT_FUNCTION(MagickQueryConfigureOption)
    CONCEPT_FUNCTION(MagickQueryConfigureOptions)
    CONCEPT_FUNCTION(MagickQueryFonts)
    CONCEPT_FUNCTION(MagickQueryFormats)
    CONCEPT_FUNCTION(MagickGetColorspace)
    CONCEPT_FUNCTION(MagickGetCompression)
    CONCEPT_FUNCTION(MagickGetCopyright)
    CONCEPT_FUNCTION(MagickGetPackageName)
    CONCEPT_FUNCTION(MagickGetQuantumDepth)
    CONCEPT_FUNCTION(MagickGetQuantumRange)
    CONCEPT_FUNCTION(MagickGetReleaseDate)
    CONCEPT_FUNCTION(MagickGetVersion)
    CONCEPT_FUNCTION(MagickGetPointsize)
    CONCEPT_FUNCTION(MagickGetSamplingFactors)
    CONCEPT_FUNCTION(MagickQueryFontMetrics)
    CONCEPT_FUNCTION(MagickQueryMultilineFontMetrics)
    CONCEPT_FUNCTION(MagickGetGravity)
    CONCEPT_FUNCTION(MagickGetType)
    CONCEPT_FUNCTION(MagickGetInterlaceScheme)
    CONCEPT_FUNCTION(MagickGetInterpolateMethod)
    CONCEPT_FUNCTION(MagickGetOrientation)
    CONCEPT_FUNCTION(MagickDeleteImageArtifact)
    CONCEPT_FUNCTION(MagickDeleteImageProperty)
    CONCEPT_FUNCTION(MagickDeleteOption)
    CONCEPT_FUNCTION(MagickGetAntialias)
    CONCEPT_FUNCTION(MagickGetPage)
    CONCEPT_FUNCTION(MagickGetResolution)
    CONCEPT_FUNCTION(MagickGetSize)
    CONCEPT_FUNCTION(MagickGetSizeOffset)
    CONCEPT_FUNCTION(MagickProfileImage)
    CONCEPT_FUNCTION(MagickSetAntialias)
    CONCEPT_FUNCTION(MagickSetBackgroundColor)
    CONCEPT_FUNCTION(MagickSetColorspace)
    CONCEPT_FUNCTION(MagickSetCompression)
    CONCEPT_FUNCTION(MagickSetCompressionQuality)
    CONCEPT_FUNCTION(MagickSetDepth)
    CONCEPT_FUNCTION(MagickSetExtract)
    CONCEPT_FUNCTION(MagickSetFilename)
    CONCEPT_FUNCTION(MagickSetFormat)
    CONCEPT_FUNCTION(MagickSetFont)
    CONCEPT_FUNCTION(MagickSetGravity)
    CONCEPT_FUNCTION(MagickSetImageArtifact)
    CONCEPT_FUNCTION(MagickSetImageProfile)
    CONCEPT_FUNCTION(MagickSetImageProperty)
    CONCEPT_FUNCTION(MagickSetInterlaceScheme)
    CONCEPT_FUNCTION(MagickSetInterpolateMethod)
    CONCEPT_FUNCTION(MagickSetOption)
    CONCEPT_FUNCTION(MagickSetOrientation)
    CONCEPT_FUNCTION(MagickSetPage)
    CONCEPT_FUNCTION(MagickSetPassphrase)
    CONCEPT_FUNCTION(MagickSetPointsize)
    CONCEPT_FUNCTION(MagickSetResolution)
    CONCEPT_FUNCTION(MagickSetResourceLimit)
    CONCEPT_FUNCTION(MagickSetSamplingFactors)
    CONCEPT_FUNCTION(MagickSetSize)
    CONCEPT_FUNCTION(MagickSetSizeOffset)
    CONCEPT_FUNCTION(MagickSetType)
    //CONCEPT_FUNCTION(MagickSetProgressMonitor)
    CONCEPT_FUNCTION(MagickGetResource)
    CONCEPT_FUNCTION(MagickGetResourceLimit)
    CONCEPT_FUNCTION(MagickGetBackgroundColor)
    CONCEPT_FUNCTION(MagickGetImageProfile)
    CONCEPT_FUNCTION(MagickRemoveImageProfile)

    CONCEPT_FUNCTION(PixelGetIteratorException)
    CONCEPT_FUNCTION(PixelGetIteratorExceptionType)
    CONCEPT_FUNCTION(IsPixelIterator)
    CONCEPT_FUNCTION(PixelClearIteratorException)
    CONCEPT_FUNCTION(PixelSetIteratorRow)
    CONCEPT_FUNCTION(PixelSyncIterator)
    CONCEPT_FUNCTION(ClonePixelIterator)
    CONCEPT_FUNCTION(DestroyPixelIterator)
    CONCEPT_FUNCTION(NewPixelIterator)
    CONCEPT_FUNCTION(NewPixelRegionIterator)
    CONCEPT_FUNCTION(PixelGetCurrentIteratorRow)
    CONCEPT_FUNCTION(PixelGetNextIteratorRow)
    CONCEPT_FUNCTION(PixelGetPreviousIteratorRow)
    CONCEPT_FUNCTION(PixelGetIteratorRow)
    CONCEPT_FUNCTION(ClearPixelIterator)
    CONCEPT_FUNCTION(PixelResetIterator)
    CONCEPT_FUNCTION(PixelSetFirstIteratorRow)
    CONCEPT_FUNCTION(PixelSetLastIteratorRow)
}


#endif // __LIBRARY_H
