//------------ standard header -----------------------------------//
#include "stdlibrary.h"
//------------ end of standard header ----------------------------//
#include "library.h"
#include "AnsiString.h"

#include <glib-object.h>
#include <librsvg/rsvg.h>
//-------------------------//
// Local variables         //
//-------------------------//
INVOKE_CALL InvokePtr=0;
//-----------------------------------------------------//
CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS {
	InvokePtr=Invoke;
    g_type_init();
    return 0;
}
//-----------------------------------------------------//
CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS {
    return 0;
}
//-----------------------------------------------------//
CONCEPT_FUNCTION_IMPL_MINMAX_PARAMS(SVG, 1, 4)
    T_STRING(0)
    char *type="png";
    double dpi=-1;
    if (PARAMETERS_COUNT>1) {
        T_STRING(1)
        type=PARAM(1);
    }
    if (PARAMETERS_COUNT>2) {
        T_NUMBER(2)
        dpi=PARAM(2);
    }
    if (PARAMETERS_COUNT>3) {
        SET_STRING(3,"");
    }

    GError *gsvgerror=0;
    RsvgHandle *handle=rsvg_handle_new_from_data((const guchar *)PARAM(0), PARAM_LEN(0), &gsvgerror);
    if (gsvgerror) {
        if (PARAMETERS_COUNT>3) {
            SET_STRING(3, gsvgerror->message);
        }
        if (handle)
            rsvg_handle_close(handle, &gsvgerror); 
        RETURN_STRING("");
        return 0;
    }
    if ((handle) && (dpi>0))
        rsvg_handle_set_dpi(handle, dpi);

    GdkPixbuf *pixbuf=rsvg_handle_get_pixbuf(handle); 

    if (pixbuf) {
        gchar *data=0;
        gsize buf_size=0;

        gdk_pixbuf_save_to_buffer(pixbuf, &data, &buf_size, type, &gsvgerror, 0);
        if (gsvgerror) {
            if (PARAMETERS_COUNT>3) {
                SET_STRING(3, gsvgerror->message);
            }
        }
        if ((data) && (buf_size>0)) {
            RETURN_BUFFER(data, buf_size);
        } else {
            RETURN_STRING("");
        }
        if (data)
            g_free(data);
    } else {
        RETURN_STRING("");
    }
    rsvg_handle_close(handle, &gsvgerror); 
    if (pixbuf)
        g_object_unref(pixbuf);
END_IMPL
//-----------------------------------------------------//
