#ifndef __LIBRARY_H
#define __LIBRARY_H

// user definition ...

extern "C" {
    // other functions declared here
    CONCEPT_FUNCTION(MD5Init)
    CONCEPT_FUNCTION(MD5Update)
    CONCEPT_FUNCTION(MD5Final)

    CONCEPT_FUNCTION(SHA1Init)
    CONCEPT_FUNCTION(SHA1Update)
    CONCEPT_FUNCTION(SHA1Final)

    CONCEPT_DLL_API CONCEPT_md5 CONCEPT_API_PARAMETERS;
    CONCEPT_DLL_API CONCEPT_sha1 CONCEPT_API_PARAMETERS;
    CONCEPT_DLL_API CONCEPT_crc32 CONCEPT_API_PARAMETERS;

    CONCEPT_FUNCTION(aes_encrypt);
    CONCEPT_FUNCTION(aes_decrypt);

    CONCEPT_DLL_API CONCEPT__rsa_encrypt CONCEPT_API_PARAMETERS;
    CONCEPT_DLL_API CONCEPT__rsa_decrypt CONCEPT_API_PARAMETERS;
    CONCEPT_DLL_API CONCEPT__rsa_generate_keys CONCEPT_API_PARAMETERS;

    CONCEPT_DLL_API CONCEPT__rsa_sign CONCEPT_API_PARAMETERS;
    CONCEPT_DLL_API CONCEPT__rsa_verify CONCEPT_API_PARAMETERS;

    CONCEPT_FUNCTION(hmac_md5)
    CONCEPT_FUNCTION(hmac_sha1)
    CONCEPT_FUNCTION(hmac_sha256)

    CONCEPT_FUNCTION(Murmur)
}


#endif // __LIBRARY_H
