#ifndef __LIBRARY_H
#define __LIBRARY_H

// user definition ...

extern "C" {
    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

    CONCEPT_FUNCTION(gdAlphaBlend)
    CONCEPT_FUNCTION(gdImageCreate)
    CONCEPT_FUNCTION(gdImageCreateTrueColor)
    CONCEPT_FUNCTION(gdImageCreateFromPng)
    CONCEPT_FUNCTION(gdImageCreateFromPngCtx)
    CONCEPT_FUNCTION(gdImageCreateFromPngPtr)
    CONCEPT_FUNCTION(gdImageCreateFromGif)
    CONCEPT_FUNCTION(gdImageCreateFromGifCtx)
    CONCEPT_FUNCTION(gdImageCreateFromGifPtr)
    CONCEPT_FUNCTION(gdImageCreateFromWBMP)
    CONCEPT_FUNCTION(gdImageCreateFromWBMPCtx)
    CONCEPT_FUNCTION(gdImageCreateFromWBMPPtr)
    CONCEPT_FUNCTION(gdImageCreateFromJpeg)
    CONCEPT_FUNCTION(gdImageCreateFromJpegCtx)
    CONCEPT_FUNCTION(gdImageCreateFromJpegPtr)
    CONCEPT_FUNCTION(gdImageCreateFromPngSource)
    CONCEPT_FUNCTION(gdImageCreateFromGd)
    CONCEPT_FUNCTION(gdImageCreateFromGdCtx)
    CONCEPT_FUNCTION(gdImageCreateFromGdPtr)
    CONCEPT_FUNCTION(gdImageCreateFromGd2)
    CONCEPT_FUNCTION(gdImageCreateFromGd2Ctx)
    CONCEPT_FUNCTION(gdImageCreateFromGd2Ptr)
    CONCEPT_FUNCTION(gdImageCreateFromGd2Part)
    CONCEPT_FUNCTION(gdImageCreateFromGd2PartCtx)
    CONCEPT_FUNCTION(gdImageCreateFromGd2PartPtr)
    CONCEPT_FUNCTION(gdImageCreateFromXbm)
    CONCEPT_FUNCTION(gdImageCreateFromXpm)
    CONCEPT_FUNCTION(gdImageDestroy)
    CONCEPT_FUNCTION(gdImageSetPixel)
    CONCEPT_FUNCTION(gdImageGetPixel)
    CONCEPT_FUNCTION(gdImageGetTrueColorPixel)
    CONCEPT_FUNCTION(gdImageAABlend)
    CONCEPT_FUNCTION(gdImageLine)
    CONCEPT_FUNCTION(gdImageDashedLine)
    CONCEPT_FUNCTION(gdImageRectangle)
    CONCEPT_FUNCTION(gdImageFilledRectangle)
    CONCEPT_FUNCTION(gdImageSetClip)
    CONCEPT_FUNCTION(gdImageGetClip)
    CONCEPT_FUNCTION(gdImageBoundsSafe)
    CONCEPT_FUNCTION(gdImageChar)
    CONCEPT_FUNCTION(gdImageCharUp)
    CONCEPT_FUNCTION(gdImageString)
    CONCEPT_FUNCTION(gdImageStringUp)
    CONCEPT_FUNCTION(gdImageString16)
    CONCEPT_FUNCTION(gdImageStringUp16)
    CONCEPT_FUNCTION(gdFontCacheSetup)
    CONCEPT_FUNCTION(gdFontCacheShutdown)
    CONCEPT_FUNCTION(gdFreeFontCache)
    CONCEPT_FUNCTION(gdImageStringTTF)
    CONCEPT_FUNCTION(gdImageStringFT)
    CONCEPT_FUNCTION(gdFTUseFontConfig)
    CONCEPT_FUNCTION(gdImageStringFTEx)
    CONCEPT_FUNCTION(gdImagePolygon)
    CONCEPT_FUNCTION(gdImageOpenPolygon)
    CONCEPT_FUNCTION(gdImageFilledPolygon)
    CONCEPT_FUNCTION(gdImageColorAllocate)
    CONCEPT_FUNCTION(gdImageColorAllocateAlpha)
    CONCEPT_FUNCTION(gdImageColorClosest)
    CONCEPT_FUNCTION(gdImageColorClosestAlpha)
    CONCEPT_FUNCTION(gdImageColorClosestHWB)
    CONCEPT_FUNCTION(gdImageColorExact)
    CONCEPT_FUNCTION(gdImageColorExactAlpha)
    CONCEPT_FUNCTION(gdImageColorResolve)
    CONCEPT_FUNCTION(gdImageColorResolveAlpha)
    CONCEPT_FUNCTION(gdImageColorDeallocate)
    CONCEPT_FUNCTION(gdImageCreatePaletteFromTrueColor)
    CONCEPT_FUNCTION(gdImageTrueColorToPalette)
    CONCEPT_FUNCTION(gdImageColorTransparent)
    CONCEPT_FUNCTION(gdImagePaletteCopy)
    CONCEPT_FUNCTION(gdImageGif)
    CONCEPT_FUNCTION(gdImagePng)
    CONCEPT_FUNCTION(gdImagePngCtx)
    CONCEPT_FUNCTION(gdImageGifCtx)
    CONCEPT_FUNCTION(gdImagePngEx)
    CONCEPT_FUNCTION(gdImagePngCtxEx)
    CONCEPT_FUNCTION(gdImageWBMP)
    CONCEPT_FUNCTION(gdImageWBMPCtx)
    CONCEPT_FUNCTION(gdFree)
    CONCEPT_FUNCTION(gdImageWBMPPtr)
    CONCEPT_FUNCTION(gdImageJpeg)
    CONCEPT_FUNCTION(gdImageJpegCtx)
    CONCEPT_FUNCTION(gdImageJpegPtr)
    CONCEPT_FUNCTION(gdImageGifAnimBegin)
    CONCEPT_FUNCTION(gdImageGifAnimAdd)
    CONCEPT_FUNCTION(gdImageGifAnimEnd)
    CONCEPT_FUNCTION(gdImageGifAnimBeginCtx)
    CONCEPT_FUNCTION(gdImageGifAnimAddCtx)
    CONCEPT_FUNCTION(gdImageGifAnimEndCtx)
    CONCEPT_FUNCTION(gdImageGifAnimBeginPtr)
    CONCEPT_FUNCTION(gdImageGifAnimAddPtr)
    CONCEPT_FUNCTION(gdImageGifAnimEndPtr)
    CONCEPT_FUNCTION(gdImagePngToSink)
    CONCEPT_FUNCTION(gdImageGd)
    CONCEPT_FUNCTION(gdImageGd2)
    CONCEPT_FUNCTION(gdImageGifPtr)
    CONCEPT_FUNCTION(gdImagePngPtr)
    CONCEPT_FUNCTION(gdImagePngPtrEx)
    CONCEPT_FUNCTION(gdImageGdPtr)
    CONCEPT_FUNCTION(gdImageGd2Ptr)
    //CONCEPT_FUNCTION(gdImageEllipse)
    CONCEPT_FUNCTION(gdImageFilledArc)
    CONCEPT_FUNCTION(gdImageArc)
    CONCEPT_FUNCTION(gdImageEllipse)
    CONCEPT_FUNCTION(gdImageFilledEllipse)
    CONCEPT_FUNCTION(gdImageFillToBorder)
    CONCEPT_FUNCTION(gdImageFill)
    CONCEPT_FUNCTION(gdImageCopy)
    CONCEPT_FUNCTION(gdImageCopyMerge)
    CONCEPT_FUNCTION(gdImageCopyMergeGray)
    CONCEPT_FUNCTION(gdImageCopyResized)
    CONCEPT_FUNCTION(gdImageCopyResampled)
    CONCEPT_FUNCTION(gdImageCopyRotated)
    CONCEPT_FUNCTION(gdImageSetBrush)
    CONCEPT_FUNCTION(gdImageSetTile)
    CONCEPT_FUNCTION(gdImageSetAntiAliased)
    CONCEPT_FUNCTION(gdImageSetAntiAliasedDontBlend)
    CONCEPT_FUNCTION(gdImageSetStyle)
    CONCEPT_FUNCTION(gdImageSetThickness)
    CONCEPT_FUNCTION(gdImageInterlace)
    CONCEPT_FUNCTION(gdImageAlphaBlending)
    CONCEPT_FUNCTION(gdImageSaveAlpha)
    CONCEPT_FUNCTION(gdNewFileCtx)
    CONCEPT_FUNCTION(gdNewDynamicCtx)
    CONCEPT_FUNCTION(gdNewDynamicCtxEx)
    CONCEPT_FUNCTION(gdNewSSCtx)
    //CONCEPT_FUNCTION(gdDPExtractData)
    CONCEPT_FUNCTION(gdImageSquareToCircle)
    CONCEPT_FUNCTION(gdImageStringFTCircle)
    CONCEPT_FUNCTION(gdImageSharpen)


    CONCEPT_FUNCTION(gdTrueColorGetAlpha)
    CONCEPT_FUNCTION(gdTrueColorGetRed)
    CONCEPT_FUNCTION(gdTrueColorGetGreen)
    CONCEPT_FUNCTION(gdTrueColorGetBlue)
    CONCEPT_FUNCTION(gdTrueColor)
    CONCEPT_FUNCTION(gdTrueColorAlpha)
    CONCEPT_FUNCTION(gdImageTrueColor)
    CONCEPT_FUNCTION(gdImageSX)
    CONCEPT_FUNCTION(gdImageSY)
    CONCEPT_FUNCTION(gdImageColorsTotal)
    CONCEPT_FUNCTION(gdImageRed)
    CONCEPT_FUNCTION(gdImageGreen)
    CONCEPT_FUNCTION(gdImageBlue)
    CONCEPT_FUNCTION(gdImageAlpha)
    CONCEPT_FUNCTION(gdImageGetTransparent)
    CONCEPT_FUNCTION(gdImageGetInterlaced)
    CONCEPT_FUNCTION(gdImagePalettePixel)
    CONCEPT_FUNCTION(gdImageTrueColorPixel)
}



#endif // __LIBRARY_H
