#ifndef __LIBRARY_H
#define __LIBRARY_H

// user definition ...

extern "C" {
    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

    CONCEPT_FUNCTION(_HPDF_GetVersion)
    CONCEPT_FUNCTION(_HPDF_New)
    CONCEPT_FUNCTION(_HPDF_SetErrorHandler)
    CONCEPT_FUNCTION(_HPDF_Free)
    CONCEPT_FUNCTION(_HPDF_NewDoc)
    CONCEPT_FUNCTION(_HPDF_FreeDoc)
    CONCEPT_FUNCTION(_HPDF_HasDoc)
    CONCEPT_FUNCTION(_HPDF_FreeDocAll)
    CONCEPT_FUNCTION(_HPDF_SaveToStream)
    CONCEPT_FUNCTION(_HPDF_GetStreamSize)
    CONCEPT_FUNCTION(_HPDF_ReadFromStream)
    CONCEPT_FUNCTION(_HPDF_ResetStream)
    CONCEPT_FUNCTION(_HPDF_SaveToFile)
    CONCEPT_FUNCTION(_HPDF_GetError)
    CONCEPT_FUNCTION(_HPDF_GetErrorDetail)
    CONCEPT_FUNCTION(_HPDF_ResetError)
    CONCEPT_FUNCTION(_HPDF_SetPagesConfiguration)
    CONCEPT_FUNCTION(_HPDF_GetPageByIndex)
    CONCEPT_FUNCTION(_HPDF_GetPageLayout)
    CONCEPT_FUNCTION(_HPDF_SetPageLayout)
    CONCEPT_FUNCTION(_HPDF_GetPageMode)
    CONCEPT_FUNCTION(_HPDF_SetPageMode)
    CONCEPT_FUNCTION(_HPDF_GetViewerPreference)
    CONCEPT_FUNCTION(_HPDF_SetViewerPreference)
    CONCEPT_FUNCTION(_HPDF_SetOpenAction)
    CONCEPT_FUNCTION(_HPDF_GetCurrentPage)
    CONCEPT_FUNCTION(_HPDF_AddPage)
    CONCEPT_FUNCTION(_HPDF_InsertPage)
    CONCEPT_FUNCTION(_HPDF_Page_SetWidth)
    CONCEPT_FUNCTION(_HPDF_Page_SetHeight)
    CONCEPT_FUNCTION(_HPDF_Page_SetSize)
    CONCEPT_FUNCTION(_HPDF_Page_SetRotate)
    CONCEPT_FUNCTION(_HPDF_GetFont)
    CONCEPT_FUNCTION(_HPDF_LoadType1FontFromFile)
    CONCEPT_FUNCTION(_HPDF_LoadTTFontFromFile)
    CONCEPT_FUNCTION(_HPDF_LoadTTFontFromFile2)
    CONCEPT_FUNCTION(_HPDF_AddPageLabel)
    CONCEPT_FUNCTION(_HPDF_UseJPFonts)
    CONCEPT_FUNCTION(_HPDF_UseKRFonts)
    CONCEPT_FUNCTION(_HPDF_UseCNSFonts)
    CONCEPT_FUNCTION(_HPDF_UseCNTFonts)
    CONCEPT_FUNCTION(_HPDF_CreateOutline)
    CONCEPT_FUNCTION(_HPDF_Outline_SetOpened)
    CONCEPT_FUNCTION(_HPDF_Outline_SetDestination)
    CONCEPT_FUNCTION(_HPDF_Page_CreateDestination)
    CONCEPT_FUNCTION(_HPDF_Destination_SetXYZ)
    CONCEPT_FUNCTION(_HPDF_Destination_SetFit)
    CONCEPT_FUNCTION(_HPDF_Destination_SetFitH)
    CONCEPT_FUNCTION(_HPDF_Destination_SetFitV)
    CONCEPT_FUNCTION(_HPDF_Destination_SetFitR)
    CONCEPT_FUNCTION(_HPDF_Destination_SetFitB)
    CONCEPT_FUNCTION(_HPDF_Destination_SetFitBH)
    CONCEPT_FUNCTION(_HPDF_Destination_SetFitBV)
    CONCEPT_FUNCTION(_HPDF_GetEncoder)
    CONCEPT_FUNCTION(_HPDF_GetCurrentEncoder)
    CONCEPT_FUNCTION(_HPDF_SetCurrentEncoder)
    CONCEPT_FUNCTION(_HPDF_Encoder_GetType)
    CONCEPT_FUNCTION(_HPDF_Encoder_GetByteType)
    CONCEPT_FUNCTION(_HPDF_Encoder_GetUnicode)
    CONCEPT_FUNCTION(_HPDF_Encoder_GetWritingMode)
    CONCEPT_FUNCTION(_HPDF_UseJPEncodings)
    CONCEPT_FUNCTION(_HPDF_UseKREncodings)
    CONCEPT_FUNCTION(_HPDF_UseCNSEncodings)
    CONCEPT_FUNCTION(_HPDF_UseCNTEncodings)
    CONCEPT_FUNCTION(_HPDF_Page_CreateTextAnnot)
    CONCEPT_FUNCTION(_HPDF_Page_CreateLinkAnnot)
    CONCEPT_FUNCTION(_HPDF_Page_CreateURILinkAnnot)
    CONCEPT_FUNCTION(_HPDF_LinkAnnot_SetBorderStyle)
    CONCEPT_FUNCTION(_HPDF_TextAnnot_SetIcon)
    CONCEPT_FUNCTION(_HPDF_TextAnnot_SetOpened)
    CONCEPT_FUNCTION(_HPDF_LoadPngImageFromFile)
    CONCEPT_FUNCTION(_HPDF_LoadPngImageFromFile2)
    CONCEPT_FUNCTION(_HPDF_LoadJpegImageFromFile)
    CONCEPT_FUNCTION(_HPDF_LoadRawImageFromFile)
    CONCEPT_FUNCTION(_HPDF_LoadRawImageFromMem)
    CONCEPT_FUNCTION(_HPDF_Image_GetSize)
    CONCEPT_FUNCTION(_HPDF_Image_GetSize2)
    CONCEPT_FUNCTION(_HPDF_Image_GetWidth)
    CONCEPT_FUNCTION(_HPDF_Image_GetHeight)
    CONCEPT_FUNCTION(_HPDF_Image_GetBitsPerComponent)
    CONCEPT_FUNCTION(_HPDF_Image_GetColorSpace)
    CONCEPT_FUNCTION(_HPDF_Image_SetColorMask)
    CONCEPT_FUNCTION(_HPDF_Image_SetMaskImage)
    CONCEPT_FUNCTION(_HPDF_SetInfoAttr)
    CONCEPT_FUNCTION(_HPDF_GetInfoAttr)
    CONCEPT_FUNCTION(_HPDF_SetInfoDateAttr)
    CONCEPT_FUNCTION(_HPDF_SetPassword)
    CONCEPT_FUNCTION(_HPDF_SetPermission)
    CONCEPT_FUNCTION(_HPDF_SetEncryptionMode)
    CONCEPT_FUNCTION(_HPDF_SetCompressionMode)
    CONCEPT_FUNCTION(_HPDF_Font_GetFontName)
    CONCEPT_FUNCTION(_HPDF_Font_GetEncodingName)
    CONCEPT_FUNCTION(_HPDF_Font_GetUnicodeWidth)
    CONCEPT_FUNCTION(_HPDF_Font_GetBBox)
    CONCEPT_FUNCTION(_HPDF_Font_GetAscent)
    CONCEPT_FUNCTION(_HPDF_Font_GetDescent)
    CONCEPT_FUNCTION(_HPDF_Font_GetXHeight)
    CONCEPT_FUNCTION(_HPDF_Font_GetCapHeight)
    CONCEPT_FUNCTION(_HPDF_Font_TextWidth)
    CONCEPT_FUNCTION(_HPDF_Font_MeasureText)
    CONCEPT_FUNCTION(_HPDF_CreateExtGState)
    CONCEPT_FUNCTION(_HPDF_ExtGState_SetAlphaStroke)
    CONCEPT_FUNCTION(_HPDF_ExtGState_SetAlphaFill)
    CONCEPT_FUNCTION(_HPDF_ExtGState_SetBlendMode)
    CONCEPT_FUNCTION(_HPDF_Page_TextWidth)
    CONCEPT_FUNCTION(_HPDF_Page_MeasureText)
    CONCEPT_FUNCTION(_HPDF_Page_GetWidth)
    CONCEPT_FUNCTION(_HPDF_Page_GetHeight)
    CONCEPT_FUNCTION(_HPDF_Page_GetGMode)
    CONCEPT_FUNCTION(_HPDF_Page_GetCurrentPos)
    CONCEPT_FUNCTION(_HPDF_Page_GetCurrentPos2)
    CONCEPT_FUNCTION(_HPDF_Page_GetCurrentTextPos)
    CONCEPT_FUNCTION(_HPDF_Page_GetCurrentTextPos2)
    CONCEPT_FUNCTION(_HPDF_Page_GetCurrentFont)
    CONCEPT_FUNCTION(_HPDF_Page_GetCurrentFontSize)
    CONCEPT_FUNCTION(_HPDF_Page_GetTransMatrix)
    CONCEPT_FUNCTION(_HPDF_Page_GetLineWidth)
    CONCEPT_FUNCTION(_HPDF_Page_GetLineCap)
    CONCEPT_FUNCTION(_HPDF_Page_GetLineJoin)
    CONCEPT_FUNCTION(_HPDF_Page_GetMiterLimit)
    //CONCEPT_FUNCTION(_HPDF_Page_GetDash)
    CONCEPT_FUNCTION(_HPDF_Page_GetFlat)
    CONCEPT_FUNCTION(_HPDF_Page_GetCharSpace)
    CONCEPT_FUNCTION(_HPDF_Page_GetWordSpace)
    CONCEPT_FUNCTION(_HPDF_Page_GetHorizontalScalling)
    CONCEPT_FUNCTION(_HPDF_Page_GetTextLeading)
    CONCEPT_FUNCTION(_HPDF_Page_GetTextRenderingMode)
    CONCEPT_FUNCTION(_HPDF_Page_GetTextRaise)
    CONCEPT_FUNCTION(_HPDF_Page_GetTextRise)
    CONCEPT_FUNCTION(_HPDF_Page_GetRGBFill)
    CONCEPT_FUNCTION(_HPDF_Page_GetRGBStroke)
    CONCEPT_FUNCTION(_HPDF_Page_GetCMYKFill)
    CONCEPT_FUNCTION(_HPDF_Page_GetCMYKStroke)
    CONCEPT_FUNCTION(_HPDF_Page_GetGrayFill)
    CONCEPT_FUNCTION(_HPDF_Page_GetGrayStroke)
    CONCEPT_FUNCTION(_HPDF_Page_GetStrokingColorSpace)
    CONCEPT_FUNCTION(_HPDF_Page_GetFillingColorSpace)
    CONCEPT_FUNCTION(_HPDF_Page_GetTextMatrix)
    CONCEPT_FUNCTION(_HPDF_Page_GetGStateDepth)
    CONCEPT_FUNCTION(_HPDF_Page_SetLineWidth)
    CONCEPT_FUNCTION(_HPDF_Page_SetLineCap)
    CONCEPT_FUNCTION(_HPDF_Page_SetLineJoin)
    CONCEPT_FUNCTION(_HPDF_Page_SetMiterLimit)
    CONCEPT_FUNCTION(_HPDF_Page_SetDash)
    CONCEPT_FUNCTION(_HPDF_Page_SetFlat)
    CONCEPT_FUNCTION(_HPDF_Page_SetExtGState)
    CONCEPT_FUNCTION(_HPDF_Page_GSave)
    CONCEPT_FUNCTION(_HPDF_Page_GRestore)
    CONCEPT_FUNCTION(_HPDF_Page_Concat)
    CONCEPT_FUNCTION(_HPDF_Page_MoveTo)
    CONCEPT_FUNCTION(_HPDF_Page_LineTo)
    CONCEPT_FUNCTION(_HPDF_Page_CurveTo)
    CONCEPT_FUNCTION(_HPDF_Page_CurveTo2)
    CONCEPT_FUNCTION(_HPDF_Page_CurveTo3)
    CONCEPT_FUNCTION(_HPDF_Page_ClosePath)
    CONCEPT_FUNCTION(_HPDF_Page_Rectangle)
    CONCEPT_FUNCTION(_HPDF_Page_Stroke)
    CONCEPT_FUNCTION(_HPDF_Page_ClosePathStroke)
    CONCEPT_FUNCTION(_HPDF_Page_Fill)
    CONCEPT_FUNCTION(_HPDF_Page_Eofill)
    CONCEPT_FUNCTION(_HPDF_Page_FillStroke)
    CONCEPT_FUNCTION(_HPDF_Page_EofillStroke)
    CONCEPT_FUNCTION(_HPDF_Page_ClosePathFillStroke)
    CONCEPT_FUNCTION(_HPDF_Page_ClosePathEofillStroke)
    CONCEPT_FUNCTION(_HPDF_Page_EndPath)
    CONCEPT_FUNCTION(_HPDF_Page_Clip)
    CONCEPT_FUNCTION(_HPDF_Page_Eoclip)
    CONCEPT_FUNCTION(_HPDF_Page_BeginText)
    CONCEPT_FUNCTION(_HPDF_Page_EndText)
    CONCEPT_FUNCTION(_HPDF_Page_SetCharSpace)
    CONCEPT_FUNCTION(_HPDF_Page_SetWordSpace)
    CONCEPT_FUNCTION(_HPDF_Page_SetHorizontalScalling)
    CONCEPT_FUNCTION(_HPDF_Page_SetTextLeading)
    CONCEPT_FUNCTION(_HPDF_Page_SetFontAndSize)
    CONCEPT_FUNCTION(_HPDF_Page_SetTextRenderingMode)
    CONCEPT_FUNCTION(_HPDF_Page_SetTextRise)
    CONCEPT_FUNCTION(_HPDF_Page_SetTextRaise)
    CONCEPT_FUNCTION(_HPDF_Page_MoveTextPos)
    CONCEPT_FUNCTION(_HPDF_Page_MoveTextPos2)
    CONCEPT_FUNCTION(_HPDF_Page_SetTextMatrix)
    CONCEPT_FUNCTION(_HPDF_Page_MoveToNextLine)
    CONCEPT_FUNCTION(_HPDF_Page_ShowText)
    CONCEPT_FUNCTION(_HPDF_Page_ShowTextNextLine)
    CONCEPT_FUNCTION(_HPDF_Page_ShowTextNextLineEx)
    CONCEPT_FUNCTION(_HPDF_Page_SetGrayFill)
    CONCEPT_FUNCTION(_HPDF_Page_SetGrayStroke)
    CONCEPT_FUNCTION(_HPDF_Page_SetRGBFill)
    CONCEPT_FUNCTION(_HPDF_Page_SetRGBStroke)
    CONCEPT_FUNCTION(_HPDF_Page_SetCMYKFill)
    CONCEPT_FUNCTION(_HPDF_Page_SetCMYKStroke)
    CONCEPT_FUNCTION(_HPDF_Page_ExecuteXObject)
    CONCEPT_FUNCTION(_HPDF_Page_DrawImage)
    CONCEPT_FUNCTION(_HPDF_Page_Circle)
    CONCEPT_FUNCTION(_HPDF_Page_Ellipse)
    CONCEPT_FUNCTION(_HPDF_Page_Arc)
    CONCEPT_FUNCTION(_HPDF_Page_TextOut)
    CONCEPT_FUNCTION(_HPDF_Page_TextRect)
    CONCEPT_FUNCTION(_HPDF_Page_SetSlideShow)
}



#endif // __LIBRARY_H
