//------------ standard header -----------------------------------//
#include "stdlibrary.h"
//------------ end of standard header ----------------------------//
#include "library.h"
#include <string.h>
#include "AnsiString.h"
#define HPDF_SHARED
#include <hpdf.h>


INVOKE_CALL InvokePtr=0;

void Do_CMYKColor(void *RESULT, HPDF_CMYKColor color) {
    InvokePtr(INVOKE_CREATE_ARRAY,RESULT);
    InvokePtr(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"c",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)color.c);
    InvokePtr(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"m",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)color.m);
    InvokePtr(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"y",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)color.y);
    InvokePtr(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"k",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)color.k);
}
//-----------------------------------------------------------------------------------
void Do_RGBColor(void *RESULT, HPDF_RGBColor color) {
    InvokePtr(INVOKE_CREATE_ARRAY,RESULT);
    InvokePtr(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"r",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)color.r);
    InvokePtr(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"g",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)color.g);
    InvokePtr(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"b",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)color.b);
}
//-----------------------------------------------------------------------------------
void Do_Point(void *RESULT, HPDF_Point point) {
    InvokePtr(INVOKE_CREATE_ARRAY,RESULT);
    InvokePtr(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"x",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)point.x);
    InvokePtr(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"y",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)point.y);
}
//-----------------------------------------------------------------------------------
void Do_TextWidth(void *RESULT, HPDF_TextWidth txt) {
    InvokePtr(INVOKE_CREATE_ARRAY,RESULT);
    InvokePtr(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"numchars",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)txt.numchars);
    InvokePtr(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"numwords",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)txt.numwords);
    InvokePtr(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"width",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)txt.width);
    InvokePtr(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"numspace",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)txt.numspace);
}
//-----------------------------------------------------------------------------------
void Do_TransMatrix(void *RESULT, HPDF_TransMatrix trans) {
    InvokePtr(INVOKE_CREATE_ARRAY,RESULT);
    InvokePtr(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"a",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)trans.a);
    InvokePtr(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"b",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)trans.b);
    InvokePtr(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"c",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)trans.c);
    InvokePtr(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"d",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)trans.d);
    InvokePtr(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"x",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)trans.x);
    InvokePtr(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"y",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)trans.y);
}
//-----------------------------------------------------------------------------------
void Do_Box(void *RESULT, HPDF_Box box) {
    InvokePtr(INVOKE_CREATE_ARRAY,RESULT);
    InvokePtr(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"left",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)box.left);
    InvokePtr(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"bottom",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)box.bottom);
    InvokePtr(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"right",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)box.right);
    InvokePtr(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"top",(INTEGER)VARIABLE_NUMBER,(char *)"",(NUMBER)box.top);
}
//-----------------------------------------------------------------------------------
HPDF_Rect Get_Rect(void *arr) {
    HPDF_Rect rect;
    INTEGER type=0;
    char *str=0;
    NUMBER nr=0;
    
    InvokePtr(INVOKE_GET_ARRAY_ELEMENT_BY_KEY, arr, "left", &type, &str, &nr);
    if (type==VARIABLE_NUMBER)
        rect.left=nr;

    InvokePtr(INVOKE_GET_ARRAY_ELEMENT_BY_KEY, arr, "bottom", &type, &str, &nr);
    if (type==VARIABLE_NUMBER)
        rect.bottom=nr;

    InvokePtr(INVOKE_GET_ARRAY_ELEMENT_BY_KEY, arr, "right", &type, &str, &nr);
    if (type==VARIABLE_NUMBER)
        rect.right=nr;

    InvokePtr(INVOKE_GET_ARRAY_ELEMENT_BY_KEY, arr, "top", &type, &str, &nr);
    if (type==VARIABLE_NUMBER)
        rect.top=nr;

    return rect;
}
//-----------------------------------------------------------------------------------
HPDF_Date Get_Date(void *arr) {
    HPDF_Date date;
    INTEGER type=0;
    char *str=0;
    NUMBER nr=0;
    
    InvokePtr(INVOKE_GET_ARRAY_ELEMENT_BY_KEY, arr, "year", &type, &str, &nr);
    if (type==VARIABLE_NUMBER)
        date.year=(int)nr;
    InvokePtr(INVOKE_GET_ARRAY_ELEMENT_BY_KEY, arr, "month", &type, &str, &nr);
    if (type==VARIABLE_NUMBER)
        date.month=(int)nr;
    InvokePtr(INVOKE_GET_ARRAY_ELEMENT_BY_KEY, arr, "day", &type, &str, &nr);
    if (type==VARIABLE_NUMBER)
        date.day=(int)nr;
    InvokePtr(INVOKE_GET_ARRAY_ELEMENT_BY_KEY, arr, "hour", &type, &str, &nr);
    if (type==VARIABLE_NUMBER)
        date.hour=(int)nr;
    InvokePtr(INVOKE_GET_ARRAY_ELEMENT_BY_KEY, arr, "minutes", &type, &str, &nr);
    if (type==VARIABLE_NUMBER)
        date.minutes=(int)nr;
    InvokePtr(INVOKE_GET_ARRAY_ELEMENT_BY_KEY, arr, "seconds", &type, &str, &nr);
    if (type==VARIABLE_NUMBER)
        date.seconds=(int)nr;
    InvokePtr(INVOKE_GET_ARRAY_ELEMENT_BY_KEY, arr, "ind", &type, &str, &nr);
    if (type==VARIABLE_NUMBER)
        date.ind=(char)(int)nr;
    InvokePtr(INVOKE_GET_ARRAY_ELEMENT_BY_KEY, arr, "off_hour", &type, &str, &nr);
    if (type==VARIABLE_NUMBER)
        date.off_hour=(int)nr;
    InvokePtr(INVOKE_GET_ARRAY_ELEMENT_BY_KEY, arr, "off_minutes", &type, &str, &nr);
    if (type==VARIABLE_NUMBER)
        date.off_minutes=(int)nr;

    return date;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS {
    InvokePtr=Invoke;

    DEFINE_ECONSTANT(HPDF_TRUE)
    DEFINE_ECONSTANT(HPDF_FALSE)

    DEFINE_ECONSTANT(HPDF_OK)
    DEFINE_ECONSTANT(HPDF_NOERROR)

    DEFINE_ECONSTANT(HPDF_TMP_BUF_SIZ)
    DEFINE_ECONSTANT(HPDF_SHORT_BUF_SIZ)
    DEFINE_ECONSTANT(HPDF_REAL_LEN)
    DEFINE_ECONSTANT(HPDF_INT_LEN)
    DEFINE_ECONSTANT(HPDF_TEXT_DEFAULT_LEN)
    DEFINE_ECONSTANT(HPDF_UNICODE_HEADER_LEN)
    DEFINE_ECONSTANT(HPDF_DATE_TIME_STR_LEN)

    DEFINE_ECONSTANT(HPDF_BYTE_OFFSET_LEN)
    DEFINE_ECONSTANT(HPDF_OBJ_ID_LEN)
    DEFINE_ECONSTANT(HPDF_GEN_NO_LEN)

    DEFINE_ESCONSTANT(HPDF_DEF_FONT)
    DEFINE_ECONSTANT(HPDF_DEF_PAGE_LAYOUT)
    DEFINE_ECONSTANT(HPDF_DEF_PAGE_MODE)
    DEFINE_ECONSTANT(HPDF_DEF_WORDSPACE)
    DEFINE_ECONSTANT(HPDF_DEF_CHARSPACE)
    DEFINE_ECONSTANT(HPDF_DEF_FONTSIZE)
    DEFINE_ECONSTANT(HPDF_DEF_HSCALING)
    DEFINE_ECONSTANT(HPDF_DEF_LEADING)
    DEFINE_ECONSTANT(HPDF_DEF_RENDERING_MODE)
    DEFINE_ECONSTANT(HPDF_DEF_RISE)
    DEFINE_ECONSTANT(HPDF_DEF_RAISE)
    DEFINE_ECONSTANT(HPDF_DEF_LINEWIDTH)
    DEFINE_ECONSTANT(HPDF_DEF_LINECAP)
    DEFINE_ECONSTANT(HPDF_DEF_LINEJOIN)
    DEFINE_ECONSTANT(HPDF_DEF_MITERLIMIT)
    DEFINE_ECONSTANT(HPDF_DEF_FLATNESS)
    DEFINE_ECONSTANT(HPDF_DEF_PAGE_NUM)

    DEFINE_ECONSTANT(HPDF_BS_DEF_WIDTH)


    DEFINE_ECONSTANT(HPDF_DEF_PAGE_WIDTH)
    DEFINE_ECONSTANT(HPDF_DEF_PAGE_HEIGHT)

    DEFINE_ESCONSTANT(HPDF_VERSION_TEXT)

    DEFINE_ECONSTANT(HPDF_COMP_NONE)
    DEFINE_ECONSTANT(HPDF_COMP_TEXT)
    DEFINE_ECONSTANT(HPDF_COMP_IMAGE)
    DEFINE_ECONSTANT(HPDF_COMP_METADATA)
    DEFINE_ECONSTANT(HPDF_COMP_ALL)
    DEFINE_ECONSTANT(HPDF_COMP_MASK)
    DEFINE_ECONSTANT(HPDF_ENABLE_READ)
    DEFINE_ECONSTANT(HPDF_ENABLE_PRINT)
    DEFINE_ECONSTANT(HPDF_ENABLE_EDIT_ALL)
    DEFINE_ECONSTANT(HPDF_ENABLE_COPY)
    DEFINE_ECONSTANT(HPDF_ENABLE_EDIT)
    DEFINE_ECONSTANT(HPDF_HIDE_TOOLBAR)
    DEFINE_ECONSTANT(HPDF_HIDE_MENUBAR)
    DEFINE_ECONSTANT(HPDF_HIDE_WINDOW_UI)
    DEFINE_ECONSTANT(HPDF_FIT_WINDOW)
    DEFINE_ECONSTANT(HPDF_CENTER_WINDOW)
    DEFINE_ECONSTANT(HPDF_LIMIT_MAX_INT)
    DEFINE_ECONSTANT(HPDF_LIMIT_MIN_INT)

    DEFINE_ECONSTANT(HPDF_LIMIT_MAX_REAL)
    DEFINE_ECONSTANT(HPDF_LIMIT_MIN_REAL)

    DEFINE_ECONSTANT(HPDF_LIMIT_MAX_STRING_LEN)
    DEFINE_ECONSTANT(HPDF_LIMIT_MAX_NAME_LEN)

    DEFINE_ECONSTANT(HPDF_LIMIT_MAX_ARRAY)
    DEFINE_ECONSTANT(HPDF_LIMIT_MAX_DICT_ELEMENT)
    DEFINE_ECONSTANT(HPDF_LIMIT_MAX_XREF_ELEMENT)
    DEFINE_ECONSTANT(HPDF_LIMIT_MAX_GSTATE)
    DEFINE_ECONSTANT(HPDF_LIMIT_MAX_DEVICE_N)
    DEFINE_ECONSTANT(HPDF_LIMIT_MAX_DEVICE_N_V15)
    DEFINE_ECONSTANT(HPDF_LIMIT_MAX_CID)
    DEFINE_ECONSTANT(HPDF_MAX_GENERATION_NUM)

    DEFINE_ECONSTANT(HPDF_MIN_PAGE_HEIGHT)
    DEFINE_ECONSTANT(HPDF_MIN_PAGE_WIDTH)
    DEFINE_ECONSTANT(HPDF_MAX_PAGE_HEIGHT)
    DEFINE_ECONSTANT(HPDF_MAX_PAGE_WIDTH)
    DEFINE_ECONSTANT(HPDF_MIN_MAGNIFICATION_FACTOR)
    DEFINE_ECONSTANT(HPDF_MAX_MAGNIFICATION_FACTOR)

    DEFINE_ECONSTANT(HPDF_MIN_PAGE_SIZE)
    DEFINE_ECONSTANT(HPDF_MAX_PAGE_SIZE)
    DEFINE_ECONSTANT(HPDF_MIN_HORIZONTALSCALING)
    DEFINE_ECONSTANT(HPDF_MAX_HORIZONTALSCALING)
    DEFINE_ECONSTANT(HPDF_MIN_WORDSPACE)
    DEFINE_ECONSTANT(HPDF_MAX_WORDSPACE)
    DEFINE_ECONSTANT(HPDF_MIN_CHARSPACE)
    DEFINE_ECONSTANT(HPDF_MAX_CHARSPACE)
    DEFINE_ECONSTANT(HPDF_MAX_FONTSIZE)
    DEFINE_ECONSTANT(HPDF_MAX_ZOOMSIZE)
    DEFINE_ECONSTANT(HPDF_MAX_LEADING)
    DEFINE_ECONSTANT(HPDF_MAX_LINEWIDTH)
    DEFINE_ECONSTANT(HPDF_MAX_DASH_PATTERN)

    DEFINE_ECONSTANT(HPDF_MAX_JWW_NUM)

    DEFINE_ESCONSTANT(HPDF_COUNTRY_AF)  //"AF"    /* AFGHANISTAN */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_AL)  //"AL"    /* ALBANIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_DZ)  //"DZ"    /* ALGERIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_AS)  //"AS"    /* AMERICAN SAMOA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_AD)  //"AD"    /* ANDORRA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_AO)  //"AO"    /* ANGOLA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_AI)  //"AI"    /* ANGUILLA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_AQ)  //"AQ"    /* ANTARCTICA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_AG)  //"AG"    /* ANTIGUA AND BARBUDA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_AR)  //"AR"    /* ARGENTINA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_AM)  //"AM"    /* ARMENIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_AW)  //"AW"    /* ARUBA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_AU)  //"AU"    /* AUSTRALIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_AT)  //"AT"    /* AUSTRIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_AZ)  //"AZ"    /* AZERBAIJAN */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_BS)  //"BS"    /* BAHAMAS */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_BH)  //"BH"    /* BAHRAIN */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_BD)  //"BD"    /* BANGLADESH */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_BB)  //"BB"    /* BARBADOS */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_BY)  //"BY"    /* BELARUS */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_BE)  //"BE"    /* BELGIUM */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_BZ)  //"BZ"    /* BELIZE */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_BJ)  //"BJ"    /* BENIN */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_BM)  //"BM"    /* BERMUDA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_BT)  //"BT"    /* BHUTAN */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_BO)  //"BO"    /* BOLIVIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_BA)  //"BA"    /* BOSNIA AND HERZEGOWINA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_BW)  //"BW"    /* BOTSWANA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_BV)  //"BV"    /* BOUVET ISLAND */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_BR)  //"BR"    /* BRAZIL */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_IO)  //"IO"    /* BRITISH INDIAN OCEAN TERRITORY */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_BN)  //"BN"    /* BRUNEI DARUSSALAM */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_BG)  //"BG"    /* BULGARIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_BF)  //"BF"    /* BURKINA FASO */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_BI)  //"BI"    /* BURUNDI */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_KH)  //"KH"    /* CAMBODIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_CM)  //"CM"    /* CAMEROON */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_CA)  //"CA"    /* CANADA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_CV)  //"CV"    /* CAPE VERDE */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_KY)  //"KY"    /* CAYMAN ISLANDS */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_CF)  //"CF"    /* CENTRAL AFRICAN REPUBLIC */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_TD)  //"TD"    /* CHAD */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_CL)  //"CL"    /* CHILE */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_CN)  //"CN"    /* CHINA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_CX)  //"CX"    /* CHRISTMAS ISLAND */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_CC)  //"CC"    /* COCOS (KEELING) ISLANDS */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_CO)  //"CO"    /* COLOMBIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_KM)  //"KM"    /* COMOROS */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_CG)  //"CG"    /* CONGO */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_CK)  //"CK"    /* COOK ISLANDS */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_CR)  //"CR"    /* COSTA RICA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_CI)  //"CI"    /* COTE D'IVOIRE */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_HR)  //"HR"    /* CROATIA (local name: Hrvatska) */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_CU)  //"CU"    /* CUBA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_CY)  //"CY"    /* CYPRUS */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_CZ)  //"CZ"    /* CZECH REPUBLIC */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_DK)  //"DK"    /* DENMARK */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_DJ)  //"DJ"    /* DJIBOUTI */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_DM)  //"DM"    /* DOMINICA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_DO)  //"DO"    /* DOMINICAN REPUBLIC */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_TP)  //"TP"    /* EAST TIMOR */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_EC)  //"EC"    /* ECUADOR */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_EG)  //"EG"    /* EGYPT */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_SV)  //"SV"    /* EL SALVADOR */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_GQ)  //"GQ"    /* EQUATORIAL GUINEA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_ER)  //"ER"    /* ERITREA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_EE)  //"EE"    /* ESTONIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_ET)  //"ET"    /* ETHIOPIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_FK)  //"FK"   /* FALKLAND ISLANDS (MALVINAS) */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_FO)  //"FO"    /* FAROE ISLANDS */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_FJ)  //"FJ"    /* FIJI */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_FI)  //"FI"    /* FINLAND */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_FR)  //"FR"    /* FRANCE */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_FX)  //"FX"    /* FRANCE, METROPOLITAN */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_GF)  //"GF"    /* FRENCH GUIANA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_PF)  //"PF"    /* FRENCH POLYNESIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_TF)  //"TF"    /* FRENCH SOUTHERN TERRITORIES */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_GA)  //"GA"    /* GABON */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_GM)  //"GM"    /* GAMBIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_GE)  //"GE"    /* GEORGIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_DE)  //"DE"    /* GERMANY */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_GH)  //"GH"    /* GHANA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_GI)  //"GI"    /* GIBRALTAR */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_GR)  //"GR"    /* GREECE */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_GL)  //"GL"    /* GREENLAND */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_GD)  //"GD"    /* GRENADA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_GP)  //"GP"    /* GUADELOUPE */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_GU)  //"GU"    /* GUAM */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_GT)  //"GT"    /* GUATEMALA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_GN)  //"GN"    /* GUINEA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_GW)  //"GW"    /* GUINEA-BISSAU */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_GY)  //"GY"    /* GUYANA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_HT)  //"HT"    /* HAITI */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_HM)  //"HM"    /* HEARD AND MC DONALD ISLANDS */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_HN)  //"HN"    /* HONDURAS */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_HK)  //"HK"    /* HONG KONG */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_HU)  //"HU"    /* HUNGARY */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_IS)  //"IS"    /* ICELAND */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_IN)  //"IN"    /* INDIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_ID)  //"ID"    /* INDONESIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_IR)  //"IR"    /* IRAN (ISLAMIC REPUBLIC OF) */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_IQ)  //"IQ"    /* IRAQ */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_IE)  //"IE"    /* IRELAND */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_IL)  //"IL"    /* ISRAEL */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_IT)  //"IT"    /* ITALY */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_JM)  //"JM"    /* JAMAICA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_JP)  //"JP"    /* JAPAN */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_JO)  //"JO"    /* JORDAN */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_KZ)  //"KZ"    /* KAZAKHSTAN */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_KE)  //"KE"    /* KENYA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_KI)  //"KI"    /* KIRIBATI */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_KP)  //"KP"    /* KOREA, DEMOCRATIC PEOPLE'S REPUBLIC OF */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_KR)  //"KR"    /* KOREA, REPUBLIC OF */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_KW)  //"KW"    /* KUWAIT */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_KG)  //"KG"    /* KYRGYZSTAN */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_LA)  //"LA"    /* LAO PEOPLE'S DEMOCRATIC REPUBLIC */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_LV)  //"LV"    /* LATVIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_LB)  //"LB"    /* LEBANON */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_LS)  //"LS"    /* LESOTHO */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_LR)  //"LR"    /* LIBERIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_LY)  //"LY"    /* LIBYAN ARAB JAMAHIRIYA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_LI)  //"LI"    /* LIECHTENSTEIN */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_LT)  //"LT"    /* LITHUANIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_LU)  //"LU"    /* LUXEMBOURG */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_MO)  //"MO"    /* MACAU */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_MK)  //"MK"   /* MACEDONIA, THE FORMER YUGOSLAV REPUBLIC OF */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_MG)  //"MG"    /* MADAGASCAR */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_MW)  //"MW"    /* MALAWI */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_MY)  //"MY"    /* MALAYSIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_MV)  //"MV"    /* MALDIVES */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_ML)  //"ML"    /* MALI */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_MT)  //"MT"    /* MALTA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_MH)  //"MH"    /* MARSHALL ISLANDS */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_MQ)  //"MQ"    /* MARTINIQUE */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_MR)  //"MR"    /* MAURITANIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_MU)  //"MU"    /* MAURITIUS */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_YT)  //"YT"    /* MAYOTTE */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_MX)  //"MX"    /* MEXICO */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_FM)  //"FM"    /* MICRONESIA, FEDERATED STATES OF */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_MD)  //"MD"    /* MOLDOVA, REPUBLIC OF */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_MC)  //"MC"    /* MONACO */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_MN)  //"MN"    /* MONGOLIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_MS)  //"MS"    /* MONTSERRAT */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_MA)  //"MA"    /* MOROCCO */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_MZ)  //"MZ"    /* MOZAMBIQUE */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_MM)  //"MM"    /* MYANMAR */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_NA)  //"NA"    /* NAMIBIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_NR)  //"NR"    /* NAURU */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_NP)  //"NP"    /* NEPAL */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_NL)  //"NL"    /* NETHERLANDS */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_AN)  //"AN"    /* NETHERLANDS ANTILLES */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_NC)  //"NC"    /* NEW CALEDONIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_NZ)  //"NZ"    /* NEW ZEALAND */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_NI)  //"NI"    /* NICARAGUA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_NE)  //"NE"    /* NIGER */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_NG)  //"NG"    /* NIGERIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_NU)  //"NU"    /* NIUE */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_NF)  //"NF"    /* NORFOLK ISLAND */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_MP)  //"MP"    /* NORTHERN MARIANA ISLANDS */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_NO)  //"NO"    /* NORWAY */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_OM)  //"OM"    /* OMAN */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_PK)  //"PK"    /* PAKISTAN */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_PW)  //"PW"    /* PALAU */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_PA)  //"PA"    /* PANAMA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_PG)  //"PG"    /* PAPUA NEW GUINEA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_PY)  //"PY"    /* PARAGUAY */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_PE)  //"PE"    /* PERU */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_PH)  //"PH"    /* PHILIPPINES */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_PN)  //"PN"    /* PITCAIRN */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_PL)  //"PL"    /* POLAND */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_PT)  //"PT"    /* PORTUGAL */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_PR)  //"PR"    /* PUERTO RICO */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_QA)  //"QA"    /* QATAR */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_RE)  //"RE"    /* REUNION */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_RO)  //"RO"    /* ROMANIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_RU)  //"RU"    /* RUSSIAN FEDERATION */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_RW)  //"RW"    /* RWANDA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_KN)  //"KN"    /* SAINT KITTS AND NEVIS */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_LC)  //"LC"    /* SAINT LUCIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_VC)  //"VC"    /* SAINT VINCENT AND THE GRENADINES */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_WS)  //"WS"    /* SAMOA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_SM)  //"SM"    /* SAN MARINO */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_ST)  //"ST"    /* SAO TOME AND PRINCIPE */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_SA)  //"SA"    /* SAUDI ARABIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_SN)  //"SN"    /* SENEGAL */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_SC)  //"SC"    /* SEYCHELLES */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_SL)  //"SL"    /* SIERRA LEONE */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_SG)  //"SG"    /* SINGAPORE */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_SK)  //"SK"    /* SLOVAKIA (Slovak Republic) */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_SI)  //"SI"    /* SLOVENIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_SB)  //"SB"    /* SOLOMON ISLANDS */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_SO)  //"SO"    /* SOMALIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_ZA)  //"ZA"    /* SOUTH AFRICA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_ES)  //"ES"    /* SPAIN */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_LK)  //"LK"    /* SRI LANKA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_SH)  //"SH"    /* ST. HELENA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_PM)  //"PM"    /* ST. PIERRE AND MIQUELON */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_SD)  //"SD"    /* SUDAN */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_SR)  //"SR"    /* SURINAME */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_SJ)  //"SJ"    /* SVALBARD AND JAN MAYEN ISLANDS */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_SZ)  //"SZ"    /* SWAZILAND */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_SE)  //"SE"    /* SWEDEN */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_CH)  //"CH"    /* SWITZERLAND */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_SY)  //"SY"    /* SYRIAN ARAB REPUBLIC */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_TW)  //"TW"    /* TAIWAN, PROVINCE OF CHINA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_TJ)  //"TJ"    /* TAJIKISTAN */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_TZ)  //"TZ"    /* TANZANIA, UNITED REPUBLIC OF */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_TH)  //"TH"    /* THAILAND */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_TG)  //"TG"    /* TOGO */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_TK)  //"TK"    /* TOKELAU */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_TO)  //"TO"    /* TONGA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_TT)  //"TT"    /* TRINIDAD AND TOBAGO */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_TN)  //"TN"    /* TUNISIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_TR)  //"TR"    /* TURKEY */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_TM)  //"TM"    /* TURKMENISTAN */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_TC)  //"TC"    /* TURKS AND CAICOS ISLANDS */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_TV)  //"TV"    /* TUVALU */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_UG)  //"UG"    /* UGANDA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_UA)  //"UA"    /* UKRAINE */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_AE)  //"AE"    /* UNITED ARAB EMIRATES */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_GB)  //"GB"    /* UNITED KINGDOM */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_US)  //"US"    /* UNITED STATES */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_UM)  //"UM"    /* UNITED STATES MINOR OUTLYING ISLANDS */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_UY)  //"UY"    /* URUGUAY */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_UZ)  //"UZ"    /* UZBEKISTAN */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_VU)  //"VU"    /* VANUATU */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_VA)  //"VA"    /* VATICAN CITY STATE (HOLY SEE) */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_VE)  //"VE"    /* VENEZUELA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_VN)  //"VN"    /* VIET NAM */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_VG)  //"VG"    /* VIRGIN ISLANDS (BRITISH) */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_VI)  //"VI"    /* VIRGIN ISLANDS (U.S.) */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_WF)  //"WF"    /* WALLIS AND FUTUNA ISLANDS */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_EH)  //"EH"    /* WESTERN SAHARA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_YE)  //"YE"    /* YEMEN */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_YU)  //"YU"    /* YUGOSLAVIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_ZR)  //"ZR"    /* ZAIRE */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_ZM)  //"ZM"    /* ZAMBIA */
    DEFINE_ESCONSTANT(HPDF_COUNTRY_ZW)  //"ZW"    /* ZIMBABWE */


    DEFINE_ESCONSTANT(HPDF_LANG_AA)  //"aa"     /* Afar */
    DEFINE_ESCONSTANT(HPDF_LANG_AB)  //"ab"     /* Abkhazian */
    DEFINE_ESCONSTANT(HPDF_LANG_AF)  //"af"     /* Afrikaans */
    DEFINE_ESCONSTANT(HPDF_LANG_AM)  //"am"     /* Amharic */
    DEFINE_ESCONSTANT(HPDF_LANG_AR)  //"ar"     /* Arabic */
    DEFINE_ESCONSTANT(HPDF_LANG_AS)  //"as"     /* Assamese */
    DEFINE_ESCONSTANT(HPDF_LANG_AY)  //"ay"     /* Aymara */
    DEFINE_ESCONSTANT(HPDF_LANG_AZ)  //"az"     /* Azerbaijani */
    DEFINE_ESCONSTANT(HPDF_LANG_BA)  //"ba"     /* Bashkir */
    DEFINE_ESCONSTANT(HPDF_LANG_BE)  //"be"     /* Byelorussian */
    DEFINE_ESCONSTANT(HPDF_LANG_BG)  //"bg"     /* Bulgarian */
    DEFINE_ESCONSTANT(HPDF_LANG_BH)  //"bh"     /* Bihari */
    DEFINE_ESCONSTANT(HPDF_LANG_BI)  //"bi"     /* Bislama */
    DEFINE_ESCONSTANT(HPDF_LANG_BN)  //"bn"     /* Bengali Bangla */
    DEFINE_ESCONSTANT(HPDF_LANG_BO)  //"bo"     /* Tibetan */
    DEFINE_ESCONSTANT(HPDF_LANG_BR)  //"br"     /* Breton */
    DEFINE_ESCONSTANT(HPDF_LANG_CA)  //"ca"     /* Catalan */
    DEFINE_ESCONSTANT(HPDF_LANG_CO)  //"co"     /* Corsican */
    DEFINE_ESCONSTANT(HPDF_LANG_CS)  //"cs"     /* Czech */
    DEFINE_ESCONSTANT(HPDF_LANG_CY)  //"cy"     /* Welsh */
    DEFINE_ESCONSTANT(HPDF_LANG_DA)  //"da"     /* Danish */
    DEFINE_ESCONSTANT(HPDF_LANG_DE)  //"de"     /* German */
    DEFINE_ESCONSTANT(HPDF_LANG_DZ)  //"dz"     /* Bhutani */
    DEFINE_ESCONSTANT(HPDF_LANG_EL)  //"el"     /* Greek */
    DEFINE_ESCONSTANT(HPDF_LANG_EN)  //"en"     /* English */
    DEFINE_ESCONSTANT(HPDF_LANG_EO)  //"eo"     /* Esperanto */
    DEFINE_ESCONSTANT(HPDF_LANG_ES)  //"es"     /* Spanish */
    DEFINE_ESCONSTANT(HPDF_LANG_ET)  //"et"     /* Estonian */
    DEFINE_ESCONSTANT(HPDF_LANG_EU)  //"eu"     /* Basque */
    DEFINE_ESCONSTANT(HPDF_LANG_FA)  //"fa"     /* Persian */
    DEFINE_ESCONSTANT(HPDF_LANG_FI)  //"fi"     /* Finnish */
    DEFINE_ESCONSTANT(HPDF_LANG_FJ)  //"fj"     /* Fiji */
    DEFINE_ESCONSTANT(HPDF_LANG_FO)  //"fo"     /* Faeroese */
    DEFINE_ESCONSTANT(HPDF_LANG_FR)  //"fr"     /* French */
    DEFINE_ESCONSTANT(HPDF_LANG_FY)  //"fy"     /* Frisian */
    DEFINE_ESCONSTANT(HPDF_LANG_GA)  //"ga"     /* Irish */
    DEFINE_ESCONSTANT(HPDF_LANG_GD)  //"gd"     /* Scots Gaelic */
    DEFINE_ESCONSTANT(HPDF_LANG_GL)  //"gl"     /* Galician */
    DEFINE_ESCONSTANT(HPDF_LANG_GN)  //"gn"     /* Guarani */
    DEFINE_ESCONSTANT(HPDF_LANG_GU)  //"gu"     /* Gujarati */
    DEFINE_ESCONSTANT(HPDF_LANG_HA)  //"ha"     /* Hausa */
    DEFINE_ESCONSTANT(HPDF_LANG_HI)  //"hi"     /* Hindi */
    DEFINE_ESCONSTANT(HPDF_LANG_HR)  //"hr"     /* Croatian */
    DEFINE_ESCONSTANT(HPDF_LANG_HU)  //"hu"     /* Hungarian */
    DEFINE_ESCONSTANT(HPDF_LANG_HY)  //"hy"     /* Armenian */
    DEFINE_ESCONSTANT(HPDF_LANG_IA)  //"ia"     /* Interlingua */
    DEFINE_ESCONSTANT(HPDF_LANG_IE)  //"ie"     /* Interlingue */
    DEFINE_ESCONSTANT(HPDF_LANG_IK)  //"ik"     /* Inupiak */
    DEFINE_ESCONSTANT(HPDF_LANG_IN)  //"in"     /* Indonesian */
    DEFINE_ESCONSTANT(HPDF_LANG_IS)  //"is"     /* Icelandic */
    DEFINE_ESCONSTANT(HPDF_LANG_IT)  //"it"     /* Italian */
    DEFINE_ESCONSTANT(HPDF_LANG_IW)  //"iw"     /* Hebrew */
    DEFINE_ESCONSTANT(HPDF_LANG_JA)  //"ja"     /* Japanese */
    DEFINE_ESCONSTANT(HPDF_LANG_JI)  //"ji"     /* Yiddish */
    DEFINE_ESCONSTANT(HPDF_LANG_JW)  //"jw"     /* Javanese */
    DEFINE_ESCONSTANT(HPDF_LANG_KA)  //"ka"     /* Georgian */
    DEFINE_ESCONSTANT(HPDF_LANG_KK)  //"kk"     /* Kazakh */
    DEFINE_ESCONSTANT(HPDF_LANG_KL)  //"kl"     /* Greenlandic */
    DEFINE_ESCONSTANT(HPDF_LANG_KM)  //"km"     /* Cambodian */
    DEFINE_ESCONSTANT(HPDF_LANG_KN)  //"kn"     /* Kannada */
    DEFINE_ESCONSTANT(HPDF_LANG_KO)  //"ko"     /* Korean */
    DEFINE_ESCONSTANT(HPDF_LANG_KS)  //"ks"     /* Kashmiri */
    DEFINE_ESCONSTANT(HPDF_LANG_KU)  //"ku"     /* Kurdish */
    DEFINE_ESCONSTANT(HPDF_LANG_KY)  //"ky"     /* Kirghiz */
    DEFINE_ESCONSTANT(HPDF_LANG_LA)  //"la"     /* Latin */
    DEFINE_ESCONSTANT(HPDF_LANG_LN)  //"ln"     /* Lingala */
    DEFINE_ESCONSTANT(HPDF_LANG_LO)  //"lo"     /* Laothian */
    DEFINE_ESCONSTANT(HPDF_LANG_LT)  //"lt"     /* Lithuanian */
    DEFINE_ESCONSTANT(HPDF_LANG_LV)  //"lv"     /* Latvian,Lettish */
    DEFINE_ESCONSTANT(HPDF_LANG_MG)  //"mg"     /* Malagasy */
    DEFINE_ESCONSTANT(HPDF_LANG_MI)  //"mi"     /* Maori */
    DEFINE_ESCONSTANT(HPDF_LANG_MK)  //"mk"     /* Macedonian */
    DEFINE_ESCONSTANT(HPDF_LANG_ML)  //"ml"     /* Malayalam */
    DEFINE_ESCONSTANT(HPDF_LANG_MN)  //"mn"     /* Mongolian */
    DEFINE_ESCONSTANT(HPDF_LANG_MO)  //"mo"     /* Moldavian */
    DEFINE_ESCONSTANT(HPDF_LANG_MR)  //"mr"     /* Marathi */
    DEFINE_ESCONSTANT(HPDF_LANG_MS)  //"ms"     /* Malay */
    DEFINE_ESCONSTANT(HPDF_LANG_MT)  //"mt"     /* Maltese */
    DEFINE_ESCONSTANT(HPDF_LANG_MY)  //"my"     /* Burmese */
    DEFINE_ESCONSTANT(HPDF_LANG_NA)  //"na"     /* Nauru */
    DEFINE_ESCONSTANT(HPDF_LANG_NE)  //"ne"     /* Nepali */
    DEFINE_ESCONSTANT(HPDF_LANG_NL)  //"nl"     /* Dutch */
    DEFINE_ESCONSTANT(HPDF_LANG_NO)  //"no"     /* Norwegian */
    DEFINE_ESCONSTANT(HPDF_LANG_OC)  //"oc"     /* Occitan */
    DEFINE_ESCONSTANT(HPDF_LANG_OM)  //"om"     /* (Afan)Oromo */
    DEFINE_ESCONSTANT(HPDF_LANG_OR)  //"or"     /* Oriya */
    DEFINE_ESCONSTANT(HPDF_LANG_PA)  //"pa"     /* Punjabi */
    DEFINE_ESCONSTANT(HPDF_LANG_PL)  //"pl"     /* Polish */
    DEFINE_ESCONSTANT(HPDF_LANG_PS)  //"ps"     /* Pashto,Pushto */
    DEFINE_ESCONSTANT(HPDF_LANG_PT)  //"pt"     /* Portuguese  */
    DEFINE_ESCONSTANT(HPDF_LANG_QU)  //"qu"     /* Quechua */
    DEFINE_ESCONSTANT(HPDF_LANG_RM)  //"rm"     /* Rhaeto-Romance */
    DEFINE_ESCONSTANT(HPDF_LANG_RN)  //"rn"     /* Kirundi */
    DEFINE_ESCONSTANT(HPDF_LANG_RO)  //"ro"     /* Romanian */
    DEFINE_ESCONSTANT(HPDF_LANG_RU)  //"ru"     /* Russian */
    DEFINE_ESCONSTANT(HPDF_LANG_RW)  //"rw"     /* Kinyarwanda */
    DEFINE_ESCONSTANT(HPDF_LANG_SA)  //"sa"     /* Sanskrit */
    DEFINE_ESCONSTANT(HPDF_LANG_SD)  //"sd"     /* Sindhi */
    DEFINE_ESCONSTANT(HPDF_LANG_SG)  //"sg"     /* Sangro */
    DEFINE_ESCONSTANT(HPDF_LANG_SH)  //"sh"     /* Serbo-Croatian */
    DEFINE_ESCONSTANT(HPDF_LANG_SI)  //"si"     /* Singhalese */
    DEFINE_ESCONSTANT(HPDF_LANG_SK)  //"sk"     /* Slovak */
    DEFINE_ESCONSTANT(HPDF_LANG_SL)  //"sl"     /* Slovenian */
    DEFINE_ESCONSTANT(HPDF_LANG_SM)  //"sm"     /* Samoan */
    DEFINE_ESCONSTANT(HPDF_LANG_SN)  //"sn"     /* Shona */
    DEFINE_ESCONSTANT(HPDF_LANG_SO)  //"so"     /* Somali */
    DEFINE_ESCONSTANT(HPDF_LANG_SQ)  //"sq"     /* Albanian */
    DEFINE_ESCONSTANT(HPDF_LANG_SR)  //"sr"     /* Serbian */
    DEFINE_ESCONSTANT(HPDF_LANG_SS)  //"ss"     /* Siswati */
    DEFINE_ESCONSTANT(HPDF_LANG_ST)  //"st"     /* Sesotho */
    DEFINE_ESCONSTANT(HPDF_LANG_SU)  //"su"     /* Sundanese */
    DEFINE_ESCONSTANT(HPDF_LANG_SV)  //"sv"     /* Swedish */
    DEFINE_ESCONSTANT(HPDF_LANG_SW)  //"sw"     /* Swahili */
    DEFINE_ESCONSTANT(HPDF_LANG_TA)  //"ta"     /* Tamil */
    DEFINE_ESCONSTANT(HPDF_LANG_TE)  //"te"     /* Tegulu */
    DEFINE_ESCONSTANT(HPDF_LANG_TG)  //"tg"     /* Tajik */
    DEFINE_ESCONSTANT(HPDF_LANG_TH)  //"th"     /* Thai */
    DEFINE_ESCONSTANT(HPDF_LANG_TI)  //"ti"     /* Tigrinya */
    DEFINE_ESCONSTANT(HPDF_LANG_TK)  //"tk"     /* Turkmen */
    DEFINE_ESCONSTANT(HPDF_LANG_TL)  //"tl"     /* Tagalog */
    DEFINE_ESCONSTANT(HPDF_LANG_TN)  //"tn"     /* Setswanato Tonga */
    DEFINE_ESCONSTANT(HPDF_LANG_TR)  //"tr"     /* Turkish */
    DEFINE_ESCONSTANT(HPDF_LANG_TS)  //"ts"     /* Tsonga */
    DEFINE_ESCONSTANT(HPDF_LANG_TT)  //"tt"     /* Tatar */
    DEFINE_ESCONSTANT(HPDF_LANG_TW)  //"tw"     /* Twi */
    DEFINE_ESCONSTANT(HPDF_LANG_UK)  //"uk"     /* Ukrainian */
    DEFINE_ESCONSTANT(HPDF_LANG_UR)  //"ur"     /* Urdu */
    DEFINE_ESCONSTANT(HPDF_LANG_UZ)  //"uz"     /* Uzbek */
    DEFINE_ESCONSTANT(HPDF_LANG_VI)  //"vi"     /* Vietnamese */
    DEFINE_ESCONSTANT(HPDF_LANG_VO)  //"vo"     /* Volapuk */
    DEFINE_ESCONSTANT(HPDF_LANG_WO)  //"wo"     /* Wolof */
    DEFINE_ESCONSTANT(HPDF_LANG_XH)  //"xh"     /* Xhosa */
    DEFINE_ESCONSTANT(HPDF_LANG_YO)  //"yo"     /* Yoruba */
    DEFINE_ESCONSTANT(HPDF_LANG_ZH)  //"zh"     /* Chinese */
    DEFINE_ESCONSTANT(HPDF_LANG_ZU)  //"zu"     /* Zulu */

    DEFINE_ECONSTANT(HPDF_GMODE_PAGE_DESCRIPTION)
    DEFINE_ECONSTANT(HPDF_GMODE_PATH_OBJECT)
    DEFINE_ECONSTANT(HPDF_GMODE_TEXT_OBJECT)
    DEFINE_ECONSTANT(HPDF_GMODE_CLIPPING_PATH)
    DEFINE_ECONSTANT(HPDF_GMODE_SHADING)
    DEFINE_ECONSTANT(HPDF_GMODE_INLINE_IMAGE)
    DEFINE_ECONSTANT(HPDF_GMODE_EXTERNAL_OBJECT)
	return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS {
	return 0;
}
//---------------------------------------------------------------------------
void *DELEGATE=0;
void err_handler (HPDF_STATUS   error_no, HPDF_STATUS   detail_no, void *user_data)
{
    if (DELEGATE) {
        void *RES=0;
        void *EXCEPTION=0;
        InvokePtr(INVOKE_CALL_DELEGATE,DELEGATE,&RES,&EXCEPTION,(INTEGER)2,(INTEGER)VARIABLE_NUMBER,(char *)"",(double)(long)error_no,(INTEGER)VARIABLE_NUMBER,(char *)"",(double)(long)detail_no);
        InvokePtr(INVOKE_FREE_VARIABLE,RES);
        InvokePtr(INVOKE_FREE_VARIABLE,EXCEPTION);
    } /*else
        printf ("HPDF ERROR: error_no=%04X, detail_no=%u\n", (HPDF_UINT)error_no, (HPDF_UINT)detail_no);*/
}
//---------------------------------------------------------------------------
// Autogenerated ...
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_GetVersion,0)

	RETURN_STRING((char*)HPDF_GetVersion())
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_New,0)

	RETURN_NUMBER((long)HPDF_New(err_handler,0))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_SetErrorHandler,1)
    char *dclass=0;
    NUMBER dmember=0;
    GET_CHECK_DELEGATE(0, dclass, dmember, "Paramter 0 should be a delegate: function error_handler(nError, nStatus)")

    DELEGATE=PARAMETER(0);

    return 0;
	RETURN_NUMBER(0);
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Free,1)
	T_NUMBER(0) // HPDF_HANDLE

	HPDF_Free((HPDF_HANDLE)(long)PARAM(0));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_NewDoc,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_NewDoc((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_FreeDoc,1)
	T_NUMBER(0) // HPDF_HANDLE

	HPDF_FreeDoc((HPDF_HANDLE)(long)PARAM(0));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_HasDoc,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_HasDoc((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_FreeDocAll,1)
	T_NUMBER(0) // HPDF_HANDLE

	HPDF_FreeDocAll((HPDF_HANDLE)(long)PARAM(0));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_SaveToStream,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_SaveToStream((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_GetStreamSize,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_GetStreamSize((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_ReadFromStream,3)
	T_NUMBER(0) // HPDF_HANDLE
	T_STRING(1) // char*

	// ... parameter 2 is by reference (int*)
	HPDF_UINT32 local_parameter_2;

	RETURN_NUMBER(HPDF_ReadFromStream((HPDF_HANDLE)(long)PARAM(0), (HPDF_BYTE *)PARAM(1), &local_parameter_2))
	SET_NUMBER(2, local_parameter_2)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_ResetStream,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_ResetStream((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_SaveToFile,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_STRING(1) // char*

	RETURN_NUMBER(HPDF_SaveToFile((HPDF_HANDLE)(long)PARAM(0), PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_GetError,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_GetError((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_GetErrorDetail,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_GetErrorDetail((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_ResetError,1)
	T_NUMBER(0) // HPDF_HANDLE

	HPDF_ResetError((HPDF_HANDLE)(long)PARAM(0));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_SetPagesConfiguration,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // int

	RETURN_NUMBER(HPDF_SetPagesConfiguration((HPDF_HANDLE)(long)PARAM(0), (int)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_GetPageByIndex,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // int

	RETURN_NUMBER((long)HPDF_GetPageByIndex((HPDF_HANDLE)(long)PARAM(0), (int)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_GetPageLayout,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_GetPageLayout((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_SetPageLayout,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // HPDF_PageLayout

	RETURN_NUMBER(HPDF_SetPageLayout((HPDF_HANDLE)(long)PARAM(0), (HPDF_PageLayout)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_GetPageMode,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_GetPageMode((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_SetPageMode,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // HPDF_PageMode

	RETURN_NUMBER(HPDF_SetPageMode((HPDF_HANDLE)(long)PARAM(0), (HPDF_PageMode)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_GetViewerPreference,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_GetViewerPreference((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_SetViewerPreference,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // int

	RETURN_NUMBER(HPDF_SetViewerPreference((HPDF_HANDLE)(long)PARAM(0), (int)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_SetOpenAction,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_SetOpenAction((HPDF_HANDLE)(long)PARAM(0), (HPDF_HANDLE)(long)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_GetCurrentPage,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER((long)HPDF_GetCurrentPage((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_AddPage,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER((long)HPDF_AddPage((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_InsertPage,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // HPDF_HANDLE

	RETURN_NUMBER((long)HPDF_InsertPage((HPDF_HANDLE)(long)PARAM(0), (HPDF_HANDLE)(long)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetWidth,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float

	RETURN_NUMBER(HPDF_Page_SetWidth((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetHeight,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float

	RETURN_NUMBER(HPDF_Page_SetHeight((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetSize,3)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // HPDF_PageSizes
	T_NUMBER(2) // HPDF_PageDirection

	RETURN_NUMBER(HPDF_Page_SetSize((HPDF_HANDLE)(long)PARAM(0), (HPDF_PageSizes)PARAM(1), (HPDF_PageDirection)PARAM(2)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetRotate,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // int

	RETURN_NUMBER(HPDF_Page_SetRotate((HPDF_HANDLE)(long)PARAM(0), (int)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_GetFont,3)
	T_NUMBER(0) // HPDF_HANDLE
	T_STRING(1) // char*
	T_STRING(2) // char*

    char *enc=PARAM(2);
    if ((enc) && (!enc[0]))
        enc=0;

	RETURN_NUMBER((long)HPDF_GetFont((HPDF_HANDLE)(long)PARAM(0), PARAM(1), enc))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_LoadType1FontFromFile,3)
	T_NUMBER(0) // HPDF_HANDLE
	T_STRING(1) // char*
	T_STRING(2) // char*

	RETURN_STRING((char*)HPDF_LoadType1FontFromFile((HPDF_HANDLE)(long)PARAM(0), PARAM(1), PARAM(2)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_LoadTTFontFromFile,3)
	T_NUMBER(0) // HPDF_HANDLE
	T_STRING(1) // char*
	T_NUMBER(2) // int

	RETURN_STRING((char*)HPDF_LoadTTFontFromFile((HPDF_HANDLE)(long)PARAM(0), PARAM(1), (int)PARAM(2)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_LoadTTFontFromFile2,4)
	T_NUMBER(0) // HPDF_HANDLE
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_NUMBER(3) // int

	RETURN_STRING((char*)HPDF_LoadTTFontFromFile2((HPDF_HANDLE)(long)PARAM(0), PARAM(1), (int)PARAM(2), (int)PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_AddPageLabel,5)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // int
	T_NUMBER(2) // HPDF_PageNumStyle
	T_NUMBER(3) // int
	T_STRING(4) // char*

	RETURN_NUMBER(HPDF_AddPageLabel((HPDF_HANDLE)(long)PARAM(0), (int)PARAM(1), (HPDF_PageNumStyle)PARAM(2), (int)PARAM(3), PARAM(4)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_UseJPFonts,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_UseJPFonts((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_UseKRFonts,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_UseKRFonts((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_UseCNSFonts,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_UseCNSFonts((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_UseCNTFonts,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_UseCNTFonts((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_CreateOutline,4)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // HPDF_HANDLE
	T_STRING(2) // char*
	T_NUMBER(3) // HPDF_HANDLE

	RETURN_NUMBER((long)HPDF_CreateOutline((HPDF_HANDLE)(long)PARAM(0), (HPDF_HANDLE)(long)PARAM(1), PARAM(2), (HPDF_HANDLE)(long)PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Outline_SetOpened,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // int

	RETURN_NUMBER(HPDF_Outline_SetOpened((HPDF_HANDLE)(long)PARAM(0), (int)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Outline_SetDestination,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Outline_SetDestination((HPDF_HANDLE)(long)PARAM(0), (HPDF_HANDLE)(long)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_CreateDestination,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER((long)HPDF_Page_CreateDestination((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Destination_SetXYZ,4)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float
	T_NUMBER(2) // float
	T_NUMBER(3) // float

	RETURN_NUMBER(HPDF_Destination_SetXYZ((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1), (float)PARAM(2), (float)PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Destination_SetFit,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Destination_SetFit((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Destination_SetFitH,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float

	RETURN_NUMBER(HPDF_Destination_SetFitH((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Destination_SetFitV,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float

	RETURN_NUMBER(HPDF_Destination_SetFitV((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Destination_SetFitR,5)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float
	T_NUMBER(2) // float
	T_NUMBER(3) // float
	T_NUMBER(4) // float

	RETURN_NUMBER(HPDF_Destination_SetFitR((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1), (float)PARAM(2), (float)PARAM(3), (float)PARAM(4)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Destination_SetFitB,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Destination_SetFitB((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Destination_SetFitBH,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float

	RETURN_NUMBER(HPDF_Destination_SetFitBH((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Destination_SetFitBV,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float

	RETURN_NUMBER(HPDF_Destination_SetFitBV((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_GetEncoder,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_STRING(1) // char*

	RETURN_NUMBER((long)HPDF_GetEncoder((HPDF_HANDLE)(long)PARAM(0), PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_GetCurrentEncoder,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER((long)HPDF_GetCurrentEncoder((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_SetCurrentEncoder,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_STRING(1) // char*

	RETURN_NUMBER(HPDF_SetCurrentEncoder((HPDF_HANDLE)(long)PARAM(0), PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Encoder_GetType,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Encoder_GetType((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Encoder_GetByteType,3)
	T_NUMBER(0) // HPDF_HANDLE
	T_STRING(1) // char*
	T_NUMBER(2) // int

	RETURN_NUMBER(HPDF_Encoder_GetByteType((HPDF_HANDLE)(long)PARAM(0), PARAM(1), (int)PARAM(2)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Encoder_GetUnicode,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // int

	RETURN_NUMBER(HPDF_Encoder_GetUnicode((HPDF_HANDLE)(long)PARAM(0), (int)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Encoder_GetWritingMode,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Encoder_GetWritingMode((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_UseJPEncodings,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_UseJPEncodings((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_UseKREncodings,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_UseKREncodings((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_UseCNSEncodings,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_UseCNSEncodings((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_UseCNTEncodings,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_UseCNTEncodings((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_CreateTextAnnot,4)
	T_NUMBER(0) // HPDF_HANDLE
	//T_NUMBER(1) // HPDF_Rect
    char *data=0;
    GET_CHECK_ARRAY(1, data, "Parameter 1 should be an array");
	T_STRING(2) // char*
	T_NUMBER(3) // HPDF_HANDLE

	RETURN_NUMBER((long)HPDF_Page_CreateTextAnnot((HPDF_HANDLE)(long)PARAM(0), (HPDF_Rect)Get_Rect(PARAMETER(1)), PARAM(2), (HPDF_HANDLE)(long)PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_CreateLinkAnnot,3)
	T_NUMBER(0) // HPDF_HANDLE
	//T_NUMBER(1) // HPDF_Rect
    char *data=0;
    GET_CHECK_ARRAY(1, data, "Parameter 1 should be an array");
	T_NUMBER(2) // HPDF_HANDLE

	RETURN_NUMBER((long)HPDF_Page_CreateLinkAnnot((HPDF_HANDLE)(long)PARAM(0), (HPDF_Rect)Get_Rect(PARAMETER(1)), (HPDF_HANDLE)(long)PARAM(2)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_CreateURILinkAnnot,3)
	T_NUMBER(0) // HPDF_HANDLE
	//T_NUMBER(1) // HPDF_Rect
    char *data=0;
    GET_CHECK_ARRAY(1, data, "Parameter 1 should be an array");
	T_STRING(2) // char*

	RETURN_NUMBER((long)HPDF_Page_CreateURILinkAnnot((HPDF_HANDLE)(long)PARAM(0), (HPDF_Rect)Get_Rect(PARAMETER(1)), PARAM(2)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_LinkAnnot_SetBorderStyle,4)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float
	T_NUMBER(2) // int
	T_NUMBER(3) // int

	RETURN_NUMBER(HPDF_LinkAnnot_SetBorderStyle((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1), (int)PARAM(2), (int)PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_TextAnnot_SetIcon,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // HPDF_AnnotIcon

	RETURN_NUMBER(HPDF_TextAnnot_SetIcon((HPDF_HANDLE)(long)PARAM(0), (HPDF_AnnotIcon)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_TextAnnot_SetOpened,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // int

	RETURN_NUMBER(HPDF_TextAnnot_SetOpened((HPDF_HANDLE)(long)PARAM(0), (int)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_LoadPngImageFromFile,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_STRING(1) // char*

	RETURN_NUMBER((long)HPDF_LoadPngImageFromFile((HPDF_HANDLE)(long)PARAM(0), PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_LoadPngImageFromFile2,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_STRING(1) // char*

	RETURN_NUMBER((long)HPDF_LoadPngImageFromFile2((HPDF_HANDLE)(long)PARAM(0), PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_LoadJpegImageFromFile,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_STRING(1) // char*

	RETURN_NUMBER((long)HPDF_LoadJpegImageFromFile((HPDF_HANDLE)(long)PARAM(0), PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_LoadRawImageFromFile,5)
	T_NUMBER(0) // HPDF_HANDLE
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_NUMBER(3) // int
	T_NUMBER(4) // HPDF_ColorSpace

	RETURN_NUMBER((long)HPDF_LoadRawImageFromFile((HPDF_HANDLE)(long)PARAM(0), PARAM(1), (int)PARAM(2), (int)PARAM(3), (HPDF_ColorSpace)PARAM(4)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_LoadRawImageFromMem,6)
	T_NUMBER(0) // HPDF_HANDLE
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_NUMBER(3) // int
	T_NUMBER(4) // HPDF_ColorSpace
	T_NUMBER(5) // int

	RETURN_NUMBER((long)HPDF_LoadRawImageFromMem((HPDF_HANDLE)(long)PARAM(0), (HPDF_BYTE *)PARAM(1), (int)PARAM(2), (int)PARAM(3), (HPDF_ColorSpace)PARAM(4), (int)PARAM(5)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Image_GetSize,1)
	T_NUMBER(0) // HPDF_HANDLE

    Do_Point(RESULT,HPDF_Image_GetSize((HPDF_HANDLE)(long)PARAM(0)));
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Image_GetSize2,2)
	T_NUMBER(0) // HPDF_HANDLE

	// ... parameter 1 is by reference (HPDF_Point*)
	HPDF_Point local_parameter_1;

	RETURN_NUMBER(HPDF_Image_GetSize2((HPDF_HANDLE)(long)PARAM(0), &local_parameter_1))
    Do_Point(PARAMETER(1),local_parameter_1);
	//SET_NUMBER(1, local_parameter_1)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Image_GetWidth,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Image_GetWidth((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Image_GetHeight,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Image_GetHeight((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Image_GetBitsPerComponent,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Image_GetBitsPerComponent((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Image_GetColorSpace,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_STRING((char*)HPDF_Image_GetColorSpace((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Image_SetColorMask,7)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // int
	T_NUMBER(2) // int
	T_NUMBER(3) // int
	T_NUMBER(4) // int
	T_NUMBER(5) // int
	T_NUMBER(6) // int

	RETURN_NUMBER(HPDF_Image_SetColorMask((HPDF_HANDLE)(long)PARAM(0), (int)PARAM(1), (int)PARAM(2), (int)PARAM(3), (int)PARAM(4), (int)PARAM(5), (int)PARAM(6)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Image_SetMaskImage,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Image_SetMaskImage((HPDF_HANDLE)(long)PARAM(0), (HPDF_HANDLE)(long)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_SetInfoAttr,3)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // HPDF_InfoType
	T_STRING(2) // char*

	RETURN_NUMBER(HPDF_SetInfoAttr((HPDF_HANDLE)(long)PARAM(0), (HPDF_InfoType)PARAM(1), PARAM(2)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_GetInfoAttr,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // HPDF_InfoType

	RETURN_STRING((char*)HPDF_GetInfoAttr((HPDF_HANDLE)(long)PARAM(0), (HPDF_InfoType)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_SetInfoDateAttr,3)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // HPDF_InfoType
	//T_NUMBER(2) // HPDF_Date
    char *data=0;
    GET_CHECK_ARRAY(2, data, "Parameter 2 should be an array");


	RETURN_NUMBER(HPDF_SetInfoDateAttr((HPDF_HANDLE)(long)PARAM(0), (HPDF_InfoType)PARAM(1), (HPDF_Date)Get_Date(PARAMETER(2))))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_SetPassword,3)
	T_NUMBER(0) // HPDF_HANDLE
	T_STRING(1) // char*
	T_STRING(2) // char*

	RETURN_NUMBER(HPDF_SetPassword((HPDF_HANDLE)(long)PARAM(0), PARAM(1), PARAM(2)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_SetPermission,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // int

	RETURN_NUMBER(HPDF_SetPermission((HPDF_HANDLE)(long)PARAM(0), (int)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_SetEncryptionMode,3)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // HPDF_EncryptMode
	T_NUMBER(2) // int

	RETURN_NUMBER(HPDF_SetEncryptionMode((HPDF_HANDLE)(long)PARAM(0), (HPDF_EncryptMode)PARAM(1), (int)PARAM(2)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_SetCompressionMode,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // int

	RETURN_NUMBER(HPDF_SetCompressionMode((HPDF_HANDLE)(long)PARAM(0), (int)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Font_GetFontName,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_STRING((char*)HPDF_Font_GetFontName((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Font_GetEncodingName,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_STRING((char*)HPDF_Font_GetEncodingName((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Font_GetUnicodeWidth,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // HPDF_UNICODE

	RETURN_NUMBER(HPDF_Font_GetUnicodeWidth((HPDF_HANDLE)(long)PARAM(0), (HPDF_UNICODE)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Font_GetBBox,1)
	T_NUMBER(0) // HPDF_HANDLE

	Do_Box(RESULT, HPDF_Font_GetBBox((HPDF_HANDLE)(long)PARAM(0)));
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Font_GetAscent,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Font_GetAscent((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Font_GetDescent,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Font_GetDescent((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Font_GetXHeight,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Font_GetXHeight((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Font_GetCapHeight,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Font_GetCapHeight((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Font_TextWidth,3)
	T_NUMBER(0) // HPDF_HANDLE
	T_STRING(1) // char*
	T_NUMBER(2) // int

    Do_TextWidth(RESULT, HPDF_Font_TextWidth((HPDF_HANDLE)(long)PARAM(0), (HPDF_BYTE *)PARAM(1), (int)PARAM(2)));
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Font_MeasureText,9)
	T_NUMBER(0) // HPDF_HANDLE
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_NUMBER(3) // float
	T_NUMBER(4) // float
	T_NUMBER(5) // float
	T_NUMBER(6) // float
	T_NUMBER(7) // int

	// ... parameter 8 is by reference (float*)
	float local_parameter_8;

	RETURN_NUMBER(HPDF_Font_MeasureText((HPDF_HANDLE)(long)PARAM(0), (HPDF_BYTE*)PARAM(1), (int)PARAM(2), (float)PARAM(3), (float)PARAM(4), (float)PARAM(5), (float)PARAM(6), (int)PARAM(7), &local_parameter_8))
	SET_NUMBER(8, local_parameter_8)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_CreateExtGState,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER((long)HPDF_CreateExtGState((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_ExtGState_SetAlphaStroke,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float

	RETURN_NUMBER(HPDF_ExtGState_SetAlphaStroke((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_ExtGState_SetAlphaFill,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float

	RETURN_NUMBER(HPDF_ExtGState_SetAlphaFill((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_ExtGState_SetBlendMode,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // HPDF_BlendMode

	RETURN_NUMBER(HPDF_ExtGState_SetBlendMode((HPDF_HANDLE)(long)PARAM(0), (HPDF_BlendMode)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_TextWidth,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_STRING(1) // char*

	RETURN_NUMBER(HPDF_Page_TextWidth((HPDF_HANDLE)(long)PARAM(0), PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_MeasureText,5)
	T_NUMBER(0) // HPDF_HANDLE
	T_STRING(1) // char*
	T_NUMBER(2) // float
	T_NUMBER(3) // int

	// ... parameter 4 is by reference (float*)
	float local_parameter_4;

	RETURN_NUMBER(HPDF_Page_MeasureText((HPDF_HANDLE)(long)PARAM(0), PARAM(1), (float)PARAM(2), (int)PARAM(3), &local_parameter_4))
	SET_NUMBER(4, local_parameter_4)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetWidth,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_GetWidth((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetHeight,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_GetHeight((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetGMode,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_GetGMode((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetCurrentPos,1)
	T_NUMBER(0) // HPDF_HANDLE

	Do_Point(RESULT,HPDF_Page_GetCurrentPos((HPDF_HANDLE)(long)PARAM(0)));
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetCurrentPos2,2)
	T_NUMBER(0) // HPDF_HANDLE

	// ... parameter 1 is by reference (HPDF_Point*)
	HPDF_Point local_parameter_1;

	RETURN_NUMBER(HPDF_Page_GetCurrentPos2((HPDF_HANDLE)(long)PARAM(0), &local_parameter_1))
    Do_Point(PARAMETER(1),local_parameter_1);
	//SET_NUMBER(1, local_parameter_1)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetCurrentTextPos,1)
	T_NUMBER(0) // HPDF_HANDLE

	Do_Point(RESULT,HPDF_Page_GetCurrentTextPos((HPDF_HANDLE)(long)PARAM(0)));
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetCurrentTextPos2,2)
	T_NUMBER(0) // HPDF_HANDLE

	// ... parameter 1 is by reference (HPDF_Point*)
	HPDF_Point local_parameter_1;

	RETURN_NUMBER(HPDF_Page_GetCurrentTextPos2((HPDF_HANDLE)(long)PARAM(0), &local_parameter_1))
    Do_Point(PARAMETER(1),local_parameter_1);
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetCurrentFont,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER((long)HPDF_Page_GetCurrentFont((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetCurrentFontSize,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_GetCurrentFontSize((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetTransMatrix,1)
	T_NUMBER(0) // HPDF_HANDLE

	Do_TransMatrix(RESULT, HPDF_Page_GetTransMatrix((HPDF_HANDLE)(long)PARAM(0)));
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetLineWidth,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_GetLineWidth((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetLineCap,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_GetLineCap((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetLineJoin,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_GetLineJoin((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetMiterLimit,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_GetMiterLimit((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
/*CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetDash,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_GetDash((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL*/
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetFlat,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_GetFlat((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetCharSpace,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_GetCharSpace((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetWordSpace,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_GetWordSpace((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetHorizontalScalling,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_GetHorizontalScalling((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetTextLeading,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_GetTextLeading((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetTextRenderingMode,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_GetTextRenderingMode((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetTextRaise,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_GetTextRaise((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetTextRise,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_GetTextRise((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetRGBFill,1)
	T_NUMBER(0) // HPDF_HANDLE

	Do_RGBColor(RESULT, HPDF_Page_GetRGBFill((HPDF_HANDLE)(long)PARAM(0)));
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetRGBStroke,1)
	T_NUMBER(0) // HPDF_HANDLE

    Do_RGBColor(RESULT, HPDF_Page_GetRGBStroke((HPDF_HANDLE)(long)PARAM(0)));
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetCMYKFill,1)
	T_NUMBER(0) // HPDF_HANDLE

	Do_CMYKColor(RESULT, HPDF_Page_GetCMYKFill((HPDF_HANDLE)(long)PARAM(0)));
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetCMYKStroke,1)
	T_NUMBER(0) // HPDF_HANDLE

	Do_CMYKColor(RESULT, HPDF_Page_GetCMYKStroke((HPDF_HANDLE)(long)PARAM(0)));
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetGrayFill,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_GetGrayFill((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetGrayStroke,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_GetGrayStroke((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetStrokingColorSpace,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_GetStrokingColorSpace((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetFillingColorSpace,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_GetFillingColorSpace((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetTextMatrix,1)
	T_NUMBER(0) // HPDF_HANDLE

	Do_TransMatrix(RESULT, HPDF_Page_GetTextMatrix((HPDF_HANDLE)(long)PARAM(0)));
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GetGStateDepth,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_GetGStateDepth((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetLineWidth,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float

	RETURN_NUMBER(HPDF_Page_SetLineWidth((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetLineCap,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // HPDF_LineCap

	RETURN_NUMBER(HPDF_Page_SetLineCap((HPDF_HANDLE)(long)PARAM(0), (HPDF_LineCap)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetLineJoin,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // HPDF_LineJoin

	RETURN_NUMBER(HPDF_Page_SetLineJoin((HPDF_HANDLE)(long)PARAM(0), (HPDF_LineJoin)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetMiterLimit,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float

	RETURN_NUMBER(HPDF_Page_SetMiterLimit((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetDash,4)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(2) // int
	T_NUMBER(3) // int

	// ... parameter 1 is by reference (int*)
	HPDF_UINT16 local_parameter_1;

	RETURN_NUMBER(HPDF_Page_SetDash((HPDF_HANDLE)(long)PARAM(0), &local_parameter_1, (int)PARAM(2), (int)PARAM(3)))
	SET_NUMBER(1, local_parameter_1)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetFlat,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float

	RETURN_NUMBER(HPDF_Page_SetFlat((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetExtGState,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_SetExtGState((HPDF_HANDLE)(long)PARAM(0), (HPDF_HANDLE)(long)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GSave,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_GSave((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_GRestore,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_GRestore((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_Concat,7)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float
	T_NUMBER(2) // float
	T_NUMBER(3) // float
	T_NUMBER(4) // float
	T_NUMBER(5) // float
	T_NUMBER(6) // float

	RETURN_NUMBER(HPDF_Page_Concat((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1), (float)PARAM(2), (float)PARAM(3), (float)PARAM(4), (float)PARAM(5), (float)PARAM(6)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_MoveTo,3)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float
	T_NUMBER(2) // float

	RETURN_NUMBER(HPDF_Page_MoveTo((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1), (float)PARAM(2)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_LineTo,3)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float
	T_NUMBER(2) // float

	RETURN_NUMBER(HPDF_Page_LineTo((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1), (float)PARAM(2)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_CurveTo,7)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float
	T_NUMBER(2) // float
	T_NUMBER(3) // float
	T_NUMBER(4) // float
	T_NUMBER(5) // float
	T_NUMBER(6) // float

	RETURN_NUMBER(HPDF_Page_CurveTo((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1), (float)PARAM(2), (float)PARAM(3), (float)PARAM(4), (float)PARAM(5), (float)PARAM(6)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_CurveTo2,5)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float
	T_NUMBER(2) // float
	T_NUMBER(3) // float
	T_NUMBER(4) // float

	RETURN_NUMBER(HPDF_Page_CurveTo2((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1), (float)PARAM(2), (float)PARAM(3), (float)PARAM(4)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_CurveTo3,5)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float
	T_NUMBER(2) // float
	T_NUMBER(3) // float
	T_NUMBER(4) // float

	RETURN_NUMBER(HPDF_Page_CurveTo3((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1), (float)PARAM(2), (float)PARAM(3), (float)PARAM(4)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_ClosePath,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_ClosePath((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_Rectangle,5)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float
	T_NUMBER(2) // float
	T_NUMBER(3) // float
	T_NUMBER(4) // float

	RETURN_NUMBER(HPDF_Page_Rectangle((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1), (float)PARAM(2), (float)PARAM(3), (float)PARAM(4)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_Stroke,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_Stroke((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_ClosePathStroke,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_ClosePathStroke((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_Fill,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_Fill((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_Eofill,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_Eofill((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_FillStroke,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_FillStroke((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_EofillStroke,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_EofillStroke((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_ClosePathFillStroke,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_ClosePathFillStroke((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_ClosePathEofillStroke,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_ClosePathEofillStroke((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_EndPath,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_EndPath((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_Clip,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_Clip((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_Eoclip,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_Eoclip((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_BeginText,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_BeginText((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_EndText,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_EndText((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetCharSpace,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float

	RETURN_NUMBER(HPDF_Page_SetCharSpace((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetWordSpace,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float

	RETURN_NUMBER(HPDF_Page_SetWordSpace((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetHorizontalScalling,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float

	RETURN_NUMBER(HPDF_Page_SetHorizontalScalling((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetTextLeading,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float

	RETURN_NUMBER(HPDF_Page_SetTextLeading((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetFontAndSize,3)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // HPDF_HANDLE
	T_NUMBER(2) // float

	RETURN_NUMBER(HPDF_Page_SetFontAndSize((HPDF_HANDLE)(long)PARAM(0), (HPDF_HANDLE)(long)PARAM(1), (float)PARAM(2)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetTextRenderingMode,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // HPDF_TextRenderingMode

	RETURN_NUMBER(HPDF_Page_SetTextRenderingMode((HPDF_HANDLE)(long)PARAM(0), (HPDF_TextRenderingMode)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetTextRise,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float

	RETURN_NUMBER(HPDF_Page_SetTextRise((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetTextRaise,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float

	RETURN_NUMBER(HPDF_Page_SetTextRaise((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_MoveTextPos,3)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float
	T_NUMBER(2) // float

	RETURN_NUMBER(HPDF_Page_MoveTextPos((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1), (float)PARAM(2)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_MoveTextPos2,3)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float
	T_NUMBER(2) // float

	RETURN_NUMBER(HPDF_Page_MoveTextPos2((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1), (float)PARAM(2)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetTextMatrix,7)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float
	T_NUMBER(2) // float
	T_NUMBER(3) // float
	T_NUMBER(4) // float
	T_NUMBER(5) // float
	T_NUMBER(6) // float

	RETURN_NUMBER(HPDF_Page_SetTextMatrix((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1), (float)PARAM(2), (float)PARAM(3), (float)PARAM(4), (float)PARAM(5), (float)PARAM(6)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_MoveToNextLine,1)
	T_NUMBER(0) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_MoveToNextLine((HPDF_HANDLE)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_ShowText,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_STRING(1) // char*

	RETURN_NUMBER(HPDF_Page_ShowText((HPDF_HANDLE)(long)PARAM(0), PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_ShowTextNextLine,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_STRING(1) // char*

	RETURN_NUMBER(HPDF_Page_ShowTextNextLine((HPDF_HANDLE)(long)PARAM(0), PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_ShowTextNextLineEx,4)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float
	T_NUMBER(2) // float
	T_STRING(3) // char*

	RETURN_NUMBER(HPDF_Page_ShowTextNextLineEx((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1), (float)PARAM(2), PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetGrayFill,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float

	RETURN_NUMBER(HPDF_Page_SetGrayFill((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetGrayStroke,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float

	RETURN_NUMBER(HPDF_Page_SetGrayStroke((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetRGBFill,4)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float
	T_NUMBER(2) // float
	T_NUMBER(3) // float

	RETURN_NUMBER(HPDF_Page_SetRGBFill((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1), (float)PARAM(2), (float)PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetRGBStroke,4)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float
	T_NUMBER(2) // float
	T_NUMBER(3) // float

	RETURN_NUMBER(HPDF_Page_SetRGBStroke((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1), (float)PARAM(2), (float)PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetCMYKFill,5)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float
	T_NUMBER(2) // float
	T_NUMBER(3) // float
	T_NUMBER(4) // float

	RETURN_NUMBER(HPDF_Page_SetCMYKFill((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1), (float)PARAM(2), (float)PARAM(3), (float)PARAM(4)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetCMYKStroke,5)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float
	T_NUMBER(2) // float
	T_NUMBER(3) // float
	T_NUMBER(4) // float

	RETURN_NUMBER(HPDF_Page_SetCMYKStroke((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1), (float)PARAM(2), (float)PARAM(3), (float)PARAM(4)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_ExecuteXObject,2)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // HPDF_HANDLE

	RETURN_NUMBER(HPDF_Page_ExecuteXObject((HPDF_HANDLE)(long)PARAM(0), (HPDF_HANDLE)(long)PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_DrawImage,6)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // HPDF_HANDLE
	T_NUMBER(2) // float
	T_NUMBER(3) // float
	T_NUMBER(4) // float
	T_NUMBER(5) // float

	RETURN_NUMBER(HPDF_Page_DrawImage((HPDF_HANDLE)(long)PARAM(0), (HPDF_HANDLE)(long)PARAM(1), (float)PARAM(2), (float)PARAM(3), (float)PARAM(4), (float)PARAM(5)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_Circle,4)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float
	T_NUMBER(2) // float
	T_NUMBER(3) // float

	RETURN_NUMBER(HPDF_Page_Circle((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1), (float)PARAM(2), (float)PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_Ellipse,5)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float
	T_NUMBER(2) // float
	T_NUMBER(3) // float
	T_NUMBER(4) // float

	RETURN_NUMBER(HPDF_Page_Ellipse((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1), (float)PARAM(2), (float)PARAM(3), (float)PARAM(4)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_Arc,6)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float
	T_NUMBER(2) // float
	T_NUMBER(3) // float
	T_NUMBER(4) // float
	T_NUMBER(5) // float

	RETURN_NUMBER(HPDF_Page_Arc((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1), (float)PARAM(2), (float)PARAM(3), (float)PARAM(4), (float)PARAM(5)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_TextOut,4)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float
	T_NUMBER(2) // float
	T_STRING(3) // char*

	RETURN_NUMBER(HPDF_Page_TextOut((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1), (float)PARAM(2), PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_TextRect,8)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // float
	T_NUMBER(2) // float
	T_NUMBER(3) // float
	T_NUMBER(4) // float
	T_STRING(5) // char*
	T_NUMBER(6) // HPDF_TextAlignment

	// ... parameter 7 is by reference (int*)
	HPDF_UINT local_parameter_7;

	RETURN_NUMBER(HPDF_Page_TextRect((HPDF_HANDLE)(long)PARAM(0), (float)PARAM(1), (float)PARAM(2), (float)PARAM(3), (float)PARAM(4), PARAM(5), (HPDF_TextAlignment)PARAM(6), &local_parameter_7))
	SET_NUMBER(7, local_parameter_7)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_HPDF_Page_SetSlideShow,4)
	T_NUMBER(0) // HPDF_HANDLE
	T_NUMBER(1) // HPDF_TransitionStyle
	T_NUMBER(2) // float
	T_NUMBER(3) // float

	RETURN_NUMBER(HPDF_Page_SetSlideShow((HPDF_HANDLE)(long)PARAM(0), (HPDF_TransitionStyle)PARAM(1), (float)PARAM(2), (float)PARAM(3)))
END_IMPL
