//------------ standard header -----------------------------------//
#include "stdlibrary.h"
//------------ end of standard header ----------------------------//
#include "library.h"
#include "AnsiString.h"
#include <string.h>
#include <math.h>
#include <ctype.h>
#include <string>

extern "C" {
	#include "utf8.h"
}

std::string UriDecode(const std::string & sSrc);
std::string UriEncode(const std::string & sSrc);

// Boyer-Moore fast string search ...
//----------------------------------------------------------------------------------------//
#include <limits.h>

//static size_t max(ssize_t a, ssize_t b) { return a>b ? a : b; }
#ifndef max
    #define max(a,b) a>b ? a : b;
#endif

/* Returns a pointer to the first occurrence of "needle"
 * within "haystack", or NULL if not found.
 */
const unsigned char* memmem_boyermoore_simplified
    (const unsigned char* haystack, size_t hlen,
     const unsigned char* needle,   size_t nlen)
{
    size_t occ[UCHAR_MAX+1];
    size_t a, b, hpos;
    
    if(nlen > hlen || nlen <= 0 || !haystack || !needle) return NULL;

    /* Preprocess */
    /* Initialize the table to default value */
    for(a=0; a<UCHAR_MAX+1; ++a) occ[a] = nlen;

    /* Then populate it with the analysis of the needle */
    for(a=0, b=nlen; a<nlen; ++a) occ[needle[a]] = --b;
    
    /* Start searching from the end of needle (this is not a typo) */
    for(hpos = nlen-1; hpos < hlen; )
    {
        /* Compare the needle backwards, and stop when first mismatch is found */
        size_t npos = nlen-1;
           
        while(haystack[hpos] == needle[npos])
        {
            if(npos == 0) return haystack + hpos;
            --hpos;
            --npos;
        }
                                         
        /* Find out how much ahead we can skip based
         * on the byte that was found
         */
        hpos += max(nlen-npos, occ[haystack[hpos]]);
    }
    return NULL;
}
//----------------------------------------------------------------------------------------//
AnsiString a_rtrim(char *bin) {
    AnsiString result;

    int len=strlen(bin);
    if (len){
        char *buffer=new char[len+1];
        buffer[len]=0;

        char trimmed=0;
        int pos=len-1;
    	for (int i=len-1;i>=0;i--) {
            if (!trimmed) {
                char c=bin[i];
                if ((c!=' ') && (c!='\t') && (c!='\n') && (c!='\r') && (c!='\0') && (c!='\x0B'))
                //if (bin[i]!=' ')
                   trimmed=1;
            }

            if (trimmed)
		buffer[pos--]=bin[i];
    	}
    	result = (char *)buffer+pos+1;
        delete[] buffer;
     }
     return result;	
}

AnsiString a_ltrim(char *bin) {
    AnsiString result;

    int len=strlen(bin);
    if (len){
        char *buffer=new char[len+1];
        buffer[len]=0;

        char trimmed=0;
        int pos=0;
    	for (int i=0;i<len;i++) {
            if (!trimmed) {
                char c=bin[i];
                if ((c!=' ') && (c!='\t') && (c!='\n') && (c!='\r') && (c!='\0') && (c!='\x0B'))
                   trimmed=1;
            }
            if (trimmed)
                buffer[pos++]=bin[i];
    	}
        buffer[pos]=0;
    	result=buffer;
        delete[] buffer;
     }     
     return result;	
}

//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_StrReplace CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(3,"StrReplace takes 3 parameters : (String_to_look, replace_source, replace_with);");
    LOCAL_INIT;

    char *string;
    double len_st;
    char *replace;
    double len_rep;
    char *with;
    double len_with;
    AnsiString result;

    GET_CHECK_BUFFER(0,string,len_st,"StrReplace : parameter 1 should be a string (STATIC STRING)");
    GET_CHECK_BUFFER(1,replace,len_rep,"StrReplace : parameter 2 should be a string (STATIC STRING)");
    GET_CHECK_BUFFER(2,with,len_with,"StrReplace : parameter 3 should be a string (STATIC STRING)");

    AnsiString rep;
    rep.LoadBuffer(replace,(size_t)len_rep);
    result.LoadBuffer(string,(size_t)len_st);
    AnsiString with_st;
    with_st.LoadBuffer(with,(size_t)len_with);

    //int with_len=strlen(with);
    int delta=0;
    if (len_rep) {
       int position=0;
       int after=0;
       do {
            char *szParam0=result.c_str();
            size_t len0=result.Length()-delta;

            if (after>len0)
                break;
            const unsigned char *ptr=memmem_boyermoore_simplified(  (const unsigned char *)szParam0+after,
                                                                    (size_t)len0-after,
                                                                    (const unsigned char *)replace,
                                                                    (size_t)len_rep
                                                                );
            if (ptr) {
                position=(unsigned long)ptr-(unsigned long)szParam0;
                //AnsiString tmp;
                //AnsiString tmp2;

                int len_temp=len0-position-(size_t)len_rep;

                /*if (len_temp>0)
                   tmp2.LoadBuffer((char *)ptr+(long)len_rep,len_temp);*/
                if (len_with>len_rep) {
                    AnsiString tmp;
                    tmp.LoadBuffer(szParam0,position);

                    if ((size_t)len_with)
                        tmp+=with_st;

                    if (len_temp) {
                    //tmp+=tmp2;
                        tmp.AddBuffer((char *)ptr+(long)len_rep,len_temp);
                    }

                    result=tmp;
                } else {
                    int delta2=(int)len_rep-(int)len_with;
                    memcpy((void *)ptr, (void *)with,(size_t)len_with);
                    if (delta2) {
                        int _def_len=len0-position-delta2;
                        char *ptr2=(char *)ptr;
                        for (int i=(int)len_with;i<_def_len;i++)
                            ptr2[i]=ptr2[i+delta2];

                        delta+=delta2;
                    }
                }
                after=position+(size_t)len_with;//len_rep;


                /*AnsiString temp=result.c_str();
                char *ptr=temp.c_str();
                ptr[position-1]=0;
                AnsiString temp2=ptr;
                temp2+=with_st;
                temp2+=(char *)(ptr+position+rep.Length()-1);
                after=position+with_len-1;
                result=temp2;*/
            } else
                break;
       } while (1);
    }


    //RETURN_STRING(result);
    int len=result.Length()-delta;
    if (len) {
        RETURN_BUFFER(result, len);
    } else {
        RETURN_STRING("");
    }
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_NumberToBin CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(1,"NumberToBin takes one parameter : number to convert;");
    LOCAL_INIT;

    AnsiString result;
    AnsiString temp;
    NUMBER nr;
    unsigned long number_long;
    char rest;

    GET_CHECK_NUMBER(0,nr,"NumberToBin : parameter 1 should be a number (STATIC NUMBER)");
    number_long=(unsigned long)nr;
    do {
          rest=number_long%2;
          number_long/=2;
          temp=(char)('0'+rest);
          result=temp+result;
    } while (number_long);

    RETURN_STRING(result);
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_BinToNumber CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(1,"BinToNumber takes one parameter : string to convert;");
    LOCAL_INIT;

    double result=0;
    char *bin;
    GET_CHECK_STRING(0,bin,"BinToNumber : parameter 1 should be a string (STATIC STRING)");

    AnsiString temp=bin;
    int len=temp.Length();
    for (int i=0;i<len;i++) {
	if (temp[i]!='0')
        	result+=pow(2,len-i-1);
    }
    RETURN_NUMBER(result);
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_RepeatString CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(2,"RepeatString takes 2 parameters : fill_string, length;");
    LOCAL_INIT;

    char *fill_string;
    NUMBER times;
    GET_CHECK_STRING(0,fill_string,"RepeatString : parameter 1 should be a string (STATIC STRING)");
    GET_CHECK_NUMBER(1,times,"RepeatString : parameter 2 should be a number (STATIC NUMBER)");

    int len=(int)times;
    if (len) {
        int len2=strlen(fill_string);
        if (!len2) {
    		RETURN_STRING("");
    		return 0;
	}

    	char *buffer=new char[len*len2+1];
        buffer[len*len2]=0;

        char *ptr=buffer;
    	for (int i=0;i<len;i++) {
		memcpy(ptr,fill_string,len2);
		ptr+=len2;
	}

    	RETURN_STRING(buffer);
	delete[] buffer;
    } else
    	RETURN_STRING("");
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_SubStr CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(3,"SubStr takes 3 parameters : string, start, length;");
    LOCAL_INIT;

    //AnsiString result;
    char *fill_string;
    NUMBER start;
    NUMBER len;
    NUMBER mfill_len;
    GET_CHECK_BUFFER(0,fill_string,mfill_len,"SubStr : parameter 1 should be a string (STATIC STRING)");
    GET_CHECK_NUMBER(1,start,"SubStr : parameter 2 should be a number (STATIC NUMBER)");
    GET_CHECK_NUMBER(2,len,"SubStr : parameter 3 should be a number (STATIC NUMBER)");

    if (start<0)
       start=0;

    if (len<0)
       len=0;

    int end=(int)start+(int)len;
    int fill_len=(int)mfill_len;

    if (!fill_len) {
        RETURN_STRING("");
        return 0;
    }


    if (end>fill_len)
       end=fill_len;

    //for (int i=(int)start;i<(int)end;i++)
	//result+=fill_string[i];
    char *result=fill_string+(INTEGER)start;

    if (end-start<=0) {
      RETURN_STRING("");
    } else {
      RETURN_BUFFER(result, end-start);
    }
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_String CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(1,"String takes one parameter : string_buffer");
    LOCAL_INIT;

    AnsiString result;
    char *fill_string;
    NUMBER len;
    GET_CHECK_BUFFER(0,fill_string,len,"String : parameter 1 should be a string (STATIC STRING)");

    /*if ((int)len)
	if (fill_string[(int)len-1])
		fill_string[(int)len-1]=0;*/

    //result=fill_string;
    if (((int)len) && (fill_string)) {
        RETURN_STRING(/*result*/fill_string);
    } else {
        RETURN_STRING("");
    }
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_chr CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(1,"chr takes one parameter : character index");
    LOCAL_INIT;

    NUMBER ord;
    char vl[2];
    vl[1]=0;

    GET_CHECK_NUMBER(0,ord,"chr : parameter 1 should be a number (STATIC NUMBER)");

    vl[0]=(char)ord;

    RETURN_BUFFER(vl,1);
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_ord CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(1,"ord takes one parameter : character");
    LOCAL_INIT;
    char *str;
    NUMBER len;

    GET_CHECK_BUFFER(0,str,len,"ord : parameter 1 should be a string (STATIC STRING)");

    if (len!=1)
	return (char*)"ord: parameter 1 should be a character (a string with 1 byte length)";


    RETURN_NUMBER((double)str[0]);
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_NumberToHex CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(1,"NumberToHex takes one parameter : number to convert;");
    LOCAL_INIT;
    char hex[]="0123456789abcdef";

    AnsiString result;
    AnsiString temp;
    NUMBER nr;
    unsigned long number_long;
    char rest;

    GET_CHECK_NUMBER(0,nr,"NumberToHex : parameter 1 should be a number (STATIC NUMBER)");
    number_long=(unsigned long)nr;
    do {
          rest=number_long%16;
          number_long/=16;
          temp=hex[rest];
          result=temp+result;
    } while (number_long);

    RETURN_STRING(result);
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_HexToNumber CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(1,"HexToNumber takes one parameter : string to convert;");
    LOCAL_INIT;

    double result=0;
    char *bin;
    GET_CHECK_STRING(0,bin,"HexToNumber : parameter 1 should be a string (STATIC STRING)");

    AnsiString temp=bin;
    int len=temp.Length();
    for (int i=0;i<len;i++) {
	if (temp[i]!='0')
	switch (temp[i]) {
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
        		result+=(temp[i]-'0')*pow(16,len-i-1);
			break;
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
        		result+=(10+temp[i]-'a')*pow(16,len-i-1);
			break;
		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
        		result+=(10+temp[i]-'A')*pow(16,len-i-1);
			break;
	}
    }
    RETURN_NUMBER(result);
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_NumberToOct CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(1,"NumberToOct takes one parameter : number to convert;");
    LOCAL_INIT;

    AnsiString result;
    AnsiString temp;
    NUMBER nr;
    unsigned long number_long;
    char rest;

    GET_CHECK_NUMBER(0,nr,"NumberToOct : parameter 1 should be a number (STATIC NUMBER)");
    number_long=(unsigned long)nr;
    do {
          rest=number_long%8;
          number_long/=8;
          temp=(char)('0'+rest);
          result=temp+result;
    } while (number_long);

    RETURN_STRING(result);
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_OctToNumber CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(1,"OctToNumber takes one parameter : string to convert;");
    LOCAL_INIT;

    double result=0;
    char *bin;
    GET_CHECK_STRING(0,bin,"OctToNumber : parameter 1 should be a string (STATIC STRING)");

    AnsiString temp=bin;
    int len=temp.Length();
    for (int i=0;i<len;i++) {
	if (temp[i]!='0')
        	result+=(temp[i]-'0')*pow(8,len-i-1);
    }
    RETURN_NUMBER(result);
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_ltrim CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(1,"ltrim takes one parameter : string to trim left;");
    LOCAL_INIT;

    char *bin;
    GET_CHECK_STRING(0,bin,"ltrim : parameter 1 should be a string (STATIC STRING)");

    int len=strlen(bin);
    if (len){
        char *buffer=new char[len+1];
        buffer[len]=0;

        char trimmed=0;
        int pos=0;
    	for (int i=0;i<len;i++) {
            if (!trimmed) {
                char c=bin[i];
                //if (bin[i]!=' ')
                if ((c!=' ') && (c!='\t') && (c!='\n') && (c!='\r') && (c!='\0') && (c!='\x0B'))
                   trimmed=1;
            }
            if (trimmed)
		buffer[pos++]=bin[i];
    	}
        buffer[pos]=0;
    	RETURN_STRING(buffer);
        delete[] buffer;
    } else
    	RETURN_STRING("");
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_rtrim CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(1,"rtrim takes one parameter : string to trim right;");
    LOCAL_INIT;

    char *bin;
    GET_CHECK_STRING(0,bin,"rtrim : parameter 1 should be a string (STATIC STRING)");

    int len=strlen(bin);
    if (len){
        char *buffer=new char[len+1];
        buffer[len]=0;

        char trimmed=0;
        int pos=len-1;
    	for (int i=len-1;i>=0;i--) {
            if (!trimmed) {
                char c=bin[i];
                //if (bin[i]!=' ')
                if ((c!=' ') && (c!='\t') && (c!='\n') && (c!='\r') && (c!='\0') && (c!='\x0B'))
                   trimmed=1;
            }
            if (trimmed)
		buffer[pos--]=bin[i];
    	}
    	RETURN_STRING(buffer+pos+1);
        delete[] buffer;
    } else
    	RETURN_STRING("");
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_trim CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(1,"trim takes one parameter : string to trim;");
    LOCAL_INIT;

    char *bin;
    NUMBER blen;
    GET_CHECK_BUFFER(0,bin,blen,"trim : parameter 1 should be a string (STATIC STRING)");

    if ((!(int)blen) || (!bin)) {
        RETURN_STRING("");
        return 0;
    }
    int len=strlen(bin);

    /*if (len>=blen) {
	len=blen;
	if (blen)
            bin[len-1]=0;
    }*/
    
    if (len) {
        RETURN_STRING(a_rtrim(a_ltrim(bin)));
    } else
    	RETURN_STRING("");
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_Ext CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(1,"Ext takes one parameter");
    LOCAL_INIT;

    char *bin;
    NUMBER blen;
    GET_CHECK_BUFFER(0,bin,blen,"Ext : parameter 1 should be a string (STATIC STRING)");

	if (blen) {
		AnsiString ext;
		int has_ext=0;
		for (int i=(int)blen-1;i>=0;i--) {
			if (bin[i]=='.') {
				has_ext=1;
				break;
			}
			ext=AnsiString(bin[i])+ext;
		}
		if (has_ext) {
			RETURN_STRING(ext);
		} else {
			RETURN_STRING("");
		}
	} else {
    	RETURN_STRING("");
	}
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_ToUpper CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(1,"ToUpper takes one parameter");
    LOCAL_INIT;

    char *bin;
    NUMBER blen;
    GET_CHECK_BUFFER(0,bin,blen,"ToUpper : parameter 1 should be a string (STATIC STRING)");

    if (blen) {
	AnsiString ext;
	ext.LoadBuffer(bin,(long)blen);
	char *target=ext.c_str();
	for (int i=0;i<blen;i++)
		target[i]=toupper(target[i]);
    	RETURN_STRING(ext);
    } else
    	RETURN_STRING("");
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_ToLower CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(1,"ToLower takes one parameter");
    LOCAL_INIT;

    char *bin;
    NUMBER blen;
    GET_CHECK_BUFFER(0,bin,blen,"ToLower : parameter 1 should be a string (STATIC STRING)");

    if (blen) {
	AnsiString ext;
	ext.LoadBuffer(bin,(long)blen);
	char *target=ext.c_str();
	for (int i=0;i<blen;i++)
		target[i]=tolower(target[i]);
    	RETURN_STRING(ext);
    } else
    	RETURN_STRING("");
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_ToHTML CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(1,"ToHTML takes one parameter");
    LOCAL_INIT;

    char *bin;
    NUMBER blen;
    GET_CHECK_BUFFER(0,bin,blen,"ToHTML : parameter 1 should be a string (STATIC STRING)");

    if (blen) {
        AnsiString ext;
        for (int i=0;i<blen;i++) {
            switch (bin[i]) {
                case ' ':
                    ext+="&nbsp;";
                    break;
                case '<':
                    ext+="&lt;";
                    break;
                case '>':
                    ext+="&gt;";
                    break;
                case '&':
                    ext+="&amp;";
                    break;
                default:
                    ext+=bin[i];
            }
        }
        RETURN_STRING(ext);
    } else
        RETURN_STRING("");
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_Pos CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(2,"Pos takes 2 parameters");
    LOCAL_INIT;

    char *szParam0;
    char *szParam1;
    double len0;
    double len1;

    GET_CHECK_BUFFER(0,szParam0,len0,"Pos : parameter 1 should be a string (STATIC STRING)");
    GET_CHECK_BUFFER(1,szParam1,len1,"Pos : parameter 2 should be a string (STATIC STRING)");
    
    const unsigned char *ptr=memmem_boyermoore_simplified(  (const unsigned char *)szParam0,
                                                            (size_t)len0,
                                                            (const unsigned char *)szParam1,
                                                            (size_t)len1
                                                         );
    int pos;
    if (ptr) {
        pos=(unsigned long)ptr-(unsigned long)szParam0+1;
    } else
        pos=0;
    RETURN_NUMBER(pos);
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_StrSplit CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK_MIN_MAX(2,3,"StrSplit takes 2(or 3) parameters: string, separator string[, boolean put_empty_strings=0]");
    LOCAL_INIT;

    char *szParam0;
    char *szParam1;
    double put_empty=0;

    GET_CHECK_STRING(0,szParam0,"StrSplit : parameter 1 should be a string (STATIC STRING)");
    GET_CHECK_STRING(1,szParam1,"StrSplit : parameter 2 should be a string (STATIC STRING)");
    if (PARAMETERS_COUNT==3) {
        GET_CHECK_NUMBER(2,put_empty,"StrSplit : parameter 3 should be a number (STATIC NUMBER)");
    }

    if (!IS_OK(Invoke(INVOKE_CREATE_ARRAY,RESULT)))
	return (void *)"Failed to INVOKE_CREATE_ARRAY";
    AnsiString target=szParam0;
    AnsiString sep=szParam1;
    int len_sep=sep.Length();

    int pos=target.Pos(sep);
    int index=0;
    int start=0;
    while (pos>0) {
        if (pos>1) {
            if (!IS_OK(Invoke(INVOKE_SET_ARRAY_ELEMENT,RESULT,(INTEGER)index++,(INTEGER)VARIABLE_STRING,target.c_str(),(double)pos-1)))
                return (void *)"Failed to INVOKE_SET_ARRAY_ELEMENT";
        } else if ((int)put_empty) {
            if (!IS_OK(Invoke(INVOKE_SET_ARRAY_ELEMENT,RESULT,(INTEGER)index++,(INTEGER)VARIABLE_STRING,"",(double)0)))
                return (void *)"Failed to INVOKE_SET_ARRAY_ELEMENT";
        }
        AnsiString temp=target;
        target=temp.c_str()+pos+len_sep-1;
        pos=target.Pos(sep);
    }
    if ((target.Length()) || ((int)put_empty)) {
        if (!IS_OK(Invoke(INVOKE_SET_ARRAY_ELEMENT,RESULT,(INTEGER)index,(INTEGER)VARIABLE_STRING,target.c_str(),(double)0)))
            return (void *)"Failed to INVOKE_SET_ARRAY_ELEMENT";
    }
    
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_StrNumberSplit CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK_MIN_MAX(2,3,"StrNumberSplit takes 2(or 3) parameters: string, separator string[, boolean put_empty_strings=0]");
    LOCAL_INIT;

    char *szParam0;
    char *szParam1;
    double put_empty=0;

    GET_CHECK_STRING(0,szParam0,"StrNumberSplit : parameter 1 should be a string (STATIC STRING)");
    GET_CHECK_STRING(1,szParam1,"StrNumberSplit : parameter 2 should be a string (STATIC STRING)");
    if (PARAMETERS_COUNT==3) {
        GET_CHECK_NUMBER(2,put_empty,"StrNumberSplit : parameter 3 should be a number (STATIC NUMBER)");
    }

    if (!IS_OK(Invoke(INVOKE_CREATE_ARRAY,RESULT)))
	return (void *)"Failed to INVOKE_CREATE_ARRAY";
    AnsiString target=szParam0;
    AnsiString sep=szParam1;
    int len_sep=sep.Length();

    int pos=target.Pos(sep);
    int index=0;
    int start=0;
    while (pos>0) {
        if (pos>1) {
            AnsiString number;
            number.LoadBuffer(target.c_str(), pos-1);

            if (!IS_OK(Invoke(INVOKE_SET_ARRAY_ELEMENT,RESULT,(INTEGER)index++,(INTEGER)VARIABLE_NUMBER,"",(double)number.ToFloat())))
                return (void *)"Failed to INVOKE_SET_ARRAY_ELEMENT";
        } else if ((int)put_empty) {
            if (!IS_OK(Invoke(INVOKE_SET_ARRAY_ELEMENT,RESULT,(INTEGER)index++,(INTEGER)VARIABLE_NUMBER,"",(double)0)))
                return (void *)"Failed to INVOKE_SET_ARRAY_ELEMENT";
        }
        AnsiString temp=target;
        target=temp.c_str()+pos+len_sep-1;
        pos=target.Pos(sep);
    }
    if ((target.Length()) || ((int)put_empty)) {
        if (!IS_OK(Invoke(INVOKE_SET_ARRAY_ELEMENT,RESULT,(INTEGER)index,(INTEGER)VARIABLE_NUMBER,"",(double)target.ToFloat())))
            return (void *)"Failed to INVOKE_SET_ARRAY_ELEMENT";
    }
    
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_StrFrom CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(2,"SubStr takes 2 parameters : string, start;");
    LOCAL_INIT;

    AnsiString result;
    char *fill_string;
    NUMBER start;
    NUMBER mfill_len;

	GET_CHECK_BUFFER(0,fill_string,mfill_len,"SubStr : parameter 1 should be a string (STATIC STRING)");
    GET_CHECK_NUMBER(1,start,"SubStr : parameter 2 should be a number (STATIC NUMBER)");

    if (start<0)
       start=0;

    if (mfill_len<0)
       mfill_len=0;

	if (start>=mfill_len) {
      RETURN_STRING("");
	  return 0;
	}

    RETURN_BUFFER(fill_string+(INTEGER)start, mfill_len-start);
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(URIEncode,1)
	T_STRING(0)
	std::string in((const char *)PARAM(0), PARAM_LEN(0));

	std::string out=UriEncode(in);

	RETURN_BUFFER(out.c_str(), out.length())
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(URIDecode,1)
	T_STRING(0)
	std::string in((const char *)PARAM(0), PARAM_LEN(0));

	std::string out=UriDecode(in);

	RETURN_BUFFER(out.c_str(), out.length())
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(UTF8ToWide, 1)
    T_STRING(0)
    if (PARAM_LEN(0)<=0) {
        RETURN_STRING("");
        return 0;
    }

    int len=PARAM_LEN(0);
    int new_sz=len+1;
    unsigned int *buf=new unsigned int[new_sz];//size len*4 bytes
    buf[0]=0;
    new_sz=u8_toucs(buf, new_sz, PARAM(0), len);
    RETURN_BUFFER((char *)buf, new_sz*sizeof(unsigned int));
    delete[] buf;
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(WideToUTF8, 1)
    T_STRING(0)
    if (PARAM_LEN(0)<=0) {
        RETURN_STRING("");
        return 0;
    }
    int len=(PARAM_LEN(0))/sizeof(unsigned int);
    int new_sz=len+1;
    char *buf=new char[new_sz];
    buf[0]=0;
    new_sz=u8_toutf8(buf, new_sz, (unsigned int *)PARAM(0), len);
    RETURN_BUFFER((char *)buf, new_sz*sizeof(unsigned int));
    delete[] buf;
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(UTF8Offset, 2)
    T_STRING(0)
    T_NUMBER(1)
    if (PARAM_LEN(0)<=0) {
        RETURN_NUMBER(-1);
        return 0;
    }

    RETURN_NUMBER(u8_offset(PARAM(0), PARAM_INT(1), PARAM_LEN(0)));
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(UTF8Charnum, 2)
    T_STRING(0)
    T_NUMBER(1)

    if (PARAM_LEN(0)<=0) {
        RETURN_NUMBER(-1);
        return 0;
    }
    RETURN_NUMBER(u8_charnum(PARAM(0), PARAM_INT(1)));
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(UTF8NextChar, 2)
    T_STRING(0)
    T_NUMBER(1)

    int i=PARAM_INT(1);
    RETURN_NUMBER(u8_nextchar(PARAM(0), &i, PARAM_LEN(0)));
    SET_NUMBER(1, i);
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(UTF8Next, 2)
    T_STRING(0)
    T_NUMBER(1)

    int i=PARAM_INT(1);
    u8_inc(PARAM(0), &i);
    RETURN_NUMBER(0);
    SET_NUMBER(1, i);
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(UTF8Prev, 2)
    T_STRING(0)
    T_NUMBER(1)

    int i=PARAM_INT(1);
    u8_dec(PARAM(0), &i);
    RETURN_NUMBER(0);
    SET_NUMBER(1, i);
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(UTF8Escape, 1)
    T_STRING(0)
    if (PARAM_LEN(0)<=0) {
        RETURN_STRING("");
        return 0;
    }

    int sz=(PARAM_LEN(0))*16+1; //(max 4 bytes per char, 3 for digit and one for slash
    char *buf=new char[sz];
    buf[0]=0;
    int len=u8_escape(buf, sz, PARAM(0), 0, PARAM_LEN(0));
    RETURN_BUFFER(buf, len);
    delete[] buf;
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(UTF8Unescape, 1)
    T_STRING(0)
    if (PARAM_LEN(0)<=0) {
        RETURN_STRING("");
        return 0;
    }
    int sz=(PARAM_LEN(0))*4+1;
    char *buf=new char[sz];
    buf[0]=0;
    int len=u8_unescape(buf, sz, PARAM(0));
    RETURN_BUFFER(buf, len);
    delete[] buf;
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(UTF8Length, 1)
    T_STRING(0)

    if (PARAM_LEN(0)>0) {
        RETURN_NUMBER((NUMBER)u8_strlen(PARAM(0), PARAM_LEN(0)));
    } else {
        RETURN_NUMBER(0);
    }
END_IMPL
//---------------------------------------------------------------------------
