//#define GO_DEBUG

//------------ standard header -----------------------------------//
#include "stdlibrary.h"
//------------ end of standard header ----------------------------//
#include "library.h"
#ifdef _WIN32
    #include <windows.h>
#else
    #include <pthread.h>
    #include <unistd.h>
    #define DWORD long
    #define LPVOID void*
#endif
#include "AnsiString.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "semhh.h"

struct Container {
	void *DELEGATE;
	void *CONTEXT;
};

INVOKE_CALL LocalInvoker;
//---------------------------------------------------------------------------
CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS {
    LocalInvoker=Invoke;
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS {
    return 0;
}
//---------------------------------------------------------------------------
#ifdef _WIN32
DWORD WINAPI ThreadFunction(LPVOID DPARAM) {
#else
LPVOID ThreadFunction(LPVOID DPARAM) {
#endif
	Container *cdc=(Container *)DPARAM;
	void *DELEGATE=cdc->DELEGATE;
	void *context=cdc->CONTEXT;
	delete cdc;

	void *RES=0;
    void *EXCEPTION=0;
	LocalInvoker(INVOKE_SET_THREAD_DATA, context);
    LocalInvoker(INVOKE_CALL_DELEGATE,DELEGATE,&RES,&EXCEPTION,(INTEGER)0);
    LocalInvoker(INVOKE_FREE_VARIABLE,RES);
    LocalInvoker(INVOKE_FREE_VARIABLE,EXCEPTION);
    LocalInvoker(INVOKE_FREE_VARIABLE,DELEGATE);
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_RunThread CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(1,"RunThread parameters error : RunThread(delegate)");

    LOCAL_INIT;

    char *cls;
    NUMBER mid;
	void *context=0;

    GET_CHECK_DELEGATE(0,cls,mid,"RunThread : delegate should be of DELEGATE type");

	Container *cdc=new Container();

    //LocalInvoker(INVOKE_DYNAMIC_LOCK,PARAMETER(0));
    LocalInvoker(INVOKE_LOCK_VARIABLE,PARAMETER(0));
	LocalInvoker(INVOKE_GET_THREAD_DATA, &context);

	cdc->DELEGATE=PARAMETER(0);
	cdc->CONTEXT=context;
#ifdef _WIN32
    DWORD threadID;
    HANDLE thandle=CreateThread(NULL,0,ThreadFunction,(LPVOID)cdc,0,&threadID);
    threadID=(long)thandle;
#else
    pthread_t threadID;
    pthread_create(&threadID, NULL, ThreadFunction,(LPVOID)cdc);
#endif
    RETURN_NUMBER((double)(long)threadID);
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_KillThread CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(1,"KillThread parameters error : KillThread(threadID)");

    LOCAL_INIT;
    NUMBER nThreadID;

    GET_CHECK_NUMBER(0,nThreadID,"KillThread : threadID should be of STATIC NUMBER type");

#ifdef _WIN32
    TerminateThread((HANDLE)(long)nThreadID,0);
#else
    pthread_cancel((pthread_t)(long)nThreadID);
#endif
    RETURN_NUMBER(0);
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT_WaitThread CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(1,"WaitThread parameters error : WaitThread(threadID)");

    LOCAL_INIT;
    NUMBER nThreadID;

    GET_CHECK_NUMBER(0,nThreadID,"WaitThread : threadID should be of STATIC NUMBER type");

#ifdef _WIN32
    WaitForSingleObject((HANDLE)(long)nThreadID,INFINITE);
#else
    void *data;
    pthread_join((pthread_t)(long)nThreadID,&data);
#endif
    RETURN_NUMBER(0);
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__Sleep CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK(1,"Sleep : Sleep(miliseconds)");

    LOCAL_INIT;
    NUMBER nSeconds;

    GET_CHECK_NUMBER(0,nSeconds,"Sleep : 'miliseconds' should be of STATIC NUMBER type");

#ifdef _WIN32
    Sleep((long)nSeconds);
#else
    usleep((long)nSeconds*1000);
#endif
    RETURN_NUMBER(0);
    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_semcreate,0)
    HHSEM *sm=new HHSEM;
    RETURN_NUMBER((long)sm)
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_semdone,1)
    T_HANDLE(0)

    HHSEM *sm=(HHSEM *)PARAM_INT(0);

    delete sm;

    RETURN_NUMBER(0)
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_seminit,2)
    T_HANDLE(0)
    T_NUMBER(1)

    HHSEM *sm=(HHSEM *)PARAM_INT(0);

    seminit((*sm), PARAM_INT(1));

    RETURN_NUMBER(0)
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_semp,1)
    T_HANDLE(0)

    HHSEM *sm=(HHSEM *)PARAM_INT(0);

    semp((*sm));

    RETURN_NUMBER(0)
END_IMPL
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_semv,1)
    T_HANDLE(0)

    HHSEM *sm=(HHSEM *)PARAM_INT(0);

    semv((*sm));

    RETURN_NUMBER(0)
END_IMPL
//---------------------------------------------------------------------------
