#ifndef __LIBRARY_H
#define __LIBRARY_H

// user definition ...

extern "C" {
    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

	CONCEPT_FUNCTION(XapianDocumentCreate)
	CONCEPT_FUNCTION(XapianDocumentDestroy)
	CONCEPT_FUNCTION(XapianDocument__get_value)
	CONCEPT_FUNCTION(XapianDocument__add_value)
	CONCEPT_FUNCTION(XapianDocument__remove_value)
	CONCEPT_FUNCTION(XapianDocument__clear_values)
	CONCEPT_FUNCTION(XapianDocument__get_data)
	CONCEPT_FUNCTION(XapianDocument__set_data)
	CONCEPT_FUNCTION(XapianDocument__add_posting)
	CONCEPT_FUNCTION(XapianDocument__add_term)
	CONCEPT_FUNCTION(XapianDocument__remove_posting)
	CONCEPT_FUNCTION(XapianDocument__remove_term)
	CONCEPT_FUNCTION(XapianDocument__clear_terms)
	CONCEPT_FUNCTION(XapianDocument__termlist_count)
	CONCEPT_FUNCTION(XapianDocument__values_count)
	CONCEPT_FUNCTION(XapianDocument__get_docid)
	CONCEPT_FUNCTION(XapianDocument__get_description) 
	CONCEPT_FUNCTION(XapianDocument__values_begin)
	CONCEPT_FUNCTION(XapianDocument__values_end)
	CONCEPT_FUNCTION(XapianDocument__termlist_begin)
	CONCEPT_FUNCTION(XapianDocument__termlist_end) 

	CONCEPT_FUNCTION(XapianWritableDatabaseCreate)
	CONCEPT_FUNCTION(XapianWritableDatabaseCreate2)
	CONCEPT_FUNCTION(XapianWritableDatabaseDestroy)
	CONCEPT_FUNCTION(XapianWritableDatabase__flush)
	CONCEPT_FUNCTION(XapianWritableDatabase__begin_transaction)
	CONCEPT_FUNCTION(XapianWritableDatabase__commit_transaction)
	CONCEPT_FUNCTION(XapianWritableDatabase__cancel_transaction)
	CONCEPT_FUNCTION(XapianWritableDatabase__add_document)
	CONCEPT_FUNCTION(XapianWritableDatabase__delete_document)
	CONCEPT_FUNCTION(XapianWritableDatabase__delete_document2)
	CONCEPT_FUNCTION(XapianWritableDatabase__replace_document)
	CONCEPT_FUNCTION(XapianWritableDatabase__replace_document2)
	CONCEPT_FUNCTION(XapianWritableDatabase__add_spelling)
	CONCEPT_FUNCTION(XapianWritableDatabase__remove_spelling)
	CONCEPT_FUNCTION(XapianWritableDatabase__add_synonym)
	CONCEPT_FUNCTION(XapianWritableDatabase__remove_synonym)
	CONCEPT_FUNCTION(XapianWritableDatabase__clear_synonyms)
	CONCEPT_FUNCTION(XapianWritableDatabase__set_metadata)
	CONCEPT_FUNCTION(XapianWritableDatabase__get_description)

	CONCEPT_FUNCTION(XapianTermGeneratorCreate)
	CONCEPT_FUNCTION(XapianTermGeneratorDestroy)
	CONCEPT_FUNCTION(XapianTermGenerator__set_stemmer)
	CONCEPT_FUNCTION(XapianTermGenerator__set_stopper)
	CONCEPT_FUNCTION(XapianTermGenerator__set_document)
	CONCEPT_FUNCTION(XapianTermGenerator__get_document)
	CONCEPT_FUNCTION(XapianTermGenerator__set_database)
	CONCEPT_FUNCTION(XapianTermGenerator__set_flags)
	CONCEPT_FUNCTION(XapianTermGenerator__index_text)
	CONCEPT_FUNCTION(XapianTermGenerator__index_text_without_positions)
	CONCEPT_FUNCTION(XapianTermGenerator__increase_termpos)
	CONCEPT_FUNCTION(XapianTermGenerator__get_termpos)
	CONCEPT_FUNCTION(XapianTermGenerator__set_termpos)
	CONCEPT_FUNCTION(XapianTermGenerator__get_description)

	CONCEPT_FUNCTION(XapianStemCreate)
	CONCEPT_FUNCTION(XapianStemCreate2)
	CONCEPT_FUNCTION(XapianStemDestroy)
	CONCEPT_FUNCTION(XapianStem__get_description)
	CONCEPT_FUNCTION(XapianStem__stem_word) 

	CONCEPT_FUNCTION(XapianValueIterator__next)
	CONCEPT_FUNCTION(XapianValueIterator__get_value)
	CONCEPT_FUNCTION(XapianValueIterator__get_valueno)
	CONCEPT_FUNCTION(XapianValueIterator__get_description) 
	CONCEPT_FUNCTION(XapianValueIterator__equal)

	CONCEPT_FUNCTION(XapianPositionIterator__next)
	CONCEPT_FUNCTION(XapianPositionIterator__get_value)
	CONCEPT_FUNCTION(XapianPositionIterator__skip_to)
	CONCEPT_FUNCTION(XapianPositionIterator__get_description)
	CONCEPT_FUNCTION(XapianPositionIterator__equal)

	CONCEPT_FUNCTION(XapianTermIterator__next)
	CONCEPT_FUNCTION(XapianTermIterator__get_value)
	CONCEPT_FUNCTION(XapianTermIterator__skip_to)
	CONCEPT_FUNCTION(XapianTermIterator__get_description)
	CONCEPT_FUNCTION(XapianTermIterator__equal)
	CONCEPT_FUNCTION(XapianTermIterator__get_wdf)
	CONCEPT_FUNCTION(XapianTermIterator__get_termfreq)
	CONCEPT_FUNCTION(XapianTermIterator__positionlist_count)
	CONCEPT_FUNCTION(XapianTermIterator__positionlist_begin)
	CONCEPT_FUNCTION(XapianTermIterator__positionlist_end)

	CONCEPT_FUNCTION(XapianMSetIterator__next)
	CONCEPT_FUNCTION(XapianMSetIterator__prev)
	CONCEPT_FUNCTION(XapianMSetIterator__get_value)
	CONCEPT_FUNCTION(XapianMSetIterator__get_description)
	CONCEPT_FUNCTION(XapianMSetIterator__equal)
	CONCEPT_FUNCTION(XapianMSetIterator__get_document)
	CONCEPT_FUNCTION(XapianMSetIterator__get_rank)
	CONCEPT_FUNCTION(XapianMSetIterator__get_weight)
	CONCEPT_FUNCTION(XapianMSetIterator__get_collapse_key)
	CONCEPT_FUNCTION(XapianMSetIterator__get_collapse_count)
	CONCEPT_FUNCTION(XapianMSetIterator__get_percent)

	CONCEPT_FUNCTION(XapianESetIterator__next)
	CONCEPT_FUNCTION(XapianESetIterator__prev)
	CONCEPT_FUNCTION(XapianESetIterator__get_value)
	CONCEPT_FUNCTION(XapianESetIterator__get_description)
	CONCEPT_FUNCTION(XapianESetIterator__equal)
	CONCEPT_FUNCTION(XapianESetIterator__get_weight)

	CONCEPT_FUNCTION(XapianPostingIterator__next)
	CONCEPT_FUNCTION(XapianPostingIterator__get_value)
	CONCEPT_FUNCTION(XapianPostingIterator__get_description)
	CONCEPT_FUNCTION(XapianPostingIterator__equal)
	CONCEPT_FUNCTION(XapianPostingIterator__get_wdf)
	CONCEPT_FUNCTION(XapianPostingIterator__get_doclength)
	CONCEPT_FUNCTION(XapianPostingIterator__positionlist_begin)
	CONCEPT_FUNCTION(XapianPostingIterator__positionlist_end)

	CONCEPT_FUNCTION(XapianDatabaseCreate)
	CONCEPT_FUNCTION(XapianDatabaseCreate2)
	CONCEPT_FUNCTION(XapianDatabaseDestroy)
	CONCEPT_FUNCTION(XapianDatabase__add_database)
	CONCEPT_FUNCTION(XapianDatabase__reopen)
	CONCEPT_FUNCTION(XapianDatabase__get_description)
	CONCEPT_FUNCTION(XapianDatabase__postlist_begin)
	CONCEPT_FUNCTION(XapianDatabase__postlist_end)
	CONCEPT_FUNCTION(XapianDatabase__termlist_begin)
	CONCEPT_FUNCTION(XapianDatabase__termlist_end)
	CONCEPT_FUNCTION(XapianDatabase__has_positions)
	CONCEPT_FUNCTION(XapianDatabase__positionlist_begin)
	CONCEPT_FUNCTION(XapianDatabase__positionlist_end)
	CONCEPT_FUNCTION(XapianDatabase__allterms_begin)
	CONCEPT_FUNCTION(XapianDatabase__allterms_end)
	CONCEPT_FUNCTION(XapianDatabase__allterms_begin2)
	CONCEPT_FUNCTION(XapianDatabase__allterms_end2)
	CONCEPT_FUNCTION(XapianDatabase__get_doccount)
	CONCEPT_FUNCTION(XapianDatabase__get_lastdocid)
	CONCEPT_FUNCTION(XapianDatabase__get_avlength)
	CONCEPT_FUNCTION(XapianDatabase__get_termfreq)
	CONCEPT_FUNCTION(XapianDatabase__term_exists)
	CONCEPT_FUNCTION(XapianDatabase__get_collection_freq)
	CONCEPT_FUNCTION(XapianDatabase__get_doclength)
	CONCEPT_FUNCTION(XapianDatabase__keep_alive)
	CONCEPT_FUNCTION(XapianDatabase__get_document)
	CONCEPT_FUNCTION(XapianDatabase__get_spelling_suggestion)
	//CONCEPT_FUNCTION(XapianDatabase__spellings_begin)
	//CONCEPT_FUNCTION(XapianDatabase__spellings_end)
	CONCEPT_FUNCTION(XapianDatabase__synonyms_begin)
	CONCEPT_FUNCTION(XapianDatabase__synonyms_end)
	CONCEPT_FUNCTION(XapianDatabase__synonym_keys_begin)
	CONCEPT_FUNCTION(XapianDatabase__synonym_keys_end)
	CONCEPT_FUNCTION(XapianDatabase__get_metadata)
	CONCEPT_FUNCTION(XapianDatabase__metadata_keys_begin)
	CONCEPT_FUNCTION(XapianDatabase__metadata_keys_end) 

	CONCEPT_FUNCTION(XapianQueryCreate)
	CONCEPT_FUNCTION(XapianQueryCreate2)
	CONCEPT_FUNCTION(XapianQueryCreate3)
	CONCEPT_FUNCTION(XapianQueryCreate4)
	CONCEPT_FUNCTION(XapianQueryCreate5)
	CONCEPT_FUNCTION(XapianQueryDestroy)
	CONCEPT_FUNCTION(XapianQuery__get_length)
	CONCEPT_FUNCTION(XapianQuery__get_terms_begin)
	CONCEPT_FUNCTION(XapianQuery__get_terms_end)
	CONCEPT_FUNCTION(XapianQuery__empty)
	CONCEPT_FUNCTION(XapianQuery__get_description)
	//CONCEPT_FUNCTION(XapianQuery__serialise)
	//CONCEPT_FUNCTION(XapianQuery__get_parameter)
	//CONCEPT_FUNCTION(XapianQuery__get_terms) 

	CONCEPT_FUNCTION(XapianQueryParserCreate)
	CONCEPT_FUNCTION(XapianQueryParserDestroy)
	CONCEPT_FUNCTION(XapianQueryParser__set_stemmer)
	CONCEPT_FUNCTION(XapianQueryParser__set_stemming_strategy)
	CONCEPT_FUNCTION(XapianQueryParser__set_stopper)
	CONCEPT_FUNCTION(XapianQueryParser__set_default_op)
	CONCEPT_FUNCTION(XapianQueryParser__get_default_op)
	CONCEPT_FUNCTION(XapianQueryParser__set_database)
	CONCEPT_FUNCTION(XapianQueryParser__parse_query)
	CONCEPT_FUNCTION(XapianQueryParser__add_prefix)
	CONCEPT_FUNCTION(XapianQueryParser__add_boolean_prefix)
	CONCEPT_FUNCTION(XapianQueryParser__add_valuerangeprocessor)
	CONCEPT_FUNCTION(XapianQueryParser__stoplist_begin)
	CONCEPT_FUNCTION(XapianQueryParser__stoplist_end)
	CONCEPT_FUNCTION(XapianQueryParser__unstem_begin)
	CONCEPT_FUNCTION(XapianQueryParser__unstem_end)
	CONCEPT_FUNCTION(XapianQueryParser__get_corrected_query_string)
	CONCEPT_FUNCTION(XapianQueryParser__get_description) 

	CONCEPT_FUNCTION(XapianESetCreate)
	CONCEPT_FUNCTION(XapianESetDestroy)
	CONCEPT_FUNCTION(XapianESet__get_ebound)
	CONCEPT_FUNCTION(XapianESet__size)
	CONCEPT_FUNCTION(XapianESet__max_size)
	CONCEPT_FUNCTION(XapianESet__empty)
	CONCEPT_FUNCTION(XapianESet__swap)
	CONCEPT_FUNCTION(XapianESet__begin)
	CONCEPT_FUNCTION(XapianESet__end)
	CONCEPT_FUNCTION(XapianESet__back)
	CONCEPT_FUNCTION(XapianESet__getiter)
	CONCEPT_FUNCTION(XapianESet__get_description) 

	CONCEPT_FUNCTION(XapianMSetCreate)
	CONCEPT_FUNCTION(XapianMSetDestroy)
	CONCEPT_FUNCTION(XapianMSet__fetch)
	CONCEPT_FUNCTION(XapianMSet__convert_to_percent)
	CONCEPT_FUNCTION(XapianMSet__convert_to_percent2)
	CONCEPT_FUNCTION(XapianMSet__get_termfreq)
	CONCEPT_FUNCTION(XapianMSet__get_termweight)
	CONCEPT_FUNCTION(XapianMSet__get_firstitem)
	CONCEPT_FUNCTION(XapianMSet__get_matches_lower_bound)
	CONCEPT_FUNCTION(XapianMSet__get_matches_estimated)
	CONCEPT_FUNCTION(XapianMSet__get_matches_upper_bound)
	CONCEPT_FUNCTION(XapianMSet__get_max_possible)
	CONCEPT_FUNCTION(XapianMSet__get_max_attained)
	CONCEPT_FUNCTION(XapianMSet__size)
	CONCEPT_FUNCTION(XapianMSet__max_size)
	CONCEPT_FUNCTION(XapianMSet__empty)
	CONCEPT_FUNCTION(XapianMSet__swap)
	CONCEPT_FUNCTION(XapianMSet__begin)
	CONCEPT_FUNCTION(XapianMSet__end)
	CONCEPT_FUNCTION(XapianMSet__back)
	CONCEPT_FUNCTION(XapianMSet__getiter)
	CONCEPT_FUNCTION(XapianMSet__get_description) 

	CONCEPT_FUNCTION(XapianRSetCreate)
	CONCEPT_FUNCTION(XapianRSetDestroy)
	CONCEPT_FUNCTION(XapianRSet__size)
	CONCEPT_FUNCTION(XapianRSet__empty)
	CONCEPT_FUNCTION(XapianRSet__add_document)
	CONCEPT_FUNCTION(XapianRSet__add_document2)
	CONCEPT_FUNCTION(XapianRSet__remove_document)
	CONCEPT_FUNCTION(XapianRSet__remove_document2)
	CONCEPT_FUNCTION(XapianRSet__contains)
	CONCEPT_FUNCTION(XapianRSet__contains2)
	CONCEPT_FUNCTION(XapianRSet__get_description)

	CONCEPT_FUNCTION(XapianEnquireCreate)
	CONCEPT_FUNCTION(XapianEnquireDestroy)
	CONCEPT_FUNCTION(XapianEnquire__set_query)
	CONCEPT_FUNCTION(XapianEnquire__get_query)
	CONCEPT_FUNCTION(XapianEnquire__set_weighting_scheme)
	CONCEPT_FUNCTION(XapianEnquire__set_collapse_key)
	CONCEPT_FUNCTION(XapianEnquire__set_docid_order)
	CONCEPT_FUNCTION(XapianEnquire__set_cutoff)
	CONCEPT_FUNCTION(XapianEnquire__set_sort_by_relevance)
	CONCEPT_FUNCTION(XapianEnquire__set_sort_by_value)
	CONCEPT_FUNCTION(XapianEnquire__set_sort_by_value_then_relevance)
	CONCEPT_FUNCTION(XapianEnquire__get_mset)
	CONCEPT_FUNCTION(XapianEnquire__get_eset)
	CONCEPT_FUNCTION(XapianEnquire__get_eset2)
	CONCEPT_FUNCTION(XapianEnquire__get_matching_terms_begin)
	CONCEPT_FUNCTION(XapianEnquire__get_matching_terms_end)
	CONCEPT_FUNCTION(XapianEnquire__get_matching_terms_begin2)
	CONCEPT_FUNCTION(XapianEnquire__get_matching_terms_end2)
	CONCEPT_FUNCTION(XapianEnquire__get_description)

    CONCEPT_FUNCTION(XapianStringValueRangeProcessorCreate)
    CONCEPT_FUNCTION(XapianStringValueRangeProcessorDestroy)

    CONCEPT_FUNCTION(XapianDateValueRangeProcessorCreate)
    CONCEPT_FUNCTION(XapianDateValueRangeProcessorDestroy)

    CONCEPT_FUNCTION(XapianNumberValueRangeProcessorCreate)
    CONCEPT_FUNCTION(XapianNumberValueRangeProcessorDestroy)

    CONCEPT_FUNCTION(XapianSimpleStopperCreate)
    CONCEPT_FUNCTION(XapianSimpleStopperDestroy)
    CONCEPT_FUNCTION(XapianSimpleStopper__add)
    CONCEPT_FUNCTION(XapianSimpleStopper__has)
}


#endif // __LIBRARY_H
