//#define DEBUG
//#define DISABLE_CHECKPOINTS

#include <stdlib.h>
#include <fcntl.h>
#ifdef _WIN32
 #include <io.h>
//#include <windows.h>
 #include <winsock2.h>
 #include <sys/utime.h>
#else
 #include <dlfcn.h>        // dlopen

 #define HANDLE     void *
 #define HMODULE    HANDLE

 #define SOCKET     int
#endif

#include "AnsiString.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>

#ifdef _WIN32
//#include <dir.h>
 #include <direct.h>
#else
 #define SOCKET            int
 #define INVALID_SOCKET    -1
 #define SOCKET_ERROR      -1
 #define DWORD             int
 #define LPVOID            void *

 #include <sys/types.h>
 #include <sys/socket.h>
 #include <netinet/in.h>
 #include <netdb.h>

 #include <unistd.h>


//    #define LINUX_PATH "/opt/Concept/bin/"

#endif

#ifdef _WIN32
 #define LIBRARY    "concept-core.2.0.dll"
#else
//#define LIBRARY      AnsiString(LINUX_PATH) + "concept-core.1.0alpha.so"
 #define LIBRARY    "libconceptcore.2.0.so"
#endif

#define INI_FILE    "concept.ini"

typedef int (*GET_VARIABLE_PROC)(int operation, void *VDESC, void *CONTEXT, int Depth, char *VariableName, char *buffer, int buf_size);
typedef int (*DEBUGGER_CALLBACK)(void *VDESC, void *CONTEXT, int Depth, int line, char *filename, GET_VARIABLE_PROC GVP, void *DEBUGGER_RESERVED);

typedef void (*CHECK_POINT)(int status);

extern "C" {
typedef int (*API_INTERPRETER)(char *filename, char *inc_dir, char *lib_dir, void *fp, SOCKET sock, int debug, DEBUGGER_CALLBACK DEBUGGER_TRAP, void *DEBUGGER_RESERVED, char *SERVER_PUBLIC_KEY, char *SERVER_PRIVATE_KEY, char *CLIENT_PUBLIC_KEY, int pipe_in, int pipe_out, int apid, int parent);

typedef int (*API_INTERPRETER2)(char *filename, char *inc_dir, char *lib_dir, void *fp, SOCKET sock, int debug, DEBUGGER_CALLBACK DEBUGGER_TRAP, void *DEBUGGER_RESERVED, char *SERVER_PUBLIC_KEY, char *SERVER_PRIVATE_KEY, char *CLIENT_PUBLIC_KEY, int pipe_in, int pipe_out, int apid, int parent, CHECK_POINT check_point, void *userdata);

typedef int (*API_INTERPRETER3)(char *filename);
}

#define     DEBUG_RUN         0x01
#define     DEBUG_STEPINTO    0x02
#define     DEBUG_RUNTO       0x03
#define     DEBUG_STEPOVER    0x04

#define MAX_DEBUG_REQUEST     8192

int __pipe_out = 0;
int __pipe_in  = 0;
int __p_apid   = 0;

typedef struct {
    long       CLIENT_NOTICE; // VARIABILA SETATA DE INTERPRETOR !!!

    int        last_line;
    int        debug_type;
    int        run_to_line;
    AnsiString FileName;
    AnsiString run_to_filename;
    void       *context_id;
    SOCKET     sock;
    SOCKET     DEBUG_SOCKET;
} ClientDebugInfo;


int  status      = 0;
bool check_point = false;

void CheckPoint(int _status) {
    status      = _status;
    check_point = true;
}

int NotifyParent(int msg_id, AnsiString DATA) {
    if ((__p_apid <= 0) || (__pipe_in <= 0))
        return(0);

    int params[3];
    params[0] = __p_apid;
    params[1] = msg_id;
    params[2] = DATA.Length();

    write(__pipe_out, params, sizeof(int) * 3);

    if (params[2])
        write(__pipe_out, DATA.c_str(), params[2]);

    return(1);
}

AnsiString SetWebDirectory(char *filename) {
    char       *buffer;
    AnsiString temp  = filename;
    AnsiString temp2 = filename;

    if (temp != (char *)"") {
        buffer = temp.c_str();
        for (int i = strlen(buffer) - 1; i >= 0; i--)
            if ((buffer[i] == '/') || (buffer[i] == '\\')) {
                temp2         = (char *)buffer + i + 1;
                buffer[i + 1] = 0;
                break;
            }
        chdir(buffer);
    }
    return(temp2);
}

int need_compilation(char *filename) {
    AnsiString accel_filename = filename;

    accel_filename += ".accel";
    struct stat buf1, buf2;
    // if some error, report no need for compilation
    if (stat(filename, &buf1))
        return(0);

    if (stat(accel_filename.c_str(), &buf2))
        return(1);

    // last modification time don't match ... need recompilation ...
    if (buf1.st_mtime != buf2.st_mtime)
        return(1);

    return(0);
}

void Print(char *str, int length) {
    if (length > 0)
        std::cout.write(str, length);
    else
        std::cout << str;
}

int GetParent(int *parent, int *msg_id, AnsiString *DATA) {
    if ((__p_apid <= 0) || (__pipe_out <= 0))
        return(0);

    int params[3];

    if (read(__pipe_in, params, sizeof(int) * 3) != sizeof(int) * 3)
        return(0);

    *parent = params[0];
    *msg_id = params[1];

    if (params[2]) {
        char *data = new char [params[2] + 1];
        data[params[2]] = 0;
        int rd = read(__pipe_in, data, params[2]);
        *DATA = data;
        delete[] data;
        if (rd != params[2])
            return(0);
    }

    return(1);
}

int TALK_TO_CLIENT(void *VDESC, void *CONTEXT, int Depth, int line, char *filename, GET_VARIABLE_PROC GVP, void *DEBUGGER_RESERVED) {
    ClientDebugInfo *DINFO = (ClientDebugInfo *)DEBUGGER_RESERVED;

    AnsiString SERVER_QUERY = filename;

    /*SERVER_QUERY    =   (char *)"<Message _OWNER=\"";
     * SERVER_QUERY    +=  "%DEBUGGER";
     * SERVER_QUERY    +=  (char *)"\" _ID=-10 _TARGET=\"";
     * SERVER_QUERY    +=  filename;
     * SERVER_QUERY    +=  "\" _DATA=\"";
     * SERVER_QUERY    +=  AnsiString(line);
     * SERVER_QUERY    +=  (char *)"\" />";*/

    int size = SERVER_QUERY.Length() + 1 + sizeof(int);

    send(DINFO->DEBUG_SOCKET, (char *)&size, sizeof(int), 0);
    send(DINFO->DEBUG_SOCKET, (char *)&line, sizeof(int), 0);
    send(DINFO->DEBUG_SOCKET, SERVER_QUERY, SERVER_QUERY.Length() + 1, 0);

    while (1) {
        int size      = 0;
        int received  = 0;
        int rec_count = 0;
        do {
            received   = recv(DINFO->DEBUG_SOCKET, (char *)&size + rec_count, sizeof(int) - rec_count, 0);
            rec_count += received;
        } while ((rec_count < sizeof(int)) && (received > 0));

        // host is down ...
        if ((received <= 0) || (size > MAX_DEBUG_REQUEST) || (size <= 0))
            return(1);

        char *buffer = new char[size + 1];
        buffer[size] = 0;
        rec_count    = 0;
        do {
            received   = recv(DINFO->DEBUG_SOCKET, buffer + rec_count, size - rec_count, 0);
            rec_count += received;
        } while ((received > 0) && (rec_count < size));
        AnsiString command = buffer;
        delete[] buffer;

        if (received <= 0)
            return(1);

        if (command == (char *)"stepinto") {
            DINFO->debug_type    = DEBUG_STEPINTO;
            DINFO->CLIENT_NOTICE = 0;
            break;
        } else
        if (command == (char *)"stepover") {
            DINFO->context_id    = CONTEXT;
            DINFO->debug_type    = DEBUG_STEPOVER;
            DINFO->CLIENT_NOTICE = (long)CONTEXT;
            break;
        } else
        if (command == (char *)"run") {
            DINFO->debug_type    = DEBUG_RUN;
            DINFO->CLIENT_NOTICE = 0;
            break;
        } else
        if (command == (char *)"break") {
            DINFO->debug_type    = DEBUG_RUN;
            DINFO->CLIENT_NOTICE = 0;
            return(1);
            break;
        } else
        if (command.Pos((char *)"runto ") == 1) {
            AnsiString line = (char *)command.c_str() + 6;
            DINFO->debug_type      = DEBUG_RUNTO;
            DINFO->run_to_line     = line.ToInt();
            DINFO->run_to_filename = filename;
            DINFO->CLIENT_NOTICE   = 0;
            break;
        } else
        if (command.Pos((char *)"watch ") == 1) {
            AnsiString varname = (char *)command.c_str() + 6;
            char       var_buffer[MAX_DEBUG_REQUEST + 1];
            strcpy(var_buffer, "(Variable not defined)");
            var_buffer[MAX_DEBUG_REQUEST] = 0;
            if (GVP(0, VDESC, CONTEXT, Depth, varname, var_buffer, MAX_DEBUG_REQUEST)) {
                // to do ... variable undefined ...
            }

            int res_size = strlen(var_buffer) + 1;
            send(DINFO->DEBUG_SOCKET, (char *)&res_size, sizeof(int), 0);
            send(DINFO->DEBUG_SOCKET, var_buffer, res_size, 0);
        }
    }
    return(0);
}

int DEBUGGER_TRAP(void *VDESC, void *CONTEXT, int Depth, int line, char *filename, GET_VARIABLE_PROC GVP, void *DEBUGGER_RESERVED) {
    ClientDebugInfo *DINFO = (ClientDebugInfo *)DEBUGGER_RESERVED;
    // to do !
    // Debugger is now trapped !
    //if (DINFO->FileName!=filename)
    //   return 0;
    int result = 0;

    switch (DINFO->debug_type) {
        case DEBUG_RUN:
            break;

        case DEBUG_RUNTO:
            if ((DINFO->run_to_line == line) && (DINFO->run_to_filename == filename))
                // Notify Client
                result = TALK_TO_CLIENT(VDESC, CONTEXT, Depth, line, filename, GVP, DEBUGGER_RESERVED);
            break;

        case DEBUG_STEPINTO:
            if ((DINFO->last_line != line) || (DINFO->FileName != filename))
                // Notify Client
                // s-a schimbat linia ...
                result = TALK_TO_CLIENT(VDESC, CONTEXT, Depth, line, filename, GVP, DEBUGGER_RESERVED);
            break;

        case DEBUG_STEPOVER:
            if ((DINFO->last_line != line) || (DINFO->FileName != filename))
                if ((CONTEXT == DINFO->context_id) || (DINFO->CLIENT_NOTICE == -1)) {
                    result = TALK_TO_CLIENT(VDESC, CONTEXT, Depth, line, filename, GVP, DEBUGGER_RESERVED);
                    DINFO->CLIENT_NOTICE = 0;
                }
            break;
    }
    DINFO->FileName  = filename;
    DINFO->last_line = line;
    return(result);
}

SOCKET CONTACT_DEBUGER(char *hostname, int port) {
    struct sockaddr_in sin;
    struct hostent     *hp;
    SOCKET             DEBUG_SOCKET = 0;

    if ((hp = gethostbyname(hostname)) == 0)
        return(0);

    memset(&sin, 0, sizeof(sin));
    //INADDR_ANY;
    sin.sin_addr.s_addr = ((struct in_addr *)(hp->h_addr))->s_addr;
    sin.sin_family      = AF_INET;
    sin.sin_port        = htons(port);

    // creez socket-ul
    if ((DEBUG_SOCKET = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) == INVALID_SOCKET)
        return(0);

    if (connect(DEBUG_SOCKET, (struct sockaddr *)&sin, sizeof(sin)) == INVALID_SOCKET)
        return(0);

    return(DEBUG_SOCKET);
}

int RunDebugConceptApplication(char *filename, char *Include, char *Library, SOCKET sock, char *DEBUG_HOST, int DEBUG_PORT, int pipein, int pipeout, int apid, int parent_apid) {
    HMODULE          hDLL;
    API_INTERPRETER2 Concept_Execute;

#ifdef _WIN32
    hDLL = LoadLibrary(LIBRARY);
#else
    // linux module
    hDLL = dlopen(LIBRARY_PATH, RTLD_LAZY);
#endif
    if (!hDLL) {
        std::cerr << "Error loading core library '" << LIBRARY << "'\r\n";
        return(-1);
    }

#ifdef _WIN32
    Concept_Execute = (API_INTERPRETER2)GetProcAddress(hDLL, "Concept_Execute2");
#else
    Concept_Execute = (API_INTERPRETER2)dlsym(hDLL, "Concept_Execute2");
#endif
    if (!Concept_Execute) {
        std::cerr << "Corrupted library : '" << LIBRARY << "'\r\n";
#ifdef _WIN32
        FreeLibrary(hDLL);
#else
        dlclose(hDLL);
#endif
        return(-1);
    }

    SOCKET DEBUG_SOCKET = CONTACT_DEBUGER(DEBUG_HOST, DEBUG_PORT);

    if ((!DEBUG_SOCKET) || (DEBUG_SOCKET == INVALID_SOCKET))
        return(100);

    ClientDebugInfo DINFO;
    DINFO.CLIENT_NOTICE = 0;
    DINFO.last_line     = 0;
    DINFO.sock          = sock;
    DINFO.debug_type    = DEBUG_STEPINTO;
    DINFO.run_to_line   = 0;
    DINFO.FileName      = filename;
    DINFO.context_id    = 0;
    DINFO.DEBUG_SOCKET  = DEBUG_SOCKET;

    int res = Concept_Execute(filename, Include, Library, (void *)Print, sock, 1, DEBUGGER_TRAP, &DINFO, 0, 0, 0, pipein, pipeout, apid, parent_apid, CheckPoint, 0);
    // inchid conexiunea cu debugger-ul
#ifdef _WIN32
    closesocket(DEBUG_SOCKET);
#else
    close(DEBUG_SOCKET);
#endif
    if (res == -3)
        std::cerr << "File not found or insufficient rights : " << filename << "\r\n";
#ifdef _WIN32
    FreeLibrary(hDLL);
#else
    dlclose(hDLL);
#endif
    return(res);
}

int PROCESS_COMMAND(AnsiString DATA, ClientDebugInfo *DINFO, void *CONTEXT) {
    int result = 0;

    if (DATA == (char *)"stepinto") {
        DINFO->debug_type    = DEBUG_STEPINTO;
        DINFO->CLIENT_NOTICE = 0;
    } else
    if (DATA == (char *)"stepover") {
        DINFO->context_id    = CONTEXT;
        DINFO->debug_type    = DEBUG_STEPOVER;
        DINFO->CLIENT_NOTICE = (long)CONTEXT;
    } else
    if (DATA == (char *)"run") {
        DINFO->debug_type    = DEBUG_RUN;
        DINFO->CLIENT_NOTICE = 0;
    } else
    if (DATA == (char *)"break") {
        DINFO->debug_type    = DEBUG_RUN;
        DINFO->CLIENT_NOTICE = 0;
        result = 1;
    }

    return(result);
}

AnsiString REGISTERED_FILES[0xFF];
int        REGISTERED_COUNT = 0;

int IS_REGISTERED(AnsiString filename) {
    for (int i = 0; i < REGISTERED_COUNT; i++)
        if (REGISTERED_FILES[i] == filename)
            return(i + 1);
    if (!REGISTERED_COUNT)
        return(-1);
    return(0);
}

int REGISTER_FILE(AnsiString filename) {
    if (IS_REGISTERED(filename) > 0)
        return(0);
    REGISTERED_FILES[REGISTERED_COUNT++] == filename;
    return(1);
}

typedef struct {
    AnsiString filename;
    int        line;
} BREAKPOINT;

#define MAX_BREAKPOINTS    0xFF
BREAKPOINT breakpoints[MAX_BREAKPOINTS];
int        max_breakpoints   = 0;
int        breakpoints_count = 0;

/*void write_debug(char *what) {
 *      FILE *f=fopen("c:\\debug.txt","rt+");
 *      if (f) {
 *              fseek(f, 0, SEEK_END);
 *              fwrite(what, 1, strlen(what), f);
 *              fclose(f);
 *      }
 * }*/

int AddBreakpoint(char *filename, int line) {
    int target = 0;
    int i      = 0;

    for (i = 0; i < max_breakpoints; i++)
        if (breakpoints[i].line == -1)
            break;

    target = i;
    if (target >= MAX_BREAKPOINTS)
        return(0);

    breakpoints[i].filename = filename;
    breakpoints[i].line     = line;

    /*write_debug("Breakpoint added: ");
     * write_debug(filename);
     * write_debug(", line ");
     * write_debug(AnsiString((long)line).c_str());
     * write_debug("\n");*/

    max_breakpoints++;
    breakpoints_count++;

    return(1);
}

int RemoveBreakpoint(char *filename, int line) {
    for (int i = 0; i < max_breakpoints; i++)
        if ((breakpoints[i].line == line) && (breakpoints[i].filename == filename)) {
            breakpoints[i].line = -1;
            breakpoints_count--;
            return(1);
        }
    return(0);
}

void ClearBreakpoints() {
    max_breakpoints   = 0;
    breakpoints_count = 0;
}

int IsBreakpoint(char *filename, int line) {
    for (int i = 0; i < max_breakpoints; i++)
        if ((breakpoints[i].line == line) && (breakpoints[i].filename == filename))
            return(1);
    return(0);
}

int CONCEPT_DEBUGGER_TRAP(void *VDESC, void *CONTEXT, int Depth, int line, char *filename, GET_VARIABLE_PROC GVP, void *DEBUGGER_RESERVED) {
    ClientDebugInfo *DINFO = (ClientDebugInfo *)DEBUGGER_RESERVED;
    // to do !
    // Debugger is now trapped !
    //if (DINFO->FileName!=filename)
    //   return 0;
    int  result = 0;
    int  parent;
    int  msg_id;
    char buffer2[0xFFFF];

    //if (!IS_REGISTERED(filename))
    //    return result;

/*write_debug(filename);
 * write_debug(":");
 * write_debug(AnsiString((long)line).c_str());
 * write_debug("\n");*/
    switch (DINFO->debug_type) {
        case DEBUG_RUNTO:
            break;

        case DEBUG_RUN:
            if (!IsBreakpoint(filename, line))
                break;

        case DEBUG_STEPINTO:
            {
                AnsiString DATA;
                DATA  = filename;
                DATA += (char *)"<:>";
                DATA += AnsiString((long)line);
                NotifyParent(-0x100, DATA);

                do {
                    GetParent(&parent, &msg_id, &DATA);
                    if (msg_id == -0x100)
                        result = PROCESS_COMMAND(DATA, DINFO, CONTEXT);
                    else
                    if (msg_id == -0x101)
                        REGISTER_FILE(DATA);
                    else
                    if (msg_id == -0x102) {
                        char var_buffer[MAX_DEBUG_REQUEST + 1];
                        strcpy(var_buffer, "(Variable not defined)");
                        var_buffer[MAX_DEBUG_REQUEST] = 0;
                        if (!GVP(0, VDESC, CONTEXT, Depth, DATA, var_buffer, MAX_DEBUG_REQUEST))
                            // to do ... variable undefined ...
                            strcpy(var_buffer, "(Variable not defined)");

                        DATA += (char *)"<:>";
                        DATA += var_buffer;
                        NotifyParent(-0x102, DATA);
                    } else
                    if (msg_id == -0x103) {
                        char var_buffer[MAX_DEBUG_REQUEST + 1];
                        int  index = DATA.Pos(":");
                        if (index > 1) {
                            AnsiString varvalue = (char *)DATA.c_str() + index;
                            DATA.c_str()[index - 1] = 0;
                            AnsiString varname = DATA.c_str();
                            // first parameter is 1, to SET variable (0 is for GET)
                            if (!GVP(1, VDESC, CONTEXT, Depth, varname, varvalue, varvalue.Length() + 1)) {
                                // to do ... variable undefined ...
                            } else {
                                var_buffer[MAX_DEBUG_REQUEST] = 0;
                                if (!GVP(0, VDESC, CONTEXT, Depth, varname, var_buffer, MAX_DEBUG_REQUEST)) {
                                    // to do ... variable undefined ...
                                } else {
                                    DATA += (char *)"<:>";
                                    DATA += var_buffer;
                                    NotifyParent(-0x102, DATA);
                                }
                            }
                        }
                    } else
                    if (msg_id == -0x104) {
                        GVP(-1, 0, 0, 0, 0, buffer2, 0xFFFF);
                        NotifyParent(-0x104, buffer2);
                    } else
                    if (msg_id == -0x105) {
                        int index = DATA.Pos(":");
                        // add breakpoint
                        if (index > 1) {
                            int break_line = AnsiString((char *)DATA.c_str() + index).ToInt();
                            DATA.c_str()[index - 1] = 0;
                            AnsiString fname = DATA.c_str();
                            AddBreakpoint(fname, break_line);
                        }
                    } else
                    if (msg_id == -0x106) {
                        // remove breakpoint
                        int index = DATA.Pos(":");
                        if (index > 1) {
                            int break_line = AnsiString((char *)DATA.c_str() + index).ToInt();
                            DATA.c_str()[index - 1] = 0;
                            AnsiString fname = DATA.c_str();
                            RemoveBreakpoint(fname, break_line);
                        }
                    } else
                    if (msg_id == -0x107)
                        ClearBreakpoints();
                } while (msg_id != -0x100);
            }
            break;

        case DEBUG_STEPOVER:
            if ((DINFO->last_line != line) || (DINFO->FileName != filename))
                if ((CONTEXT == DINFO->context_id) || (DINFO->CLIENT_NOTICE == -1)) {
                    AnsiString DATA;
                    DATA  = filename;
                    DATA += (char *)"<:>";
                    DATA += AnsiString((long)line);
                    NotifyParent(-0x100, DATA);

                    do {
                        GetParent(&parent, &msg_id, &DATA);
                        if (msg_id == -0x100)
                            result = PROCESS_COMMAND(DATA, DINFO, CONTEXT);
                        else
                        if (msg_id == -0x101)
                            REGISTER_FILE(DATA);
                        else
                        if (msg_id == -0x102) {
                            char var_buffer[MAX_DEBUG_REQUEST + 1];
                            strcpy(var_buffer, "(Variable not defined)");
                            var_buffer[MAX_DEBUG_REQUEST] = 0;
                            if (!GVP(0, VDESC, CONTEXT, Depth, DATA, var_buffer, MAX_DEBUG_REQUEST))
                                // to do ... variable undefined ...
                                strcpy(var_buffer, "(Variable not defined)");

                            DATA += (char *)"<:>";
                            DATA += var_buffer;
                            NotifyParent(-0x102, DATA);
                        } else
                        if (msg_id == -0x103) {
                            char var_buffer[MAX_DEBUG_REQUEST + 1];
                            int  index = DATA.Pos(":");
                            if (index > 1) {
                                AnsiString varvalue = (char *)DATA.c_str() + index;
                                DATA.c_str()[index - 1] = 0;
                                AnsiString varname = DATA.c_str();
                                // first parameter is 1, to SET variable (0 is for GET)
                                if (!GVP(1, VDESC, CONTEXT, Depth, varname, varvalue, varvalue.Length() + 1)) {
                                    // to do ... variable undefined ...
                                } else {
                                    var_buffer[MAX_DEBUG_REQUEST] = 0;
                                    if (!GVP(0, VDESC, CONTEXT, Depth, varname, var_buffer, MAX_DEBUG_REQUEST)) {
                                        // to do ... variable undefined ...
                                    } else {
                                        DATA += (char *)"<:>";
                                        DATA += var_buffer;
                                        NotifyParent(-0x102, DATA);
                                    }
                                }
                            }
                        } else
                        if (msg_id == -0x104) {
                            GVP(-1, 0, 0, 0, 0, buffer2, 0xFFFF);
                            NotifyParent(-0x104, buffer2);
                        } else
                        if (msg_id == -0x105) {
                            int index = DATA.Pos(":");
                            // add breakpoint
                            if (index > 1) {
                                int break_line = AnsiString((char *)DATA.c_str() + index).ToInt();
                                DATA.c_str()[index - 1] = 0;
                                AnsiString fname = DATA.c_str();
                                AddBreakpoint(fname, break_line);
                            }
                        } else
                        if (msg_id == -0x106) {
                            // remove breakpoint
                            int index = DATA.Pos(":");
                            if (index > 1) {
                                int break_line = AnsiString((char *)DATA.c_str() + index).ToInt();
                                DATA.c_str()[index - 1] = 0;
                                AnsiString fname = DATA.c_str();
                                RemoveBreakpoint(fname, break_line);
                            }
                        } else
                        if (msg_id == -0x107)
                            ClearBreakpoints();
                    } while (msg_id != -0x100);

                    DINFO->CLIENT_NOTICE = 0;
                }
            break;
    }
    DINFO->FileName  = filename;
    DINFO->last_line = line;

    return(result);
}

int RunDebugConceptApplication2(char *filename, char *Include, char *Library, SOCKET sock, int pipein, int pipeout, int apid, int parent_apid) {
    HMODULE          hDLL;
    API_INTERPRETER2 Concept_Execute;

#ifdef _WIN32
    hDLL = LoadLibrary(LIBRARY);
#else
    // linux module
    hDLL = dlopen(LIBRARY_PATH, RTLD_LAZY);
#endif
    if (!hDLL) {
        std::cerr << "Error loading core library '" << LIBRARY << "'\r\n";
        return(-1);
    }

#ifdef _WIN32
    Concept_Execute = (API_INTERPRETER2)GetProcAddress(hDLL, "Concept_Execute2");
#else
    Concept_Execute = (API_INTERPRETER2)dlsym(hDLL, "Concept_Execute2");
#endif
    if (!Concept_Execute) {
        std::cerr << "Corrupted library : '" << LIBRARY << "'\r\n";
#ifdef _WIN32
        FreeLibrary(hDLL);
#else
        dlclose(hDLL);
#endif
        return(-1);
    }

    ClientDebugInfo DINFO;
    DINFO.CLIENT_NOTICE = 0;
    DINFO.last_line     = 0;
    DINFO.sock          = sock;
    DINFO.debug_type    = DEBUG_STEPINTO;
    DINFO.run_to_line   = 0;
    DINFO.FileName      = filename;
    DINFO.context_id    = 0;
    DINFO.DEBUG_SOCKET  = 0;

    int res = Concept_Execute(filename, Include, Library, (void *)Print, sock, 1, CONCEPT_DEBUGGER_TRAP, &DINFO, 0, 0, 0, pipein, pipeout, apid, parent_apid, CheckPoint, 0);

    if (res == -3)
        std::cerr << "File not found or insufficient rights : " << filename << "\r\n";
#ifdef _WIN32
    FreeLibrary(hDLL);
#else
    dlclose(hDLL);
#endif
    return(res);
}

AnsiString Strip(char *filename) {
    AnsiString fname = filename;

    if (fname[0] == '"') {
        int len = fname.Length();
        if (len > 2) {
            fname = filename + 1;
            fname.c_str()[len - 2] = 0;
        }
    }
    return(fname);
}

void SetEnvVar(char *varname, const char *value) {
#ifdef _WIN32
    AnsiString my_str = varname;
    my_str += (char *)"=";
    my_str += (char *)value;
    _putenv(my_str.c_str());
#else
    setenv(varname, value, 1);
#endif
}

void EnvSocketVars(int socket, int secured, int debug) {
    SetEnvVar("REMOTE_SECURED", secured ? "1" : "0");
    SetEnvVar("REMOTE_DEBUG", debug ? "1" : "0");
}

int main2(int argc, char **argv) {
    if ((argc < 10) || ((argc >= 10) && (argv[0][1]))) {
        std::cerr << "This program is used internaly by Concept Server and should not be instantiated from shell\n";
        return(-10);
    }
    char *arguments = argv[argc - 1];

    if (arguments)
        SetEnvVar("CONCEPT_ARGUMENTS", arguments);

    AnsiString use_pools_str = (char *)getenv("CONCEPT_UseSharedMemoryPool");
    int        use_pools     = 0;
    use_pools = use_pools_str.ToInt();
#ifdef _WIN32
    WSAData wsa;
    WSAStartup(MAKEWORD(2, 2), &wsa);
    chdir(getenv("CONCEPT_ROOT"));
#endif

    int  debug     = atoi(argv[0]);
    char *filename = argv[6];
    SetEnvVar("CONCEPT_FILENAME", filename);
    SOCKET sock        = /*dup*/ ((SOCKET)AnsiString(argv[7]).ToInt());
    char   *Include    = argv[8];
    char   *Library    = argv[9];
    char   *DEBUG_HOST = 0;
    int    DEBUG_PORT  = 2663;
    int    direct_pipe = AnsiString(argv[1]).ToInt();
    int    pipein      = AnsiString(argv[2]).ToInt();
    int    pipeout     = AnsiString(argv[3]).ToInt();
    int    apid        = AnsiString(argv[4]).ToInt();
    int    parent_apid = AnsiString(argv[5]).ToInt();

    char *SERVER_PUBLIC_KEY  = 0;
    char *SERVER_PRIVATE_KEY = 0;
    char *CLIENT_PUBLIC_KEY  = 0;

    char NON_HEX_KEY[16];
    int  autocompile = 0;

    int secured = 0;

#ifdef _WIN32
    WSAPROTOCOL_INFO wp;
    int write_pipe;
    if (read(direct_pipe, &write_pipe, sizeof(int)) != sizeof(int))
        perror("read");
    else {
        int proc_id = GetCurrentProcessId();
        if (write(write_pipe, &proc_id, sizeof(int)) != sizeof(int))
            perror("Send procid, write: ");
    }

    int read_size = read(direct_pipe, &wp, sizeof(WSAPROTOCOL_INFO));
    if (read_size != sizeof(WSAPROTOCOL_INFO)) {
        std::cerr << "Received " << read_size << " bytes, last error: " << GetLastError() << "\n";
        perror("read");
        std::cerr << "Pipe " << direct_pipe << "\n";
        std::cerr.flush();
    } else {
        sock = WSASocket(FROM_PROTOCOL_INFO, FROM_PROTOCOL_INFO, FROM_PROTOCOL_INFO, &wp, 0, 0);
        if (sock == INVALID_SOCKET) {
            std::cerr << "could not create inherited socket: error code :" << WSAGetLastError() << "\n";
            return(-1);
        }
    }
#endif

/*
 *  std::cout << "Arguments : " << argc << "\n";
 *  for (int i=0;i<argc;i++) {
 *      std::cout << "Arg " << i << " : " << argv[i] << "\n";
 *  }
 */

    AnsiString got_file = SetWebDirectory(filename);
    filename = got_file.c_str();
    AnsiString temp1;
    AnsiString temp2;
    AnsiString temp3;

    __pipe_out = pipeout;
    __pipe_in  = pipein;
    __p_apid   = parent_apid;

    if ((debug) && (__pipe_out > 0) && (__pipe_in > 0) && (__p_apid > 0)) {
        //DEBUG_HOST=argv[9];
        //DEBUG_PORT=atoi(argv[10]);

        int code = RunDebugConceptApplication2(filename, Include, Library, sock, pipein, pipeout, apid, parent_apid);

        // nu pot incepe debug-ul, rulez normal ...
        if (code != 100)
            return(0);
    } else {
        SERVER_PUBLIC_KEY  = (argc > 10) && (argv[10][0]) ? argv[10] : 0;
        SERVER_PRIVATE_KEY = (argc > 11) && (argv[11][0]) ? argv[11] : 0;
        CLIENT_PUBLIC_KEY  = (argc > 12) && (argv[12][0]) ? argv[12] : 0;

        if (SERVER_PUBLIC_KEY) {
            temp1             = AnsiString(SERVER_PUBLIC_KEY).Replace("%20", " ");
            SERVER_PUBLIC_KEY = temp1.c_str();
        }

        if (SERVER_PRIVATE_KEY) {
            temp2 = AnsiString(SERVER_PRIVATE_KEY).Replace("%20", " ");
            SERVER_PRIVATE_KEY = temp2.c_str();
        }

        if (CLIENT_PUBLIC_KEY) {
            temp3             = AnsiString(CLIENT_PUBLIC_KEY).Replace("%20", " ");
            CLIENT_PUBLIC_KEY = temp3.c_str();
        }
        if ((SERVER_PUBLIC_KEY) && (SERVER_PRIVATE_KEY) && (CLIENT_PUBLIC_KEY))
            secured = 1;
    }

    /*std::cout << "Filename : " << filename << "\n";
     * std::cout << "Socket   : " << (int)sock << "\n";
     * std::cout << "Include  : " << Include << "\n";
     * std::cout << "Library  : " << Library << "\n";
     * if (argc>=7) {
     *  std::cout << "SERVER_PUBLIC_KEY  : " << SERVER_PUBLIC_KEY << "\n";
     *  std::cout << "SERVER_PRIVATE_KEY  : " << SERVER_PRIVATE_KEY << "\n";
     *  std::cout << "CLIENT_PUBLIC_KEY  : " << CLIENT_PUBLIC_KEY << "\n";
     * }*/

    HMODULE          hDLL;
    API_INTERPRETER2 Concept_Execute    = 0;
    API_INTERPRETER3 Concept_CachedInit = 0;
    API_INTERPRETER3 Concept_CachedDone = 0;
    int size = -1;

#ifdef _WIN32
    hDLL = LoadLibrary(LIBRARY);
#else
    // linux module
    hDLL = dlopen(LIBRARY_PATH, RTLD_LAZY);
#endif

    if (!hDLL) {
        std::cout << "Error loading core library '" << LIBRARY << "'\r\n";
        return(-1);
    }

    EnvSocketVars(sock, secured, debug);
    if (use_pools) {
#ifdef _WIN32
        Concept_CachedInit = (API_INTERPRETER3)GetProcAddress(hDLL, "Concept_CachedInit");
#else
        Concept_CachedInit = (API_INTERPRETER3)dlsym(hDLL, "Concept_CachedInit");
#endif
        if (Concept_CachedInit) {
            /// to do !
            size = Concept_CachedInit(filename);
            if (size < 0)
                std::cout << "Caching disabled - no valid compiled version for " << filename << "\n";
            else
                std::cout << "Cache init, computed size: " << size << " bytes\n";

#ifdef _WIN32
            Concept_CachedDone = (API_INTERPRETER3)GetProcAddress(hDLL, "Concept_CachedDone");
#else
            Concept_CachedDone = (API_INTERPRETER3)dlsym(hDLL, "Concept_CachedDone");
#endif
        }
    }
#ifdef _WIN32
    Concept_Execute = (API_INTERPRETER2)GetProcAddress(hDLL, "Concept_Execute2");
#else
    Concept_Execute = (API_INTERPRETER2)dlsym(hDLL, "Concept_Execute2");
#endif
    if (!Concept_Execute) {
        std::cout << "Corrupted library : '" << LIBRARY << "'\n";
#ifdef _WIN32
        FreeLibrary(hDLL);
#else
        dlclose(hDLL);
#endif
        return(-1);
    }

    //std::cout << "About to execute " << filename << "...\n";
    int res = Concept_Execute(filename, Include, Library, (void *)Print, sock, 0, 0, 0, SERVER_PUBLIC_KEY, SERVER_PRIVATE_KEY, CLIENT_PUBLIC_KEY, pipein, pipeout, apid, parent_apid, CheckPoint, 0);
    //if (res==-3)
    //   std::cout << "File not found or insufficient rights : " << filename << "\n";
    if (res) {
        switch (res) {
            case -1:
            case -2:
            case -3:
                std::cout << "Result : " << res << "\n";
                break;
        }
    }
    if ((size > 0) && (Concept_CachedInit) && (Concept_CachedDone))
        Concept_CachedDone(filename);

#ifdef _WIN32
    FreeLibrary(hDLL);
    WSACleanup();
#else
    dlclose(hDLL);
#endif
    return(res);
}

int  done    = 0;
long seconds = 0;

#ifdef _WIN32
DWORD WINAPI thread_watcher(void *) {
#else
void *thread_watcher(void *) {
#endif
    while (!done) {
#ifdef _WIN32
        Sleep(1000);
#else
        sleep(1);
#endif
        seconds++;

        if (check_point) {
            seconds     = 0;
            check_point = false;
        }

        if ((status > 0) && (seconds > status)) {
#ifdef _WIN32
            TerminateProcess(GetCurrentProcess(), 101);
#else
            exit(101);
#endif
        }
    }
    return(0);
}

int main(int argc, char **argv) {
#ifndef DISABLE_CHECKPOINTS
 #ifdef _WIN32
    DWORD threadID;
    CreateThread(NULL, 0, thread_watcher, 0, 0, &threadID);
 #else
    //pthread *threadID;
    pthread_t threadID;
    pthread_create(&threadID, NULL, thread_watcher, 0);
 #endif
#endif
    int result = main2(argc, argv);
    done = 1;
}
