<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" indent="yes"/>

<xsl:template match="/">
<xsl:variable name="format" select="HTMLContainer/Format"/>
<xsl:variable name="username" select="HTMLContainer/Username"/>
<xsl:variable name="uid" select="HTMLContainer/UID"/>
<xsl:variable name="scriptid" select="HTMLContainer/ScriptID"/>
<xsl:variable name="__DBID" select="HTMLContainer/Data/__DBID"/>
<xsl:variable name="redirect" select="HTMLContainer/Redirect"/>
<xsl:variable name="op" select="HTMLContainer/Op"/>
<xsl:variable name="message" select="HTMLContainer/Message"/>
<xsl:variable name="response" select="HTMLContainer/Response"/>
<xsl:variable name="template" select="HTMLContainer/Template"/>

<html>
<head>
<title>{title}</title>
<xsl:if test="HTMLContainer/NoHeader='0'">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<link type="text/css" href="css/flick/jquery-ui-1.8.14.custom.css" rel="stylesheet" />	
<link type="text/css" href="css/tables.css" rel="stylesheet" />	
<link rel="stylesheet" type="text/css" href="js/fancybox/jquery.fancybox-1.3.4.css" media="screen" />
<script type="text/javascript" src="js/jquery.min.js"></script>
<script type="text/javascript" src="js/jquery-ui.min.js"></script>
<script type="text/javascript" src="js/fancybox/jquery.mousewheel-3.0.4.pack.js"></script>
<script type="text/javascript" src="js/fancybox/jquery.fancybox-1.3.4.pack.js"></script>
</xsl:if>
<script type="text/javascript">
//<![CDATA[
	$(function() {ldelim}
		$("#master_{public_name}").tabs(
{literal}
			{
				history: true,
				create: function(event, ui) {
					$("a[rel=pagination]", ui.panel).live("click", function () {
						$(ui.panel).load(this.href);
						return false;
					});
				}
			}
		);
{endliteral}
		$("a[rel=img_group_{public_name}]").fancybox({literal}
		{
			'transitionIn'		: 'elastic',
			'transitionOut'		: 'elastic',
			'titlePosition' 	: 'over',
			'titleFormat'		: function(title, currentArray, currentIndex, currentOpts) {
				return '<span id="fancybox-title-over">Image ' + (currentIndex + 1) + ' / ' + currentArray.length + (title.length ? ' &nbsp; ' + title : '') + '</span>';
			}
		});
{endliteral}
		$("a[rel=movie_group_{public_name}]").fancybox({literal}
		{
			'transitionIn'		: 'elastic',
			'transitionOut'		: 'elastic'
		});
{endliteral}
{foreach category}
{foreach category.Elements}
{if category.Elements.is_relation}
//]]>

		$("#ax-{category.Elements.member_name}").load('_REL_{public_name}{category.Elements.member_name}.csp?p=<xsl:value-of select="$__DBID" />&amp;__REDIRECT=<xsl:value-of select="$scriptid" />.csp%253Fid%253D<xsl:value-of select="$__DBID" />');
//<![CDATA[
{else}
{if category.Elements.is_mixed}
//]]>

		$("#ax-{category.Elements.member_name}").load('_REL_{public_name}{category.Elements.member_name}.csp?p=<xsl:value-of select="$__DBID" />&amp;__REDIRECT=<xsl:value-of select="$scriptid" />.csp%253Fid%253D<xsl:value-of select="$__DBID" />');
//<![CDATA[
{endif}
{endif}
{endfor}
{endfor}
{literal}
	});
{endliteral}
//]]>
</script>
{extra_head}
</head>
<body>
	<xsl:if test="HTMLContainer/Message!=''">
		<div class="ui-widget">
			<div class="ui-state-error ui-corner-all" style="padding: 0 .7em;"> 
				<p>
					<span class="ui-icon ui-icon-alert" style="float: left; margin-right: .3em;"></span> 
					<xsl:value-of disable-output-escaping="yes" select="HTMLContainer/Message"/>
				</p>
			</div>
		</div>
	</xsl:if>
	<xsl:if test="HTMLContainer/Response!=''">
		<div class="ui-widget">
			<div class="ui-state-highlight ui-corner-all" style="margin-top: 20px; padding: 0 .7em;"> 
				<p>
					<span class="ui-icon ui-icon-info" style="float: left; margin-right: .3em;"></span>
					<xsl:value-of disable-output-escaping="yes" select="HTMLContainer/Response"/>
				</p>
			</div>
		</div>
	</xsl:if>
	<div class="ui-widget">
		<div class="ui-state-highlight ui-corner-all" style="margin-top: 20px; padding: 0 .7em;"> 
			<p>
				<span class="ui-icon ui-icon-info" style="float: left; margin-right: .3em;"></span>
	<xsl:choose>
		<xsl:when test="HTMLContainer/Username!=''">
					You are logged in as <xsl:value-of disable-output-escaping="yes" select="HTMLContainer/Username"/>
					| <a href="LogIn.csp?logout=1">Sign out</a>
		</xsl:when>
		<xsl:otherwise>
					Please <a href="LogIn.csp">Sign in</a> or <a href="SignUp.csp">sign up</a>
		</xsl:otherwise>
	</xsl:choose>
			</p>
		</div>
	</div>
	<xsl:if test="HTMLContainer/CanAdd='1'">
		<a href="{public_name}.csp?xslt&#x3D;tpls/{public_name}.edit.xslt&amp;op&#x3D;new">New</a>| 
	</xsl:if>
	<xsl:if test="HTMLContainer/CanModify='1'">
		<a href="{public_name}.csp?id&#x3D;{ldelim}$__DBID{rdelim}&amp;xslt&#x3D;tpls/{public_name}.edit.xslt">Modify</a>| 
	</xsl:if>
	<xsl:if test="HTMLContainer/CanArchive='1'">
		<a href="{public_name}.csp?id&#x3D;{ldelim}$__DBID{rdelim}&amp;xslt&#x3D;&amp;op&#x3D;arc">Archive</a>| 
	</xsl:if>
	<xsl:if test="HTMLContainer/CanDelete='1'">
		<a href="{public_name}.csp?id&#x3D;{ldelim}$__DBID{rdelim}&amp;xslt&#x3D;&amp;op&#x3D;del">Delete</a>| 
	</xsl:if>

	<xsl:if test="HTMLContainer/Data!='0'">

	<div id="master_{public_name}">
		<ul>
{foreach category}
			<li><a href="#tab-{category.Reserved}">{category.Name}</a></li>
{endfor}
		</ul>
{foreach category}
		<div id="tab-{category.Reserved}">
			<table>
{foreach category.Elements}
			<tr>
{if category.Elements.is_subcat}
				<td colspan="2"><u><b>{category.Elements.column_name}</b></u></td>
{else}
				<xsl:variable name="{category.Elements.member_name}" select="HTMLContainer/Data/{category.Elements.member_name}"/>
				<td align="right"><b>{category.Elements.column_name}</b></td>
				<td>
{if category.Elements.is_picture}
					<xsl:variable name="{category.Elements.member_name}_filename" select="HTMLContainer/Data/{category.Elements.member_name}_filename"/>
					<xsl:choose>
						<xsl:when test="HTMLContainer/Data/{category.Elements.member_name}_filename != ''">
							<a rel="img_group_{public_name}" href="get{public_name}{category.Elements.member_name}.csp?id&#x3D;{ldelim}$__DBID{rdelim}&amp;e&#x3D;.jpg">
								<img src="get{public_name}{category.Elements.member_name}.csp?id&#x3D;{ldelim}$__DBID{rdelim}&amp;preview&#x3D;1" alt="{ldelim}${category.Elements.member_name}_filename{rdelim}" />
							</a>
						</xsl:when>
						<xsl:otherwise>
							<i>(none)</i>
						</xsl:otherwise>
					</xsl:choose>
{else}
{if category.Elements.is_file}
					<xsl:variable name="{category.Elements.member_name}_filename" select="HTMLContainer/Data/{category.Elements.member_name}_filename"/>
					<xsl:choose>
						<xsl:when test="HTMLContainer/Data/{category.Elements.member_name}_filename != ''">
							<a href="get{public_name}{category.Elements.member_name}.csp?id&#x3D;{ldelim}$__DBID{rdelim}">
								<xsl:value-of select="HTMLContainer/Data/{category.Elements.member_name}_filename"/>
							</a>
						</xsl:when>
						<xsl:otherwise>
							<i>(none)</i>
						</xsl:otherwise>
					</xsl:choose>
{else}
{if category.Elements.is_video}
					<xsl:variable name="{category.Elements.member_name}_filename" select="HTMLContainer/Data/{category.Elements.member_name}_filename"/>
					<xsl:choose>
						<xsl:when test="HTMLContainer/Data/{category.Elements.member_name}_filename != ''">
							<a rel="movie_group_{public_name}" href="Show{public_name}{category.Elements.member_name}.csp?id&#x3D;{ldelim}$__DBID{rdelim}">
								<img src="get{public_name}{category.Elements.member_name}.csp?id&#x3D;{ldelim}$__DBID{rdelim}&amp;preview&#x3D;1" alt="{ldelim}${category.Elements.member_name}_filename{rdelim}" />
							</a>
						</xsl:when>
						<xsl:otherwise>
							(none)
						</xsl:otherwise>
					</xsl:choose>
{else}
{if category.Elements.is_mixed}
					<div id="ax-{category.Elements.member_name}"></div>
{else}
{if category.Elements.is_relation}
					<div id="ax-{category.Elements.member_name}"></div>
{else}
{if category.Elements.no_format}
					<xsl:value-of disable-output-escaping="yes" select="HTMLContainer/Data/{category.Elements.member_name}"/>
{else}
{if category.Elements.is_secret}
					<b>********</b>
{else}
					<xsl:value-of select="HTMLContainer/Data/{category.Elements.member_name}"/>
{endif}
{endif}
{endif}
{endif}
{endif}
{endif}
{endif}
				</td>
{endif}
			</tr>
{endfor}
			</table>
		</div>
{endfor}		
	</div>
	</xsl:if>
</body>
</html>
</xsl:template>
</xsl:stylesheet>