<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" indent="yes"/>

<xsl:template match="/">
<xsl:variable name="format" select="HTMLContainer/Format"/>
<xsl:variable name="username" select="HTMLContainer/Username"/>
<xsl:variable name="uid" select="HTMLContainer/UID"/>
<xsl:variable name="scriptid" select="HTMLContainer/ScriptID"/>
<xsl:variable name="redirect" select="HTMLContainer/Redirect"/>
<xsl:variable name="op" select="HTMLContainer/Op"/>
<xsl:variable name="message" select="HTMLContainer/Message"/>
<xsl:variable name="response" select="HTMLContainer/Response"/>
<xsl:variable name="template" select="HTMLContainer/Template"/>


<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<title>Please log in</title>
<link type="text/css" href="css/flick/jquery-ui-1.8.14.custom.css" rel="stylesheet" />	
<script type="text/javascript" src="js/jquery.min.js" />
<script type="text/javascript" src="js/md5.js" />
<script type="text/javascript" src="js/jquery-ui.min.js"/>
<script type="text/javascript">
//<![CDATA[
	$(function() {
		$( "#dialog" ).dialog();
	});

	function encrypt() {
		var s = document.loginform.password.value;
		var s = hex_md5(s);
		document.loginform.password.value =s;
	}
//]]>
</script>
</head>
<body class="ui-overlay">

<div id="dialog" title="Log in" class="ui-widget ui-widget-content ui-corner-all">
	<form id="loginform" name="loginform" method="post" action="">

	<xsl:if test="HTMLContainer/Message!=''">
		<div class="ui-widget">
			<div class="ui-state-error ui-corner-all" style="padding: 0 .7em;"> 
				<p>
					<span class="ui-icon ui-icon-alert" style="float: left; margin-right: .3em;"></span> 
					<xsl:value-of disable-output-escaping="yes" select="HTMLContainer/Message"/>
				</p>
			</div>
		</div>
	</xsl:if>
	<xsl:if test="HTMLContainer/Response!=''">
		<div class="ui-widget">
			<div class="ui-state-highlight ui-corner-all" style="margin-top: 20px; padding: 0 .7em;"> 
				<p>
					<span class="ui-icon ui-icon-info" style="float: left; margin-right: .3em;"></span>
					<xsl:value-of disable-output-escaping="yes" select="HTMLContainer/Response"/>
				</p>
			</div>
		</div>
	</xsl:if>

		<xsl:if test="HTMLContainer/Op = 'ok'">
			<xsl:choose>
				<xsl:when test="HTMLContainer/Redirect != ''">
					<script>window.location.href="<xsl:value-of select="$redirect"/>";</script>
				</xsl:when>
				<xsl:otherwise>
					<script>window.location.href="/" />"</script>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>

		<label for="username">username:</label>
		<input type="text" name="username" tabindex="1" id="username" />
		<label for="password">password:</label>
		<input type="password" name="password" tabindex="2" id="password" />
		<label for="remember_me">Remember me ?</label>
		<input type="checkbox" name="remember" value="1" tabindex="3" id="remember" />
		<br/>
		<input name="__REDIRECT" type="hidden" value="{$redirect}" />
		<input name="method" type="hidden" value="md5" />
		<br/>
		<a href="SignUp.csp">New user? Click here to signup.</a><br/><br/>
		<input name="Submit" type="submit" id="submit" tabindex="4" value="Log in" onclick="encrypt();"/>
	</form>
</div>

</body>
</html>

</xsl:template>
</xsl:stylesheet>