#ifndef __CONCEPTTYPES_H
#define __CONCEPTTYPES_H

#ifdef _WIN32
 #include <winsock2.h>
#else
 #include <sys/types.h>
 #include <sys/socket.h>
 #include <netinet/in.h>
#endif
#include <string.h>
#include "AnsiString.h"


class SimpleStream {
private:
    int sock;
public:
    SimpleStream(int _sock = 0) {
        sock = _sock;
    }

    int SerializeBuffer(char **buffer, long *size, AnsiString *Owner, long message, AnsiString *Target, AnsiString *Value) {
        // OWNER poate avea maxim 256 octeti
        *size = sizeof(char) + Owner->Length() + sizeof(long) + sizeof(short) + Target->Length() + Value->Length();
        char *buf = new char[*size];
        *buffer = buf;

        *(unsigned char *)buf = (unsigned char)Owner->Length();
        buf += sizeof(char);

        memcpy(buf, Owner->c_str(), Owner->Length());
        buf += Owner->Length();

        *(long *)buf = htonl(message);
        buf         += sizeof(long);

        *(unsigned short *)buf = htons((unsigned short)Target->Length());
        buf += sizeof(short);

        memcpy(buf, Target->c_str(), Target->Length());
        buf += Target->Length();

        memcpy(buf, Value->c_str(), Value->Length());

        return(1);
    }

    void Print(char *str, int length = -1) {
        if (sock) {
            /*AnsiString SERVER_QUERY;
             * //SERVER_QUERY    =   (char *)"<?xml version=\"1.0\"><ConceptXMLDataExchangeDocument><Message _OWNER=\"";
             * SERVER_QUERY    =   (char *)"<Message _OWNER=\"";
             * SERVER_QUERY    +=  "%SYSTEM";
             * SERVER_QUERY    +=  (char *)"\" _ID=-1 _TARGET=\"%SCREEN\" _DATA=\"";
             * SERVER_QUERY    +=  str;
             * SERVER_QUERY    +=  (char *)"\" />";//</ConceptXMLDataExchangeDocument>";
             *
             * long         size=SERVER_QUERY.Length()+1;
             * //send(sock,str,strlen(str)+1,0);*/
            char       *buffer = 0;
            long       size    = 0;
            AnsiString Owner("%SYSTEM");
            AnsiString Target("%SCREEN");
            AnsiString Value;
            Value = str;
            SerializeBuffer(&buffer, &size, &Owner, -1, &Target, &Value);
            long size_n = htonl(size);
            send(sock, (char *)&size_n, sizeof(long), 0);
            send(sock, buffer, size, 0);
            delete[] buffer;
        }
    }

    void Print(double val) {
        AnsiString value(val);

        Print(value.c_str());
    }

    void ClientError(char *error_text, int err_id = -11) {
        if (sock) {
            /*AnsiString SERVER_QUERY;
             * SERVER_QUERY    =   (char *)"<Message _OWNER=\"";
             * SERVER_QUERY    +=  "%SYSTEM";
             * SERVER_QUERY    +=  (char *)"\" _ID=-11 _TARGET=\"%SCREEN\" _DATA=\"";
             * SERVER_QUERY    +=  error_text;
             * SERVER_QUERY    +=  (char *)"\" />";;
             * long         size=SERVER_QUERY.Length()+1;
             * send(sock,(char *)&size,sizeof(long),0);
             * send(sock,SERVER_QUERY,size,0);*/
            char       *buffer = 0;
            long       size    = 0;
            AnsiString Owner("%SYSTEM");
            AnsiString Target("%SCREEN");
            AnsiString Value(error_text);
            SerializeBuffer(&buffer, &size, &Owner, err_id, &Target, &Value);
            long size_n = htonl(size);
            send(sock, (char *)&size_n, sizeof(long), 0);
            send(sock, buffer, size, 0);
            delete[] buffer;
        } else {
            Print("\n---- RUN TIME ERROR --------------------------------------------\n");
            Print(error_text);
            Print("----------------------------------------------------------------\n");
        }
    }
};

#endif //__CONCEPTTYPES_H
